/*
 * shan.zheng@wdk-networks.com 
 *
 */
/* start of add app conf by zhengshan 2011-6-23 */
#include <config/autoconf.h>
/* start of add app conf by zhengshan 2011-6-23 */
#include <bcmnvram.h>

#include "upload.cgi.h"
#include "upload_msg.h"
#include <autoconf.h>

#define RFC_ERROR "RFC1867 error"

#define INFO_UPGRADE_FILE "2T2R_v10.dat"
#define PRIMARY_FTPSERVER_SITE "221.150.163.218"
#define SECOND_FTPSERVER_SITE "cnsupgrade.netween.co.kr"

#define FTP_USER_NAME "cns"
#define FTP_PASSWORD "cns*#1"

#define MODE_NAME "310A"
#define VERSION "1.0.0"

void *memmem(const void *buf, size_t buf_len, const void *byte_line, size_t byte_line_len)
{
    unsigned char *bl = (unsigned char *)byte_line;
    unsigned char *bf = (unsigned char *)buf;
    unsigned char *p  = bf;

    while (byte_line_len <= (buf_len - (p - bf))){
        unsigned int b = *bl & 0xff;
        if ((p = (unsigned char *) memchr(p, b, buf_len - (p - bf))) != NULL){
            if ( (memcmp(p, byte_line, byte_line_len)) == 0)
                return p;
            else
                p++;
        }else{
            break;
        }
    }
    return NULL;
}

#define MEM_SIZE	1024
#define MEM_HALF	512
#define DEFAULT_LANGUAGE "English"
static char *getLang(void)
{
	char *lang=NULL;
	
    lang = nvram_safe_get("Language");
	if (!strcmp(lang, ""))
		strcpy(lang, DEFAULT_LANGUAGE);

	return lang;

}

#if defined (UPLOAD_FIRMWARE_SUPPORT)

/*
 *  taken from "mkimage -l" with few modified....
 */
int check(char *imagefile, int len, char *err_msg)
{
	struct stat sbuf;

	int  data_len ;
	char *data;
	unsigned char *ptr;
	unsigned long checksum;

	image_header_t header;
	image_header_t *hdr = &header;

	int ifd;
	char *lang_old = getLang();

	if ((unsigned)len < sizeof(image_header_t)) {
		if(!strcmp(lang_old,"English"))
			sprintf (err_msg, "Bad size: \"%s\" is not valid image\n", imagefile);
		else
			sprintf (err_msg, "ļߴ: Ƿӳļ\n");
		return 0;
	}

	ifd = open(imagefile, O_RDONLY);
	if(!ifd){
		if(!strcmp(lang_old,"English"))
			sprintf (err_msg, "Can't open %s: %s\n", imagefile, strerror(errno));
		else
			sprintf (err_msg, "޷ ӳļ: %s\n", strerror(errno));
		return 0;
	}

	if (fstat(ifd, &sbuf) < 0) {
		close(ifd);
		if(!strcmp(lang_old,"English"))
			sprintf (err_msg, "Can't stat %s: %s\n", imagefile, strerror(errno));
		else
			sprintf (err_msg, "޷ȡӳļ״̬: %s\n", strerror(errno));
		return 0;
	}

	ptr = (unsigned char *) mmap(0, sbuf.st_size, PROT_READ, MAP_SHARED, ifd, 0);
	if ((caddr_t)ptr == (caddr_t)-1) {
		close(ifd);
		if(!strcmp(lang_old,"English"))
			sprintf (err_msg, "Can't map %s: %s\n", imagefile, strerror(errno));
		else
			sprintf (err_msg, "޷ӳ ļ: %s\n", strerror(errno));
		return 0;
    }

	/*
	 *  handle Header CRC32
	 */
    memcpy (hdr, ptr, sizeof(image_header_t));

    if (ntohl(hdr->ih_magic) != IH_MAGIC) {
		munmap(ptr, len);
		close(ifd);
		if(!strcmp(lang_old,"English"))
			sprintf (err_msg, "Bad Magic Number: \"%s:0x%x\" is not valid image\n", imagefile, hdr->ih_magic);
		else
			sprintf (err_msg, "ʶ: 0x%x. Ƿӳļ\n", hdr->ih_magic);
		return 0;
	}

	data = (char *)hdr;

    checksum = ntohl(hdr->ih_hcrc);
    hdr->ih_hcrc = htonl(0);	/* clear for re-calculation */

    if (crc32 (0, data, sizeof(image_header_t)) != checksum) {
		munmap(ptr, len);
		close(ifd);
		if(!strcmp(lang_old,"English"))
			sprintf (err_msg, "*** Warning: \"%s\" has bad header checksum!\n", imagefile);
		else
			sprintf (err_msg, "*** : \"%s\" һУͷ!\n", imagefile);
		return 0;
    }



	/*
	 *  handle Data CRC32
	 */
    data = (char *)(ptr + sizeof(image_header_t));
	data_len  = len - sizeof(image_header_t) ;	
	if (crc32 (0, data, data_len) != ntohl(hdr->ih_dcrc)) {
		munmap(ptr, len);
		close(ifd);
		if(!strcmp(lang_old,"English"))
			sprintf (err_msg, "*** Warning: \"%s\" has corrupted data!\n", imagefile);
		else
			sprintf (err_msg, "*** : \"%s\" ݻٻ!\n", imagefile);
		return 0;
	}

#if 0
	/* start of add image name check by zhengshan 20110601*/
	if (strncmp(hdr->ih_name, CONFIG_TRADEMARK_MODEL, strlen(CONFIG_TRADEMARK_MODEL))!=0)
	{
		munmap(ptr, len);
		close(ifd);
		sprintf (err_msg, "*** Warning: image is not match chip:%#x\n", (hdr->ih_name));
		return 0;
	}
	/* end of add image name check by zhengshan 20110601*/
#endif

#if 1
	/*
	 * compare MTD partition size and image size
	 */
#if defined (CONFIG_RT2880_ROOTFS_IN_RAM)
	if(len > getMTDPartSize("\"Kernel\"")){
		munmap(ptr, len);
		close(ifd);
		if(!strcmp(lang_old,"English"))
			sprintf(err_msg, "*** Warning: the image file(0x%x) is bigger than Kernel MTD partition.\n", len);
		else
			sprintf(err_msg, "*** : ӳļ(0x%x) ڿ÷.\n", len);
		return 0;
	}
#elif defined (CONFIG_RT2880_ROOTFS_IN_FLASH)
  #ifdef CONFIG_ROOTFS_IN_FLASH_NO_PADDING
	if(len > getMTDPartSize("\"Kernel_RootFS\"")){
		munmap(ptr, len);
		close(ifd);
		sprintf(err_msg, "*** Warning: the image file(0x%x) is bigger than Kernel_RootFS MTD partition.\n", len);
		return 0;
	}
  #else
	if(len < CONFIG_MTD_KERNEL_PART_SIZ){
		munmap(ptr, len);
		close(ifd);
		sprintf(err_msg, "*** Warning: the image file(0x%x) size doesn't make sense.\n", len);
		return 0;
	}

	if((len - CONFIG_MTD_KERNEL_PART_SIZ) > getMTDPartSize("\"RootFS\"")){
		munmap(ptr, len);
		close(ifd);
		sprintf(err_msg, "*** Warning: the image file(0x%x) is bigger than RootFS MTD partition.\n", len - CONFIG_MTD_KERNEL_PART_SIZ);
		return 0;
	}
  #endif
#else
#error "goahead: no CONFIG_RT2880_ROOTFS defined!"
#endif
#endif

	munmap(ptr, len);
	close(ifd);

	return 1;
}

#endif /* UPLOAD_FIRMWARE_SUPPORT */

int main (int argc, char *argv[])
{
    char cmd[256],line[256];
	char imgname[100]={0},modename[100]={0},imagesize[10]={0},ver[10]={0};
	char err_msg[256];
	char *p1,*p2;
    int boundary_len,state = -1,fail_conect_times = 0,ftpserver_flag = 1,filesize = 0;
    FILE *file = NULL;

    sprintf(cmd,"busybox ftpget -u %s -p %s %s /var/2T2R.dat %s",FTP_USER_NAME,FTP_PASSWORD,PRIMARY_FTPSERVER_SITE,INFO_UPGRADE_FILE);

    for(fail_conect_times = 0;fail_conect_times<3 && -1==state;fail_conect_times++)
       state = system(cmd);

	if(-1 == state)
	{  
	   ftpserver_flag = 2;
	   sprintf(cmd,"busybox ftpget -u %s -p %s %s /var/2T2R.dat %s",FTP_USER_NAME,FTP_PASSWORD,SECOND_FTPSERVER_SITE,INFO_UPGRADE_FILE);

	   for(fail_conect_times = 0;fail_conect_times<3 && -1==state;fail_conect_times++)
           state = system(cmd);
	}
	file = fopen("/var/2T2R.dat","r");

	if(-1 == state || file == NULL)
		goto err;

    fread(line,1,256,file);
    p1 = strchr(line,',');
	if(NULL == p1)
		goto err;
    else
	    strncpy(modename,line,p1-line);


	p2 = strchr(p1+1,',');
	if(NULL == p2 )
		goto err;
    else
		strncpy(ver,p1+1,p2-p1-1);

	
	p1=strchr(p2+1,',');
	if(NULL == p1)
		goto err;
    else
	    strncpy(imgname,p2+1,p1-p2-1);

	p2 = strchr(p1+1,' ');
	if(NULL == p2)
		goto err;
	else
		strncpy(imagesize,p1+1,p2-p1-1);

	filesize = atoi(imagesize);

    fclose(file);

	if(strcmp(modename,MODE_NAME)||strcmp(ver,VERSION) <= 0)
	{
        goto err;
	}

	memset(cmd,0,256);   

	if(1 == ftpserver_flag)
        sprintf(cmd,"busybox ftpget -u %s -p %s %s /var/upgrade.img %s",FTP_USER_NAME,FTP_PASSWORD,PRIMARY_FTPSERVER_SITE,imgname);
    else
		sprintf(cmd,"busybox ftpget -u %s -p %s %s /var/upgrade.img %s",FTP_USER_NAME,FTP_PASSWORD,SECOND_FTPSERVER_SITE,imgname);

	state = system(cmd);

	if(-1 == state)
			goto err;

    struct stat sbuf;
    int ifd = open("/var/upgrade.img",O_RDONLY);
    if(!ifd)
    	goto err;

    if (fstat(ifd, &sbuf) < 0) {
	 	 close(ifd);
	   	 goto err;
     }

     close(ifd);

    if(!check("/var/upgrade.img", sbuf.st_size, err_msg) || sbuf.st_size != filesize){
        printf("Error in check. %s", err_msg);
        javascriptUpdate(0);
        goto err;
    }

    write_flash_kernel_version("/var/upgrade.img", 0);


    if( mtd_write_firmware("/var/upgrade.img", 0, sbuf.st_size) == -1){
	    printf("mtd_write fatal error! The corrupted image has ruined the flash!!");
    	javascriptUpdate(0);
    	goto err;
    }

	webwrite(1,NULL);
    javascriptUpdate(1);
	webFoot();
	system("sleep 3 && reboot &");
    exit(0);
err:
	webwrite(0,"err!\n");
	javascriptUpdate(1);
    webFoot();
	system("sleep 3 && reboot &");
    exit(0);
}

