
/*
 * Codes at here are heavily taken from upload.cgi.c which is for large file uploading , but
 * in fact "upload_settings" only need few memory(~16k) so it is not necessary to follow
 * upload.cgi.c at all.
 *
 * YYHuang@Ralink TODO: code size.
 *
 */

#include <unistd.h>	//for unlink
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <linux/reboot.h>
#include <bcmnvram.h>

#include "upload_msg.h"

#define cprintf(fmt, args...) do { \
	FILE *fp = fopen("/dev/console", "w"); \
	if (fp) { \
		fprintf(fp, fmt , ## args); \
		fclose(fp); \
	} \
} while (0)

#define doSystem(fmt ...)	do \
{	\
	char cmd[256] = {0};	\
	snprintf(cmd, sizeof(cmd)-1, fmt);	\
	system(cmd);	\
}while(0)


/*start of add status minpengwei 20111206*/
#if 0
int del4download_status(char * proccess)
{
    //this may limited the list of download process
    char buf[4096] = {0};
	char *p = NULL;
	char *p_next = NULL;
	char *p_t = NULL;
    FILE *pp = popen("nvram get download_status", "r");
	if(pp == NULL)
	{
        cprintf("___Error, Can't open pipe.___\n");
		return 0;
	}
	fgets(buf, sizeof(buf), pp);
	pclose(pp);
	//get an empty list
	if(buf[0]==0)
		return 0;
	//delete proccess from list
    p = strstr(buf, proccess);
	//not in the list
	if(p == NULL)
	    return 0;
	p[0] = 0;
	p_next = strchr(p+1, ';');
	if(p_next == NULL)
	{
		doSystem("nvram set download_status=\"%s\"", buf);
		doSystem("nvram commit");
		return 0;
	}
	p_next = p_next + 1;
	p_t = strdup(p_next);
	strcat(buf, p_t);
	free(p_t);
	doSystem("nvram set download_status=\"%s\"", buf);
	doSystem("nvram commit");

	return 0;
}

int add2download_status(char * proccess)
{
	doSystem("nvram set download_status=\"`nvram get download_status`\"\"%s;\"",	proccess);
	doSystem("nvram commit");
	return 0;
}
#endif
/*end of add status minpengwei 20111206*/


#define US_DEBUG 1 

#ifdef US_DEBUG
#define uprintf(fmt, args...) cprintf("(%s:%d)=> " fmt, __FUNCTION__, __LINE__, ## args)
#else
#define uprintf(fmt, args...)
#endif /* DEBUG */


#define RFC_ERROR "RFC1867 ...."
#define REFRESH_TIMEOUT		"60000"		/* Modiy by zhengshan at 20110301 60000 = 60 secs*/


void *memmem(const void *buf, size_t buf_len, const void *byte_line, size_t byte_line_len)
{
    unsigned char *bl = (unsigned char *)byte_line;
    unsigned char *bf = (unsigned char *)buf;
    unsigned char *p  = bf;

    while (byte_line_len <= (buf_len - (p - bf))){
        unsigned int b = *bl & 0xff;
        if ((p = (unsigned char *) memchr(p, b, buf_len - (p - bf))) != NULL){
            if ( (memcmp(p, byte_line, byte_line_len)) == 0)
                return p;
            else
                p++;
        }else{
            break;
        }
    }
    return NULL;
}

#define MEM_SIZE	1024
#define MEM_HALT	512


int findStrInFile(char *filename, int offset, unsigned char *str, int str_len)
{
	int pos = 0, rc;
	FILE *fp;
	unsigned char mem[MEM_SIZE];

	if(str_len > MEM_HALT)
		return -1;
	if(offset <0)
		return -1;

	fp = fopen(filename, "rb");
	if(!fp)
		return -1;

	rewind(fp);
	fseek(fp, offset + pos, SEEK_SET);
	rc = fread(mem, 1, MEM_SIZE, fp);
	while(rc){
		unsigned char *mem_offset;
		mem_offset = (unsigned char*)memmem(mem, rc, str, str_len);
		if(mem_offset){
			fclose(fp);	//found it
			return (mem_offset - mem) + pos + offset;
		}

		if(rc == MEM_SIZE){
			pos += MEM_HALT;	// 8
		}else
			break;

		rewind(fp);
		fseek(fp, offset+pos, SEEK_SET);
		rc = fread(mem, 1, MEM_SIZE, fp);
	}

	fclose(fp);
	return -1;
}

/*
 *  ps. callee must free memory...
 */
void *getMemInFile(char *filename, int offset, int len)
{
    void *result;
    FILE *fp;
    if( (fp = fopen(filename, "r")) == NULL ){
        return NULL;
    }
	fseek(fp, offset, SEEK_SET);
    result = malloc(sizeof(unsigned char) * (len+1) );
	if(!result)
		return NULL;
	memset(result,'\0', sizeof(unsigned char) * (len+1) );
    if( fread(result, 1, len, fp) != len){
        free(result);
        return NULL;
    }
    return result;
}

static int isFileChecksumInvalid(char *filename, const char *checksum)
{
	FILE *fp = NULL;
	char fileChecksum[32] = {0};
	char cmd[128] = {0};
	int ret = 0;

	snprintf(cmd, sizeof(cmd), "cksum %s", filename);
	fp = popen(cmd, "r");
	if (fp){
		if ( fgets(fileChecksum, sizeof(fileChecksum)-1, fp) )
			strtok(fileChecksum, " ");
		pclose(fp);
	}
	ret = strncmp(fileChecksum, checksum, sizeof(fileChecksum));
	return ret;
}

#define PROFILE_HEADER		"WDK1"
static int import(char *filename, int offset, int len, const char *checksum)
{
    char cmd[4096];
	int ret = 0;
	char *data;
	FILE *fp, *src;
	char *pname = tempnam("/tmp", "set");
	char header[8];
	unsigned long count;

	snprintf(cmd, 4096, "cp %s /tmp/tmpcgi", filename);
      system(cmd);

    if (!(fp = fopen(pname, "w+"))) {
		return -1;
    }

	if (!(src = fopen(filename, "r"))) {
		fclose(fp);
		return -1;
	}

    if( fseek(src, offset, SEEK_SET) == -1){
        printf("fseek error\n");
    }
	
	while(len > 0) {
		if (!fread(&data, 1, 1, src))
			break;
		fwrite(&data, 1, 1, fp);
		len--;
	}

    fclose(fp);
    fclose(src);

	if ( isFileChecksumInvalid(pname, checksum) ) {
        printf("Checksum invalid.");
        ret = -1;
    } else {
        snprintf(cmd, 4096, "nvram restore %s", pname);
	system(cmd);
	ret = nvram_commit();
    }
	
	unlink(pname);
	
    return ret;
}
void __websRedirect(char *page)
{
	printf("HTTP/1.0 200 OK\n");
	printf("Server: GoAhead-Webs\r\n");
	printf("Pragma: no-cache\n");
	printf("Cache-control: no-cache\n");
	printf("Content-Type: text/html\n");
	printf("\n");
	printf("<html>\n");
	printf("<head>\n\
	<title><#WDKWEB#></title>\n\
	<meta http-equiv=\"Content-Type\" content=\"application/html; charset=utf-8\">\n\
	</head>\n");
	printf("<body onload=\"refresh_all();\">\n\
	<div>\n");

	printf("<script language=\"JavaScript\" type=\"text/javascript\">");
#if 1
	printf(" \
	function refresh_all(){ \
	  document.location.href = \"http://%s/%s\"; \
	} ", getLanIP(),page);
#endif
	printf("</script>");

	printf("<form method=\"get\">\n");
	printf("<#Uploadsettingintroduct2#>\n");
	printf("</form>\n<br>\n\
	</div>\n\
	");

    printf("</body></html>\n");
}

static int __import(char *dirpath ,char *filename, int offset, int len)
{
	char *data;
	FILE *fp, *src;

    if (!(fp = fopen(dirpath, "w+"))) {
		return -1;
    }

	if (!(src = fopen(filename, "r"))) {
		fclose(fp);
		return -1;
	}

    if( fseek(src, offset, SEEK_SET) == -1){
        printf("fseek error\n");
    }
	
	while(len > 0) {
		if (!fread(&data, 1, 1, src))
			break;
		fwrite(&data, 1, 1, fp);
		len--;
	}

    fclose(fp);
    fclose(src);

    return 0;
}

int main (int argc, char *argv[])
{
    int file_begin, file_end;
    int line_begin, line_end;
    char *boundary; int boundary_len;
    char *line, *semicolon, *user_filename, *final_filename_start, *final_filename_end, *final_filename;
    char *filename = getenv("UPLOAD_FILENAME");
    uprintf( "enter.\n" );
    if(!filename){
        cprintf("failed, can't get env var.\n");
        goto err;
    }
	//line 1
    line_begin = 0;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err;
    }
	
    //line 2
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err;
    }
	
    //line 3
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err;
    }
	
    //line 4 save_path
    //free
    char * save_path = NULL;
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err;
    }
    save_path = getMemInFile(filename, line_begin, line_end - line_begin);
	//cprintf("___%s, %d, %s___\n", __FUNCTION__, __LINE__, save_path);
	//line 1
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_save_path;
    }
	
    //line 2
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_save_path;
    }
	
    //line 3
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_save_path;
    }
	
    //line 4 downloadptcl
    //free
    char *downloadptcl = NULL;
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_save_path;
    }
	
    downloadptcl = getMemInFile(filename, line_begin, line_end - line_begin);
	//cprintf("___%s, %d, %s___\n", __FUNCTION__, __LINE__, downloadptcl);
	//line 1
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadptcl;
    }
	
    //line 2
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadptcl;
    }
	
    //line 3
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadptcl;
	}
	
    //downloadurl
    //free
    char *downloadurl = NULL;
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadptcl;
    }
	
    downloadurl = getMemInFile(filename, line_begin, line_end - line_begin);
	//cprintf("___%s, %d, %d___\n", __FUNCTION__, __LINE__, line_end - line_begin);
	//cprintf("___%s, %d, %s, %d___\n", __FUNCTION__, __LINE__, downloadurl, strlen(downloadurl));
#if 0
    int i;
	int len = strlen(downloadurl);
	cprintf("___");
	for(i=0; i<len; i++)
	{
		cprintf("%x", downloadurl[i]);
	}
	cprintf("___\n");
#endif
#if 0
	if(downloadptcl[0] == '0')
	{
        doSystem("cd %s && axel -n 1 -s 1000 %s&", save_path, downloadurl);
		/*start  of add status minpengwei 20111206*/
		char _my_buf1[256] = {0};
		snprintf(_my_buf1, sizeof(_my_buf1), "cd %s && axel -n 1 -s 1000 %s&", save_path, downloadurl);
		//add2download_status(_my_buf1);
		/*end of add status minpengwei 20111206*/
		sleep(10);
		goto finish_url;
	}
#endif
	//line 1
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadurl;
    }
	
    //line 2
    //downloadtorrent
    // Content-Disposition: form-data; name="filename"; filename="\\192.168.3.171\tftpboot\a.out"
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadurl;
    }
	
    line = getMemInFile(filename, line_begin, line_end - line_begin);
	//cprintf("___%s, %d, %s___\n", __FUNCTION__, __LINE__, line);
    if(strncasecmp(line, "content-disposition: form-data;", strlen("content-disposition: form-data;"))){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
		free(line);
        goto err_downloadurl;
    }
    semicolon = line + strlen("content-disposition: form-data;") + 1;
    if(! (semicolon = strchr(semicolon, ';'))  ){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("dont support multi-field upload.\n");
		free(line);
        goto err_downloadurl;
    }
    user_filename = semicolon + 2;
    if( strncasecmp(user_filename, "filename=", strlen("filename="))  ){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
		free(line);
        goto err_downloadurl;
    }
    user_filename += strlen("filename=");	
	//cprintf("___%s, %d, %s___\n", __FUNCTION__, __LINE__, user_filename);
	final_filename_start = strrchr(user_filename, '\\');
	//linux just filename no path
	if(final_filename_start == NULL)
		final_filename_start = user_filename;
	//free
	final_filename = strdup(final_filename_start+1);	
	*(strrchr(final_filename, '\"')) = 0;	
	//cprintf("___%s, %d, %s___\n", __FUNCTION__, __LINE__, final_filename);
    free(line);
	//line 1
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadtorrent;
    }
	
	//line2
    line_begin = line_end + 2;
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_downloadtorrent;
    }
	

    //file content
    //free
    char * torrent_file = NULL;
	torrent_file = malloc(strlen(save_path) + strlen(final_filename) + 2);
	memset(torrent_file,'\0',(strlen(save_path) + strlen(final_filename) + 2));
	strcat(torrent_file, save_path);
	strcat(torrent_file, "/");
	strcat(torrent_file, final_filename);
	//cprintf("___%s, %d, %s___\n", __FUNCTION__, __LINE__, torrent_file);
    line_begin = line_end + 2;
	#if 0
    if((line_end = findStrInFile(filename, line_begin, "\r\n", 2)) == -1){
		cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_torrent_file;
    }
	#endif
    if((line_end = findStrInFile(filename, line_begin, "----------", 10)) == -1){
		//cprintf("___%s, %d___\n", __FUNCTION__, __LINE__);
        cprintf("%s", RFC_ERROR);
        goto err_torrent_file;
    }
	line_end = line_end -2;
	//cprintf("___%s, %d, %s, %d___\n", torrent_file, line_begin, filename, line_end - line_begin);
	__import(torrent_file, filename, line_begin, line_end - line_begin);
#if 0
    doSystem("cd %s && ctorrent -C 1 -T %s&",save_path, torrent_file);
	/*start  of add status minpengwei 20111206*/
	char _my_buf[256] = {0};
	snprintf(_my_buf, sizeof(_my_buf), "cd %s && ctorrent -C 1 -T %s&",save_path, torrent_file);
	//add2download_status(_my_buf);
	/*end of add status minpengwei 20111206*/
	sleep(20);
#endif
err_torrent_file:
	free(torrent_file);
err_downloadtorrent:
	free(final_filename);
err_downloadurl:
finish_url:
	free(downloadurl);
err_downloadptcl:
	free(downloadptcl);
err_save_path:
	free(save_path);
finish:
err:
	__websRedirect("download2.asp");
	return 0;
}

