/*
 *	inic.h -- Wireless Configuration Header 
 *
 *	Copyright (c) Ralink Technology Corporation All Rights Reserved.
 *
 *	$Id: firewall.h,v 1.6 2010-02-10 08:47:35 yy Exp $
 */


#define PROTO_UNKNOWN	0
#define PROTO_TCP		1
#define PROTO_UDP		2
#define PROTO_TCP_UDP	3
#define PROTO_ICMP		4
#define PROTO_NONE		5


#define RULE_MODE_DISABLE	0
#define RULE_MODE_DROP		1
#define RULE_MODE_ACCEPT	2

#define ACTION_DROP		0
#define ACTION_ACCEPT	1

#define WEB_FILTER_CHAIN				"web_filter"
#define IPPORT_FILTER_CHAIN				"macipport_filter"
#define MALICIOUS_FILTER_CHAIN			"malicious_filter"
#define TCP_SYNFLOOD_FILTER_CHAIN			"tcp_synflood_filter"//tcp forword flood
#define UDP_SYNFLOOD_FILTER_CHAIN			"udp_synflood_filter"//udp forword flood
#define ICMP_SYNFLOOD_FILTER_CHAIN			"icmp_synflood_filter"//icmp forword flood
#define MALICIOUS_INPUT_FILTER_CHAIN	    "malicious_input_filter"
#define TCP_SYNFLOOD_INPUT_FILTER_CHAIN		"tcp_synflood_input_filter"//tcp input flood
#define UDP_SYNFLOOD_INPUT_FILTER_CHAIN		"udp_synflood_input_filter"//udp input flood
#define ICMP_SYNFLOOD_INPUT_FILTER_CHAIN	"icmp_synflood_input_filter"//icmp input flood
#define LAN_WEB_FILTER_CHAIN	            "lan_web_filter"
#define REMOTE_MANAGE_PREROUT_CHAIN	        "remote_mangle_prerout"
#define REMOTE_MANAGE_INPUT_CHAIN	        "remote_mangle_input"
#define WAN_ICMP_INPUT_CHAIN	            "wan_icmp_input"

/* radar.20090403 */
#define SPI_FORWARD_CHAIN	             "spi_forward"
#define SPI_INPUT_CHAIN	                 "spi_input"

#define DMZ_CHAIN			             "DMZ"
#define DMZ_FILTER_CHAIN	             "DMZ_FILTER"
#define PORT_FORWARD_CHAIN	             "port_forward"
#define PORT_FORWARD_FILTER_CHAIN	     "port_forward_filter"
#define PORT_TRIGGER_CHAIN	             "port_trigger"

#define MAGIC_NUM			"IPCHAINS"			

#define HTML_NO_FIREWALL_UNDER_BRIDGE_MODE	\
"<img src=\"/graphics/warning.gif\"><font color=#ff0000>&nbsp; &nbsp;Warning: The current operation mode is \"Bridge mode\" and these settings may not be functional.</font>"

void iptablesSpiFwForwardRun(void);
void iptablesSpiFwInputRun(void);
void iptablesFilterClear(void);
void iptablesFilterRun(char *rule);
void iptablesWebsFilterRun(void);
void iptablesIPPortFilterRun(void);
void iptablesIPPortFilterFlush(void);
void formDefineFirewall(void);
void firewall_init(void);
int isIpNetmaskValid(char *s);	// export for QoS
int isMacValid(char *);			// export for QoS
