/*
 * Create By zym 01/15/2010 (zhaoyanming@twsz.com)
 */

#include <stdlib.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <net/route.h>
#include <string.h>
#include <dirent.h>
#include <net_conn.h>
#include <oid.h>
#include <notify.h>
#include "internet.h"
#include "bcmnvram.h"
#include "webs.h"
#include "utils.h"
#include "firewall.h"
#include "ip_control.h"
#include "config/autoconf.h" //user config


// #define _M_DEBUG
#ifdef _M_DEBUG
#define mdbg(format, args...) printf("[%d:%s()]=>"format, __LINE__, __FUNCTION__, ##args)
#else
#define mdbg(format, args...)
#endif

static int ip_ctl_apply( void );

static char *replace( char *source, char *sub, char *rep )
{
    char *result = NULL;
    char *ps_begin = NULL,  *ps_end = NULL,  *ps_tmp = NULL;
    int isource = 0, isub = 0, irep = 0;
    int i_len = 0;

	if( source == NULL )
		return NULL;

	if( NULL == sub || *sub == '\0' )
        return strdup( source );

    isub = strlen( sub );
	if( rep == NULL )
		irep = 0;
	else
		irep = strlen( rep );
    isource = strlen( source );

    ps_begin = strstr( source, sub );
    if( ps_begin == NULL )
    {
        printf( "%s(%d)->String '%s' isn't exist in source.\n",
            __FUNCTION__, __LINE__, sub );
        return NULL;
    }
    ps_end = ps_begin + isub;
    if( irep == 0 && *ps_end == ';' )
        ++ps_end;

    i_len = ( ( irep > isub ) ? ( isource + irep - isub + 1 ) : isource );
    i_len = i_len + 16;
    printf( "%s(%d)->isource=%d, isub=%d, irep=%d, i_len=%d.\n",
        __FUNCTION__, __LINE__, isource, isub, irep, i_len );
    result=( char * )malloc( i_len );
    if( result == NULL )
    {
        printf( "%s(%d)->malloc fail.\n", __FUNCTION__, __LINE__ );
        return NULL;
   	}
    memset( result, 0, i_len );
    strcpy( result, source );

    ps_tmp = result + ( ps_begin - source );
    if( ( irep == 0 ) && ( *( ps_tmp + isub ) == '\0' )
        && ( ps_tmp != result ) )
        --ps_tmp;

    if( irep > 0 )
    {
        strcpy( ps_tmp, rep );
        ps_tmp = ps_tmp + irep;
    }

    strcpy( ps_tmp, ps_end );

    return result;
}


static int position( const char *ps_src, const char c_mark,
    const int i_idx, char *ps_out, const int i_out_len )
{
    int i = 0;
    char *pc_end = NULL, *pc_begin = NULL, *pc_curr = NULL;

    if( ps_src == NULL || i_idx < 1 || ps_out == NULL || i_out_len < 1 )
        return -1;

    pc_begin = (char *)ps_src;
    pc_end = (char *)ps_src;
    for( i = 0; i < i_idx; ++i)
    {
        pc_begin = pc_end;
        pc_end = strchr( pc_begin + 1, c_mark );
        if( pc_end == NULL )
            break;
    }

    if( pc_end == NULL )
        pc_end = (char *)ps_src + strlen( ps_src );

    i = 0;
	if( pc_begin != ps_src )
		++pc_begin;
    pc_curr = ps_out;
    while( pc_begin != pc_end )
    {
        *pc_curr = *pc_begin;
        if( ( *pc_begin == '\0' ) || ( i >= i_out_len ) )
            break;

        ++i;
        ++pc_curr;
        ++pc_begin;
    }

    if( pc_curr < ( ps_out + i_out_len - 1 ) )
        *pc_curr = '\0';
    else
        *( ps_out + i_out_len - 1 ) = '\0';

    return 0;
}

void ip_control_init( void )
{
    mdbg( "enter.\n" );
    ip_ctl_apply();
}

/*-------------------------NEED DELETE------------------------------

int qos_rule_enable( void )
{
    char *pc_itf = NULL, *pc_speed = NULL, s_cmd[ 256 ] = { 0 };
    char ps_upif[ 16 ] = { 0 }, ps_downif[ 16 ] = { 0 };
    char ps_upspeed[ 16 ] = { 0 }, ps_dwspeed[ 16 ] = { 0 };
    char ps_child_cmd[ 33 ] = { 0 };
    char *sa_addr_s[ 2 ] = { "-s", "-d" };
    char *sa_addr_d[ 2 ] = { "-d", "-s" };
    char *sa_port_s[ 2 ] = { "--sport", "--dport" };
    char *sa_port_d[ 2 ] = { "--dport", "--sport" };
    qos_rule_t *p_head = NULL, *p_curr = NULL;
    int i_count = 0, i_cntup = 0, i_cntdw = 0, i_total = 0, i = 0;
    int in_idx = 0, i_cnt_speed = 0, i_ridx = 0, i_flag = 0;
    unsigned int ui_mark = 0;
    unsigned long ul_speed = 0;

    if( strcmp( nvram_safe_get( "qos_enable" ), "on" ) )
        return 0;

    strncpy( ps_upspeed, nvram_safe_get( "up_str_speed" ), 15 );
    if( !strncmp( ps_upspeed, "customize" , 16 ) )
        strncpy( ps_upspeed, nvram_safe_get( "up_str_speed_cst" ), 15 );

    strncpy( ps_dwspeed, nvram_safe_get( "dw_str_speed" ), 15 );
    if( !strncmp( ps_dwspeed, "customize" , 16 ) )
        strncpy( ps_dwspeed, nvram_safe_get( "dw_str_speed_cst" ), 15 );

    strncpy( ps_upif, nvram_safe_get( "wan_ifname" ), 15 );
    strncpy( ps_downif, nvram_safe_get( "lan_ifname" ), 15 );
    if( strlen( ps_upif ) == 0 || strlen( ps_downif ) == 0 )
        return -1;

    qos_rule_read( &p_head );
    if( p_head == NULL )
        return -1;

    i_count = 0;
    i_total = atoi( nvram_safe_get( "qos_rule_total" ) );
    p_curr = p_head;
    for( i = 0; ( i < i_total ) || ( p_curr != NULL ); ++i )
    {
        if( p_curr->i_enable == 1 )
        {
            ++i_count;
            if( p_curr->ul_up_speed > 0 )
                ++i_cntup;
            if( p_curr->ul_dw_speed > 0 )
                ++i_cntdw;
        }

        p_curr = p_curr->p_next;
    }
    //mdbg( "i_count=%d, i_cntup=%d, i_cntdw=%d\n", i_count, i_cntup, i_cntdw );
    if( i_count == 0 || i_count < 0 )
        return -1;

    snprintf( s_cmd, 255, "tc qdisc del dev %s root", ps_upif );
    bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );
    snprintf( s_cmd, 255, "tc qdisc del dev %s root", ps_downif );
    bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );

    pc_itf = ps_upif;
    pc_speed = ps_upspeed;
    i_cnt_speed = i_cntup;
    for( in_idx = 0; in_idx < 2; ++in_idx )
    {
        if( ( in_idx + 1 ) == 2 )
        {
            pc_itf = ps_downif;
            pc_speed = ps_dwspeed;
            i_cnt_speed = i_cntdw;
        }

        if( i_cnt_speed == 0 )
            continue;
        snprintf( s_cmd, 255, "tc qdisc add dev %s root handle %d: htb default %d",
            pc_itf, in_idx + 1, ( i_cnt_speed + 1 ) * 10 );
        bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );
        snprintf( s_cmd, 255, "tc class add dev %s parent %d:0 classid %d:1 htb rate %sbit burst 15k",
            pc_itf, in_idx + 1, in_idx + 1, pc_speed );
        bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );

        i_ridx = 1;
        ui_mark = in_idx << 8;
        p_curr = p_head;
        for( i = 0; ( i < i_total ) && ( p_curr != NULL ); ++i )
        {
            //mdbg( "index=%d, i=%d, i_ridx=%d, name=%s, up speed=%lu, down speed=%lu\n",
            //     in_idx + 1, i, i_ridx, p_curr->s_name, p_curr->ul_up_speed, p_curr->ul_dw_speed );
            if( p_curr->i_enable == 0 )
            {
                p_curr = p_curr->p_next;
                continue;
            }

            if( ( in_idx + 1 ) == 1 )
            {
                ul_speed = p_curr->ul_up_speed;
                if( ul_speed == 0 )
                {
                    p_curr = p_curr->p_next;
                    continue;
                }
            }

            if( ( in_idx + 1 ) == 2 )
            {
                ul_speed = p_curr->ul_dw_speed;
                if( ul_speed == 0 )
                {
                    p_curr = p_curr->p_next;
                    continue;
                }
            }

            snprintf( s_cmd, 255,
                "tc class add dev %s parent %d:1 classid %d:%d htb rate %lubit ceil %lubit burst 15k",
                pc_itf, in_idx + 1, in_idx + 1, i_ridx * 10, ul_speed, ul_speed );
            bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );

            snprintf( s_cmd, 255,
                "tc qdisc add dev %s parent %d:%d handle %d: sfq perturb 10",
                pc_itf, in_idx + 1, i_ridx * 10, i_ridx * 10 );
            bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );

            ui_mark = ui_mark & ~0xFF;
            ui_mark = ( ui_mark | i_ridx ) & 0xFFFF;
            snprintf( s_cmd, 255,
                "tc filter add dev %s parent %d:0 protocol ip prio %d handle 0x%04x fw classid %d:%d",
                pc_itf, in_idx + 1, p_curr->i_priority, ui_mark,
                in_idx + 1, i_ridx * 10 );
            bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );

            snprintf( s_cmd, 255, "iptables -t mangle -I FORWARD " );
            i_flag = 0;
            if( !strcmp( p_curr->s_protocol, "tcp" ) )
                strcat( s_cmd, "-p TCP " );
            else if( !strcmp( p_curr->s_protocol, "udp" ) )
                strcat( s_cmd, "-p UDP " );
            else
                i_flag = 1;

            if( strlen( p_curr->s_src_ip ) > 0
                && strcmp( p_curr->s_src_ip, "0.0.0.0" ) != 0 )
            {
                snprintf( ps_child_cmd, 32, "%s %s/%d ", sa_addr_s[ in_idx ],
                    p_curr->s_src_ip, p_curr->i_src_mask );
                strcat( s_cmd, ps_child_cmd );
            }

            if( p_curr->i_src_port > 0 && i_flag == 0 )
            {
                snprintf( ps_child_cmd, 32, "%s %d ",
                    sa_port_s[ in_idx ], p_curr->i_src_port );
                strcat( s_cmd, ps_child_cmd );
            }

            if( strlen( p_curr->s_dst_ip ) > 0
                && strcmp( p_curr->s_dst_ip, "0.0.0.0" ) != 0 )
            {
                snprintf( ps_child_cmd, 32, "%s %s/%d ", sa_addr_d[ in_idx ],
                    p_curr->s_dst_ip, p_curr->i_dst_mask );
                strcat( s_cmd, ps_child_cmd );
            }

            if( p_curr->i_dst_port > 0 && i_flag == 0 )
            {
                snprintf( ps_child_cmd, 32, "%s %d ",
                    sa_port_d[ in_idx ], p_curr->i_dst_port );
                strcat( s_cmd, ps_child_cmd );
            }

            snprintf( ps_child_cmd, 32, "-j MARK --set-mark 0x%04x", ui_mark );
            strcat( s_cmd, ps_child_cmd );
            bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );

            ++i_ridx;
            p_curr = p_curr->p_next;
        }

        snprintf( s_cmd, 255, "tc class add dev %s parent %d:1 classid %d:%d htb rate 10Mbit ceil 100Mbit burst 15k",
            pc_itf, in_idx + 1, in_idx + 1, i_ridx * 10 );
        bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );
        snprintf( s_cmd, 255, "tc qdisc add dev %s parent %d:%d handle %d: sfq perturb 10",
            pc_itf, in_idx + 1, i_ridx * 10, i_ridx * 10 );
        bcmSystemEx( s_cmd, QOS_RUlE_CMD_DEBUG );
    }

    qos_rule_free( p_head );

    return 0;
}

-------------------------NEED DELETE------------------------------*/
#if 1
static int ip_ctl_apply( void )
{
	doSystem("ip_qos");	// 2 > /dev/null");
}
#else
static int ip_ctl_apply( void )
{
    char *ps_rules = NULL;
    char as_rule_en[ 8 ] = { 0 };
    char as_ip_addr_begin[ 32 ] = { 0 };
    char as_ip_addr_end[ 32 ] = { 0 };
    char as_protocol[ 16 ] = { 0 };
    char as_up_bw_min[ 32 ] = { 0 };
    char as_up_bw_max[ 32 ] = { 0 };
    char as_down_bw_min[ 32 ] = { 0 };
    char as_down_bw_max[ 32 ] = { 0 };
    char as_rule[ 128 ] = { 0 }, *p_ch = NULL;
    char *pc_itf = NULL, *pc_speed = NULL, s_cmd[ 256 ] = { 0 };
    int i_form_port = 0, i_to_port = 0;
    int i = 0, i_ipctl_en = 0, i_ipctl_count = 0;
    int i_ret = 0, i_rule_en = 0;

    mdbg( "enter.\n" );
    i_ipctl_en = atoi( nvram_safe_get(  NVRAM_IPCTL_EN ) );
    mdbg( "i_ipctl_en=%d\n", i_ipctl_en );
    if( i_ipctl_en == 0 )
        return 0;

    i_ipctl_count = atoi( nvram_safe_get(  NVRAM_IPCTL_COUNT ) );
    mdbg( "i_ipctl_count=%d\n", i_ipctl_count );
    if( i_ipctl_count == 0 || i_ipctl_count < 0 )
        return 0;

    ps_rules = nvram_safe_get(  NVRAM_IPCTL_RULES );
    mdbg( "ps_rules=%s\n", ps_rules );
    if( ps_rules == NULL )
        return 0;

    mdbg( "explor rules.\n" );
    for( i = 0; i < i_ipctl_count; ++i )
    {
        i_ret = position( ps_rules, ';', i + 1, as_rule, sizeof( as_rule ) );
        if( i_ret < 0 )
            continue;

        p_ch = as_rule;
        while( *p_ch )
        {
            if( *p_ch == ',' )
                *p_ch = ' ';
            ++p_ch;
        }

        mdbg( "%d: %s\n", i + 1, as_rule );
        i_ret = sscanf( as_rule, "%s %s %s %d %d %s %s %s %s %s",
            as_rule_en, as_ip_addr_begin, as_ip_addr_end, &i_form_port,
            &i_to_port, as_protocol, as_up_bw_min, as_up_bw_max, as_down_bw_min,
            as_down_bw_max );
        mdbg( "i_ret=%d\n", i_ret );
        if( i_ret != 10 )
        {
            printf( "sscanf fail\n" );
            continue;
        }
        else
            printf( "explor:%s,%s,%s,%d,%d,%s,%s,%s,%s,%s\n",
                as_rule_en, as_ip_addr_begin, as_ip_addr_end, i_form_port,
                i_to_port, as_protocol, as_up_bw_min, as_up_bw_max, as_down_bw_min,
                as_down_bw_max );
    }

    return 0;
}
#endif

static void ip_ctl_mngr( webs_t wp, char_t *path, char_t *query )
{
    char *ps_del_act = NULL;
    char *pc_ch = NULL;
    char *ps_old_rules = NULL;
    const char *tmprules = NULL;
    char *ps_rule = NULL;
    char as_rule[ 128 ] = { 0 };
    char as_tmp[ 32 ] = { 0 };
    char c_del_mark[ IP_CTL_PROFILE_ENTRYS_MAX + 1 ] = { 0 };
    int i = 0, i_len = 0, i_ret = 0, i_tmp = 0;
    int i_rules_count = 0;

    mdbg( "enter.\n" );
    ps_del_act = websGetVar( wp, T( "ip_ctl_del_act" ), T( "0" ) );
    mdbg( "ip_ctl_del_act=%s\n", ps_del_act );
    i_rules_count = atoi( nvram_safe_get(  NVRAM_IPCTL_COUNT ) );
    if( i_rules_count < 0 )
        i_rules_count = 0;

    if( !strcmp( ps_del_act, "all" ) )
    {
        nvram_set(  NVRAM_IPCTL_RULES, "" );
        nvram_set(  NVRAM_IPCTL_COUNT, "0" );
	    nvram_commit(  );
    }
    else
    {
        tmprules = nvram_safe_get(  NVRAM_IPCTL_RULES );
        if( !tmprules || !strlen(tmprules) )
            goto jump_over;

        i_len = strlen( tmprules );
        ps_rule = malloc( i_len + 1 );
        if( ps_rule == NULL )
            goto jump_over;

        strcpy( ps_rule, tmprules );
        *( ps_rule + i_len ) = '\0';

        i_len = strlen( ps_del_act );
        strncpy( c_del_mark, ps_del_act, IP_CTL_PROFILE_ENTRYS_MAX );
        pc_ch = c_del_mark;
        for( i = 0; i < i_len; ++i )
        {
            if( i > IP_CTL_PROFILE_ENTRYS_MAX )
                break;

            if( *pc_ch == '1' )
            {
                ps_old_rules = ps_rule;

                i_ret = position( ps_old_rules, ';', i + 1, as_rule, sizeof( as_rule ) );
                if( i_ret < 0 )
                {
                    free( ps_rule ); /* ps_old_rules is equal to ps_rule. just need to free ps_rule. modified by radar. 2010.7.23 */
                    ps_rule = NULL;
                    goto jump_over;
                }

                if( ( i + 1 ) < i_rules_count )
                    strcat( as_rule, ";" );

                ps_rule = replace( ps_old_rules, as_rule, "");
                if( ps_rule == NULL )
                {
                    free( ps_old_rules );
                    goto jump_over;
                }
                --i_rules_count;
                free( ps_old_rules );

                i_tmp = strlen( ps_rule );
                if( ( ( i + 1 ) == i_len ) && ( *( ps_rule + i_tmp - 1 ) == ';' ) )
                    *( ps_rule + i_tmp - 1 ) = '\0';
            }

            ++pc_ch;
        }

        sprintf( as_tmp, "%d", i_rules_count );
        nvram_set( NVRAM_IPCTL_RULES, ps_rule );
        nvram_set( NVRAM_IPCTL_COUNT, as_tmp );
	    nvram_commit();
    }

    notification_send_rc( OID_SERVICE_QOS, NOTIFY_WAIT );

jump_over:
    if( ps_rule != NULL )
        free( ps_rule );
/*start of add ip control page and ip rules page together minpengwei 20111104*/
    //websRedirect( wp, "ip_rules.asp" );
	websRedirect( wp, "ip_control.asp" );
/*end of add ip control page and ip rules page together minpengwei 20111104*/
}

static void ip_ctl_rule( webs_t wp, char_t *path, char_t *query )
{
    char *ps_edit_en = NULL;
    char *ps_edit_idx = NULL;
    char *ps_rule_enable = NULL;
    char *ps_ip_addr_begin = NULL;
    char *ps_ip_addr_end = NULL;
    char *ps_form_port = NULL;
    char *ps_to_port = NULL;
    char *ps_protocol = NULL;
    char *ps_up_bw_min = NULL;
    char *ps_up_bw_max = NULL;
    char *ps_down_bw_min = NULL;
    char *ps_down_bw_max = NULL;
    const char *ps_old_rules = NULL;
    char *ps_rules = NULL;
    int i_rules_len = 0, i_len = 0;
    int i_rules_count = 0, i_ret = 0;
    int i_edit_en = 0;
    int i_edit_idx = 0;
    char as_rule[ 128 ] = { 0 }, as_old_rule[ 128 ] = { 0 };

    mdbg( "enter.\n" );
    ps_edit_en = websGetVar(wp, T("ip_ctl_edit_en"), T("0"));
    ps_edit_idx = websGetVar(wp, T("ip_ctl_edit_idx"), T("0"));
    mdbg( "ip_ctl_edit_en=%s, ip_ctl_edit_idx=%s\n",
        ps_edit_en, ps_edit_idx );

#define	EMPTY_STR_SET_TO_ZEROSTR(pstr)	do { if (0 == strlen(pstr))	(pstr) =  "0"; }while(0)

	ps_rule_enable = websGetVar(wp, T("rule_enable"), T("0"));
	ps_ip_addr_begin = websGetVar(wp, T("ip_addr_begin"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_ip_addr_begin);

	ps_ip_addr_end = websGetVar(wp, T("ip_addr_end"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_ip_addr_end);

	ps_form_port = websGetVar(wp, T("from_port"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_form_port);

	ps_to_port = websGetVar(wp, T("to_port"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_to_port);

	ps_protocol = websGetVar(wp, T("protocol"), T("?"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_protocol);

	ps_up_bw_min = websGetVar(wp, T("up_bw_min"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_up_bw_min);

	ps_up_bw_max = websGetVar(wp, T("up_bw_max"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_up_bw_max);

	ps_down_bw_min = websGetVar(wp, T("down_bw_min"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_down_bw_min);

	ps_down_bw_max = websGetVar(wp, T("down_bw_max"), T("0"));
	EMPTY_STR_SET_TO_ZEROSTR(ps_down_bw_max);

    ps_old_rules = nvram_safe_get(  NVRAM_IPCTL_RULES );
    if( ps_old_rules != NULL )
        i_rules_len = strlen( ps_old_rules );

    i_rules_count = atoi( nvram_safe_get(  NVRAM_IPCTL_COUNT ) );
    if( i_rules_count < 0 )
        i_rules_count = 0;

    i_edit_en = atoi( ps_edit_en );
    i_edit_idx = atoi( ps_edit_idx );

    snprintf( as_rule, sizeof( as_rule ) - 1, "%s,%s,%s,%s,%s,%s,%s,%s,%s,%s",
        ps_rule_enable, ps_ip_addr_begin, ps_ip_addr_end, ps_form_port,
        ps_to_port, ps_protocol, ps_up_bw_min, ps_up_bw_max, ps_down_bw_min,
        ps_down_bw_max );
    mdbg( "as_rule=%s\n", as_rule );

    if( i_edit_en > 0 )
    {
        if( i_rules_len == 0 )
            goto jump_over;


        i_ret = position((char *) ps_old_rules, ';', i_edit_idx + 1,
            as_old_rule, sizeof( as_old_rule ) );


        if( i_ret < 0 )
            goto jump_over;

        ps_rules = replace( (char *)ps_old_rules, as_old_rule, as_rule );
        if( ps_rules == NULL )
            goto jump_over;
    }
    else
    {
        ps_rules = ( char * )malloc( i_rules_len + 128 );
        if( ps_rules == NULL )
        {
            printf( "ip_ctl_rule: malloc fail.\n" );
            goto jump_over;
        }
        memset( ps_rules, 0, i_rules_len + 128 );
        if( i_rules_len > 0 )
        {
            strcpy( ps_rules, ps_old_rules );
            strcat( ps_rules, ";" );
        }
        strcat( ps_rules, as_rule );

        ++i_rules_count;
        sprintf( as_rule, "%d", i_rules_count );
        nvram_set(  NVRAM_IPCTL_COUNT, as_rule );
    }

    nvram_set( NVRAM_IPCTL_RULES, ps_rules );
	nvram_commit();

    notification_send_rc( OID_SERVICE_QOS, NOTIFY_WAIT );

	/* refresh rules */
jump_over:
    if( ps_rules != NULL )
        free( ps_rules );
//	 if( ps_old_rules != NULL && strcmp(ps_old_rules,""))
//        free( ps_old_rules );
/*start of add ip control page and ip rules page together minpengwei 20111104*/
	//websRedirect( wp, "ip_rules.asp" );
    websRedirect( wp, "ip_control.asp" );
/*end of add ip control page and ip rules page together minpengwei 20111104*/
}

static void ip_ctl_setup( webs_t wp, char_t *path, char_t *query )
{
	char *ps_en = NULL;
//	char *ps_wan_type = NULL;
	char *ps_up_bw = NULL;
	char *ps_up_down_bw = NULL;

    mdbg( "enter.\n" );
    ps_en = websGetVar( wp, T( "ip_ctl_select" ), T( "0" ) );
//	ps_wan_type = websGetVar( wp, T( "wan_type" ), T( "" ) );
	ps_up_bw = websGetVar( wp, T( "upload_band_width" ), T( "" ) );
	ps_up_down_bw = websGetVar( wp, T( "download_band_width" ), T( "" ) );

    mdbg( "ip_ctl_select=%s,wan_type=%s,upload_band_width=%s,download_band_width=%s",
        ps_en, "unknown"/*ps_wan_type*/, ps_up_bw, ps_up_down_bw );
	if( strncmp( ps_en, "0", 1 ) )
		ps_en = "1";
	nvram_set( NVRAM_IPCTL_EN, ps_en );
    nvram_set( NVRAM_IPCTL_UPBW, ps_up_bw );
    nvram_set( NVRAM_IPCTL_DOWNBW, ps_up_down_bw );
	nvram_commit();

	/* TODO: refresh your rule now... */
	notification_send_rc( OID_SERVICE_QOS, NOTIFY_WAIT );

	websRedirect( wp, "ip_control.asp" );
}

void form_define_ip_control( void )
{
    websFormDefine( T( "ip_ctl_mngr" ), ip_ctl_mngr );
    websFormDefine( T( "ip_ctl_rule" ), ip_ctl_rule );
    websFormDefine( T( "ip_ctl_setup" ), ip_ctl_setup );
}


