#include <stdlib.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <arpa/inet.h>
#include <asm/types.h>
#include <linux/if.h>
#include <linux/wireless.h>
#include <ctype.h>
#include <errno.h>
#include <notify.h>
#include <oid.h>
#include "linux/autoconf.h"
#include "config/autoconf.h" //user config
#include "user/busybox/include/autoconf.h" //busybox config

#include <sys/time.h>
#include <signal.h>
#include <sys/stat.h>
#include <fcntl.h>
/*start of add for mulitcast forwarding by zengxianzhu at 20110214*/
#include <dirent.h>
/*end of add for mulitcast forwarding by zengxianzhu at 20110214*/


#include <sys/types.h>
#include <sys/wait.h>
#include <oid.h>
#include <notify.h>

#ifdef USER_MANAGEMENT_SUPPORT
#include "um.h"
#endif
#include "bcmnvram.h"
#include "utils.h"
#include "webs.h"
#include "internet.h"
#include "wireless.h"

#include "management.h"
#include "wps.h"

#include "translate.h"
#include "sha1.h"

#define CMD_DEBUG          1

extern kw_t dictionary;
extern int login;
extern int logout;
void WPSRestart(void);
void formDefineWPS(void);
#if defined (CONFIG_RTDEV_MII) || defined (CONFIG_RTDEV_USB) || defined (CONFIG_RTDEV_PCI)
#ifndef CONFIG_UNIQUE_WPS
void RaixWPSRestart();
#endif
#endif

#ifdef HAVE_USER_SSL_CCMS_CLIENT	
static void SoftwareUpgradeSettings(webs_t wp, char_t *path, char_t *query);
static void SoftwareUpgradeCancel(webs_t wp, char_t *path, char_t *query);
#endif
static int getWizardBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int getPPPOECDBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int getWatchDogBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int getSnortBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int getLoginCheck(int eid, webs_t wp, int argc, char_t **argv);
/*start of add for check wan port plus in by zengxianzhu at 20111101*/
static int CheckWanPortConnect(int eid, webs_t wp, int argc, char_t **argv);
/*end of add for check wan port plus in by zengxianzhu at 20111101*/
#define COMMAND_MAX	1024
static char system_command[COMMAND_MAX];

#ifdef CONFIG_USER_WIZARD
#define LFW(x, y)	do { 	x = websGetVar(wp, T(#y), T("")); } while(0)
#define DHCPCONF(x, y, z)	do { 	strcpy(x, y);		\
					char *p = strrchr(x, '.');	\
					strcpy(p+1, #z);		\
				} while(0)
static void setWizard(webs_t wp, char_t *path, char_t *query)
{
	char_t *connectionType, *security_mode;
	char_t *staticIp, *staticNetmask, *staticGateway, *staticPriDns,
	       *staticSecDns;
	char_t *pppoeUser, *pppoePass, *pppoeOPMode, *pppoeRedialPeriod,
	       *pppoeIdleTime;
	char_t *l2tpServer, *l2tpUser, *l2tpPass, *l2tpMode, *l2tpIp,
	       *l2tpNetmask, *l2tpGateway, *l2tpOPMode, *l2tpRedialPeriod;
	char_t *pptpServer, *pptpUser, *pptpPass, *pptpMode, *pptpIp,
	       *pptpNetmask, *pptpGateway, *pptpOPMode, *pptpRedialPeriod;
	char_t *Dev3G;
	char_t *ssid, *security_key;
	char lan_ipaddr[16], dhcp_start[16], dhcp_end[16];

	strcpy(lan_ipaddr, nvram_safe_get( "lan_ipaddr"));
	DHCPCONF(dhcp_start, lan_ipaddr, 100);
	DHCPCONF(dhcp_end, lan_ipaddr, 200);
	doSystem("ralink_init clear 2860");
	doSystem("ralink_init renew 2860 /etc_ro/Wireless/RT2860AP/RT2860_default_vlan");

	LFW(connectionType, connectionType);
	LFW(staticIp, staticIp);
	LFW(staticNetmask, staticNetmask);
	LFW(staticGateway, staticGateway);
	LFW(staticPriDns, staticPriDns);
	LFW(staticSecDns, staticSecDns);
	LFW(pppoeUser, pppoeUser);
	LFW(pppoePass, pppoePass);
#ifndef CONFIG_USER_PPPOECD
	LFW(pppoeOPMode, pppoeOPMode);
	LFW(pppoeRedialPeriod, pppoeRedialPeriod);
	LFW(pppoeIdleTime, pppoeIdleTime);
#endif
	LFW(l2tpServer, l2tpServer);
	LFW(l2tpUser, l2tpUser);
	LFW(l2tpPass, l2tpPass);
	LFW(l2tpMode, l2tpMode);
	LFW(l2tpIp, l2tpIp);
	LFW(l2tpNetmask, l2tpNetmask);
	LFW(l2tpGateway, l2tpGateway);
	LFW(l2tpOPMode, l2tpOPMode);
	LFW(l2tpRedialPeriod, l2tpRedialPeriod);
	LFW(pptpServer, pptpServer);
	LFW(pptpUser, pptpUser);
	LFW(pptpPass, pptpPass);
	LFW(pptpMode, pptpMode);
	LFW(pptpIp, pptpIp);
	LFW(pptpNetmask, pptpNetmask);
	LFW(pptpGateway, pptpGateway);
	LFW(pptpOPMode, pptpOPMode);
	LFW(pptpRedialPeriod, pptpRedialPeriod);
	LFW(Dev3G, Dev3G);
	LFW(ssid, ssid);
	LFW(security_mode, security_mode);
	LFW(security_key, security_key);

	nvram_set( "wanConnectionMode", connectionType);
	if (!strncmp(connectionType, "STATIC", 7))
	{
		if (-1 == inet_addr(staticIp))
		{
			websError(wp, 200, "invalid IP Address");
			return;
		}
		/*
		 * lan and wan ip should not be the same
		 */
		if (!strncmp(staticIp, lan_ipaddr, 15))
		{
			websError(wp, 200, "IP address is identical to LAN");
			return;
		}
		nvram_set( "wan_ipaddr", staticIp);
		if (-1 == inet_addr(staticNetmask))
		{
			websError(wp, 200, "invalid Subnet Mask");
			return;
		}
		nvram_set( "wan_netmask", staticNetmask);
		nvram_set( "wan_gateway", staticGateway);
		nvram_set( "wan_primary_dns", staticPriDns);
		nvram_set( "wan_secondary_dns", staticSecDns);
	}
	else if (!strncmp(connectionType, "PPPOE", 6))
	{
		char_t *pppoe_optime;

		if (0 == strcmp(pppoeOPMode, "OnDemand"))
			pppoe_optime = pppoeRedialPeriod;
		else
			pppoe_optime = pppoeIdleTime;
		nvram_set( "wan_pppoe_user", pppoeUser);
		nvram_set( "wan_pppoe_pass", pppoePass);
		nvram_set( "wan_pppoe_opmode", pppoeOPMode);
		nvram_set( "wan_pppoe_optime", pppoe_optime);
	}
	else if (!strncmp(connectionType, "L2TP", 5))
	{
		nvram_set( "wan_l2tp_server", l2tpServer);
		nvram_set( "wan_l2tp_user", l2tpUser);
		nvram_set( "wan_l2tp_pass", l2tpPass);
		nvram_set( "wan_l2tp_mode", l2tpMode);
		nvram_set( "wan_l2tp_opmode", l2tpOPMode);
		nvram_set( "wan_l2tp_optime", l2tpRedialPeriod);
		if (!strncmp(l2tpMode, "0", 2))
		{
			nvram_set( "wan_l2tp_ip", l2tpIp);
			nvram_set( "wan_l2tp_netmask", l2tpNetmask);
			nvram_set( "wan_l2tp_gateway", l2tpGateway);
		}
	}
	else if (!strncmp(connectionType, "PPTP", 5))
	{
		nvram_set( "wan_pptp_server", pptpServer);
		nvram_set( "wan_pptp_user", pptpUser);
		nvram_set( "wan_pptp_pass", pptpPass);
		nvram_set( "wan_pptp_mode", pptpMode);
		nvram_set( "wan_pptp_opmode", pptpOPMode);
		nvram_set( "wan_pptp_optime", pptpRedialPeriod);
		if (!strncmp(pptpMode, "0", 2))
		{
			nvram_set( "wan_pptp_ip", pptpIp);
			nvram_set( "wan_pptp_netmask", pptpNetmask);
			nvram_set( "wan_pptp_gateway", pptpGateway);
		}
	}
	else if (!strncmp(connectionType, "3G", 3))
	{
		nvram_set( "wan_3g_dev", Dev3G);
	}
	nvram_set( "lan_ipaddr", lan_ipaddr);
	nvram_set( "dhcp_start", dhcp_start);
	nvram_set( "dhcp_end", dhcp_end);
	nvram_set( "dhcp_gateway", lan_ipaddr);
	nvram_set( "lltdEnabled", "1");
	nvram_set( "upnp_enabled", "1");

	if (0 == strlen(ssid))
	{
		websError(wp, 403, T("'SSID' should not be empty!!!"));
		return;
	}
	nvram_set( "SSID1", ssid);	
	nvram_set( "AuthMode", security_mode);
	if (!strcmp(security_mode, "WEPAUTO"))
	{
		nvram_set( "EncrypType", "WEP");
		nvram_set( "DefaultKeyID", "1");
		if (10 == strlen(security_key) || 26 == strlen(security_key))
			nvram_set( "Key1Type", "0"); 	// HEX
		else if (5 == strlen(security_key) || 13 == strlen(security_key))
			nvram_set( "Key1Type", "1");	// ASCII
		nvram_set( "Key1Str1", security_key);
	}
	else if (!strcmp(security_mode, "WPAPSKWPA2PSK"))
	{
		nvram_set( "EncrypType", "TKIPAES");
		nvram_set( "DefaultKeyID", "2");
		nvram_set( "RekeyInterval", "3600");
		nvram_set( "RekeyMethod", "TIME");
		nvram_set( "IEEE8021X", "0");
		nvram_set( "WPAPSK1", security_key);
	}
	else
	{
		nvram_set( "EncrypType", "NONE");
	}

	nvram_commit();

	//debug print
	websHeader(wp);
	websWrite(wp, T("<h2>Wizard Web Debug</h2><br>\n"));
	websWrite(wp, T("connectionType: %s<br>\n"), connectionType);
	websWrite(wp, T("staticIp: %s<br>\n"), staticIp);
	websWrite(wp, T("staticNetmask: %s<br>\n"), staticNetmask);
	websWrite(wp, T("staticGateway: %s<br>\n"), staticGateway);
	websWrite(wp, T("staticPriDns: %s<br>\n"), staticPriDns);
	websWrite(wp, T("staticSecDns: %s<br>\n"), staticSecDns);
	websWrite(wp, T("pppoeUser: %s<br>\n"), pppoeUser);
	websWrite(wp, T("pppoePass: %s<br>\n"), pppoePass);
	websWrite(wp, T("pppoeOPMode: %s<br>\n"), pppoeOPMode);
	websWrite(wp, T("pppoeRedialPeriod: %s<br>\n"), pppoeRedialPeriod);
	websWrite(wp, T("pppoeIdleTime: %s<br>\n"), pppoeIdleTime);
	websWrite(wp, T("l2tpServer: %s<br>\n"), l2tpServer);
	websWrite(wp, T("l2tpUser: %s<br>\n"), l2tpUser);
	websWrite(wp, T("l2tpPass: %s<br>\n"), l2tpPass);
	websWrite(wp, T("l2tpMode: %s<br>\n"), l2tpMode);
	websWrite(wp, T("l2tpIp: %s<br>\n"), l2tpIp);
	websWrite(wp, T("l2tpNetmask: %s<br>\n"), l2tpNetmask);
	websWrite(wp, T("l2tpGateway: %s<br>\n"), l2tpGateway);
	websWrite(wp, T("l2tpOPMode: %s<br>\n"), l2tpOPMode);
	websWrite(wp, T("l2tpRedialPeriod: %s<br>\n"), l2tpRedialPeriod);
	websWrite(wp, T("pptpServer: %s<br>\n"), pptpServer);
	websWrite(wp, T("pptpUser: %s<br>\n"), pptpUser);
	websWrite(wp, T("pptpPass: %s<br>\n"), pptpPass);
	websWrite(wp, T("pptpMode: %s<br>\n"), pptpMode);
	websWrite(wp, T("pptpIp: %s<br>\n"), pptpIp);
	websWrite(wp, T("pptpNetmask: %s<br>\n"), pptpNetmask);
	websWrite(wp, T("pptpGateway: %s<br>\n"), pptpGateway);
	websWrite(wp, T("pptpOPMode: %s<br>\n"), pptpOPMode);
	websWrite(wp, T("pptpRedialPeriod: %s<br>\n"), pptpRedialPeriod);
	websWrite(wp, T("Dev3G: %s<br>\n"), Dev3G);
	websWrite(wp, T("<br>\n"));
	websWrite(wp, T("security_mode: %s<br>\n"), security_mode);
	websWrite(wp, T("ssid: %s<br>\n"), ssid);
	websWrite(wp, T("security_key: %s<br>\n"), security_key);
	websFooter(wp);
	websDone(wp, 200);

	sleep(3);
	doSystem("killall goahead;goahead &");
}
#endif

#if (defined CONFIG_RALINK_WATCHDOG || defined CONFIG_RALINK_WATCHDOG_MODULE) && defined CONFIG_USER_WATCHDOG
static void WatchDogRestart(void)
{
	doSystem("killall -9 watchdog 1>/dev/null 2>&1");
	doSystem("rmmod ralink_wdt.o");
	if (strcmp(nvram_get( "WatchDogEnable"), "1") == 0) {
		doSystem("insmod ralink_wdt.o");
		doSystem("wdg.sh");
		doSystem("watchdog");
	}
}
#endif


#ifdef HAVE_EMAIL
/*
 * goform/SendEmail, add by liugang, 20130311
 */
static void SendEmail(webs_t wp, char_t *path, char_t *query)
{
	char_t *send_ser, *send_addr, *send_usr, *send_passwd;
	char_t *to_addr, *subject, *message;

	send_ser = websGetVar(wp, T("mailser"), T(""));
	send_addr = websGetVar(wp, T("sendaddr"), T(""));
	send_usr = websGetVar(wp, T("senduser"), T(""));
	send_passwd = websGetVar(wp, T("sendpasswd"), T(""));
	to_addr = websGetVar(wp, T("sendtoaddr"), T(""));
	subject = websGetVar(wp, T("subject"), T(""));
	message = websGetVar(wp, T("message"), T(""));

	nvram_set( "EmailServer", send_ser);
	nvram_set( "EsendAddr", send_addr);
	nvram_set( "EsendUser", send_usr);
	nvram_set( "EsendPassword", send_passwd);
	nvram_set( "EtoAddress", to_addr);
	nvram_set( "Esubject", subject);
	nvram_set( "Emessage", message);
	nvram_commit();
	
#if 0
	doSystem("rm -f /etc/msmtprc");
	doSystem("touch /etc/msmtprc");
	doSystem("echo logfile /var/msmtp.log >> /etc/msmtprc");
	doSystem("echo host %s >> /etc/msmtprc", send_ser);
	doSystem("echo from %s >> /etc/msmtprc", send_addr);
	doSystem("echo auth login >> /etc/msmtprc");	
	doSystem("echo user %s >> /etc/msmtprc", send_usr);
	doSystem("echo password %s >> /etc/msmtprc", send_passwd);

	doSystem("rm -f /var/notic_mail");
	doSystem("touch /var/notic_mail");
	doSystem("echo To:  %s >> /var/notic_mail", to_addr);
	doSystem("echo From:  %s >> /var/notic_mail", send_addr);
	doSystem("echo Subject:  %s >> /var/notic_mail", subject);
	doSystem("echo  >> /var/notic_mail");
	doSystem("echo %s >> /var/notic_mail", message);

	doSystem("msmtp %s < /var/notic_mail", to_addr);
#endif	
//	websRedirect(wp, "adm/E-mail.asp");
	websRedirect(wp, "E-mail.asp");

	return;
}
#endif

/*
 * goform/setSysAdm
 */
static void setSysAdm(webs_t wp, char_t *path, char_t *query)
{
	char_t *admuser, *admpass;
	char *old_user;
    char_t *telnetd;

    char old_user_name[64] = {0};
    char user_name[64] = {0};
    char user_passwd[64] = {0};
    strncpy(old_user_name, nvram_safe_get("http_username"), sizeof(old_user_name)-1);
	old_user = old_user_name;

	admuser = websGetVar(wp, T("admuser"), T(""));
	admpass = websGetVar(wp, T("admpass"), T(""));
    telnetd = websGetVar(wp, T("nTelnet"), T(""));

    if ( 0 == strcmp(telnetd, "1"))
    {
        system("telnetd");
        return 0;
    }

	if (!strlen(admuser)) {
		error(E_L, E_LOG, T("setSysAdm: account empty, leave it unchanged"));
		return;
	}
	if (!strlen(admpass)) {
		error(E_L, E_LOG, T("setSysAdm: password empty, leave it unchanged"));
		return;
	}
	nvram_set( "http_username", admuser);
	nvram_set( "http_passwd", admpass);

    nvram_set( "sysadm_set", "1");

#if (defined CONFIG_RALINK_WATCHDOG || defined CONFIG_RALINK_WATCHDOG_MODULE) && defined CONFIG_USER_WATCHDOG
	char_t *watchdogcap;
	watchdogcap = websGetVar(wp, T("admwatchdog"), T(""));
	nvram_set( "watch_dog_enable", watchdogcap);
#endif

	nvram_commit();

#if (defined CONFIG_RALINK_WATCHDOG || defined CONFIG_RALINK_WATCHDOG_MODULE) && defined CONFIG_USER_WATCHDOG
	notification_send_rc( OID_SYSTEM_WATCHDOG, NOTIFY_WAIT );
#endif
    notification_send_rc( OID_SYSTEM_ADMIN, NOTIFY_WAIT );

    login=0;
    logout=1;

    strncpy(user_name, nvram_safe_get("http_username"), sizeof(user_name)-1);
    websDecode64(user_passwd, nvram_safe_get("http_passwd"), sizeof(user_passwd));
    admuser = user_name;
    admpass = user_passwd;

#ifdef USER_MANAGEMENT_SUPPORT
	if (umGroupExists(T("adm")) == FALSE)
		umAddGroup(T("adm"), 0x07, AM_DIGEST, FALSE, FALSE);
	if (old_user != NULL && umUserExists(old_user))
		umDeleteUser(old_user);
	if (umUserExists(admuser))
		umDeleteUser(admuser);
	umAddUser(admuser, admpass, T("adm"), FALSE, FALSE);
#endif


#ifdef	GOAHEAD_SHOWSUBMITINFO
	websHeader(wp);
	websWrite(wp, T("<h2>Adminstrator Settings</h2><br>\n"));
	websWrite(wp, T("adm user: %s<br>\n"), admuser);
	websWrite(wp, T("adm pass: %s<br>\n"), admpass);
    #if (defined CONFIG_RALINK_WATCHDOG || defined CONFIG_RALINK_WATCHDOG_MODULE) && defined CONFIG_USER_WATCHDOG
	websWrite(wp, T("adm watchdog: %s<br>\n"), watchdogcap);
    #endif
	websFooter(wp);
	websDone(wp, 200);
#else
	jsGoPage(wp, "/login.asp");
#endif
}

/*
 * goform/test_ate
 */
static void test_ate(webs_t wp, char_t *path, char_t *query)
{
	char_t *ated;
    char_t *telnetd;

	ated = websGetVar(wp, T("nAte"), T(""));
    telnetd = websGetVar(wp, T("nTelnet"), T(""));

    if ( 0 == strcmp(telnetd, "1"))
    {
        system("telnetd");
    }

     if ( 0 == strcmp(ated, "1"))
    {
        system("ated");
    }

    websRedirect(wp, "test_ate.asp");
    
    return 0;
}

/*
 * goform/setSysLang
 */
static void setSysLang(webs_t wp, char_t *path, char_t *query)
{
	char_t *lang;

	lang = websGetVar(wp, T("langSelection"), T(""));
	nvram_set( "Language", lang);
	nvram_commit();

#ifdef	GOAHEAD_SHOWSUBMITINFO
	websHeader(wp);
	websWrite(wp, T("<h2>Language Selection</h2><br>\n"));
	websWrite(wp, T("language: %s<br>\n"), lang);
	websFooter(wp);
	websDone(wp, 200);
#else
	websRedirect(wp, "adm/management.asp");
#endif
}

/*
 * goform/setLanguage
 */
static void setLanguage(webs_t wp, char_t *path, char_t *query)
{
	char_t language[64] = {0};

	sscanf(query, "%63s", language);
    printf( "%s:%d->language=%s\n", __FUNCTION__, __LINE__, language );
	if ( strlen(language) ) {	 // TODO: check the language string is valid and exist Language. (like: English, Chinese etc.)
		nvram_set( "Language", language);
/* If user specify the language, use it until the system is restored .      by wwb 2013-10-31 */
		nvram_set( "auto_language", "0");
		nvram_set( "user_language", "1"); 
		nvram_commit();		
/* End of  If user specify the language, use it until the system is restored .      by wwb 2013-10-31 */
	    load_dictionary (language, &dictionary);
    }
    websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));
	websDone(wp, 200);
	return;
}

 void louout(void)
	{

		nvram_set( "logout_flag", "1");
		nvram_commit();

	}


void stopTimerlog(void)
{
	struct itimerval value, ovalue;

	value.it_value.tv_sec = 0;
	value.it_value.tv_usec = 0;
	value.it_interval.tv_sec = 0;
	value.it_interval.tv_usec = 0;
	setitimer(ITIMER_REAL, &value, &ovalue);
}

int setTimerlog(unsigned long microsec, void ((*sigroutine)(int)))
{
	struct itimerval value, ovalue;

	signal(SIGALRM, sigroutine);
	value.it_value.tv_sec = 0;
	value.it_value.tv_usec = microsec;
	value.it_interval.tv_sec = 0;
	value.it_interval.tv_usec = microsec;
	return setitimer(ITIMER_REAL, &value, &ovalue);
}


/* start of add by zhengshan 2011/3/1 */
extern void getSysUpTime(long *saveUpTime);
extern long last_access_time;
/* end of add by zhengshan 2011/3/1 */

static int getLoginCheck(int eid,webs_t wp,int argc,char_t * * argv)
{
    char result[8] = {0};
    strncpy(result, nvram_safe_get("logincheck"), sizeof(result)-1);
    nvram_set("logincheck","1");
    nvram_commit();
    return websWrite(wp, T("%s"), result);
}

/*start of add for check wan port plus in by zengxianzhu at 20111101*/
static int CheckWanPortConnect(int eid,webs_t wp,int argc,char_t * * argv)
{
        if(is_phyconnected() >0)
	{
		return websWrite(wp, T("1"));
	}
	else
	{
		return websWrite(wp, T("0"));
	}
}
/*end of add for check wan port plus in by zengxianzhu at 20111101*/


/*
 * goform/formLogin
 */

static void formLogin(webs_t wp, char_t *path, char_t *query)
{
	char_t *user_name, *pass_word;
	const char_t *username_old, *password_old;
	char_t *language;
	const char_t *sysadm_set,*language_old;

    char en_user_name[64] = {0};
    char en_user_passwd[64] = {0};
    char web_user_name[64] = {0};
    char web_user_passwd[64] = {0};

	nvram_set( "auto_language", "0");   //After login, disabled auto_language
    nvram_commit();
    //printf( "%s:%d-> formLogin XXXXXXXXXXXXXXXX\n", __FUNCTION__, __LINE__);
		
    strncpy(en_user_name, nvram_safe_get("http_username"), sizeof(en_user_name)-1);
    websDecode64(en_user_passwd, nvram_safe_get("http_passwd"), sizeof(en_user_passwd));

	username_old = en_user_name;
	password_old = en_user_passwd;

	language_old = nvram_safe_get( "Language");
	sysadm_set = nvram_safe_get( "sysadm_set");

	user_name = websGetVar(wp, T("username"), T(""));
	pass_word = websGetVar(wp, T("password"), T(""));
	language = websGetVar(wp, T("Language"), T("Chinese"));

    strncpy(web_user_name, user_name, sizeof(web_user_name)-1);
    websDecode64(web_user_passwd, pass_word, sizeof(web_user_passwd));
	user_name = web_user_name;
	pass_word = web_user_passwd;

#ifdef DEFINE_PHONE_WEB
		char_t *pc;
		char_t *phone;
	
		pc = websGetVar(wp, T("nPC"), T(""));
		phone = websGetVar(wp, T("nPhone"), T(""));
#endif


	if (!strcmp(sysadm_set,"0")||(!strcmp(sysadm_set,"1")&&!strcmp(username_old, user_name)&&!strcmp(password_old, pass_word)))
	{
		login=1;
		logout=0;
#ifdef HAVE_WEB_CNS
		websRedirect(wp, "status.asp");
#else
#ifndef DEFINE_PHONE_WEB
		printf( "login index.\n" );
        websRedirect(wp, "index.asp");
#else //for webapp
	    if ( 0 == strcmp(pc, "1"))
	    {
	        websRedirect(wp, "index.asp");
	    }
	    if ( 0 == strcmp(phone, "1"))
	    {
	        websRedirect(wp, "phonesetting.asp");
	    }
#endif
	
#endif
		if(0 != strcmp(language_old, language)){
			nvram_set( "Language", language);
			nvram_commit();
			load_dictionary (language, &dictionary);
		}
		/* start of add by zhengshan 2011/3/1 */
        getSysUpTime(&last_access_time);
        /* end of add by zhengshan 2011/3/1 */
	}
	else
	{
	    nvram_set("logincheck","0");
        nvram_commit();
	   	websRedirect(wp, "login.asp");
	}
}

/*
 * goform/NTP
 */
static void NTP(webs_t wp, char_t *path, char_t *query)
{
	char *tz, *ntpServer, *ntpSync;
	char *ntpSecServer;

	tz = websGetVar(wp, T("time_zone"), T(""));
	ntpServer = websGetVar(wp, T("NTPServerIP"), T(""));
	ntpSecServer = websGetVar(wp, T("NTPSecServerIP"), T("0.0.0.0"));
	ntpSync = websGetVar(wp, T("NTPSync"), T("1"));

	if(!tz || !ntpServer || !ntpSync)
		goto END;

	if(!strlen(tz))
		goto END;

	if(checkSemicolon(tz))
		goto END;

	if(!strlen(ntpServer)){
		// user choose to make  NTP server disable
		nvram_set( "NTPServerIP", "");
		nvram_set( "NTPSecServerIP", "");
		nvram_set( "NTPSync", "");
	}else{
		if(checkSemicolon(ntpServer))
			goto END;
		if(!strlen(ntpSync))
			goto END;
		if(atoi(ntpSync) > 300)
			goto END;
		nvram_set( "NTPServerIP", ntpServer);
		nvram_set( "NTPSecServerIP", ntpSecServer);
		nvram_set( "NTPSync", "1");
	}
	nvram_set( "time_zone", tz);
	nvram_commit();


	notification_send_rc( OID_TIMER, NOTIFY_WAIT );

END:
	websRedirect(wp, "sys_time.asp");
}

#ifdef CONFIG_DATE
/*
 * Update kernel timezone
 * By zym 04-06-2011
 */
static void set_timezone(void)
{
	time_t now;
	struct tm gm, local;
    int i_ret = 0;
	struct timezone tz;

    printf( "set_timezone: Update kernel timezone.\n" );
	/* Update kernel timezone */
	time(&now);
	gmtime_r(&now, &gm);
	localtime_r(&now, &local);
	tz.tz_minuteswest = (mktime(&gm) - mktime(&local)) / 60;
	i_ret = settimeofday(NULL, &tz);
    if( i_ret < 0 )
        printf( "set_timezone: Update fail.\n" );
    else
        printf( "set_timezone: Update successful.\n" );
}


/*
 * goform/NTPSyncWithHost
 */
static void NTPSyncWithHost(webs_t wp, char_t *path, char_t *query)
{
	time_t usecs;
	char buf[12],temp[12];
	FILE *fp;
	int totaltime;
	if(!query || (!strlen(query)))
		return;
	if(strchr(query, ';'))
		return;

	doSystem("date -s \"%s\"", query);

    set_timezone(); /* Add for update kernel timezone by zym 04-06-2011 */

	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));
	websWrite(wp, T("n/a"));
	websDone(wp, 200);
}
#endif

#ifdef CONFIG_USER_GOAHEAD_GreenAP
/*
 * goform/GreenAP
 */
static void GreenAP(webs_t wp, char_t *path, char_t *query)
{
	char_t *shour1, *sminute1, *ehour1, *eminute1, *action1;
	char_t *shour2, *sminute2, *ehour2, *eminute2, *action2;
	char_t *shour3, *sminute3, *ehour3, *eminute3, *action3;
	char_t *shour4, *sminute4, *ehour4, *eminute4, *action4;
	char start[6], end[6];
	shour1 = websGetVar(wp, T("GAPSHour1"), T(""));
	sminute1 = websGetVar(wp, T("GAPSMinute1"), T(""));
	ehour1 = websGetVar(wp, T("GAPEHour1"), T(""));
	eminute1 = websGetVar(wp, T("GAPEMinute1"), T(""));
	action1 = websGetVar(wp, T("GAPAction1"), T(""));
	sprintf(start, "%s %s", sminute1, shour1);
	sprintf(end, "%s %s", eminute1, ehour1);
	nvram_set( "GreenAPStart1", start);
	nvram_set( "GreenAPEnd1", end);
	nvram_set( "GreenAPAction1", action1);
	shour2 = websGetVar(wp, T("GAPSHour2"), T(""));
	sminute2 = websGetVar(wp, T("GAPSMinute2"), T(""));
	ehour2 = websGetVar(wp, T("GAPEHour2"), T(""));
	eminute2 = websGetVar(wp, T("GAPEMinute2"), T(""));
	action2 = websGetVar(wp, T("GAPAction2"), T(""));
	sprintf(start, "%s %s", sminute2, shour2);
	sprintf(end, "%s %s", eminute2, ehour2);
	nvram_set( "GreenAPStart2", start);
	nvram_set( "GreenAPEnd2", end);
	nvram_set( "GreenAPAction2", action2);
	shour3 = websGetVar(wp, T("GAPSHour3"), T(""));
	sminute3 = websGetVar(wp, T("GAPSMinute3"), T(""));
	ehour3 = websGetVar(wp, T("GAPEHour3"), T(""));
	eminute3 = websGetVar(wp, T("GAPEMinute3"), T(""));
	action3 = websGetVar(wp, T("GAPAction3"), T(""));
	sprintf(start, "%s %s", sminute3, shour3);
	sprintf(end, "%s %s", eminute3, ehour3);
	nvram_set( "GreenAPStart3", start);
	nvram_set( "GreenAPEnd3", end);
	nvram_set( "GreenAPAction3", action3);
	shour4 = websGetVar(wp, T("GAPSHour4"), T(""));
	sminute4 = websGetVar(wp, T("GAPSMinute4"), T(""));
	ehour4 = websGetVar(wp, T("GAPEHour4"), T(""));
	eminute4 = websGetVar(wp, T("GAPEMinute4"), T(""));
	action4 = websGetVar(wp, T("GAPAction4"), T(""));
	sprintf(start, "%s %s", sminute4, shour4);
	sprintf(end, "%s %s", eminute4, ehour4);
	nvram_set( "GreenAPStart4", start);
	nvram_set( "GreenAPEnd4", end);
	nvram_set( "GreenAPAction4", action4);
	nvram_commit();

	doSystem("greenap.sh init");

    #ifdef WEB_DEBUG
	websHeader(wp);
	websWrite(wp, T("GreenAPStart1: %s %s<br>\n"), sminute1, shour1);
	websWrite(wp, T("GreenAPEnd1: %s %s<br>\n"), eminute1, ehour1);
	websWrite(wp, T("GreenAPAction1: %s<br>\n"), action1);
	websWrite(wp, T("GreenAPStart2: %s %s<br>\n"), sminute2, shour2);
	websWrite(wp, T("GreenAPEnd2: %s %s<br>\n"), eminute2, ehour2);
	websWrite(wp, T("GreenAPAction2: %s<br>\n"), action2);
	websWrite(wp, T("GreenAPStart3: %s %s<br>\n"), sminute3, shour3);
	websWrite(wp, T("GreenAPEnd3: %s %s<br>\n"), eminute3, ehour3);
	websWrite(wp, T("GreenAPAction3: %s<br>\n"), action3);
	websWrite(wp, T("GreenAPStart4: %s %s<br>\n"), sminute4, shour4);
	websWrite(wp, T("GreenAPEnd4: %s %s<br>\n"), eminute4, ehour4);
	websWrite(wp, T("GreenAPAction4: %s<br>\n"), action4);
	websFooter(wp);
	websDone(wp, 200);
	#else
	websRedirect(wp, "adm/management.asp.asp");
	#endif
}
#endif

#ifdef HAVE_DDNS
void * safe_malloc (size_t size) {
	void * retval = NULL;
	retval = malloc(size);
	if (!retval) {
		exit(1);
	}
	return (retval);
}

char *request_freedns(char *user, char *password)
{
	unsigned char final[32];
	char un[128];

	unlink("/tmp/.hash");
	sprintf(un, "%s|%s", user, password);
	sha1_ctx_t context;

	sha1_begin(&context);
	sha1_hash(un, strlen(un), &context);
	sha1_end(final, &context);
	char request[128] = { 0 };
	int i;

	for (i = 0; i < 20; i++)
		sprintf(request, "%s%02x", request, final[i]);
	doSystem("rm -f /tmp/.hash");
	sysprintf
	    ("wget \"http://freedns.afraid.org/api/?action=getdyndns&sha=%s\" -O /tmp/.hash",
	     request);
	FILE *in = fopen("/tmp/.hash", "rb");

	if (in == NULL)
		return NULL;
	while (getc(in) != '?' && feof(in) == 0) ;
	i = 0;
	char *hash = safe_malloc(64);

	if (feof(in)) {
		free(hash);
		return NULL;
	}
	for (i = 0; i < 36; i++)
		hash[i] = getc(in);
	fclose(in);
	hash[i++] = 0;
	return hash;
}

/*
 * goform/DDNS
 */
static void DDNS(webs_t wp, char_t *path, char_t *query)
{
	char *ddns_provider, *ddns, *ddns_acc, *ddns_pass;
	char empty_char = '\0';

	ddns_provider = websGetVar(wp, T("DDNSProvider"), T("none"));
	ddns = websGetVar(wp, T("DDNS"), T(""));
	ddns_acc = websGetVar(wp, T("Account"), T(""));
	ddns_pass = websGetVar(wp, T("Password"), T(""));

	if(!ddns_provider || !ddns || !ddns_acc || !ddns_pass)
		return;

	if(!strcmp(T("none"), ddns_provider )){
		ddns = ddns_acc = ddns_pass = &empty_char;
	}else{
		if(!strlen(ddns) || !strlen(ddns_acc) || !strlen(ddns_pass))
			return;
	}

	if(checkSemicolon(ddns) || checkSemicolon(ddns_acc) || checkSemicolon(ddns_pass))
		return;

	nvram_set( "ddns_provider", ddns_provider);
	nvram_set( "ddns_account", ddns_acc);
	nvram_set( "ddns_password", ddns_pass);
	
	if(!strcmp(ddns_provider,"freedns.afraid.org"))
	{
		char hostn[128];
		char *hash = request_freedns(ddns_acc, ddns_pass);
	
		if (hash) {
			sprintf(hostn, "%s,%s", ddns, hash);
			nvram_set("ddns", hostn);
			free(hash);
		} else {
			nvram_set("ddns", ddns);
		}
  }
  else
  {
		nvram_set( "ddns", ddns);
  }
	
	nvram_commit();

//	doSystem("ddns.sh");
	notification_send_rc(OID_SERVICE_DDNS, NOTIFY_WAIT);

#ifdef	GOAHEAD_SHOWSUBMITINFO
	websHeader(wp);
	websWrite(wp, T("<h2>DDNS Settings</h2><br>\n"));
	websWrite(wp, T("DDNSProvider: %s<br>\n"), ddns_provider);
	websWrite(wp, T("DDNS: %s<br>\n"), ddns);
	websWrite(wp, T("DDNSAccount: %s<br>\n"), ddns_acc);
	websWrite(wp, T("DDNSPassword: %s<br>\n"), ddns_pass);
	websFooter(wp);
	websDone(wp, 200);
#else
	websRedirect(wp, "ddns.asp");
#endif
}
#endif

#ifdef CONFIG_USER_SNORT
/*
 * goform/Snort
 */
static void Snort(webs_t wp, char_t *path, char_t *query)
{
	char *snort_enable_str;
	int snort_enable;

	snort_enable_str = websGetVar(wp, T("SnortSelect"), T("0"));
	if(!snort_enable_str)
		return;

	snort_enable = atoi(snort_enable_str);
	if(snort_enable == 1)
		nvram_set( "SnortEnable", "1");
	else
		nvram_set( "SnortEnable", "0");
	nvram_commit();

	doSystem("snort.sh");

	websHeader(wp);
	websWrite(wp, T("<h2>Snort Settings</h2><br>\n"));
	websWrite(wp, T("Snort: %s<br>\n"), snort_enable ? "Enable" : "Disable");
	websFooter(wp);
	websDone(wp, 200);
}
#endif

static void SystemCommand(webs_t wp, char_t *path, char_t *query)
{
	char *command;

	command = websGetVar(wp, T("command"), T(""));

	if(!command)
		return;

	if(!strlen(command))
		snprintf(system_command, COMMAND_MAX, "cat /dev/null > %s", SYSTEM_COMMAND_LOG);
	else
		snprintf(system_command, COMMAND_MAX, "%s 1>%s 2>&1", command, SYSTEM_COMMAND_LOG);

	if(strlen(system_command))
		doSystem(system_command);

//	websRedirect(wp, "adm/system_command.asp");
	websRedirect(wp, "sys_cmd.asp");

	return;
}

static void repeatLastSystemCommand(webs_t wp, char_t *path, char_t *query)
{
	if(strlen(system_command))
		doSystem(system_command);

//	websRedirect(wp, "adm/system_command.asp");
	websRedirect(wp, "sys_cmd.asp");

	return;
}


int showSystemCommandASP(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	char buf[1024];

	fp = fopen(SYSTEM_COMMAND_LOG, "r");
	if(!fp){
		websWrite(wp, T(""));
		return 0;
	}

	while(fgets(buf, 1024, fp)){
		websWrite(wp, T("%s"), buf);
	}
	fclose(fp);

	return 0;
}

static inline char *strip_space(char *str)
{
	while( *str == ' ')
		str++;
	return str;
}


char* getField(char *a_line, char *delim, int count)
{
	int i=0;
	char *tok;
	tok = strtok(a_line, delim);
	while(tok){
		if(i == count)
			break;
        i++;
		tok = strtok(NULL, delim);
    }
    if(tok && isdigit(*tok))
		return tok;

	return NULL;
}

/*
 *   C version. (ASP version is below)
 */
static long long getIfStatistic(char *interface, int type)
{
	int found_flag = 0;
	int skip_line = 2;
	char buf[1024], *field, *semiColon = NULL;
	FILE *fp = fopen(PROC_IF_STATISTIC, "r");
	if(!fp){
		printf("no proc?\n");
		return -1;
	}

	while(fgets(buf, 1024, fp)){
		char *ifname;
		if(skip_line != 0){
			skip_line--;
			continue;
		}
		if(! (semiColon = strchr(buf, ':'))  )
			continue;
		*semiColon = '\0';
		ifname = buf;
		ifname = strip_space(ifname);

		if(!strcmp(ifname, interface)){
			found_flag = 1;
			break;
		}
	}
	fclose(fp);

	/* using found_flag. by radar. 2010.8.17 */
	if ( !found_flag )
		return 0L;

	semiColon++;

	switch(type){
	case TXBYTE:
		if(  (field = getField(semiColon, " ", 8))  ){
			return strtoll(field, NULL, 10);
		}
		break;
	case TXPACKET:
		if(  (field = getField(semiColon, " ", 9))  ){
			return strtoll(field, NULL, 10);
		}
		break;
	case RXBYTE:
		if(  (field = getField(semiColon, " ", 0))  ){
			return strtoll(field, NULL, 10);
		}
		break;
	case RXPACKET:
		if(  (field = getField(semiColon, " ", 1))  ){
			return strtoll(field, NULL, 10);
		}
		break;
	}
	return -1;
}

/*
 *     getIfStatistic()   ASP version
 */
int getIfStatisticASP(int eid, webs_t wp, int argc, char_t **argv)
{
	int found_flag = 0;
	int skip_line = 2;
	char *interface, *type, *field, *semiColon = NULL;
	char buf[1024], result[32];
	FILE *fp = fopen(PROC_IF_STATISTIC, "r");
	if(!fp){
		websWrite(wp, T("no proc?\n"));
		return -1;
	}

    if(ejArgs(argc, argv, T("%s %s"), &interface, &type) != 2){
		websWrite(wp, T("Wrong argument.\n"));
        return -1;
    }

	while(fgets(buf, 1024, fp)){
		char *ifname;
		if(skip_line != 0){
			skip_line--;
			continue;
		}
		if(! (semiColon = strchr(buf, ':'))  )
			continue;
		*semiColon = '\0';
		ifname = buf;
		ifname = strip_space(ifname);

		if(!strcmp(ifname, interface)){
			found_flag = 1;
			break;
		}
	}
	fclose(fp);

	semiColon++;

	if(!strcmp(type, T("TXBYTE")  )){
		if(  (field = getField(semiColon, " ", 8))  ){
			snprintf(result, 32,"%lld",   strtoll(field, NULL, 10));
			ejSetResult(eid, result);
		}
	}else if(!strcmp(type, T("TXPACKET")  )){
		if(  (field = getField(semiColon, " ", 9))  ){
			snprintf(result, 32,"%lld",   strtoll(field, NULL, 10));
			ejSetResult(eid, result);
		}
    }else if(!strcmp(type, T("RXBYTE")  )){
		if(  (field = getField(semiColon, " ", 0))  ){
			snprintf(result, 32,"%lld",   strtoll(field, NULL, 10));
			ejSetResult(eid, result);
		}
    }else if(!strcmp(type, T("RXPACKET")  )){
		if(  (field = getField(semiColon, " ", 1))  ){
			snprintf(result, 32,"%lld",   strtoll(field, NULL, 10));
			ejSetResult(eid, result);
		}
    }else{
		websWrite(wp, T("unknown type.") );
		return -1;
	}
	return -1;
}

int getWANRxByteASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic(getWanIfNamePPP(), RXBYTE); //( getWanIfName(), RXBYTE);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"), buf);
	return 0;
}

int getWANRxPacketASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic(getWanIfNamePPP(), RXPACKET); //( getWanIfName(), RXPACKET);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"), buf);
	return 0;
}

int getWANTxByteASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic(getWanIfNamePPP(), TXBYTE); //( getWanIfName(), TXBYTE);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"), buf);
	return 0;
}

int getWANTxPacketASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic(getWanIfNamePPP(), TXPACKET); //( getWanIfName(), TXPACKET);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"), buf);
	return 0;
}

int getLANRxByteASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic( getLanIfName(), RXBYTE);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"), buf);
	return 0;
}

int getLANRxPacketASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic( getLanIfName(), RXPACKET);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"), buf);
	return 0;
}

int getLANTxByteASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic( getLanIfName(), TXBYTE);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"), buf);
	return 0;
}

int getLANTxPacketASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[32] = {0};
	long long data = getIfStatistic( getLanIfName(), TXPACKET);
	snprintf(buf, 32, "%lld", data);
	websWrite(wp, T("%s"),buf);
	return 0;
}

/*
 * This ASP function is for javascript usage, ex:
 *
 * <script type="text/javascript">
 *   var a = new Array();
 *   a = [<% getAllNICStatisticASP(); %>];         //ex: a = ["lo","10","1000", "20", "2000","eth2"];
 *   document.write(a)
 * </script>
 *
 * Javascript could get info with  getAllNICStatisticASP().
 *
 * We dont produce table-related tag in this ASP function .It's
 * more extensive since ASP just handle data and Javascript present them,
 * although the data form is only for Javascript now.
 *
 * TODO: a lot, there are many ASP functions binding with table-relted tag...
 */
int getAllNICStatisticASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char result[1024];
	char buf[1024];
	int rc = 0, pos = 0, skip_line = 2;
	int first_time_flag = 1;
	FILE *fp = fopen(PROC_IF_STATISTIC, "r");
	if(!fp){
		printf("no proc?\n");
		return -1;
	}

	while(fgets(buf, 1024, fp)){
		char *ifname, *semiColon;
		if(skip_line != 0){
			skip_line--;
			continue;
		}
		if(! (semiColon = strchr(buf, ':'))  )
			continue;
		*semiColon = '\0';

		ifname = buf;
		ifname = strip_space(ifname);

		/* try to get statistics data */
		if(getIfStatistic(ifname, RXPACKET) >= 0){
			/* a success try */
			if(first_time_flag){
				pos = snprintf(result+rc, 1024-rc, "\"%s\"", ifname);
				rc += pos;
				first_time_flag = 0;
			}else{
				pos = snprintf(result+rc, 1024-rc, ",\"%s\"", ifname);
				rc += pos;
			}

		}else	/* failed and just skip */
			continue;

		pos = snprintf(result+rc, 1024-rc, ",\"%lld\"", getIfStatistic(ifname, RXPACKET));
		rc += pos;
		pos = snprintf(result+rc, 1024-rc, ",\"%lld\"", getIfStatistic(ifname, RXBYTE));
		rc += pos;
		pos = snprintf(result+rc, 1024-rc, ",\"%lld\"", getIfStatistic(ifname, TXPACKET));
		rc += pos;
		pos = snprintf(result+rc, 1024-rc, ",\"%lld\"", getIfStatistic(ifname, TXBYTE));
		rc += pos;
	}
	fclose(fp);

	websWrite(wp, T("%s"), result);
    return 0;
}

/*
*	get 3G Traffic Statistics
*	add by wwb 20140513
*/
//#define PORT_3G  "ppp0"


static int get3GFlowASP(int eid, webs_t wp, int argc, char_t **argv)
{

	const char *ppp0_rx_file = "/sys/class/net/ppp0/statistics/rx_bytes" ;
	const char *ppp0_tx_file = "/sys/class/net/ppp0/statistics/tx_bytes" ;
	FILE* fp;
	char str_rx[32] = {0};
	char str_tx[32] = {0};
	
	char result[1024];
	char buf[64];
	int rc = 0, pos = 0;
	char buf0[256];
  

	static float rxbyte = 0.00, txbyte = 0.00;
	static float rxbyte_day = 0, txbyte_day = 0;
	static float rxbyte_month = 0, txbyte_month = 0;		
	static char rxunit[2] = "KB", txunit[2] = "KB";
	static char rxdayunit[2] = "KB", txdayunit[2] = "KB";
	static char rxmonthunit[2] = "KB", txmonthunit[2] = "KB";
	
	if ((fp=fopen(ppp0_rx_file, "r"))==NULL){
   		printf("open ppp0_rx_file file error\n");
		goto open_err;
   	}
   	fgets(str_rx, sizeof(str_rx), fp);
   	fclose(fp);

   	if ((fp=fopen(ppp0_tx_file, "r"))==NULL){
   		printf("open ppp0_tx_file file error\n");
		goto open_err;
   	}
   	fgets(str_tx, sizeof(str_tx), fp);
   	fclose(fp);
	
	
	rxbyte=atof(str_rx);
	txbyte=atof(str_tx);


	/*start of rxbyte/txbyte unit conversion*/
	rxbyte = rxbyte/1024; //KB
	txbyte = txbyte/1024; //KB
	
	
	if( rxbyte > 1024 * 1024 )
	{
		rxbyte /= (1024*1024);
		strcpy(rxunit,"GB");
	}
	else if ( rxbyte > 1024 )
	{
		rxbyte /= 1024;
		strcpy(rxunit,"MB");
	}
	else
	{
		strcpy(rxunit,"KB");			
	}
	if( txbyte > 1024 * 1024 )
	{
		txbyte /= (1024*1024);
		strcpy(txunit,"GB");
	}
	else if ( txbyte > 1024 )
	{
		txbyte /= 1024;
		strcpy(txunit,"MB");
	}
	else
	{
		strcpy(txunit,"KB");			
	}
	/*end of  rxbyte/txbyte unit conversion*/

	/*start of rx_day_data/tx_day_data unit conversion*/
	rxbyte_day = (float)atoi(nvram_safe_get("rx_day_data"))/1024; //KB
	txbyte_day = (float)atoi(nvram_safe_get("tx_day_data"))/1024; //KB

	//printf("rxbyte_day = %.2f \n",rxbyte_day);
	//printf("txbyte_day = %.2f \n",txbyte_day);
	
	if( rxbyte_day > 1024 * 1024 )
	{
		rxbyte_day /= (1024*1024);
		strcpy(rxdayunit,"GB");
	}
	else if ( rxbyte_day > 1024 )
	{
		rxbyte_day /= 1024;
		strcpy(rxdayunit,"MB");
	}
	else
	{
		strcpy(rxdayunit,"KB");			
	}
	if( txbyte_day > 1024 * 1024 )
	{
		txbyte_day /= (1024*1024);
		strcpy(txdayunit,"GB");
	}
	else if ( txbyte_day > 1024 )
	{
		txbyte_day /= 1024;
		strcpy(txdayunit,"MB");
	}
	else
	{
		strcpy(txdayunit,"KB");			
	}
	/*end of  rxbyte_day/txbyte_day unit conversion*/

	/*start of rx_day_data/tx_day_data unit conversion*/
	rxbyte_month = atof(nvram_safe_get("rx_month_data"))/1024; //KB
	txbyte_month = atof(nvram_safe_get("tx_month_data"))/1024; //KB

	//printf("rxbyte_month = %.2f \n",rxbyte_month);
	//printf("txbyte_month = %.2f \n",txbyte_month);
	
	if( rxbyte_month > 1024 * 1024 )
	{
		rxbyte_month /= (1024*1024);
		strcpy(rxmonthunit,"GB");
	}
	else if ( rxbyte_month > 1024 )
	{
		rxbyte_month /= 1024;
		strcpy(rxmonthunit,"MB");
	}
	else
	{
		strcpy(rxmonthunit,"KB");			
	}
	if( txbyte_month > 1024 * 1024 )
	{
		txbyte_month /= (1024*1024);
		strcpy(txmonthunit,"GB");
	}
	else if ( txbyte_month > 1024 )
	{
		txbyte_month /= 1024;
		strcpy(txmonthunit,"MB");
	}
	else
	{
		strcpy(txmonthunit,"KB");			
	}
	/*end of  rxbyte_day/txbyte_day unit conversion*/
				


open_err:

	pos = snprintf(result+rc, 1024-rc, ",\"%.2f %s\"", rxbyte,rxunit);
	rc += pos;

	pos = snprintf(result+rc, 1024-rc, ",\"%s\"", nvram_safe_get("rx_rate_3g"));
	rc += pos;
	pos = snprintf(result+rc, 1024-rc, ",\"%.2f %s\"", txbyte,txunit);
	rc += pos;
	pos = snprintf(result+rc, 1024-rc, ",\"%s\"", nvram_safe_get("tx_rate_3g"));
	rc += pos;
	pos = snprintf(result+rc, 1024-rc, ",\"%.2f %s\"", rxbyte_day,rxdayunit);
	rc += pos;
	pos = snprintf(result+rc, 1024-rc, ",\"%.2f %s\"", txbyte_day,txdayunit);
	rc += pos;
	pos = snprintf(result+rc, 1024-rc, ",\"%.2f %s\"", rxbyte_month,rxmonthunit);
	rc += pos;
	pos = snprintf(result+rc, 1024-rc, ",\"%.2f %s\"", txbyte_month,txmonthunit);
	rc += pos;		

	//printf("result = %s \n",result);
	websWrite(wp, T("%s"), result);
    return 0;
}


int getMemTotalASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[1024], *semiColon, *key, *value;
	FILE *fp = fopen(PROC_MEM_STATISTIC, "r");
	if(!fp){
		websWrite(wp, T("no proc?\n"));
		return -1;
	}

	while(fgets(buf, 1024, fp)){
		if(! (semiColon = strchr(buf, ':'))  )
			continue;
		*semiColon = '\0';
		key = buf;
		value = semiColon + 1;
		if(!strcmp(key, "MemTotal")){
			value = strip_space(value);
			websWrite(wp, T("%s"), value);
			fclose(fp);
			return 0;
		}
	}
	websWrite(wp, T(""));
	fclose(fp);

	return -1;
}

int getCurrentTimeASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t buf[64];
	FILE *fp = popen("date", "r");
	if(!fp){
		websWrite(wp, T("none"));
		return 0;
	}
	fgets(buf, 64, fp);
	pclose(fp);

	websWrite(wp, T("%s"), buf);
	return 0;

}

int getMemLeftASP(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[1024], *semiColon, *key, *value;
	FILE *fp = fopen(PROC_MEM_STATISTIC, "r");
	if(!fp){
		websWrite(wp, T("no proc?\n"));
		return -1;
	}

	while(fgets(buf, 1024, fp)){
		if(! (semiColon = strchr(buf, ':'))  )
			continue;
		*semiColon = '\0';
		key = buf;
		value = semiColon + 1;
		if(!strcmp(key, "MemFree")){
			value = strip_space(value);
			websWrite(wp, T("%s"), value);
			fclose(fp);
			return 0;
		}
	}
	websWrite(wp, T(""));
	fclose(fp);
	return -1;
}

/*start of add for curlѻ״̬ʾ by wangjian at 20111018*/
int getDOWNload_Received(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[8];
	char bufdest[7] = {0};
	char info[32] = {0};
	char retu[2] = {'0'};
	char bufsrc[1024] = {0};
	FILE *fp = fopen(TMP_PROGRESS, "r");
	if (!fp) {
		printf("no /tmp/progressinfo");
		snprintf(buf, 8, "%s", retu);
		websWrite(wp, T("%s"), buf);
		return 0;
	}
	while(fgets(bufsrc, 100, fp)) {
		strncpy(bufdest, &bufsrc[14], 6);
		snprintf(buf, 8, "%s", bufdest);
		websWrite(wp, T("%s"), buf);
	}
	
	return 0;
}

int getDOWNload_Total(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[8];
	char bufdest[7] = {0};
	char info[32] = {0};
	char retu[2] = {'0'};
	char bufsrc[1024] = {0};
	FILE *fp = fopen(TMP_PROGRESS, "r");
	if (!fp) {
		printf("no /tmp/progressinfo");
		snprintf(buf, 8, "%s", retu);
		websWrite(wp, T("%s"), buf);
		return 0;
	}
	while(fgets(bufsrc, 100, fp)) {
		strncpy(bufdest, &bufsrc[4], 6);
		snprintf(buf, 8, "%s", bufdest);
		websWrite(wp, T("%s"), buf);
	}

	return 0;
}

int getDOWNload_speed(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[8];
	char bufdest[7] = {0};
	char info[32] = {0};
	char retu[2] = {'0'};
	char bufsrc[1024] = {0};
	FILE *fp = fopen(TMP_PROGRESS, "r");
	if (!fp) {
		printf("no /tmp/progressinfo");
		snprintf(buf, 8, "%s", retu);
		websWrite(wp, T("%s"), buf);
		return 0;
	}
	while(fgets(bufsrc, 100, fp)) {
		strncpy(bufdest, &bufsrc[70], 6);
		snprintf(buf, 8, "%s", bufdest);
		websWrite(wp, T("%s"), buf);
	}

	return 0;
}

int getDOWNload_Percent(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[6];
	char bufdest[6] = {0};
	char info[32] = {0};
	char retu[2] = {'0'};
	char bufsrc[1024] = {0};
	FILE *fp = fopen(TMP_PROGRESS, "r");
	if (!fp) {
		printf("no /tmp/progressinfo");
		snprintf(buf, 6, "%s", retu);
		websWrite(wp, T("%s"), buf);
		return retu;
	}
	while(fgets(bufsrc, 100, fp)) {
		strncpy(bufdest, &bufsrc[0], 4);
		snprintf(buf, 6, "%s", bufdest);
		websWrite(wp, T("%s"), buf);
	}

	return 0;
}

int getDOWNload_spent(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[12];
	char bufdest[11] = {0};
	char info[32] = {0};
	char retu[2] = {'0'};
	char bufsrc[1024] = {0};
	FILE *fp = fopen(TMP_PROGRESS, "r");
	if (!fp) {
		printf("no /tmp/progressinfo");
		snprintf(buf, 12, "%s", retu);
		websWrite(wp, T("%s"), buf);
		return 0;
	}
	while(fgets(bufsrc, 100, fp)) {
		strncpy(bufdest, &bufsrc[51], 10);
		snprintf(buf, 12, "%s", bufdest);
		websWrite(wp, T("%s"), buf);
	}

	return 0;
}
/*end of add for curlѻ״̬ʾ by wangjian at 20111018*/

static int FirmwareUpgradePostASP(int eid, webs_t wp, int argc, char_t **argv)
{
#if 0
	FILE *fp;
	char ver[128], week[32], mon[32] , date[32], time[32], *pos;

	char *expect = nvram_safe_get( "Expect_Firmware");
	if(!expect || !strlen(expect) )
		return 0;

	fp = fopen("/proc/version", "r");
	if(!fp)
		return 0;

	fgets(ver, 128, fp);
	fclose(fp);

	if(!(pos = strchr(ver, '#')) )
		return 0;

	if(!(pos = strchr(pos+1, ' ')) )
		return 0;

	pos++;
	sscanf(pos, "%s %s %s %s", week, mon, date, time);
	sprintf(ver, "Linux Kernel Image %s%s%s", mon, date, time);

	if(!strcmp(expect, ver)){
		websWrite(wp, T("alert(\"Firmware Upgrade Success.\");"));
		nvram_set( "Expect_Firmware", "");
		nvram_commit();
	}else{
		websWrite(wp, T("alert(\"Firmware Upgrade may be failed:\\nexpect new image : %s\\ncurrent : %s\");"), expect, ver);
	}
	return 0;
#endif
	FILE *fp;
	char buf[512];
	const char *old_firmware = nvram_safe_get( "old_firmware");
	if(!old_firmware || !strlen(old_firmware) )
		return 0;
	fp = fopen("/proc/version", "r");
	if(!fp)
		return 0;

	fgets(buf, sizeof(buf), fp);
	fclose(fp);
	if(!strcmp(buf, old_firmware)){
		websWrite(wp, T("alert(\"Warning!The firmware didn't change.\");"));
	}else{
		websWrite(wp, T("alert(\"Firmware Upgrade success\");"));
	}
	nvram_set( "old_firmware", "");
	nvram_commit();

	return 0;
}

#define REFRESH_TIMEOUT		"80000"		/* 40000 = 40 secs*/
/*
 * I'm too lazy to use popen() instead of system()....
 * ( note:  static buffer used)
 */
#define DEFAULT_LAN_IP "192.168.1.1"
char *getLanIP(void)
{
	static char buf[64];
	char *nl;
	FILE *fp;

	memset(buf, 0, sizeof(buf));
	if( (fp = popen("nvram get lan_ipaddr", "r")) == NULL )
		goto error;

	if(!fgets(buf, sizeof(buf), fp)){
		pclose(fp);
		goto error;
	}

	if(!strlen(buf)){
		pclose(fp);
		goto error;
	}
	pclose(fp);

	nl = strchr(buf, '\n');
	if( nl != NULL )
		*nl = '\0';

	return buf;

error:
	fprintf(stderr, "warning, cant find lan ip\n");
	return DEFAULT_LAN_IP;
}

void javascriptReload(webs_t wp, int success, char *timeout_ms)
{
    websWrite(wp, T("<script language=\"JavaScript\" type=\"text/javascript\">\n"));
    if(success){
        websWrite(wp, T(" \
function refresh_all(){	\
  location.href = \"http://%s/home.asp\"; \
} \
function update(){ \
  self.setTimeout(\"refresh_all()\", %s);\
}\n"), getLanIP(), timeout_ms);
    }else{
        websWrite(wp, T("function update(){ parent.menu.setUnderFirmwareUpload(0);}\n"));
    }
    websWrite(wp, T("</script>\n"));
}

void javascriptReloadwirelsee(webs_t wp, int success, char *timeout_ms)
{
    websWrite(wp, T("<script language=\"JavaScript\" type=\"text/javascript\">\n"));
    if(success){
        websWrite(wp, T(" \
function refresh_all(){	\
  top.view.location.href = \"http://%s/wireless/basic.asp\"; \
} \
function update(){ \
  self.setTimeout(\"refresh_all()\", %s);\
}\n"), getLanIP(), timeout_ms);
    }else{
        websWrite(wp, T("function update(){ parent.menu.setUnderFirmwareUpload(0);}\n"));
    }
    websWrite(wp, T("</script>\n"));
}


void javascriptUpdate(webs_t wp, int success)
{
	javascriptReload(wp, success, REFRESH_TIMEOUT);
}

static void LoadDefaultSettings(webs_t wp, char_t *path, char_t *query)
{
	websWrite(wp, T("HTTP/1.0 200 OK\n"));

    nvram_set( "restore_defaults", "1" );
    nvram_commit();

    do_system( "restoredefault", CMD_DEBUG );
	do_system( "reboot", CMD_DEBUG );
}

#ifdef HAVE_USER_SSL_CCMS_CLIENT
static void SoftwareUpgradeSettings(webs_t wp, char_t *path, char_t *query)
{
	//cpe_SoftwareUpgrade();
	dprintf("####come here1.\n");
	nvram_set("cpeUpgradeByWEB", "1");	
	nvram_set("upgrade_process", "1");
}

static void SoftwareUpgradeCancel(webs_t wp, char_t *path, char_t *query)
{
	dprintf("####come here2.\n");
	nvram_set("upgrade_process", "");
	nvram_set("auto_upgrade_reboot", "");
	nvram_set("cpeUpgradeByWEB", "");
	nvram_commit();
}

#endif

/*
 * callee must free memory.
 */
/*
static char *getLog(char *filename)
{
	FILE *fp;
	struct stat filestat;
	char *log;

	if(stat(filename, &filestat) == -1)
		return NULL;

//	printf("%d\n", filestat.st_size);
	log = (char *)malloc(sizeof(char) * (filestat.st_size + 1) );
	if(!log)
		return NULL;

	if(!(fp = fopen(filename, "r"))){
		return NULL;
	}

	if( fread(log, 1, filestat.st_size, fp) != filestat.st_size){
		printf("read not enough\n");
		free(log);
		return NULL;
	}

	log[filestat.st_size] = '\0';

	fclose(fp);
	return log;
}
*/

#if defined CONFIG_LOGREAD && defined CONFIG_KLOGD
static void clearlog(webs_t wp, char_t *path, char_t *query)
{
	const char *value;
    const char *syslogip; 
	doSystem("killall -q klogd");
	doSystem("killall -q syslogd");

	value = nvram_safe_get( "remotesyslog");
    if ( strlen(value) )
    {
        syslogip = nvram_safe_get( "syslogIp");
        doSystem("syslogd -C8 -R %s 1>/dev/null 2>&1", syslogip);
    }
    else
    {
        doSystem("syslogd -C8 1>/dev/null 2>&1");
    }
	doSystem("klogd 1>/dev/null 2>&1");

	websRedirect(wp, "sys_syslog.asp");
}
#endif

#define LOG_MAX (16384)
static void syslog(webs_t wp, char_t *path, char_t *query)
{
	FILE *fp = NULL;
	char *log;

	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));

	fp = popen("logread", "r");
	if(!fp){
		websWrite(wp, "-1");
		goto error;
	}

	log = malloc(LOG_MAX * sizeof(char));
	if(!log){
		websWrite(wp, "-1");
		goto error;
	}
	memset(log, 0, LOG_MAX);
	fread(log, 1, LOG_MAX, fp);
	websLongWrite(wp, log);

	free(log);
error:
	if(fp)
		pclose(fp);
	websDone(wp, 200);
}

/* add by yeyingke 20090219 */
int getSyslogIp(int eid, webs_t wp, int argc, char_t **argv)
{
	const char *value;

	value = nvram_safe_get( "syslogIp");
	return websWrite(wp, T("%s"), value);
}

int getremotelog(int eid, webs_t wp, int argc, char_t **argv)
{
	const char *value;

	value = nvram_safe_get( "remotesyslog");

	if (!strcmp(value, ""))
			return websWrite(wp, T("0"));

	return websWrite(wp, T("%s"), value);
}

static void syslogapply(webs_t wp, char_t *path, char_t *query)
{
      char_t * pSyslogIp = NULL;
      char_t * pRemotesyslog = NULL;

      pSyslogIp = websGetVar(wp, T("syslogIp"), T(""));
      pRemotesyslog = websGetVar(wp, T("remotesyslog"), T(""));

      nvram_set( "syslogIp", pSyslogIp);
      nvram_set( "remotesyslog", pRemotesyslog);
      nvram_commit();
      
#if defined CONFIG_LOGREAD && defined CONFIG_KLOGD
      clearlog(wp, path, query);
#endif
}

/* end add yeyingke 20090219*/
void management_init(void)
{
	const char *value; /*add by yeyingke 20090219*/
	doSystem("ntp.sh");
#ifdef CONFIG_USER_GOAHEAD_GreenAP
    	doSystem("greenap.sh init");
#endif
	doSystem("ddns.sh");
	WPSRestart();
	sleep(3);
#if defined (CONFIG_RTDEV_MII) || defined (CONFIG_RTDEV_USB) || defined (CONFIG_RTDEV_PCI)
#ifndef CONFIG_UNIQUE_WPS
	RaixWPSRestart();
#endif
#endif
#if defined CONFIG_RALINK_WATCHDOG|CONFIG_RALINK_WATCHDOG_MODULE && defined CONFIG_USER_WATCHDOG
	WatchDogRestart();
#endif

	doSystem("killall -q klogd");
	doSystem("killall -q syslogd");
/*change by yeyingke 20090219*/
#if 0  /*original*/
	doSystem("syslogd -C8 1>/dev/null 2>&1");
#endif
	value = nvram_safe_get( "remotesyslog");
       if ( strlen(value) )
       {
           value = nvram_safe_get( "syslogIp");
           doSystem("syslogd -C8 -R %s 1>/dev/null 2>&1", value);
       }
       else
       {
           doSystem("syslogd -C8 1>/dev/null 2>&1");
       }

	doSystem("klogd 1>/dev/null 2>&1");
}

void management_fini(void)
{
	doSystem("killall -q klogd");
	doSystem("killall -q syslogd");
}

static int getGAPBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_USER_GOAHEAD_GreenAP
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

/* add and change by radar. 2010.7.1 */
#define	DIAGNOSIS_FILE		"/tmp/diagnosis"

/* clear process and file */
static void clearDiagnosis(void)
{
	killProcByName("ping");
	killProcByName("traceroute");
	unlink(DIAGNOSIS_FILE);
}

/* user manual cancel diagnosis */
static void cancelDiagnosis( webs_t wp, char_t *path, char_t *query)
{
	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));
	clearDiagnosis();
	websDone(wp, 200);
}

/*
description:
check DIAGNOSIS_FILE and read from the special offset.
if succeed, return one line buf to page;
or else, return strin 'end'.
*/
static void updateDiagnosisResult( webs_t wp, char_t *path, char_t *query)
{
	FILE *fp = NULL;
	char *offset_str = NULL;
	char buf[1024] = {0};
	long offset;
	long file_size = 0;
    int i = 0;
	
	offset_str = websGetVar(wp, T("ResultOffset"), "0");
	offset = atol(offset_str);

	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));

	fp = fopen(DIAGNOSIS_FILE, "r");
	if(!fp){
		websWrite(wp, T("end")); /* string 'end' means: let page Ajax know status. */
		websDone(wp, 200);
		return;
	}

	fseek(fp, 0, SEEK_END);
	file_size = ftell(fp);
	fseek(fp, offset, SEEK_SET);

	/* result print to page. */
	if (file_size > offset){
		if ( 0 < fgets(buf, sizeof(buf)-1 , fp) ) {
			printf("L%d, %s", __LINE__, buf);
			websWrite(wp, T("%s"), buf);
		}
	}

	fclose(fp);
	websDone(wp, 200);

	return;
}

/* check parameters, if ok, clear current diagnosis process, and diagnose.  */
static void Diagnosis(webs_t wp, char_t *path, char_t *query)
{
	char *host = NULL;
	char *diag_type = NULL;
	char *send_num = NULL;
	char *pack_size = NULL;
	char *over_time = NULL;
	char *rou_hops = NULL;
	int send_pack_size = 0;
	char cmdbuf[1024] = {0};
	char flgCmdOk = 0;

	host = websGetVar(wp, T("pingAddr"), "0.0.0.0");
	diag_type = websGetVar(wp, T("doType"), "0");
	send_num = websGetVar(wp, T("sendNum"), "4");
	pack_size = websGetVar(wp, T("pSize"), "64");
	over_time = websGetVar(wp, T("overTime"), "10");
	rou_hops = websGetVar(wp, T("trHops"), "20");

	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));
	/* check host */
	if ( !strcmp(host, "0.0.0.0") ) {
		goto DIAG_ERROR;
	}

	switch(diag_type[0]){
		case '0':
			if (pack_size != NULL)
				send_pack_size = atoi(pack_size);

			if ( 0 < send_pack_size ) {
/*start of change diagnosis minpengwei 20120525 */
/*
				snprintf(cmdbuf, sizeof(cmdbuf) -1,
					"ping -c %s -s %d -W %s %s > %s",
					send_num, send_pack_size, over_time, host,
					DIAGNOSIS_FILE);
 */
	snprintf(cmdbuf, sizeof(cmdbuf) -1,
		"ping -c %s -s %d -W %s %s > %s 2>&1; sleep 1;rm %s",
		send_num, send_pack_size, over_time, host, DIAGNOSIS_FILE, DIAGNOSIS_FILE);
/*
/*end of change diagnosis minpengwei 20120525 */
				flgCmdOk = 1;
			}
			break;
		case '1':
/*start of change diagnosis minpengwei 20120525 */
/*
			snprintf(cmdbuf, sizeof(cmdbuf) -1, "traceroute -m %s %s > %s", rou_hops, host,
				DIAGNOSIS_FILE);
*/
			snprintf(cmdbuf, sizeof(cmdbuf) -1, "traceroute -m %s %s > %s 2>&1; sleep 1; rm %s", rou_hops, host,	DIAGNOSIS_FILE, DIAGNOSIS_FILE);
/*end of change diagnosis minpengwei 20120525 */
			flgCmdOk = 1;
			break;
		default:
			goto DIAG_ERROR;
	}

	if (flgCmdOk){
		clearDiagnosis();
/*start of change diagnosis minpengwei 20120525 */
		//doSystembk("%s; sleep 1; rm -f %s", cmdbuf, DIAGNOSIS_FILE);
		doSystembk(cmdbuf);
/*end of change diagnosis minpengwei 20120525 */
	}
	//doSystem("cat %s >> /dev/consle",DIAGNOSIS_FILE);
	websDone(wp, 200);
	return;

DIAG_ERROR:
	printf("Error: Parameter is invalid\n");
	websDone(wp, -200);
	return;

}
/* End add and change by radar. 2010.7.1 */

static int getUpnpPmList(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	char pmList[1024] = {0};
	char *temp;


	fp = fopen("/tmp/pmlist", "r");
	if (NULL == fp)
		return websWrite(wp, T(""));

	fread(pmList, 1, sizeof(pmList), fp);

	if( strlen(pmList) > 0 )
	{
		temp = strrchr(pmList, '|');
		*temp = '\0';
		websWrite(wp, T("%s"), pmList);
	}
	else
	{
		fclose(fp);
		return websWrite(wp, T(""));
	}

	fclose(fp);
	return 0;
}
/*start of add for mulitcast forwarding by zengxianzhu at 20110214*/
static void remove_delimitor( char *s)
{
    char *p1, *p2;

    p1 = p2 = s;
    while ( *p1 != '\0' || *(p1+1) != '\0') {
        if (*p1 != '\0') {
           *p2 = *p1;
           p2++;
         }
         p1++;
    }
    *p2='\0';

}
/* find_pid_by_name()
 *
 *  This finds the pid of the specified process.
 *  Currently, it's implemented by rummaging through
 *  the proc filesystem.
 *
 *  Returns a list of all matching PIDs
 */
static pid_t* find_pid_by_name( char* pidName)
{
        DIR *dir;
        struct dirent *next;
        pid_t* pidList=NULL;
        int i=0;

        /*FILE *status */
        FILE *cmdline;
        char filename[128];
        char buffer[128];
        /* char name[READ_BUF_SIZE]; */

        dir = opendir("/proc");
        if (!dir) {
                printf("cfm:Cannot open /proc");
                return NULL;
        }

        while ((next = readdir(dir)) != NULL) {
                /* re-initialize buffers */
                memset(filename, 0, sizeof(filename));
                memset(buffer, 0, sizeof(buffer));

                /* Must skip ".." since that is outside /proc */
                if (strcmp(next->d_name, "..") == 0)
                        continue;

                /* If it isn't a number, we don't want it */
                if (!isdigit(*next->d_name))
                        continue;

                /* sprintf(filename, "/proc/%s/status", next->d_name); */
                /* read /porc/<pid>/cmdline instead to get full cmd line */
                sprintf(filename, "/proc/%s/cmdline", next->d_name);
                if (! (cmdline = fopen(filename, "r")) ) {
                        continue;
                }
                if (fgets(buffer, 128-1, cmdline) == NULL) {
                        fclose(cmdline);
                        continue;
                }
                fclose(cmdline);

                /* Buffer should contain a string like "Name:   binary_name" */
                /*sscanf(buffer, "%*s %s", name);*/
                /* buffer contains full commandline params separted by '\0' */
                remove_delimitor(buffer);
                if (strstr(buffer, pidName) != NULL) {
                        pidList=realloc( pidList, sizeof(pid_t) * (i+2));
                        if (!pidList) {
                                printf("cfm: Out of memeory!\n");
				closedir(dir);
                                return NULL;
                        }
                        pidList[i++]=strtol(next->d_name, NULL, 0);
                }
        }
        closedir(dir);

        if (pidList)
                pidList[i]=0;
        else if ( strcmp(pidName, "init")==0) {
                /* If we found nothing and they were trying to kill "init",
                 * guess PID 1 and call it good...  Perhaps we should simply
                 * exit if /proc isn't mounted, but this will do for now. */
                pidList=realloc( pidList, sizeof(pid_t));
                if (!pidList) {
                        printf("cfm: Out of memeory!\n");
                        return NULL;
                }
                pidList[0]=1;
        } else {
                pidList=realloc( pidList, sizeof(pid_t));
                if (!pidList) {
                        printf("cfm: Out of memeory!\n");
                        return NULL;
                }
                pidList[0]=-1;
        }
        return pidList;
}

/***************************************************************************
// Function Name: bcmGetPid().
// Description  : get process PID which is created by command executing by using process name.
// Parameters   : command - command that launch the process.
// Returns      : process ID number.
****************************************************************************/
int RTGetPid(char * command)
{
    char cmdline[128], *p1, *p2;
    pid_t *pid = NULL;
    int ret = 0;

    p1 = command;
    p2 = cmdline;
    while ( *p1 != '\0') {
        if (*p1 != ' ') {
           *p2 = *p1;
           p2++;
         }
         p1++;
    }
    *p2='\0';

    pid = find_pid_by_name(cmdline);
    if ( pid != NULL ) {
       ret = (int)(*pid);
       free(pid);
    }

    return ret;
}


static int getMulticastStatistics(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	char pmList[1024] = {0};
        char acLine[128] = {0};
        char actmp[16] = {0};
        int lCount = 0;
        int i, k = 0;
	int tmp[3] = {0};
       char *group=NULL;
        key_t key;
        int msgid = -1;
        char acCmd[512] = {0};
        int lPid = 0;
        int GrpRepCount = 0;
        int lGrpCount = 0;
        struct in_addr stGroupAddr;
        struct in_addr stRepAddr;
        IGMP_QUERY_INFO  g_astPktInfo[IGMPPROXY_GRP_MAX];
        const char *IgmpEnable;

        IgmpEnable = nvram_safe_get( "igmp_enabled");

       if (IgmpEnable && ('1' == IgmpEnable[0]) )
       {

         memset(acCmd, 0, 512);
         lPid = RTGetPid("igmpproxy");

          if(lPid > 0)
         {
                  sprintf(acCmd, "kill -SIGUSR2 %d", lPid);
                  doSystem(acCmd);

                  	FILE *fp;
                	char pmList[1024] = {0};
                	char *temp;


                	fp = fopen("/tmp/igmptmp", "r");
                	if (NULL == fp)
                		return websWrite(wp, T(""));

                	fread(pmList, 1, sizeof(pmList), fp);

                	if( strlen(pmList) > 0 )
                	{
                		temp = strrchr(pmList, '|');
                		*temp = '\0';
                		websWrite(wp, T("%s"), pmList);
                	}
                	else
                	{
                		fclose(fp);
                		return websWrite(wp, T(""));
                	}

                	fclose(fp);


         }

       }

 	return 0;
}
/*end of add for mulitcast forwarding by zengxianzhu at 20110214*/

static int getSnortBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_USER_SNORT
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

void formDefineManagement(void)
{
	websAspDefine(T("getPPPOECDBuilt"), getPPPOECDBuilt);
	websAspDefine(T("getWizardBuilt"), getWizardBuilt);
	websAspDefine(T("getWatchDogBuilt"), getWatchDogBuilt);
#ifdef CONFIG_USER_WIZARD
	websFormDefine(T("setWizard"), setWizard);
#endif
#ifdef HAVE_EMAIL
	websFormDefine(T("SendEmail"), SendEmail);
#endif
	websFormDefine(T("setSysAdm"), setSysAdm);
    websFormDefine(T("test_ate"), test_ate);
	websFormDefine(T("setSysLang"), setSysLang);
	websFormDefine(T("setLanguage"), setLanguage);
	websFormDefine(T("NTP"), NTP);
#ifdef CONFIG_DATE
	websFormDefine(T("NTPSyncWithHost"), NTPSyncWithHost);
#endif
	websAspDefine(T("getCurrentTimeASP"), getCurrentTimeASP);
	websAspDefine(T("getGAPBuilt"), getGAPBuilt);
	websAspDefine(T("getSnortBuilt"), getSnortBuilt);
#ifdef CONFIG_USER_GOAHEAD_GreenAP
	websFormDefine(T("GreenAP"), GreenAP);
#endif
#ifdef HAVE_DDNS
	websFormDefine(T("DDNS"), DDNS);
#endif
#ifdef CONFIG_USER_SNORT
	websFormDefine(T("Snort"), Snort);
#endif

#ifdef HAVE_USER_SSL_CCMS_CLIENT	
	websFormDefine(T("SoftwareUpgradeSettings"), SoftwareUpgradeSettings);
	websFormDefine(T("SoftwareUpgradeCancel"), SoftwareUpgradeCancel);
#endif

	websAspDefine(T("get3GFlowASP"), get3GFlowASP);
	websAspDefine(T("getMemLeftASP"), getMemLeftASP);
	websAspDefine(T("getMemTotalASP"), getMemTotalASP);

	websAspDefine(T("getWANRxByteASP"), getWANRxByteASP);
	websAspDefine(T("getWANTxByteASP"), getWANTxByteASP);
	websAspDefine(T("getLANRxByteASP"), getLANRxByteASP);
	websAspDefine(T("getLANTxByteASP"), getLANTxByteASP);
	websAspDefine(T("getWANRxPacketASP"), getWANRxPacketASP);
	websAspDefine(T("getWANTxPacketASP"), getWANTxPacketASP);
	websAspDefine(T("getLANRxPacketASP"), getLANRxPacketASP);
	websAspDefine(T("getLANTxPacketASP"), getLANTxPacketASP);

	websAspDefine(T("getAllNICStatisticASP"), getAllNICStatisticASP);

	websAspDefine(T("showSystemCommandASP"), showSystemCommandASP);
	websFormDefine(T("SystemCommand"), SystemCommand);
	websFormDefine(T("repeatLastSystemCommand"), repeatLastSystemCommand);

	websFormDefine(T("LoadDefaultSettings"), LoadDefaultSettings);

	websFormDefine(T("syslog"), syslog);
#if defined CONFIG_LOGREAD && defined CONFIG_KLOGD
	websFormDefine(T("clearlog"), clearlog);
#endif

	websAspDefine(T("FirmwareUpgradePostASP"), FirmwareUpgradePostASP);
	websFormDefine(T("sylogapply"), syslogapply);
	websAspDefine(T("getSyslogIp"), getSyslogIp);
	websAspDefine(T("getremotelog"), getremotelog);

	websFormDefine(T("formLogin"), formLogin);
	websAspDefine(T("getLoginCheck"), getLoginCheck);
	/*start of add for check wan port plus in by zengxianzhu at 20111101*/
	websAspDefine(T("CheckWanPortConnect"), CheckWanPortConnect);
	/*start of add for check wan port plus in by zengxianzhu at 20111101*/
	//websFormDefine(T("logoutsetTimer"), logoutsetTimer);

	websFormDefine(T("cancelDiagnosis"), cancelDiagnosis);
	websFormDefine(T("updateDiagnosisResult"), updateDiagnosisResult);
	websFormDefine(T("Diagnosis"), Diagnosis);
	websAspDefine(T("getUpnpPmList"), getUpnpPmList);
      /*start of add for mulitcast forwarding by zengxianzhu at 20110107*/
        websAspDefine(T("getMulticastStatistics"), getMulticastStatistics);
      /*end of add for mulitcast forwarding by zengxianzhu at 20110107*/
	  /*start of add for curlѻ״̬ʾ by wangjian at 20111018*/
	  //websAspDefine(T("getDOWNload_name"), getDOWNload_name);
	  websAspDefine(T("getDOWNload_Received"), getDOWNload_Received);
	  websAspDefine(T("getDOWNload_Total"), getDOWNload_Total);
	  websAspDefine(T("getDOWNload_speed"), getDOWNload_speed);
	  websAspDefine(T("getDOWNload_Percent"), getDOWNload_Percent);
	  websAspDefine(T("getDOWNload_spent"), getDOWNload_spent);
	  /*end of add for curlѻ״̬ʾ by wangjian at 20111018*/

	formDefineWPS();
#if defined (CONFIG_RTDEV_MII) || defined (CONFIG_RTDEV_USB) || defined (CONFIG_RTDEV_PCI)
#ifndef CONFIG_UNIQUE_WPS
	formDefineRaixWPS();
#endif
#endif
}

static int getWizardBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined CONFIG_USER_WIZARD
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getPPPOECDBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined CONFIG_USER_PPPOECD
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getWatchDogBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined CONFIG_RALINK_WATCHDOG|CONFIG_RALINK_WATCHDOG_MODULE && defined CONFIG_USER_WATCHDOG
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

