#ifndef _TRANSLATION_H__
#define _TRANSLATION_H__

#include "wsIntrn.h"

typedef struct kw_s     {
        int len, tlen;                                          // actually / total
        unsigned char **idx;
        unsigned char *buf;
} kw_t, *pkw_t;

#define INC_ITEM        128
#define REALLOC_VECTOR(p, len, size, item_size) {                               \
        if (len == size)        {                                                                               \
                int new_size;                                                                                   \
                void *np;                                                                                               \
                new_size = size + INC_ITEM;                                                             \
                np = malloc (new_size * (item_size));                                   \
                bzero (np, new_size * (item_size));                                             \
                memcpy (np, p, len * (item_size));                                              \
                free (p);                                                                                               \
                p = np;                                                                                                 \
                size = new_size;                                                                                \
        }    \
}

int websWriteBlockWithTranslation(webs_t wp, char_t *buf, int nChars);
int load_dictionary (char *lang, pkw_t pkw);
void release_dictionary (pkw_t pkw);
int websWriteWithTranslation(webs_t wp, char_t *fmt, ...);

#endif /* _TRANSLATION_H__ */
