/*
 *	wireless.h -- Wireless Configuration Header 
 *
 *	Copyright (c) Ralink Technology Corporation All Rights Reserved.
 *
 *	$Id: wireless.h,v 1.11 2010-04-01 03:53:14 chhung Exp $
 */
#define SSID_NAME_SIZE                          36
#define BSSID_SIZE								22
#define SECURITY_SIZE							26
#define MODE_SIZE								12
#define EXTCH_SIZE								10
#define NT_SIZE									6
#define WPS_SIZE								6

void formDefineWireless(void);
#ifdef AP_WAPI_SUPPORT
void restartWAPIDaemon(void);
#endif
void restart8021XDaemon(void);
void updateFlash8021x(void);
void Security(webs_t wp, char_t *path, char_t *query);
void confWPAGeneral(webs_t wp, int mbssid);
void confWEP( webs_t wp, int mbssid);
void conf8021x(webs_t wp, int mbssid);
void getSecurity(webs_t wp, char_t *path, char_t *query);
void DeleteAccessPolicyList(webs_t wp, char_t *path, char_t *query);
int product_do_security_setting(char *buf);

int ApOidQueryInformation(unsigned long OidQueryCode, int socket_id, char *DeviceName, void *ptr, unsigned long PtrLength);

typedef union _MACHTTRANSMIT_SETTING {
	struct  {
		unsigned short  MCS:7;  // MCS
		unsigned short  BW:1;   //channel bandwidth 20MHz or 40 MHz
		unsigned short  ShortGI:1;
		unsigned short  STBC:2; //SPACE
		unsigned short	eTxBF:1;
		unsigned short	rsv:1;
		unsigned short	iTxBF:1;
		unsigned short  MODE:2; // Use definition MODE_xxx.
	} field;
	unsigned short      word;
} MACHTTRANSMIT_SETTING;

#define WIF "ra0"
#define URE "apcli0"
typedef struct _SITE_SURVEY 
{ 
	char channel[4];
//	unsigned char channel;
//	unsigned char centralchannel;
//	unsigned char unused;
	unsigned char ssid[33]; 
	char bssid[20];
	char authmode[24];
        char signal[8];
	char wmode[9];
	char encryption[7];
	char bsstype[4];
	char centralchannel[7];
} SITE_SURVEY;


typedef struct _SITE_SURVEY_ARRAY
{ 
	SITE_SURVEY SiteSurvey[64];
} SSA;

typedef struct apcli_t_
{
    struct apcli_t_ *p_next;
    int i_channel;
    char s_ssid[ SSID_NAME_SIZE ];
	char s_bssid[ BSSID_SIZE ];
	char s_security[ SECURITY_SIZE ];
	int i_single;
	char s_mode[ MODE_SIZE ];
	char s_extch[ EXTCH_SIZE ];
	char s_nt[ NT_SIZE ];
	char s_wps[ WPS_SIZE ];
}
apcli_t;

int get_site_survey_ap( apcli_t **pp_site_list );
int free_apcli_list( apcli_t *p_head );


