#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <unistd.h>
#include <errno.h>

#include <sys/socket.h>
#include <sys/ioctl.h>
#include <arpa/inet.h>
#include <asm/types.h>
#include <linux/if.h>
#include <linux/wireless.h>
#include <ctype.h>
#include <errno.h>
#include "linux/autoconf.h"
#include "bcmnvram.h"


#define CLIENT_ADDR "/var/product_client_addr"
#define SERVER_ADDR "/var/product_server_addr"

#define SOFTWARE_VERSION_PATH "/home/software_version"


int send_to_server(int argc, char **argv, int timeout);

/*
 * arguments: ifname  - interface name
 *            if_addr - a 18-byte buffer to store mac address
 * description: fetch mac address according to given interface name
 */
int getIfMac(char *ifname, char *if_hw)
{
	struct ifreq ifr;
	char *ptr;
	int skfd;

	if((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		printf("getIfMac: open socket error\n");
		return -1;
	}

	strncpy(ifr.ifr_name, ifname, 16);
	if(ioctl(skfd, SIOCGIFHWADDR, &ifr) < 0) {
		//error(E_L, E_LOG, T("getIfMac: ioctl SIOCGIFHWADDR error for %s"), ifname);
		return -1;
	}

	ptr = (char *)&ifr.ifr_addr.sa_data;
	sprintf(if_hw, "%02X:%02X:%02X:%02X:%02X:%02X",
			(ptr[0] & 0377), (ptr[1] & 0377), (ptr[2] & 0377),
			(ptr[3] & 0377), (ptr[4] & 0377), (ptr[5] & 0377));

	close(skfd);

	return 0;
}

/*
 * description: return LAN interface name
 */
char* getLanIfName(void)
{
	char *mode = nvram_safe_get( "OperationMode");
	static char *if_name = "br0";

	if (NULL == mode)
		return if_name;
	if (!strncmp(mode, "0", 2))
		if_name = "br0";
	else if (!strncmp(mode, "1", 2)) {
#if defined CONFIG_RAETH_ROUTER || defined CONFIG_MAC_TO_MAC_MODE || defined CONFIG_RT_3052_ESW
		if_name = "br0";
#elif defined  CONFIG_ICPLUS_PHY && CONFIG_RT2860V2_AP_MBSS
		char *num_s = nvram_safe_get( "BssidNum");
		if(atoi(num_s) > 1)	// multiple ssid
			if_name = "br0";
		else
			if_name = "ra0";
#else
		if_name = "ra0";
#endif
	}
	else if (!strncmp(mode, "2", 2)) {
		if_name = "eth2";
	}
	else if (!strncmp(mode, "3", 2)) {
		if_name = "br0";
	}
	return if_name;
}

static int getLanMac()
{
	char if_mac[18];

	if (-1 == getIfMac("eth2", if_mac)) {
		printf("getLanMac: calling getIfMac error\n");
		return -1;
	}
	printf("\n\n<==OK!Get interface:eth2  MAC:%s\n",if_mac);

	if (-1 == getIfMac("ra0", if_mac)) {
		printf("getLanMac: calling getIfMac error\n");
		return -1;
	}
	printf("\n\n<==OK!Get interface:ra0  MAC:%s\n",if_mac);
	return 0;
}

static int setLanMac(char *pstr)
{
	char buf[256],*tmp,*token;
	unsigned char mac_addr[6];
	int i;
  

	/* ifconfig down all interface */
	system("ifconfig eth2 down");
	system("ifconfig eth2.1 down");
	system("ifconfig eth2.2 down");
	system("ifconfig eth2.3 down");
	system("ifconfig eth2.4 down");
	system("ifconfig eth2.5 down");
	system("ifconfig br0 down");

	sprintf(buf,"ifconfig eth2 hw ether %s",pstr);
	system(buf);
	sprintf(buf,"ifconfig eth2.1 hw ether %s",pstr);
	system(buf);
  sprintf(buf,"ifconfig eth2.2 hw ether %s",pstr);
	system(buf);
  sprintf(buf,"ifconfig eth2.3 hw ether %s",pstr);
	system(buf);
	sprintf(buf,"ifconfig eth2.4 hw ether %s",pstr);
	system(buf);
	sprintf(buf,"ifconfig eth2.5 hw ether %s",pstr);
	system(buf);
	sprintf(buf,"ifconfig br0 hw ether %s",pstr);
	system(buf);

	i = 0;
	tmp=pstr;
	while ((token=strtok(tmp,":"))!=NULL) {
                 sscanf(token,"%x",&mac_addr[i]);
		   i++;
                tmp=0;
       }

	sprintf(buf,"iwpriv ra0 e2p 28=%02x%02x",mac_addr[1],mac_addr[0]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 2A=%02x%02x",mac_addr[3],mac_addr[2]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 2C=%02x%02x",mac_addr[5],mac_addr[4]);
	system(buf);

	sprintf(buf,"iwpriv ra0 e2p 2E=%02x%02x",mac_addr[1],mac_addr[0]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 30=%02x%02x",mac_addr[3],mac_addr[2]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 32=%02x%02x",mac_addr[5],mac_addr[4]);
	system(buf);

	sprintf(buf,"iwpriv ra0 e2p 4=%02x%02x",mac_addr[1],mac_addr[0]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 6=%02x%02x",mac_addr[3],mac_addr[2]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 8=%02x%02x",mac_addr[5],mac_addr[4]);
	system(buf);
	
#if 0	/* not to skip MAC. MACs(WLAN<ssid0> == WAN == LAN) */
	mac_addr[5]++;
	if(mac_addr[5]==0x0)
	{
		mac_addr[4]++;
		if(mac_addr[4]==0x0)
			mac_addr[3]++;
	}
#endif
	sprintf(buf,"iwpriv ra0 e2p 2E=%02x%02x",mac_addr[1],mac_addr[0]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 30=%02x%02x",mac_addr[3],mac_addr[2]);
	system(buf);
	sprintf(buf,"iwpriv ra0 e2p 32=%02x%02x",mac_addr[5],mac_addr[4]);
	system(buf);

	system("ifconfig ra0 down");
	sprintf(buf,"ifconfig ra0 hw ether %x:%x:%x:%x:%x:%x",mac_addr[0],mac_addr[1],mac_addr[2],mac_addr[3],mac_addr[4],mac_addr[5]);
	system(buf);

	/* ifconfig up all interface */
	system("ifconfig eth2 up");
	system("ifconfig eth2.1 up");
	system("ifconfig eth2.2 up");
	system("ifconfig eth2.3 up");
	system("ifconfig eth2.4 up");
	system("ifconfig eth2.5 up");
	system("ifconfig ra0 up");
	system("ifconfig br0 up");

	sprintf(buf,"%0X:%0X:%0X:%0X:%0X:%0X\n",mac_addr[0],mac_addr[1],mac_addr[2],mac_addr[3],mac_addr[4],mac_addr[5]);
	nvram_set( "WAN_MAC_ADDR", buf);
	nvram_commit();


	printf("\n\n<===Set MAC OK===>\n\n");

	return 0;
}


static void load_factory_cofig()
{
    system( "restoredefault" );
	system( "reboot" );
}

static void read_software_info()
{
	char buf[256];
	FILE *fd;

	if(fd=fopen(SOFTWARE_VERSION_PATH,"r"))
	{
		fread(buf,sizeof(char),256,fd);
		printf("\nSoftware Version is:%s",buf);
		printf("\n\n<==OK! Get Software\n");
		fclose(fd);
	}
	else
	{
		printf("No Such File:%s",SOFTWARE_VERSION_PATH);
		printf("\n\n<==FAIL! Get software\n");
	}
}

static void get_ssid()
{
	char *ssids = nvram_safe_get( "SSID1");
	if(ssids)
		printf("\n\n<==OK! Get SSID:%s\n",ssids);
}
static void set_ssid(char *ssid)
{
	//char *ssid = "hello";
	nvram_set( "SSID1", ssid);
	system("internet.sh");

	printf("\n\n<==OK!Set SSID:%s==>\n",ssid);
}
static void get_Channel()
{
	char *channels = nvram_safe_get( "Channel");
	if(channels)
		printf("\n\n<==OK! Get Channels:%s\n",channels);
}
static void set_Channel(char *channel )
{
	//char *channel = "7";
	nvram_set( "Channel", channel);
	system("internet.sh");

	printf("\n\n<==OK! Set Channel:%s==>\n",channel);
}
static void get_CountryCode()
{
	char *countrycode = nvram_safe_get( "CountryCode");
	if(countrycode)
		printf("\n\n<==OK! Get CountryCode:%s\n",countrycode);
}
static void set_CountryCode(char *countrycode)
{
	//char *countrycode = "HK";
	nvram_set( "CountryCode", countrycode);
	system("internet.sh");

	printf("\n\n<==OK!Set CountryCode:%s==>\n",countrycode);
}
static void get_BasicRate()
{
	char *basicrate = nvram_safe_get( "BasicRate");
	if(!strcmp(basicrate,"3"))
		printf("\n\n<==OK! Get BasicRate:%s(1-2M)\n",basicrate);
	else if(!strcmp(basicrate,"15"))
		printf("\n\n<==OK! Get BasicRate:%s(5.5M)\n",basicrate);
	else if(!strcmp(basicrate,"351"))
		printf("\n\n<==OK! Get BasicRate:%s(11M)\n",basicrate);
}
static void set_BasicRate(char *basicrate)
{
	//char *basicrate = "16";
	nvram_set( "BasicRate", basicrate);
	system("internet.sh");
}

int check_mac_format(char *pstr)
{
	int i;
	for(i=0;i<17;i++)
	{
		if(i==2 || i==5 || i==8 || i==11 || i==14)
		{
			if(!strncmp(&pstr[i],":",1))
				continue;
			else
			{
				printf("%dth Characters is not ':'\n");
				return -1;
			}
		}
		if((pstr[i]>='a' && pstr[i] <='f') || (pstr[i]>='A' && pstr[i] <='F') || (pstr[i]>='0' && pstr[i] <='9'))
			continue;
		else
		{
			printf("Characters shuold be hex\n");
			return -1;
		}
	}

	return 0;
}


int main( int argc, const char *argv[] )
{
	char *pargv4,tmpstr[3];
 
	if(argc<3)
	{
		printf("Usage:product [module] [action] [parameter...]\n");
		printf("module: wireless system led button detect wan\n");
		printf("action:    set/get \n");

		return -1;
	}

	if(!strcmp(argv[1],"system"))		//System start
	{
		if(!strcmp(argv[2],"set"))		//System->set
		{
			if(!strcmp(argv[3],"factory_config"))		//System->set->factory_config
			{
				load_factory_cofig();
			}
			else if(!strcmp(argv[3],"mac"))		//System->set->mac
			{
				pargv4 = argv[4];
				if(!pargv4)
				{
					printf("MAC Can't empty\n");
					return -1;
				}
				if(strlen(pargv4) !=17)
				{
					//printf("strlen(pargv4):%d\n",strlen(pargv4));
					printf("MAC format should be XX:XX:XX:XX:XX:XX (hex)\n");
					return -1;
				}
				if(check_mac_format(pargv4)<0)
				{
					printf("MAC format should be XX:XX:XX:XX:XX:XX (hex)\n");
					return -1;
				}
				setLanMac(pargv4);
			}
			else
			{
				printf("No such parameter\n");
				return -1;
			}
		}
		else if(!strcmp(argv[2],"get"))		//System->get
		{
			if(!strcmp(argv[3],"software"))		//System->get->software
			{
				read_software_info();
			}
			else if(!strcmp(argv[3],"mac"))	//System->get->mac
			{
				if((getLanMac())<0)
				{
					printf("getLanMac error\n");
					exit(-1);
				}
			}
			else
			{
				printf("No such parameter\n");
				return -1;
			}
		}
		else
		{
			printf("[action] should be set or get\n");
			return -1;
		}
	}		//System end
	else if(!strcmp(argv[1],"wireless"))		//Wireless start
	{
		if(!strcmp(argv[2],"set"))			//Wireless->set
		{
			if(!strcmp(argv[3],"ssid"))		//Wireless->set->ssid
			{
				if(argv[4])
				{
					if(strlen(argv[4])>32)
					{
						printf("The paramter is too long\n");
						return -1;
					}
					set_ssid((char *)argv[4]);
				}
				else
				{
					printf("SSID Can't Empry\n");
					return -1;
				}
			}
			else if(!strcmp(argv[3],"rate"))	//Wireless->set->rate
			{
				char s[6];
				if(!argv[4])
				{
					printf("rate parameter should be 1(1-2M) 2(5.5M) 3(11M)\n");
					return -1;
				}
				if(!strcmp(argv[4],"1"))
				{
					strcpy(s,"1-2M");
					strcpy(tmpstr,"3");
				}
				else if(!strcmp(argv[4],"2"))
				{
					strcpy(s,"5.5M");
					strcpy(tmpstr,"15");
				}
				else if(!strcmp(argv[4],"3"))
				{
					strcpy(s,"11M");
					strcpy(tmpstr,"351");

				}
				else
				{
					printf("rate parameter should be 1(1-2M) 2(5.5M) 3(11M)\n");
					return -1;
				}
				set_BasicRate(tmpstr);
				printf("\n\n<==OK! Set BasicRate:%s==>\n",s);
			}
			else if(!strcmp(argv[3],"channel"))	//Wireless->set->channel
			{
				int tmp;
				char s[2];
				if(argv[4])
				{
					sscanf(argv[4],"%d",&tmp);
					if(tmp<1 || tmp>14)
					{
						printf("Channel should be between 1 and 14\n");
						return -1;
					}
					sprintf(s,"%d",tmp);
					set_Channel(s);
				}
				else
				{
					printf("Channel should be between 1 and 14\n");
					return -1;
				}
			}
			else if(!strcmp(argv[3],"country_code"))	//Wireless->set->country_code
			{
				if(argv[4])
				{
					if(!strcmp(argv[4],"US") || !strcmp(argv[4],"JP") || !strcmp(argv[4],"FR") || !strcmp(argv[4],"TW")  \
						|| !strcmp(argv[4],"IE") || !strcmp(argv[4],"HK") )
						set_CountryCode((char *)argv[4]);
					else
					{
						printf("Parameter should be \"US\" \"JP\" \"FR\" \"TW\" \"IE\" \"HK\"\n");
						return -1;
					}
				}
				else
				{
					printf("Parameter should be \"US\" \"JP\" \"FR\" \"TW\" \"IE\" \"HK\"\n");
					return -1;
				}
			}
			else if(!strcmp(argv[3],"wmm_enable"))       //wireless->set->wmm
			{
				if (!strcmp(argv[4], "1") || !strcmp(argv[4], "0"))
					send_to_server(argc, argv, 20);
				else
				{
					 printf("Parameter should be 0 or 1\n");
					 return -1;
				}
			}
			else if (!strcmp(argv[3],"security_enable"))     //wireless->set->security
			{
				if (!strcmp(argv[4], "1") || !strcmp(argv[4], "0"))
					send_to_server(argc, argv, 20);
				else
				{
					printf("Parameter should be 0 or 1\n");
					return -1;
				}
			}
			else
			{
				printf("No such parameter\n");
				return -1;
			}
		}
		else if(!strcmp(argv[2],"get"))		//Wireless->get
		{
			if(!strcmp(argv[3],"ssid"))		//Wireless->get->ssid
			{
				get_ssid();
			}
			else if(!strcmp(argv[3],"rate"))	//Wireless->get->rate
			{
				get_BasicRate();
			}
			else if(!strcmp(argv[3],"channel"))	//Wireless->get->channel
			{
				get_Channel();
			}
			else if(!strcmp(argv[3],"country_code"))	//Wireless->get->country_code
			{
				get_CountryCode();
			}
			else
			{
				printf("No such parameter\n");
				return -1;
			}
		}
		else
		{
			printf("[action] should be set or get\n");
			return -1;
		}
	} 			//Wireless end
	else if(!strcmp(argv[1],"led"))				//led
	{
	    return led_main(argc, argv);
	}
	else if(!strcmp(argv[1],"button"))				//button
	{
		return button_main(argc, argv);
	}
	else if(!strcmp(argv[1],"detect"))				//detect
	{
		return detect_main(argc, argv);
	}
	else if (!strcmp(argv[1], "wan"))			//wan->set || wan->get
	{
		send_to_server(argc, argv, 20);
	}
	else
	{
		printf("[module] should be wireless system or led\n");
		return -1;
	}

	return 0;
}







/*
int main(int argc, char **argv)
{
	char cmd[100] = "";
	int i = 0, len = 0;

	if (argc <4 ) {
		printf("usage: product module set/get parameter\n");
		return 0;
	}
	memset(cmd, 0, 100);
 	for (i = 0; i < argc; i++) {
		len += sprintf(cmd + len, "%s:", argv[i]);
 	}
	cmd[len - 1] = 0;
	printf("we will send %s to server\n", cmd);


	int result;
	int timeout_count = 0;

		while (timeout != 3) {
			result = __process_request(cmd, timeout);
			if (result == -1) exit(-1);
			if (result == 0) {
				timeout_count++;
				//the system is busy, we wait 1s
				sleep(1);
				continue;
			}
			break;
		}
		if (timeout_count== 3){
			printf("3 timeout , the server is in error, quit\n");
			exit(1);
		}

}
*/

/* return 0: timeout ,will send later, max 3 times
    return -1:  some error when read and write
    return 1:  succeed
  */


static int __process_request(char *cmd, int timeout)
{

        char buf[500];
        int len;
        int clientfd;
        struct sockaddr_un cli_addr, serv_addr;
        clientfd = socket(AF_LOCAL, SOCK_DGRAM, 0);
        if (clientfd == -1) {
	                printf("sock_page build error\n");
	                return -1;
	}
        memset(&serv_addr, '\0', sizeof(serv_addr));
        memset(&cli_addr, '\0', sizeof(cli_addr));
        memset(buf, '\0', 500);

        unlink(CLIENT_ADDR);
        cli_addr.sun_family = AF_LOCAL;
        strcpy(cli_addr.sun_path, CLIENT_ADDR);
        if (bind(clientfd, (struct sockaddr *)&cli_addr, sizeof(cli_addr)) == -1) {
	                printf("sock_page bind error\n");
	                return -1;
	        }
        serv_addr.sun_family = AF_LOCAL;
        strcpy(serv_addr.sun_path, SERVER_ADDR);
        len = sendto(clientfd, cmd, strlen(cmd), 0, (struct sockaddr*)&serv_addr,
		                                 sizeof(serv_addr));
        if (len == -1){
	    printf("send cmd %s error\n", cmd);
	    return -1;
	}
	printf("client: we send %d bytes\n", len);

        fd_set rfds;
        struct timeval tv;
        int result;
        FD_ZERO(&rfds);
        FD_SET(clientfd, &rfds);
        tv.tv_sec = timeout;
        tv.tv_usec = 0;
        while (1) {
                if ((result = select(clientfd + 1, &rfds, NULL, NULL, &tv)) > 0) break;
                if (result == 0) {
                        printf("pptpctrl: time out when select\n");
                        close(clientfd);
                        return 0;
                }
                if (errno == EINTR) continue;
                printf("pptpctrl: error when select\n");
                close(clientfd);
                return -1;
        }
        len = recvfrom(clientfd, buf, 500, 0, NULL, NULL);
        if (len < 0) {
                printf("client: receive error from server\n");
                return -1;
        }

	printf("<-------%s\n", buf);
	 close(clientfd);
	return 1;
}

static int process_request(char *cmd, int timeout)
{
	int result;
	int timeout_count = 0;

	while (timeout != 3) {
		result = __process_request(cmd, timeout);
		if (result == -1) exit(-1);
		if (result == 0) {
			timeout_count++;
			//the system is busy, we wait 1s
			sleep(1);
			continue;
		}
		break;
	}
	if (timeout_count== 3){
		printf("3 timeout , the server is in error, quit\n");
		return -1;
	}
}


int send_to_server(int argc, char **argv, int timeout)
{
	int i = 0, len = 0;
	char cmd[100];

	if (argc <4 ) {
		printf("usage: product module set/get parameter\n");
		return 0;
	}
	memset(cmd, 0, 100);
 	for (i = 0; i < argc; i++) {
		len += sprintf(cmd + len, "%s:", argv[i]);
 	}
	cmd[len - 1] = 0;

	process_request(cmd, timeout);
	return 1;
}
