/*
 * Router default NVRAM values
 *
 * Copyright (C) 2009, Broadcom Corporation
 * All Rights Reserved.
 *
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: defaults.c,v 1.194 2010/04/23 22:32:21 Exp $
 */

#include <epivers.h>
#include "router_version.h"
#include <typedefs.h>
#include <string.h>
#include <ctype.h>
#include <bcmnvram.h>
#include <wlioctl.h>
#include <stdio.h>
#include <ezc.h>
#include <bcmconfig.h>
#include <linux/autoconf.h>
#include <config/autoconf.h>
#include <autoconf.h>
#include <own_autoconf.h>


#ifdef DEFINE_AIRMOBI
#define AIRMOBI_ACCESS_BY_HOST_NAME
#endif
#define XSTR(s) STR(s)
#define STR(s) #s
 
//#define SVN_REVISION "iTravelII-R1B011DXXXXX" //rc.c -> each time the system startup always get software version, so XXXXX

#define MANAGE_USERNAME  "admin"             /*admin*/
#define MANAGE_PASSWORD  "eHV5dWFuYmlhbw=="      /*base64 code:xuyuanbiao*/ 

#define WEB_USERNAME_DEF  "admin"             /*admin*/
#define WEB_PASSWORD_DEF  "YWRtaW4="         /*admin*/

#if 0
#define WEB_USERNAME_BYXPRESS  "byxpress"          /*byxpress*/
#define WEB_PASSWORD_BYXPRESS  "Ynl4cHJlc3M="      /*byxpress*/
#else
#define WEB_USERNAME_BYXPRESS  "admin"          /*byxpress*/
#define WEB_PASSWORD_BYXPRESS  "Zm9uaXN0QHRlbGVjb20="      /*fonist@telecom*/
#endif
struct nvram_tuple router_defaults[] = {
    /* OS parameters */
    { "os_name", "", 0 },             /* OS name string */
    { "os_version", ROUTER_VERSION_STR, 0 }, /* OS revision */
    { "os_date", __DATE__, 0 },         /* OS date */
    { "wl_version", "2.7.1.5", 0 },     /* wl dirver revision */
    { "deviceid", DEVICE_ID, 0 },     /* device id, not modify */
    { "productid", PRODUCT_ID, 0 },     /* product id */
    { "trademarkdisc", TRADEMARK_DISC, 0 },     /* trademark describe */
    { "ssidnumber", SSID_NUMBER, 0 }, 
    { "hw_ver", OWN_HW_VERSION, 0 },     /* hardware vision */
//   { "sw_ver", SVN_REVISION, 0 },     /* Software revision */
#ifdef CONFIG_RALINK_RT2880
	{ "reset_gpio", "0", 0 },     /* reset default gpio */
#else
#if defined CONFIG_RALINK_RT3052 && ((CONFIG_RALINK_I2S) || defined (CONFIG_RALINK_I2S_MODULE))
	{ "reset_gpio", "43", 0 },     /* reset default gpio */
#elif defined CONFIG_RALINK_RT3883
	//RT3883 uses gpio 27 for load-to-default
	{ "reset_gpio", "27", 0 },     /* reset default gpio */
#else
	//RT2883, RT3052 use gpio 10 for load-to-default
	{ "reset_gpio", "12", 0 },     /* reset default gpio */

#ifdef DEFINE_IREADER
	{ "sleep_gpio", "14", 0 },     /* sleep mode default gpio */
#endif

#endif	
#endif

    /* Version */
    { "nvram_version", NVRAM_SOFTWARE_VERSION, 0 },
    { "log_level", "0", 0 },        /* Bitmask 0:off 1:denied 2:accepted */
    { "upnp_enable", "1", 0 },        /* Start UPnP */
    { "ezc_enable", "1", 0 },        /* Enable EZConfig updates */
    { "ezc_version", EZC_VERSION_STR, 0 },    /* EZConfig version */
    { "is_default", "1", 0 },        /* is it default setting: 1:yes 0:no */
    { "os_server", "", 0 },            /* URL for getting upgrades */
    { "stats_server", "", 0 },        /* URL for posting stats */
    { "console_loglevel", "1", 0 },        /* Kernel panics only */
    { "sysadm_set", "1", 0 },

	{ "auto_language", "1", 0 },      /* Enable language auto change */
	{ "user_language", "0", 0 },      /* User-specified language */

	/* Country Region  0(US):1-11;1(CN\Europe)1-13;5(Japan/CN_TW):1-14*/
	{ "CountryCode", COUNTRY, 0 },

	{ "time_zone", TIME_ZONE, 0 },
	{ "timer_interval", "3600", 0 },	/* Timer interval in seconds */
	{ "NTPServerIP", "pool.ntp.org", 0 },		/* NTP server */

	/* Big switches */
    { "OperationMode", "1", 0},           /* bridge=0, gateway=1 apcli=2 sta=3 */
    { "fw_disable", "0", 0 },        /* Disable firewall (allow new connections from the
                         * WAN)
                         */

/* Web server parameters */
#ifdef DEFINE_BYXPRESS
	{ "http_username", WEB_USERNAME_BYXPRESS, WEB_USERNAME_BYXPRESS },		/* Username */
	{ "http_passwd", WEB_PASSWORD_BYXPRESS, WEB_PASSWORD_BYXPRESS },		 /* Password */
#else
	{ "http_username", WEB_USERNAME_DEF, WEB_USERNAME_DEF },		/* Username */
	{ "http_passwd", WEB_PASSWORD_DEF, WEB_PASSWORD_DEF },		 /* Password */
#endif

    { "manage_username", MANAGE_USERNAME, MANAGE_USERNAME },        /* Username */
    { "manage_passwd", MANAGE_PASSWORD, MANAGE_PASSWORD },        /* Password */
    
    { "http_wanport", "", 0 },        /* WAN port to listen on */
    { "http_lanport", "80", 0 },        /* LAN port to listen on */

    { "log_ipaddr", "", 0 },        /* syslog recipient */
    { "log_ram_enable", "", 0 },        /* remote syslog  */

    { "wan_mtu", "1500", 0 },

    /* LAN H/W parameters */
    { "lan_ifname", "br0", 0 },        /* LAN interface name */

    { "lan_ifname_guest", "br1", 0 },

    { "lan_ifnames", "", 0 },        /* Enslaved LAN interfaces */
    { "lan_hwnames", "", 0 },        /* LAN driver names (e.g. et0) */
    { "lan_hwaddr", "", 0 },        /* LAN interface MAC address */

    /* LAN TCP/IP parameters */
    { "lan_dhcp", "0", 0 },            /* DHCP client [static|dhcp] */
    { "lan_netmask", "255.255.255.0", 0 },    /* LAN netmask */
    { "lan_netmask_guest", "255.255.255.0", 0 },
    
	{ "lan_ipaddr", IPADDR, "192.168.8.8" },    /* LAN IP address */
	{ "default_lan_ipaddr", IPADDR, "192.168.8.8" },    /* LAN IP address */
	{ "lan_gateway", IPADDR, "192.168.8.8" },	/* LAN gateway */
	{ "dhcp_start", DHCP_START, "192.168.8.100" },	 /* First assignable DHCP address */
	{ "dhcp_end", DHCP_END, "192.168.8.200" },    /* Last assignable DHCP address */
	{ "dhcp_gateway", IPADDR, "192.168.8.8" },
	{ "dhcp_prim_dns", IPADDR, "192.168.8.8" },


    { "lan_ipaddr_guest", "192.168.169.1", 0 },
    { "lan_gateway_guest", "192.168.169.1", 0 },
    { "lan_proto", "1", 0 },        /* DHCP server [static|dhcpd|dhcpc] */
    { "lan_wins", "", 0 },            /* x.x.x.x x.x.x.x ... */

#if defined(AIRMOBI_ACCESS_BY_HOST_NAME) || defined(DEFINE_MT7610_AP)
	{ "lan_hostname", "c.cctairmobi", 0 }, 
#else
    { "lan_hostname", V_MODEL, 0 },  
#endif	
	{ "lan_domain","com",0 },

   
    { "lan_lease", "86400", 0 },        /* LAN lease time in seconds */
    { "lan_stp", "1", 0 },            /* LAN spanning tree protocol */
    { "lan_route", "", 0 },            /* Static routes
                         * (ipaddr:netmask:gateway:metric:ifname ...)
                         */
    /* Guest H/W parameters */
    { "lan1_ifname", "", 0 },        /* LAN interface name */
    { "lan1_ifnames", "", 0 },        /* Enslaved LAN interfaces */
    { "lan1_hwnames", "", 0 },        /* LAN driver names (e.g. et0) */
    { "lan1_hwaddr", "", 0 },        /* LAN interface MAC address */

    /* Guest TCP/IP parameters */
    { "lan1_dhcp", "0", 0 },            /* DHCP client [static|dhcp] */
    { "lan1_ipaddr", "192.168.2.1", 0 },    /* LAN IP address */
    { "lan1_netmask", "255.255.255.0", 0 },    /* LAN netmask */
    { "lan1_gateway", "192.168.2.1", 0 },    /* LAN gateway */
    { "lan1_proto", "dhcp", 0 },        /* DHCP server [static|dhcp] */
    { "lan1_wins", "", 0 },            /* x.x.x.x x.x.x.x ... */
    { "lan1_domain", "", 0 },        /* LAN domain name */
    { "lan1_lease", "86400", 0 },        /* LAN lease time in seconds */
    { "lan1_stp", "0", 0 },            /* LAN spanning tree protocol */
    { "lan1_route", "", 0 },            /* Static routes
                         * (ipaddr:netmask:gateway:metric:ifname ...)
                         */

    /* WAN H/W parameters */
    { "wan_ifname", "", 0 },        /* WAN interface name */
    { "wan_ifnames", "", 0 },        /* WAN interface names */
    { "wan_hwname", "", 0 },        /* WAN driver name (e.g. et1) */
    { "wan_hwaddr", "", 0 },        /* WAN interface MAC address */

    /* wan nat */
    { "wan_nat", "1", 0 },        /* WAN nat 1=enable; 0=disbale*/
    { "wan_hostname", "1", 0 },        /* WAN nat 1=enable; 0=disbale*/

    /* WAN TCP/IP parameters */
#ifdef DEFINE_IREADER
    { "wan_proto", "dhcp", 0 },        /* [static|dhcp|pppoe|pptp|l2tp|disabled] */
#else
    { "wan_proto", "3g", 0 },        /* [static|dhcp|pppoe|pptp|l2tp|disabled] */

#ifdef DEFINE_G4
	{ "wan_type", "0", 0 },
	{ "wan_auto", "1", 0 },      /*1--->wan detect mode is auto*/
	
    { "wan_dhcp_dnsmanual", "0", 0 },
	{ "wan_pppoe_dnsmanual", "0", 0 }, //contrary to wan_pppoe_autodns
#endif
#endif
    { "wan_proto_tmp", "dhcp", 0 },        /* [static|dhcp|pppoe|pptp|l2tp|disabled] */    
	{ "LastRouterProto", "", 0},			/* APPл·ģʽĳʼֵ. add by lg, 20131212 */
    { "wan_ipaddr", "0.0.0.0", 0 },        /* WAN IP address */
    { "wan_netmask", "0.0.0.0", 0 },    /* WAN netmask */
    { "wan_gateway", "0.0.0.0", 0 },    /* WAN gateway */
    { "wan_dnsmanual", "0", 0 },
    { "wan_dnsenable", "1", 0 },
    { "wan_mtu", "1500", 0 },
    { "wan_primary_dns", "", 0 },
    { "wan_secondary_dns", "", 0 },
    { "wan_dns", "", 0 },            /* x.x.x.x x.x.x.x ... */
    { "wan_wins", "", 0 },            /* x.x.x.x x.x.x.x ... */
    { "wan_hostname", "", 0 },        /* WAN hostname */
    { "wan_domain", "", 0 },        /* WAN domain name */
    { "wan_lease", "86400", 0 },        /* WAN lease time in seconds */

    /* PPPoE parameters */
    { "wan_pppoe_ifname", "ppp0", 0 },        /* PPPoE enslaved interface */
    { "wan_pppoe_user", "", 0 },    /* PPP username */
    { "wan_pppoe_pwd", "", 0 },        /* PPP password */
    { "wan_pppoe_idletime", "60", 0 },    /* Dial on demand max idle time (seconds) */
    { "wan_pppoe_opmode", "keep_alive", 0 },        /* Dial on demand */
    { "wan_pppoe_mru", "1492", 0 },        /* Negotiate MRU to this value */
    { "wan_pppoe_mtu", "1492", 0 },        /* Negotiate MTU to the smaller of this value or the peer MRU */
    { "wan_pppoe_ipaddr", "0.0.0.0", 0 },        /* WAN IP address */
    { "wan_pppoe_netmask", "0.0.0.0", 0 },    /* WAN netmask */
    { "wan_pppoe_gateway", "0.0.0.0", 0 },    /* WAN gateway */
    { "wan_pppoe_primary_dns", "", 0 },
    { "wan_pppoe_secondary_dns", "", 0 },
    { "wan_pppoe_srvname", "", 0 },      /* PPPoE service name */
    { "wan_pppoe_netsniper", "0", 0 },
    { "wan_pppoe_ac", "", 0 },        /* PPPoE access concentrator name */

    /* DHCP parameters */
    { "wan_dhcp_ipaddr", "0.0.0.0", 0 },
    { "wan_dhcp_netmask", "0.0.0.0", 0 },
    { "wan_dhcp_gateway", "0.0.0.0", 0 },
    { "wan_dhcp_primary_dns", "", 0 },
    { "wan_dhcp_secondary_dns", "", 0 },
    { "wan_dhcp_mtu", "1500", 0 },
    { "wan_dhcp_flag_mode", "0", 0 },
    { "wan_dhcp_domain", "", 0 },

    /* STATIC parameters */
    { "wan_static_ipaddr", "0.0.0.0", 0 },
    { "wan_static_netmask", "0.0.0.0", 0 },
    { "wan_static_gateway", "0.0.0.0", 0 },
    { "wan_static_primary_dns", "", 0 },
    { "wan_static_secondary_dns", "", 0 },
    { "wan_static_mtu", "1500", 0 },

    /* Misc WAN parameters */
    { "wan_desc", "", 0 },            /* WAN connection description */
    { "wan_route", "", 0 },            /* Static routes
                         * (ipaddr:netmask:gateway:metric:ifname ...)
                         */
    { "wan_primary", "0", 0 },        /* Primary wan connection */
    { "wan_unit", "0", 0 },            /* Last configured connection */
    { "wan_stb", "0", 0 },          /* swtich mode (WLLLL/LLLLW) */
    { "wan_dnsenable", "1", 0 },    /* wan auto get dns */

    { "misc_conntrack_x", "", 0},   /* conntrack max size */

    /* Filters */
    { "filter_maclist", "", 0 },        /* xx:xx:xx:xx:xx:xx ... */
    { "filter_macmode", "deny", 0 },    /* "allow" only, "deny" only, or "disabled"
                         * (allow all)
                         */
    { "filter_client0", "", 0 },        /* [lan_ipaddr0-lan_ipaddr1|*]:lan_port0-lan_port1,
                         * proto,enable,day_start-day_end,sec_start-sec_end,
                         * desc
                         */
    { "nat_type", "sym", 0 },               /* sym: Symmetric NAT, cone: Cone NAT */
    /* Port forwards */
    { "dmz_ipaddr", "", 0 },        /* x.x.x.x (equivalent to 0-60999>dmz_ipaddr:
                         * 0-60999)
                         */
    { "forward_port0", "", 0 },        /* wan_port0-wan_port1>lan_ipaddr:
                         * lan_port0-lan_port1[:,]proto[:,]enable[:,]desc
                         */
    { "autofw_port0", "", 0 },        /* out_proto:out_port,in_proto:in_port0-in_port1>
                         * to_port0-to_port1,enable,desc
                         */

    { "dhcp1_start", "192.168.2.100", 0 },    /* First assignable DHCP address */
    { "dhcp1_end", "192.168.2.200", 0 },    /* Last assignable DHCP address */
    { "dhcp_start_guest", "192.168.169.2", 0 },
    { "dhcp_end_guest", "192.168.169.254", 0 },
    { "dhcp_netmask_guest", "255.255.255.0", 0 },
    { "dhcp_gateway_guest", "192.168.169.1", 0 },
    { "dhcp_prim_dns_guest", "192.168.169.1", 0 },
    { "dhcp_domain", "wan", 0 },        /* Use WAN domain name first if available (wan|lan) */
    { "dhcp_netmask", "255.255.255.0", 0 },
    { "dhcp_wins", "wan", 0 },        /* Use WAN WINS first if available (wan|lan) */
    { "dhcp_lease", "86400", 0 },
    { "ip_ctl_en", "0", 0 },
	{ "telnetd", "1", 0},     /* telnetd debug */

    { "wl_ifname", "", 0 },            /* Interface name */
    { "wl_hwaddr", "", 0 },            /* MAC address */

    { "BssidNum", "1", 0 },
//	{ "SSID1", "AIRMOBI", 0 },
	{ "SSID1", "RalinkAP", 0 },
    { "WirelessMode", "9", 0 },
    { "TxRate", "0", 0 },
    { "BasicRate", "15", 0 },
    { "BeaconPeriod", "100", 0 },
    { "DtimPeriod", "1", 0 },
    { "TxPower", "100", 0 },
    { "DisableOLBC", "0", 0 },
    { "BGProtection", "0", 0 },
    { "TxAntenna", "", 0 },
    { "RxAntenna", "", 0 },
    { "TxPreamble", "0", 0 },
    { "RTSThreshold", "2347", 0 },
    { "FragThreshold", "2346", 0 },
    { "TxBurst", "1", 0 },
    { "PktAggregate", "1", 0 },
    { "TurboRate", "0", 0 },
    { "WmmCapable", "0", 0 },
    { "APAifsn", "3;7;1;1", 0 },
    { "APCwmin", "4;4;3;2", 0 },
    { "APCwmax", "6;10;4;3", 0 },
    { "APTxop", "0;0;94;47", 0 },
    { "APACM", "0;0;0;0", 0 },
    { "BSSAifsn", "3;7;2;2", 0 },
    { "BSSCwmin", "4;4;3;2", 0 },
    { "BSSCwmax", "10;10;4;3", 0 },
    { "BSSTxop", "0;0;94;47", 0 },
    { "BSSACM", "0;0;0;0", 0 },
    { "AckPolicy", "0;0;0;0", 0 },
    { "APSDCapable", "0", 0 },
    { "DLSCapable", "0", 0 },
    { "NoForwarding", "0", 0 },
    { "NoForwardingBTNBSSID", "0", 0 },
    { "HideSSID", "0", 0 },
    { "ShortSlot", "0", 0 },
    { "Channel", "0", 0 },
    { "AutoChannelSelect", "2", 0 }, // 0:disable ; 1:Old Channel Selection Algorithm ; 2:New Channel Selection Algorithm
    { "SecurityMode", "0", 0 },
    { "VLANEnable", "0", 0 },
    { "VLANName", "", 0 },
    { "VLANID", "0", 0 },
    { "VLANPriority", "0", 0 },
    { "WscConfMode", "0", 0 },
    { "WscConfStatus", "2", 0 },
    { "WscAKMP", "1", 0 },
    { "WscConfigured", "0", 0 },
//	{ "WscModeOption", "7", 0 },
	{ "WscModeOption", "0", 0 }, /* itravel2 have no wps! liugang, 20130913 */

	{ "WscDefaultPincode", "12345670", 0 },
	{ "SetDefaultPinCode", "0", 0 },
    { "WscActionIndex", "9", 0 },
    { "WscPinCode", "", 0 },
    { "WscRegResult", "1", 0 },
    { "WscUseUPnP", "1", 0 },
    { "WscUseUFD", "0", 0 },
    { "WscSSID", "default", 0 },
    { "WscKeyMGMT", "WPA-EAP", 0 },
    { "WscConfigMethod", "138", 0 },
    { "WscAuthType", "1", 0 },
    { "WscEncrypType", "1", 0 },
    { "WscNewKey", "scaptest", 0 },
    { "IEEE8021X", "0", 0 },
    { "IEEE80211H", "0", 0 },
    { "CSPeriod", "6", 0 },
    { "PreAuth", "0", 0 },
    { "AuthMode", "OPEN", 0 },
    { "EncrypType", "NONE", 0 },  
    { "RekeyInterval", "3600", 0 },
    { "RekeyMethod", "DISABLE", 0 },
    { "PMKCachePeriod", "10", 0 },
    { "DefaultKeyID", "1", 0 },
    { "Key1Type", "0", 0 },
    { "Key1Str1", "", 0 },
    { "Key2Type", "0", 0 },
    { "Key2Str1", "", 0 },
    { "Key3Type", "0", 0 },
    { "Key3Str1", "", 0 },
    { "Key4Type", "0", 0 },
    { "Key4Str1", "", 0 },
    { "HSCounter", "0", 0 },
    { "HT_HTC", "1", 0 },
    { "HT_RDG", "1", 0 },
    { "HT_LinkAdapt", "0", 0 },
    { "HT_OpMode", "1", 0 },
    { "HT_MpduDensity", "5", 0 },
    { "HT_EXTCHA", "0", 0 },
    { "HT_BW", "1", 0 },
    { "HT_AutoBA", "1", 0 },
    { "HT_BADecline", "1", 0 },
    { "HT_AMSDU", "1", 0 },
    { "HT_BAWinSize", "64", 0 },
    { "HT_GI", "1", 0 },
    { "HT_STBC", "1", 0 },
    { "HT_MCS", "33", 0 },
    { "HT_PROTECT", "1", 0 },
    { "HT_MIMOPS", "3", 0 },
    { "HT_BADecline", "0", 0 },
    { "HT_40MHZ_INTOLERANT", "0", 0 },
    { "HT_TxStream", "2", 0 },
    { "HT_RxStream", "2", 0 },
    { "HT_DisallowTKIP", "1", 0 },
    { "NintendoCapable", "0", 0 },
    { "AccessPolicy0", "0", 0 },
    { "AccessControlList0", "", 0 },
    { "AccessPolicy1", "0", 0 },
    { "AccessControlList1", "", 0 },
    { "AccessPolicy2", "0", 0 },
    { "AccessControlList2", "", 0 },
    { "AccessPolicy3", "0", 0 },
    { "AccessControlList3", "", 0 },
    { "WdsEnable", "0", 0 },
    { "WdsEncrypType", "NONE", 0 },
    { "WdsList", "", 0 },
    { "WdsKey", "", 0 },
    { "WirelessEvent", "0", 0 },
    { "RADIUS_Server", "", 0 },
    { "RADIUS_Port", "1812", 0 },
    { "RADIUS_Key", "", 0 },
    { "RADIUS_Acct_Server", "", 0 },
    { "RADIUS_Acct_Port", "1813", 0 },
    { "RADIUS_Acct_Key", "", 0 },
    { "session_timeout_interval", "0", 0 },
    { "idle_timeout_interval", "0", 0 },
    { "staWirelessMode", "0", 0 },
    { "IgmpSnEnable", "1", 0 },
    { "RadioOn", "1", 0 },
    
    { "dlna_enable", "1", 0 },  /* ushare */

	/* ftp server*/
	{ "ftp_enabled", "1", 0 }, /* for app, dlna_enable control this value */
	{ "ftp_name", "AirMobiFTP", 0 },
	{ "ftp_max_sessions", "10", 0 },
	{ "ftp_remove", "1", 0 },
	{ "ftp_read", "1", 0 },
	{ "ftp_upload", "1", 0 },
	{ "ftp_write", "1", 0 },
	{ "ftp_rename", "1", 0 },
	{ "ftp_download", "1", 0 },
	{ "ftp_add_dir", "", 0 },
	{ "ftp_port", "21", 0 },
	{ "ftp_anonymous", "1", 0 },

    { "dlna_mini_enable", "1", 0 }, 
    { "dlna_mini_port", "8200", 0 }, 
    { "enable_tivo", "1", 0 }, 
    { "strict_dlna", "1", 0 }, 

    { "printersrv_enabled", "0", 0 },    
    { "dwld_enabled", "0", 0 },    
    { "alg_ftp_enable", "1", 0 },
    { "alg_tftp_enable", "1", 0 },
    { "alg_h323_enable", "1", 0 },
    { "alg_sip_enable", "0", 0 },
    { "alg_pptp_enable", "1", 0 },
    { "alg_l2tp_enable", "1", 0 },
    { "alg_ipsec_enable", "1", 0 },
    { "spi_fw_enable", "1", 0 },
	{ "mtu_enable", "1", 0},
	//start of that control wan connect on status web by huangfeilan 20110927
	{ "set_wan_stop", "0", 0},
	//end of that control wan connect on status web by huangfeilan 20110927
    
    /* Restore defaults */
    { "restore_defaults", "0", 0 },        /* Set to 0 to not restore defaults on boot */
    { "SetupWizard", "0", 0 },  	//start of to make wireless settings effect by huangfeilan at 20111219

    { "snmpd_enable", "0", 0 },
    { "snmpd_syslocation", "www.autelan.com", 0 },
    { "snmpd_syscontact", "service@autelan.com", 0 },
    { "snmpd_sysname", "router", 0 },
    { "snmpd_rocommunity", "public", 0 },
    { "snmpd_rwcommunity", "private", 0 },
    { "snmpd_trapsink", "192.168.0.100", 0 },
//    { "dhcpd_enable", "0", 0 },	 //according to GPIO switch at rc.c  function restore_defaults()

	{ "cpe_version", CONFIG_CPE_VERSION, 0 },
	{ "wan_nat_x", "0", 0 },
	{ "wan_route_x", "IP_Bridged", 0 },		
	{ "HETbutton_0", "0", 0 },
	{ "HETbutton_1", "0", 0 },
	{ "HETbutton_2", "0", 0 },
	{ "HETbutton_3", "0", 0 },
	{ "ApCliEnable", "0", 0 },
	{ "ApCliSsid", "", 0 },
	{ "ApCliBssid", "", 0 },
	{ "ApCliChannel", "0", 0 },
	{ "ApCliAuthMode", "OPEN", 0 },
	{ "ApCliEncrypType", "NONE", 0 },
	{ "ApCliWPAPSK", "", 0 },
	{ "ApCliDefaultKeyID", "1", 0 },
	{ "ApCliKey1Type", "0", 0 },
	{ "ApCliKey1Str", "", 0 },
	{ "ApCliKey2Type", "0", 0 },
	{ "ApCliKey2Str", "", 0 },
	{ "ApCliKey3Type", "0", 0 },
	{ "ApCliKey3Str", "", 0 },
	{ "ApCliKey4Type", "0", 0 },
	{ "ApCliKey4Str", "", 0 },
#ifdef DEFINE_IREADER
	{ "sw_mode_ex", "6", 0 }, //ireader defualt repeater mode
#else
	{ "sw_mode_ex", "1", 0 }, //itravel II defualt 3g mode
#endif	
	{ "sw_mode_old", "2", 0 }, //AP
	{ "apcli0_hwaddr", "", 0 },

	/*3G Modem*/
	{ "net3gStatus", "0", 0 },	// unplugged
	{ "net3gConnectMode", "KeepAlive", 0 }, 
	{ "net3gIdleTime", "300", 0 },  //five min
	{ "net3gOperatorsName", "1", 0 }, //China Unicom
	{ "net3gmodemDevice", "ttyUSB0", 0 },
	{ "net3gState", "8", 0 }, //China:8 |India:17
	{ "net3gUsername", "", 0 },
	{ "net3gPassword", "", 0 },
	{ "net3gMannual", "0", 0 },
	{ "net3gPinSt", "0", 0 },
	{ "net3gPinCode", "1234", 0 },
	{ "net3gMtu", "1492", 0 },
	{ "net3gDialNum", "*99#", 0 },
	{ "net3gAPN", "3gnet", 0 },
	{ "net3g_set", "0", 0 },
	{ "net3g_sim", "2", 0 },  //3G SIM card: 0 no | 1 yes |2 unknow
	{ "net3g_roaming_en", "0", 0 },

#if defined(DEFINE_AIGO) || defined(DEFINE_EDUP) //EDUP default
	{ "SynSsid", "0", 0 },
#else	
	{ "SynSsid", "1", 0 },
#endif	

#if defined (DEFINE_ITRAVEL2) || defined(DEFINE_ISTORAGE2)
	{ "SafeRemoveType", "1", 0},  //iTravel II does not support SafeRemove
	{ "itravel2_flag", "1", 0},  //For Factory Function Test : iTravel II is unable to distinguish SD and U Disk
#endif

#ifdef DEFINE_DHCP_AUTO_SWITCH  //by wwb 20140811
	{ "dhcpd_enable", "1", 0 },  //κģʽdhcp 
	{ "DhcpdStat", "1", 0},  //for Dhcp_service.asp
	{ "Dhcpdflag", "1", 0},  // for Dhcp_service.asp , value=1 use DhcpdStat 
	/* factory	*/
	{ "factory_SSID1", "", 0},
	{ "factory_WLPSK", "", 0},
	{ "factory_LANIP", "", 0},
#else
	{ "Dhcpdflag", "0", 0},  //for  Dhcp_service.asp , value=0 use dhcpd_enable
#endif

#ifdef HAVE_UBOOT_AUTO_UPGRADE
	{ "upubootflag", "0", 0}, //for uboot auto upgrade by wwb 2014-8-14
#endif

#if 0//def HAVE_USER_SSL_CCMS_CLIENT
	{ "cpeRegisterState", "0", 0},
	{ "cpeServerHost", "cwmp.cctwifi.com", 0},
	{ "cpeServerPort", "8443", 0},
	{ "cpeServerPath", "ccms_v1/device.action", 0},
	{ "cpeid", "", 0},/* CPEк,һעʱΪ */
//	{ "cpeVersion", "1.0", 0},
	{ "cpeUpgradable", "0", 0},
	{ "cpeRFPara", "", 0},
	{ "cpeUbootPath", "", 0},
	{ "cpeKernelPath", "", 0},
	{ "cpeSoftware", "", 0},
	{ "cpeStunServerPath", "cwmp.cctwifi.com:34780", 0},
	{ "cpeUpgradeByAPP", "0", 0},	
	{ "cpeUpgradeByWEB", "0", 0},
	{ "cpeUpgradeKernelExplain", "", 0},
	{ "cpeUpgradeKernelSize","", 0},
	{ "cpeUpgradeKernelVersion", "", 0},
	{ "cpeBeginReboot", "0", 0},
	{ "cpeDownloadImage", "0", 0},
	{ "cpeUpgradeState", "0", 0},
#else
	{ "cpeRegisterState", "0", 0},
//	{ "cpeServerHost", "cwmp.mtomwifi.com", 0},
//	{ "cpeServerPort", "8443", 0},
//	{ "cpeServerPath", "ccms_v1/device.action", 0},
	{ "cpeid", "", 0},/* CPEк,һעʱΪ */
	{ "cpeVersion", "1.0", 0},
	{ "cpeUpgradable", "0", 0},
	{ "cpeRFPara", "", 0},
	{ "cpeUbootPath", "", 0},
	{ "cpeKernelPath", "", 0},
	{ "cpeSoftware", "", 0},
//	{ "cpeStunServerPath", "cwmp.mtomwifi.com:34780", 0},
	{ "cpeUpgradeByAPP", "0", 0},	
	{ "cpeUpgradeByWEB", "0", 0},
	{ "cpeUpgradeKernelExplain", "", 0},
	{ "cpeUpgradeKernelSize","", 0},
	{ "cpeUpgradeKernelVersion", "", 0},
	{ "cpeBeginReboot", "0", 0},
	{ "cpeDownloadImage", "0", 0},
	{ "cpeUpgradeState", "0", 0},
#endif
#ifdef DEFINE_WIFIDOG
	{ "wifidog_enable", "0", 0},
	{ "wd_mac_white_list", "", 0},
	{ "wd_gatewayid", "", 0},
	{ "wd_webservername", "", 0},
	{ "wd_port", "", 0},
	{ "wd_usermaxinum", "", 0},
	{ "wd_interval", "60", 0},
	{ "wd_timeout", "5", 0},
	{ "wd_AuthServerHost", "www.mtomwifi.com", 0},
	{ "wd_AuthServerSSL", "no", 0},
	{ "wd_AuthServerPort", "8080", 0},
	{ "wd_AuthServerPath", "/wifidogServer/wifidog/", 0},
#endif

	{ 0, 0, 0 }
};

/* Translates from, for example, wl0_ (or wl0.1_) to wl_. */
/* Only single digits are currently supported */

static void
fix_name(const char *name, char *fixed_name)
{
    char *pSuffix = NULL;

    /* Translate prefix wlx_ and wlx.y_ to wl_ */
    /* Expected inputs are: wld_root, wld.d_root, wld.dd_root
     * We accept: wld + '_' anywhere
     */
    pSuffix = strchr(name, '_');

    if ((strncmp(name, "wl", 2) == 0) && isdigit(name[2]) && (pSuffix != NULL)) {
        strcpy(fixed_name, "wl");
        strcpy(&fixed_name[2], pSuffix);
        return;
    }

    /* No match with above rules: default to input name */
    strcpy(fixed_name, name);
}


/*
 * Find nvram param name; return pointer which should be treated as const
 * return NULL if not found.
 *
 * NOTE:  This routine special-cases the variable wl_bss_enabled.  It will
 * return the normal default value if asked for wl_ or wl0_.  But it will
 * return 0 if asked for a virtual BSS reference like wl0.1_.
 */
char *
nvram_default_get(const char *name)
{
    int idx;
    char fixed_name[NVRAM_MAX_VALUE_LEN];

    fix_name(name, fixed_name);
    if (strcmp(fixed_name, "wl_bss_enabled") == 0) {
        if (name[3] == '.' || name[4] == '.') { /* Virtual interface */
            return "0";
        }
    }

    for (idx = 0; router_defaults[idx].name != NULL; idx++) {
        if (strcmp(router_defaults[idx].name, fixed_name) == 0) {
            return router_defaults[idx].value;
        }
    }

    return NULL;
}
