/*
 * link chain utility functions
 *
 * Copyright (C) 2011, WDK Corporation
 * All Rights Reserved.
 *
 * THIS SOFTWARE IS OFFERED "AS IS", AND WDK GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. WDK
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: lutils.c, by zhaoyanming 2011/06/02 Exp $
 */

#ifndef LUTILS_H
#define LUTILS_H

typedef struct node_t_
{
    void *p_entry;
    struct node_t_ *p_next;
}
node_t;

typedef int add_entry_f(  node_t *p_node, void *p_data );
typedef int match_entry_f( node_t *p_node, void *p_entry, void *p_key );
typedef int del_entry_f( void *p_entry );

typedef struct class_link_t_
{
    int i_node_sum;
    int i_fresh_flag;
    node_t *p_head;
    node_t *p_curr;
    node_t *p_end;
    add_entry_f *add_func;
    match_entry_f *match_func;
    del_entry_f *del_func;
}
class_link_t;

class_link_t *ltls_create_link_object( add_entry_f *addf,
                                       match_entry_f *machf,
                                       del_entry_f *delf );
class_link_t *ltls_destory_object( class_link_t *p_obj );
int ltls_fresh_object( class_link_t *p_obj );

void *ltls_get_entry( class_link_t *p_obj, void *p_entry, void *p_key );
void *ltls_get_next_entry( class_link_t *p_obj );

int ltls_add_node( class_link_t *p_obj, void *p_data );
node_t *ltls_get_node( class_link_t *p_obj, void *p_entry, void *p_key );
node_t *ltls_get_next_node( class_link_t *p_obj );

int ltls_del_node( class_link_t *p_obj, node_t *p_node );
int ltls_free_nodes( class_link_t *p_obj );

#endif /* LUTILS_H */

