
#ifndef _shared_h_
#define  _shared_h_

// misc.c
enum {
	ACT_IDLE,
	ACT_RC_HOTPLUG,
	ACT_RC_STOP,
	ACT_RC_START,
	ACT_RC_SERVICE,
	ACT_BOUND_LAN,
	ACT_NETWORK_LAN,
	ACT_NETWORK_WL,
	ACT_REBOOT,
	ACT_UPGRADE,
	ACT_USB3G_AT,
	ACT_UNKNOWN,
};
enum {
	USB3G_CONN,   //Connect Network
	USB4G_CONN,
	USB3G_DISC,   // DisConnect Network
	USB3G_INIT,
	USB3G_SIMERROR,   // SIM ERROR
	USB3G_SEARCH, //Search Network
	USB3G_DIAL,   //Dialing
	USB3G_REMOVE,
	USB3G_UNKNOW,
};
enum {	
	NO_SERVICE,
	SYS_MODE_AMPS,
	SYS_MODE_CDMA,
	SYS_MODE_GSM,
	SYS_MODE_EVDO,
	SYS_MODE_WCDMA,
	SYS_MODE_LTE=9,
	SYS_SYS_MODE_GWL,
};


extern int gpio_led_on(int gpio);
extern int gpio_led_off(int gpio);
extern int gpio_led_blinks(int gpio,int ons,int offs);

extern int is_phyconnected(void);
extern int check_netup(void);
extern int tcpcheck_net(const char *host, int port);

extern int check_repeater_connect_state();
typedef struct {
	unsigned long total;
	unsigned long free;
#if 0
	unsigned long shared;
	unsigned long buffers;
	unsigned long cached;
	unsigned long swaptotal;
	unsigned long swapfree;
	unsigned long maxfreeram;
#endif
} meminfo_t;
extern int get_memory(meminfo_t *m);

// files.c
#define FW_CREATE	0
#define FW_APPEND	1
#define FW_NEWLINE	2

#define TCPCHECK_TMPFILE "/tmp/.tcpcheck.tmp"
#define PING_RESULT_FILE "/tmp/ping_success"
#define TCPCHECK_TIMEOUT 3

#define STATE_OK 1
#define STATE_NO 0

extern int lock_file(const char * lock_file);
extern int unlock_file(const char * lock_file);

extern unsigned long f_size(const char *path);
extern int f_file_exist(const char *filepath);
extern int f_exists(const char *file);
extern int d_exist(const char *path);
extern int l_exist(const char *path);
extern int f_read(const char *file, void *buffer, int max);												// returns bytes read
extern int f_write(const char *file, const void *buffer, int len, unsigned flags, unsigned cmode);		//
extern int f_read_string(const char *file, char *buffer, int max);										// returns bytes read, not including term; max includes term
extern int f_write_string(const char *file, const char *buffer, unsigned flags, unsigned cmode);		//
extern int f_read_alloc(const char *path, char **buffer, int max);
extern int f_read_alloc_string(const char *path, char **buffer, int max);
extern int f_wait_exists(const char *name, int max);
extern int f_wait_notexists(const char *name, int max);

// pids.c
extern int pids(char *appname);

// umodemlib.c
#ifdef DEFINE_G4
extern void set_net3g_status(int stat);
extern int check_net3g_status(void);

#define  AT_CMD_FILE				"/var/ppp/atcmd"
#define  AT_RESULT_FILE			    "/var/ppp/atresult_1"
#define  AT_BUF_MAX     256
#define  USB_MODEM_UNK  1
#define  USB_MODEM_2G   2               
#define  USB_MODEM_3G   3
#define  USB_MODEM_4G   4
#define  USB_MODEM_ERR  4

extern int Atcmd(const char *cmd, char *dev);
extern int isAtcmdOK(char *atcmd,char *ttyitf);
extern int net_ttyusb_signal(void);
extern int read_cardinfo(struct systype_info *cardinfo);
extern int net_ttyusb_cpin(void);
extern int net_ttyusb_cgreg(void);
extern int net_ttyusb_ismi(void);
extern int is_usb_modem_from_proc(void);
extern int is_usb_modem_ok(void);
extern int is_usb_modem_ready_ok(int times);

#ifdef MODEM_UV901
#define modem_ttydev	"/dev/ttyUSB0"
#define at_ttydev		"/dev/ttyUSB1"
#elif defined(MODEM_HVL600)
#define modem_ttydev    "/dev/ttyUSB1"
#define at_ttydev       "/dev/ttyUSB2"
#elif defined(MODEM_CLM630)
#define modem_ttydev	"/dev/ttyUSB3"
#define at_ttydev		"/dev/ttyUSB2"
#else
#define modem_ttydev	"/dev/ttyUSB0"
#define at_ttydev		"/dev/ttyUSB1"
#endif

#endif

#define lock_usbnet_at "/tmp/usbnet_at.lock"
#define lock_start_3g "/tmp/start_3g.lock"


#endif /* _shared_h_ */
