/* vi: set sw=4 ts=4 sts=4: */
/*
 *	wireless.c -- Wireless Settings
 *
 *	Copyright (c) Ralink Technology Corporation All Rights Reserved.
 *
 *	$Id: wireless.c,v 1.187.2.3 2010-07-29 10:33:44 chhung Exp $
 */

#include	<signal.h>
#include	<stdlib.h>
#include	<sys/ioctl.h>
#include	<arpa/inet.h>
#include	"../../autoconf.h"
#ifdef CONFIG_DEFAULTS_KERNEL_2_6_21
  #include	<linux/types.h>
  #include	<linux/socket.h>
  #include	<linux/if.h>
#endif
#include	<linux/wireless.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/resource.h>
#include <oid.h>
#include <notify.h>

#include	"internet.h"
#include	"bcmnvram.h"
#include	"utils.h"
#include	"webs.h"
#include	"wireless.h"
#include	"wps.h"	// add by radar@20081226. for LedReset();
#define AP_MODE
#include	"oid.h"
#include	"stapriv.h"			//for statistics


#include	"linux/autoconf.h"  //kernel config

#ifdef AP_WAPI_SUPPORT
#include	<dirent.h>
#endif
#include <string.h>

/*
 * RT2860, RTINIC, RT2561
 */
static int default_shown_mbssid  = 0;

//extern int g_wsc_configured;
/* start modify wireless disable to wps by liuguangpeng at 20110802 */
//extern int wps_config;
/* end modify wireless disable to wps by liuguangpeng at 20110802 */
#if defined (RTDEV_SUPPORT)
extern int g_Raix_wsc_configured;
#endif

static int  getWAPIBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getDLSBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getDFSBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getCarrierBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlanM2UBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlanApcliBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getMaxBssidNum(int eid, webs_t wp, int argc, char_t **argv);
static int	getMeshBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int	getRVTBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int	getWDSBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int	getMBSSIDBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int	get16MBSSIDBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int	getAutoProvisionBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int	getWSCBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int	getUniWPSBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getVideoTurbineBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getTxBFBuilt(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlan11aChannels(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlan11bChannels(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlan11gChannels(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlanChannel(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlanStatusChannel(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlanCurrentMac(int eid, webs_t wp, int argc, char_t **argv);
static int  getWlanStaInfo(int eid, webs_t wp, int argc, char_t **argv);
static int	getWAPIASCertList(int eid, webs_t wp, int argc, char_t **argv);
static int	getWAPIUserCertList(int eid, webs_t wp, int argc, char_t **argv);
/*start of add Ap search bssid by wangjian at 20110617*/
static int	getApBSSIDList(int eid, webs_t wp, int argc, char_t **argv);
//static int	getApConnectionSSID(int eid, webs_t wp, int argc, char_t **argv);
/*end of add Ap search bssid by wangjian at 20110617*/
static void set_SiteSurvey( webs_t wp, char_t *path, char_t *query );
static int showMACfilterMAC(int eid, webs_t wp, int argc, char_t **argv);
static int getApcliSSID(int eid, webs_t wp, int argc, char_t **argv);
static void wirelessBasic(webs_t wp, char_t *path, char_t *query);
static void wirelessSetting(webs_t wp, char_t *path, char_t *query);

static void wirelessBasicsetting(webs_t wp, char_t *path, char_t *query);
static void wirelessMACFilter(webs_t wp, char_t *path, char_t *query);
static void wirelessAdvanced(webs_t wp, char_t *path, char_t *query);
#ifdef HAVE_GUEST
static void GuestSetting(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef CONFIG_RT2860V2_AP_WDS
static void wirelessWds(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef CONFIG_RT2860V2_AP_APCLI
static void wirelessApcli(webs_t wp, char_t *path, char_t *query);
#endif
static void wirelessWmm(webs_t wp, char_t *path, char_t *query);
static void wirelessGetSecurity(webs_t wp, char_t *path, char_t *query);
static void APSecurity(webs_t wp, char_t *path, char_t *query);
static void AddMacAndDelete(webs_t wp, char_t *path, char_t *query);//leo yuan
static int  is3t3r(int eid, webs_t wp, int argc, char_t **argv);
static int  isWPSConfiguredASP(int eid, webs_t wp, int argc, char_t **argv);
int deleteNthValueMulti(int index[], int count, char *value, char delimit);		/* for Access Policy list deletion*/
static void APDeleteAccessPolicyList(webs_t wp, char_t *path, char_t *query);
void DeleteAccessPolicyList(webs_t wp, char_t *path, char_t *query);
static int  isAntennaDiversityBuilt(int eid, webs_t wp, int argc, char_t **argv);
#ifdef CONFIG_RT2860V2_RT3XXX_ANTENNA_DIVERSITY
static void AntennaDiversity(webs_t wp, char_t *path, char_t *query);
static void getAntenna(webs_t wp, char_t *path, char_t *query);
#endif
#ifdef CONFIG_RT2860V2_AP_MESH
static void wirelessMesh(webs_t wp, char_t *path, char_t *query);
static void meshManualLink(webs_t wp, char_t *path, char_t *query);
static int	ShowMeshState(int eid, webs_t wp, int argc, char_t **argv);
#endif
static void resetApCounters(webs_t wp, char_t *path, char_t *query);
static void wirelessGetSsid( webs_t wp, char_t *path, char_t *query );

/*start of add best channel select by zym at 20100111*/
static void wirelessSelBC( webs_t wp, char_t *path, char_t *query );
static void wirelessChList( webs_t wp, char_t *path, char_t *query );
/*end of add best channel select by zym at 20101221*/

#if 0
static int	getApStats(int eid, webs_t wp, int argc, char_t **argv);
#endif
static int	getApSNR(int eid, webs_t wp, int argc, char_t **argv);
static int	getApTxBFStats(int eid, webs_t wp, int argc, char_t **argv);
static void APDelAccessList(webs_t wp, char_t *path, char_t *query);
static void wirelessRvt(webs_t wp, char_t *path, char_t *query);

void formDefineWireless(void) {
	websAspDefine(T("getWAPIBuilt"), getWAPIBuilt);
	websAspDefine(T("getDLSBuilt"), getDLSBuilt);
	websAspDefine(T("getDFSBuilt"), getDFSBuilt);
	websAspDefine(T("getCarrierBuilt"), getCarrierBuilt);
	websAspDefine(T("getWlanM2UBuilt"), getWlanM2UBuilt);
    websAspDefine(T("showMACfilterMAC"), showMACfilterMAC);
    websAspDefine(T("getMeshBuilt"), getMeshBuilt);
	websAspDefine(T("getRVTBuilt"), getRVTBuilt);
	websAspDefine(T("getWDSBuilt"), getWDSBuilt);
	websAspDefine(T("getMBSSIDBuilt"), getMBSSIDBuilt);
	websAspDefine(T("get16MBSSIDBuilt"), get16MBSSIDBuilt);
	websAspDefine(T("getAutoProvisionBuilt"), getAutoProvisionBuilt);
	websAspDefine(T("getWSCBuilt"), getWSCBuilt);
	websAspDefine(T("getUniWPSBuilt"), getUniWPSBuilt);
	websAspDefine(T("getVideoTurbineBuilt"), getVideoTurbineBuilt);
	websAspDefine(T("getTxBFBuilt"), getTxBFBuilt);

	websAspDefine(T("getWlanApcliBuilt"), getWlanApcliBuilt);
	websAspDefine(T("getMaxBssidNum"), getMaxBssidNum);
	websAspDefine(T("getWlan11aChannels"), getWlan11aChannels);
	websAspDefine(T("getWlan11bChannels"), getWlan11bChannels);
	websAspDefine(T("getWlan11gChannels"), getWlan11gChannels);
	websAspDefine(T("getWlanChannel"), getWlanChannel);
	websAspDefine(T("getWlanStatusChannel"), getWlanStatusChannel);
	websAspDefine(T("getApcliSSID"), getApcliSSID);
	websAspDefine(T("getWlanCurrentMac"), getWlanCurrentMac);
	websAspDefine(T("getWlanStaInfo"), getWlanStaInfo);
	websAspDefine(T("is3t3r"), is3t3r);
	websAspDefine(T("isWPSConfiguredASP"), isWPSConfiguredASP);
	websAspDefine(T("isAntennaDiversityBuilt"), isAntennaDiversityBuilt);
	websAspDefine(T("getApBSSIDList"), getApBSSIDList);
	//websAspDefine(T("getApConnectionSSID"), getApConnectionSSID);
#ifdef CONFIG_RT2860V2_RT3XXX_ANTENNA_DIVERSITY
	websFormDefine(T("AntennaDiversity"), AntennaDiversity);
	websFormDefine(T("getAntenna"), getAntenna);
#endif
	websFormDefine(T("wirelessBasic"), wirelessBasic);
	websFormDefine(T("wirelessSetting"), wirelessSetting);

	websFormDefine(T("wirelessMACFilter"), wirelessMACFilter);
    websFormDefine(T("wirelessBasicsetting"), wirelessBasicsetting);
	websFormDefine(T("wirelessAdvanced"), wirelessAdvanced);
#ifdef HAVE_GUEST
	websFormDefine(T("GuestSetting"), GuestSetting);
#endif
#ifdef CONFIG_RT2860V2_AP_WDS
	websFormDefine(T("wirelessWds"), wirelessWds);
#endif
#ifdef CONFIG_RT2860V2_AP_APCLI
	websFormDefine(T("wirelessApcli"), wirelessApcli);
#endif
	websFormDefine(T("wirelessWmm"), wirelessWmm);
	websFormDefine(T("wirelessGetSecurity"), wirelessGetSecurity);
	websFormDefine(T("APSecurity"), APSecurity);
	websFormDefine(T("AddMacAndDelete"), AddMacAndDelete);  //leo yuan
	websFormDefine(T("APDelAccessList"), APDelAccessList);  //zhengshan
	websFormDefine(T("APDeleteAccessPolicyList"), APDeleteAccessPolicyList);
#ifdef CONFIG_RT2860V2_AP_MESH
	websAspDefine(T("ShowMeshState"), ShowMeshState);
	websFormDefine(T("wirelessMesh"), wirelessMesh);
	websFormDefine(T("meshManualLink"), meshManualLink);
#endif
	websAspDefine(T("getWAPIASCertList"), getWAPIASCertList);
	websAspDefine(T("getWAPIUserCertList"), getWAPIUserCertList);
#if 0
	websAspDefine(T("getApStats"), getApStats);
#endif
	websFormDefine(T("resetApCounters"), resetApCounters);
    websFormDefine(T("wirelessGetSsid"), wirelessGetSsid); /* Add by zym */
    websFormDefine(T("wirelessBestChannel"), wirelessSelBC); /* Add by zym */
    websFormDefine( T("wirelessChannelList"), wirelessChList ); /* Add by zym */
	websAspDefine(T("getApSNR"), getApSNR);
	websAspDefine(T("getApTxBFStats"), getApTxBFStats);
	websFormDefine(T("wirelessRvt"), wirelessRvt);
	websFormDefine(T("set_SiteSurvey"), set_SiteSurvey);
}


#define STF(index, flash_key)	STFs(index, #flash_key, flash_key)
/*
 *   TODO:   move to util.c?
 */
static void STFs(int index, char *flash_key, char *value)
{
	char *result;
	char *tmp = (char *) nvram_get( flash_key);
	if(!tmp)
		tmp = "";
	result = setNthValue(index, tmp, value);
	nvram_set( flash_key, result);
	return ;
}


/* LFF means "Load From Flash" ...*/
#define LFF(result, x, n)	\
							do{		char tmp[128];										\
									if(! ( x  = (char *) nvram_safe_get( #x)) )				\
										tmp[0] = '\0';									\
									else{												\
										if( getNthValueSafe(n, x, ';', tmp, 128) != -1){\
											gstrncat(result, tmp, 4096);				\
										}												\
									}gstrncat(result, "\r", 4096);						\
							}while(0)

/* Load from Web */
#define LFW(x, y)	do{												\
						if(! ( x = websGetVar(wp, T(#y), T(""))))	\
							return;									\
					}while(0)


/* Set the same value into all BSSID */
#define	SetAllValues(bssid_num, flash_key, value)	do {	char buffer[24]; int i=1;						\
																	strcpy(buffer, value);							\
																	while (i++ < bssid_num)							\
																		sprintf(buffer, "%s;%s", buffer, value);	\
																	nvram_set( #flash_key, buffer);		\
															} while(0)

/*
 * description: write 802.11a channels in <select> tag
 */
static int getWlan11aChannels(int eid, webs_t wp, int argc, char_t **argv)
{
	int  idx = 0, channel;
	const char *value = nvram_get("CountryCode");
	const char *channel_s = nvram_get( "Channel");

	channel = (channel_s == NULL)? 0 : atoi(channel_s);
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "FR") == 0) ||
			(strcmp(value, "IE") == 0) || (strcmp(value, "JP") == 0) ||
			(strcmp(value, "HK") == 0)) {
		for (idx = 0; idx < 4; idx++)
			websWrite(wp, T("%s%d %s>%d%s"), "<option value=", 36+4*idx,
					(36+4*idx == channel)? "selected" : "",36+4*idx, "</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "FR") == 0) ||
			(strcmp(value, "IE") == 0) || (strcmp(value, "TW") == 0) ||
			(strcmp(value, "HK") == 0)) {
		for (idx = 4; idx < 8; idx++)
			websWrite(wp, T("%s%d %s>%d%s"), "<option value=", 36+4*idx,
					(36+4*idx == channel)? "selected" : "",36+4*idx, "</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0)) {
		for (idx = 16; idx < 27; idx++)
			websWrite(wp, T("%s%d %s>%d%s"), "<option value=", 36+4*idx,
				   	(36+4*idx == channel)? "selected" : "", 36+4*idx, "</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "TW") == 0) ||
			(strcmp(value, "CN") == 0) || (strcmp(value, "HK") == 0)) {
		for (idx = 28; idx < 32; idx++)
			websWrite(wp, T("%s%d %s>%d%s"), "<option value=",
					36+4*idx+1, (36+4*idx+1 == channel)? "selected" : "",36+4*idx+1, "</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "CN") == 0) ||
			(strcmp(value, "HK") == 0)) {
		return websWrite(wp,
				T("<option value=165 %s>5825MHz (Channel 165)</option>\n"),
				(165 == channel)? "selected" : "");
	}
	return 0;
}
#if 0
{
	int  idx = 0, channel;
	const char *value = nvram_safe_get("CountryCode");
	const char *channel_s = nvram_safe_get( "Channel");

	channel = (channel_s == NULL)? 0 : atoi(channel_s);
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "FR") == 0) ||
			(strcmp(value, "IE") == 0) || (strcmp(value, "JP") == 0) ||
			(strcmp(value, "HK") == 0)) {
		for (idx = 0; idx < 4; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", 36+4*idx,
					(36+4*idx == channel)? "selected" : "", 5180+20*idx,
					"MHz (Channel ", 36+4*idx, ")</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "FR") == 0) ||
			(strcmp(value, "IE") == 0) || (strcmp(value, "TW") == 0) ||
			(strcmp(value, "HK") == 0)) {
		for (idx = 4; idx < 8; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", 36+4*idx,
					(36+4*idx == channel)? "selected" : "", 5180+20*idx,
					"MHz (Channel ", 36+4*idx, ")</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0)) {
		for (idx = 16; idx < 27; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", 36+4*idx,
				   	(36+4*idx == channel)? "selected" : "", 5180+20*idx,
					"MHz (Channel ", 36+4*idx, ")</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "TW") == 0) ||
			(strcmp(value, "CN") == 0) || (strcmp(value, "HK") == 0)) {
		for (idx = 28; idx < 32; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=",
					36+4*idx+1, (36+4*idx+1 == channel)? "selected" : "",
					5180+20*idx+5, "MHz (Channel ", 36+4*idx+1, ")</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "CN") == 0) ||
			(strcmp(value, "HK") == 0)) {
		return websWrite(wp,
				T("<option value=165 %s>5825MHz (Channel 165)</option>\n"),
				(165 == channel)? "selected" : "");
	}
	return 0;
}
#endif

/*
 * description: write 802.11b channels in <select> tag
 */
static int getWlan11bChannels(int eid, webs_t wp, int argc, char_t **argv)
{
	int idx = 0, channel;
	const char *value = nvram_get( "CountryCode");
	const char *channel_s = nvram_get( "Channel");
	channel = (channel_s == NULL)? 0 : atoi(channel_s);
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "JP") == 0) ||
			(strcmp(value, "FR") == 0) || (strcmp(value, "IE") == 0) ||
			(strcmp(value, "TW") == 0) || (strcmp(value, "CN") == 0) ||
			(strcmp(value, "HK") == 0)|| (strcmp(value, "KR") == 0)) {//add "KR" to fix 11b no channel by zengxianzhu at 20110112
		for (idx = 0; idx < 11; idx++)
			websWrite(wp, T("%s%d %s>%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", idx+1, "</option>");
	}

	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "JP") == 0) || (strcmp(value, "TW") == 0) ||
			(strcmp(value, "FR") == 0) ||
			(strcmp(value, "IE") == 0) || (strcmp(value, "CN") == 0) ||
			(strcmp(value, "HK") == 0)|| (strcmp(value, "KR") == 0)) //add "KR" to fix 11b no channel by zengxianzhu at 20110112
	{
		for (idx = 11; idx < 13; idx++)
			websWrite(wp, T("%s%d %s>%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "",idx+1, "</option>");
	}

	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "JP") == 0)) {
		return websWrite(wp,
				T("<option value=14 %s>14</option>\n"),
				(14 == channel)? "selected" : "");
	}
	return 0;
}
#if 0
{
	int idx = 0, channel;
	char *value = nvram_safe_get( "CountryCode");
	char *channel_s = nvram_safe_get( "Channel");

	channel = (channel_s == NULL)? 0 : atoi(channel_s);
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "JP") == 0) ||
			(strcmp(value, "FR") == 0) || (strcmp(value, "IE") == 0) ||
			(strcmp(value, "TW") == 0) || (strcmp(value, "CN") == 0) ||
			(strcmp(value, "HK") == 0)) {
		for (idx = 0; idx < 11; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", 2412+5*idx,
					"MHz (Channel ", idx+1, ")</option>");
	}

	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "JP") == 0) || (strcmp(value, "TW") == 0) ||
			(strcmp(value, "FR") == 0) ||
			(strcmp(value, "IE") == 0) || (strcmp(value, "CN") == 0) ||
			(strcmp(value, "HK") == 0)) {
		for (idx = 11; idx < 13; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", 2412+5*idx,
					"MHz (Channel ", idx+1, ")</option>");
	}

	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "JP") == 0)) {
		return websWrite(wp,
				T("<option value=14 %s>2484MHz (Channel 14)</option>\n"),
				(14 == channel)? "selected" : "");
	}
	return 0;
}
#endif

/*
 * description: write 802.11g channels in <select> tag
 */
static int getWlan11gChannels(int eid, webs_t wp, int argc, char_t **argv)
{
	#if 0
	int idx = 0, channel;
	const char *value = nvram_safe_get( "CountryCode");
	const char *channel_s = nvram_safe_get( "Channel");

	channel = (channel_s == NULL)? 0 : atoi(channel_s);
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "US") == 0) || (strcmp(value, "JP") == 0) ||
			(strcmp(value, "FR") == 0) || (strcmp(value, "IE") == 0) ||
			(strcmp(value, "TW") == 0) || (strcmp(value, "CN") == 0) ||
			(strcmp(value, "HK") == 0)) {
		for (idx = 0; idx < 11; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", 2412+5*idx,
					"MHz (Channel ", idx+1, ")</option>");
	}
	if ((value == NULL) || (strcmp(value, "") == 0) ||
			(strcmp(value, "JP") == 0) || (strcmp(value, "TW") == 0) ||
			(strcmp(value, "FR") == 0) || (strcmp(value, "IE") == 0) ||
			(strcmp(value, "CN") == 0) || (strcmp(value, "HK") == 0)) {
		for (idx = 11; idx < 13; idx++)
			websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", 2412+5*idx,
					"MHz (Channel ", idx+1, ")</option>");
	}

	if ((value == NULL) || (strcmp(value, "") == 0)) {
		return websWrite(wp,
				T("<option value=14 %s>2484MHz (Channel 14)</option>\n"),
				(14 == channel)? "selected" : "");
	}

	#endif
 /*ADD by wangbin*/
    int idx = 0, channel;
	const char *value = nvram_safe_get( "RDRegion");
    const char *channel_s = nvram_get( "Channel");
    channel = (channel_s == NULL)? 0 : atoi(channel_s);
#if 0
    if(strcmp(value, "FCC") == 0)
    {
        for (idx = 0; idx < 11; idx++)
        websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", 2412+5*idx,
					"MHz (Channel ", idx+1, ")</option>");
    }
    else if(strcmp(value, "JAP") == 0)
    {
        for (idx = 0; idx < 14; idx++)
        websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", 2412+5*idx,
					"MHz (Channel ", idx+1, ")</option>");
    }
        else
    {
        for (idx = 0; idx < 13; idx++)
        websWrite(wp, T("%s%d %s>%d%s%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", 2412+5*idx,
					"MHz (Channel ", idx+1, ")</option>");
    }
#else
    if(strcmp(value, "FCC") == 0)
    {
        for (idx = 0; idx < 11; idx++)
        websWrite(wp, T("%s%d %s>%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "",idx+1, "</option>");
    }
    else if(strcmp(value, "JAP") == 0)
    {
        for (idx = 0; idx < 14; idx++)
        websWrite(wp, T("%s%d %s>%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "", idx+1, "</option>");
    }
        else
    {
        for (idx = 0; idx < 13; idx++)
        websWrite(wp, T("%s%d %s>%d%s"), "<option value=", idx+1,
					(idx+1 == channel)? "selected" : "",idx+1, "</option>");
    }
#endif
	return 0;
}

static int getWlanApcliBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_APCLI
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getMaxBssidNum(int eid, webs_t wp, int argc, char_t **argv)
{
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
	return websWrite(wp, T("16"));
#else
	return websWrite(wp, T("8"));
#endif
}

/*
 * description: write channel number or 0 if auto-select
 */
 static int getWlanStatusChannel(int eid, webs_t wp, int argc, char_t **argv)
{
#if 0
	const char *value = nvram_safe_get( "AutoChannelSelect");

	if (NULL == value)
		return websWrite(wp, T("9"));
	if (!strncmp(value, "1", 2))
		return websWrite(wp, T("0"));

		value = nvram_safe_get( "Channel");
		if (NULL == value)
			return websWrite(wp, T("9"));
		else
			return websWrite(wp, T("%s"), value);
#else
		char name[25] = {0};
		char data[256] = {0};
		int socket_id;
		struct iwreq wrq;
		int ret;
		const char *channel = nvram_get("Channel"); 

		socket_id = socket(AF_INET, SOCK_DGRAM, 0);
		if(socket_id < 0) {
			//synchronize svn No.1398 by huangfeilan at 20110820 
			/* start of  taht when wireless is disable , get channel value from nvram on status web by huangfeilan at 20110711 */
			return websWrite(wp,T("%s"), channel);
			//return websWrite(wp, T("9"));
			/* end of  taht when wireless is disable , get channel value from nvram on status web by huangfeilan at 20110711 */		
		}

		sprintf(name, "ra0");
		memset(data, 0, sizeof(data));

		strcpy(wrq.ifr_name, name);
		wrq.u.data.pointer = data;
		wrq.u.data.flags = 0;
		ret = ioctl(socket_id, SIOCGIWFREQ, &wrq);
		close( socket_id ); /* zym+ May 10 2011 */
		
		if(ret != 0)
		{
			/* start of  taht when wireless is disable , get channel value from nvram on status web by huangfeilan at 20110711 */
			return websWrite(wp,T("%s"), channel);
			//return websWrite(wp, T("9"));
			/* end of  taht when wireless is disable , get channel value from nvram on status web by huangfeilan at 20110711 */	
		}
		else
			return websWrite(wp, T("%d"), wrq.u.freq.m);
#endif

}

static int getApcliSSID(int eid, webs_t wp, int argc, char_t **argv)
{

	int opmode = atoi( nvram_safe_get( "sw_mode_ex" ) );

	if(opmode==3 || opmode==6 || opmode==7 || opmode==8)
	{
		//start of Perfect apcliSSID in status page by huangfeilan at 20120222
		char long_buf[4096];
	 	FILE *fp;
	 	memset(long_buf, 0, 4096);
		if(!(fp = popen("iwconfig apcli0", "r")))
			return websWrite(wp, T(""));
	 	fread(long_buf, 1, 4096, fp);
	 //dprintf("check apcli0 interface : %s \n\n",long_buf);
	 	pclose(fp);

		if(strstr(long_buf,"Not-Associated") != NULL)
		{			
			return websWrite(wp, T(""));
		}
	    else if ( nvram_match("ipaddr_ap_mode", "" ) )
		{
			return websWrite(wp, T(""));
		}
		else
		{
			const char *value = nvram_get( "ApCliSsid");
			if(!strcmp(value,""))
			{
				char *p1=strchr(long_buf,'\"');
				p1++;
				char apclissid[33] = {0};
				int i=0;
				while(*p1!='\"')
				{
					apclissid[i]=*p1;
					i++;
					p1++;
				}
				return websWrite(wp, T("%s"),apclissid);
			}
			else
				return websWrite(wp, T("%s"),value);
		}
		//end of Perfect apcliSSID in status page by huangfeilan at 20120222
	}
	return websWrite(wp, T(""));

}

static int getWlanChannel(int eid, webs_t wp, int argc, char_t **argv)
{
#if 1
	const char *value = nvram_get( "AutoChannelSelect");

		if (NULL == value)
			return websWrite(wp, T("9"));
		if (!strncmp(value, "1", 2))
			return websWrite(wp, T("0"));

		value = nvram_get( "Channel");
		if (NULL == value)
			return websWrite(wp, T("9"));
		else
			return websWrite(wp, T("%s"), value);
#else
	/*add by lxg: get data from driver.*/
		char name[25] = {0};
		char data[256] = {0};
		int socket_id;
		struct iwreq wrq;
		int ret;

		socket_id = socket(AF_INET, SOCK_DGRAM, 0);
		if(socket_id < 0) {
			return websWrite(wp, T("9"));
		}

		sprintf(name, "ra0");
		memset(data, 0, sizeof(data));

		strcpy(wrq.ifr_name, name);
		wrq.u.data.pointer = data;
		wrq.u.data.flags = 0;
		ret = ioctl(socket_id, SIOCGIWFREQ, &wrq);

		if(ret != 0)
			return websWrite(wp, T("9"));
		else
			return websWrite(wp, T("%d"), wrq.u.freq.m);
	/*add end by lxg*/
#endif

}

/*
 * description: write MAC address from interface 'ra0'
 */
/*start of retart wan after wl adv set minpegnwei 20120528*/
static int getWlanCurrentMac(int eid, webs_t wp, int argc, char_t **argv)
{
    char if_hw[18] = {0};

	strncpy(if_hw,nvram_safe_get("wl_hwaddr"),sizeof(if_hw)-1);

    return websWrite(wp, T("%s"), if_hw);
}
/*end of retart wan after wl adv set minpegnwei 20120528*/

typedef struct _RT_802_11_MAC_ENTRY {
#ifdef CONFIG_RT2860V2_AP_V24_DATA_STRUCTURE
	unsigned char			ApIdx;
#endif
	unsigned char           Addr[6];
	unsigned char           Aid;
	unsigned char           Psm;     // 0:PWR_ACTIVE, 1:PWR_SAVE
	unsigned char           MimoPs;  // 0:MMPS_STATIC, 1:MMPS_DYNAMIC, 3:MMPS_Enabled
	char                    AvgRssi0;
	char                    AvgRssi1;
	char                    AvgRssi2;
	unsigned int            ConnectedTime;
	MACHTTRANSMIT_SETTING	TxRate;
	unsigned int			LastRxRate;
	int 					StreamSnr[3];
	int 					SoundingRespSnr[3];
} RT_802_11_MAC_ENTRY;

#ifdef CONFIG_RT2860V2_AP_WAPI
#define MAX_NUMBER_OF_MAC               96
#else
#define MAX_NUMBER_OF_MAC               32 // if MAX_MBSSID_NUM is 8, this value can't be larger than 211
#endif

typedef struct _RT_802_11_MAC_TABLE {
	unsigned long            Num;
	RT_802_11_MAC_ENTRY      Entry[MAX_NUMBER_OF_MAC]; //MAX_LEN_OF_MAC_TABLE = 32
} RT_802_11_MAC_TABLE;

static int getWlanStaInfo(int eid, webs_t wp, int argc, char_t **argv)
{
	int i, s;
	struct iwreq iwr;
	RT_802_11_MAC_TABLE table = {0};
#ifdef CONFIG_RT2860V2_AP_TXBF
	char tmpBuff[32];
	char *phyMode[4] = {"CCK", "OFDM", "MM", "GF"};
#endif

	const char *wlanOn = nvram_safe_get( "RadioOn");
	if ( !(atoi(wlanOn)) ) {
		websWrite(wp, T(""));
		return 0;
	}
	s = socket(AF_INET, SOCK_DGRAM, 0);
	strncpy(iwr.ifr_name, "ra0", IFNAMSIZ);
	iwr.u.data.pointer = (caddr_t) &table;
//	iwr.u.data.length = sizeof(RT_802_11_MAC_TABLE);

	if (s < 0) {
		websError(wp, 500, "ioctl sock failed!");
		return -1;
	}

#ifdef CONFIG_RT2860V2_AP_V24_DATA_STRUCTURE
	if (ioctl(s, RTPRIV_IOCTL_GET_MAC_TABLE_STRUCT, &iwr) < 0) {
		websError(wp, 500, "ioctl -> RTPRIV_IOCTL_GET_MAC_TABLE_STRUCT failed!");
#else
	if (ioctl(s, RTPRIV_IOCTL_GET_MAC_TABLE, &iwr) < 0) {
		printf("wireless.c:ioctl -> RTPRIV_IOCTL_GET_MAC_TABLE failed!");
		//websError(wp, 500, "ioctl -> RTPRIV_IOCTL_GET_MAC_TABLE failed!");
#endif
		close(s);
		return -1;
	}

	close(s);
#ifdef CONFIG_RT2860V2_AP_TXBF
	for (i = 0; i < table.Num; i++) {
		RT_802_11_MAC_ENTRY *pe = &(table.Entry[i]);
		unsigned int lastRxRate = pe->LastRxRate;
		unsigned int mcs = pe->LastRxRate & 0x7F;
		int hr, min, sec;

		hr = pe->ConnectedTime/3600;
		min = (pe->ConnectedTime % 3600)/60;
		sec = pe->ConnectedTime - hr*3600 - min*60;

		// MAC Address
		websWrite(wp, T("<tr><td class=\"leftnone\">%02X:%02X:%02X:<br>%02X:%02X:%02X</td>"),
				pe->Addr[0], pe->Addr[1], pe->Addr[2], pe->Addr[3],
				pe->Addr[4], pe->Addr[5]);

		// AID, Power Save mode, MIMO Power Save
		websWrite(wp, T("<td align=\"center\">%d</td><td align=\"center\">%d</td><td align=\"center\">%d</td>"),
				pe->Aid, pe->Psm, pe->MimoPs);

		// TX Rate
		websWrite(wp, T("<td>MCS %d<br>%2dM, %cGI<br>%s%s</td>"),
				pe->TxRate.field.MCS,
				pe->TxRate.field.BW? 40: 20,
				pe->TxRate.field.ShortGI? 'S': 'L',
				phyMode[pe->TxRate.field.MODE],
				pe->TxRate.field.STBC? ", STBC": " ");

		// TxBF configuration
		websWrite(wp, T("<td align=\"center\">%c %c</td>"),
				pe->TxRate.field.iTxBF? 'I': '-',
				pe->TxRate.field.eTxBF? 'E': '-');

		// RSSI
		websWrite(wp, T("<td align=\"center\">%d<br>%d<br>%d</td>"),
				(int)(pe->AvgRssi0), (int)(pe->AvgRssi1), (int)(pe->AvgRssi2));

		// Per Stream SNR
		snprintf(tmpBuff, sizeof(tmpBuff), "%0.1f", pe->StreamSnr[0]*0.25);
		websWrite(wp, T("<td>%s<br>"), tmpBuff);
		snprintf(tmpBuff, sizeof(tmpBuff), "%0.1f", pe->StreamSnr[1]*0.25); //mcs>7? pe->StreamSnr[1]*0.25: 0.0);
		websWrite(wp, T("%s<br>"), tmpBuff);
		snprintf(tmpBuff, sizeof(tmpBuff), "%0.1f", pe->StreamSnr[2]*0.25); //mcs>15? pe->StreamSnr[2]*0.25: 0.0);
		websWrite(wp, T("%s</td>"), tmpBuff);

		// Sounding Response SNR
		if (pe->TxRate.field.eTxBF) {
			snprintf(tmpBuff, sizeof(tmpBuff), "%0.1f", pe->SoundingRespSnr[0]*0.25);
			websWrite(wp, T("<td>%s<br>"), tmpBuff);
			snprintf(tmpBuff, sizeof(tmpBuff), "%0.1f", pe->SoundingRespSnr[1]*0.25);
			websWrite(wp, T("%s<br>"), tmpBuff);
			snprintf(tmpBuff, sizeof(tmpBuff), "%0.1f", pe->SoundingRespSnr[2]*0.25);
			websWrite(wp, T("%s</td>"), tmpBuff);
		}
		else {
			websWrite(wp, T("<td align=\"center\">-<br>-<br>-</td>"));
		}

		// Last RX Rate
		websWrite(wp, T("<td>MCS %d<br>%2dM, %cGI<br>%s%s</td>"),
				mcs,  ((lastRxRate>>7) & 0x1)? 40: 20,
				((lastRxRate>>8) & 0x1)? 'S': 'L',
				phyMode[(lastRxRate>>14) & 0x3],
				((lastRxRate>>9) & 0x3)? ", STBC": " ");

		// Connect time
		websWrite(wp, T("<td align=\"center\" class=\"rightnone\">%02d:%02d:%02d</td>"), hr, min, sec);
		websWrite(wp, T("</tr>"));
	}
#else
	for (i = 0; i < table.Num; i++) {
		websWrite(wp, T("<tr><td class=\"leftnone\">%02X:%02X:%02X:%02X:%02X:%02X</td>"),
				table.Entry[i].Addr[0], table.Entry[i].Addr[1],
				table.Entry[i].Addr[2], table.Entry[i].Addr[3],
				table.Entry[i].Addr[4], table.Entry[i].Addr[5]);
		websWrite(wp, T("<td>%d</td><td>%d</td><td>%d</td>"),
				table.Entry[i].Aid, table.Entry[i].Psm, table.Entry[i].MimoPs);
		websWrite(wp, T("<td>%d</td><td>%s</td><td>%d</td><td class=\"rightnone\">%d</td></tr>"),
				table.Entry[i].TxRate.field.MCS,
				(table.Entry[i].TxRate.field.BW == 0)? "20M":"40M",
				table.Entry[i].TxRate.field.ShortGI, table.Entry[i].TxRate.field.STBC);
	}
#endif
	return 0;
}

static int getWAPIBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef AP_WAPI_SUPPORT
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getDLSBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_DLS
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getDFSBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_DFS
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getCarrierBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_CARRIER
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getWlanM2UBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_IGMP_SNOOP
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getVideoTurbineBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_VIDEO_TURBINE
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getTxBFBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_TXBF
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

int free_apcli_list( apcli_t *p_head )
{
    apcli_t *p_curr = NULL, *p_tmp = NULL;

    p_curr = p_head;
    while( p_curr )
    {
        p_tmp = p_curr;
        p_curr = p_curr->p_next;
        free( p_tmp );
    }

    return 0;
}


/* start of AP203N-W6P add_channel_compare by wangjian at 20110729 */
static int getLocalChannel()
{
	int channel;
	const char *channel_s = nvram_safe_get("Channel");
	channel = (channel_s == NULL)? 0 : atoi(channel_s);
	return channel;
}
/* end of AP203N-W6P add_channel_compare by wangjian at 20110729 */


/* start of AP203N-W6P search_connect by wangjian at 20110624 */
static int getApBSSIDList(int eid, webs_t wp, int argc, char_t **argv)
{
	int i = 0, Num = 0;
    apcli_t *p_head = NULL, *p_curr = NULL;
    //doSystem( "iwpriv ra0 set SiteSurvey=1" );
    //sleep( 1 );
	get_site_survey_ap( &p_head );
	if ( p_head == NULL ) {
		websWrite(wp, "Bssid List number is 0!\n");
		return 0;
	}
	p_curr = p_head;

	unsigned char tmpNum[16], tmpRadio[188], tmpBSSIDII[16], tmpBSSID[28], tmpSSID[64+32*4], tmpRSSI[60], tmpChannel[16], tmpAuth[32], tmpEncry[52], tmp2Encry[8], tmp3Encry[8], tmpNetworkType[24];
	unsigned char tmpSSIDII[(32+1)*4];
	char macnull[2]={0},mac1[3]={0},mac2[3]={0},mac3[3]={0},mac4[3]={0},mac5[3]={0},mac6[3]={0};
	char strconnect[ 12 ]= "__connect";
	int nSigQua = 0;
	int nChannel = 1;
	unsigned char radiocheck[8];
	int localchannel = getLocalChannel();

	while (p_curr)
	{
		memset(radiocheck, 0x00, sizeof(radiocheck));
		memset(tmpRadio, 0x00, sizeof(tmpRadio));
		memset(tmpBSSID, 0x00, sizeof(tmpBSSID));
		memset(tmpRSSI, 0x00, sizeof(tmpRSSI));
		memset(tmpSSID, 0x00, sizeof(tmpSSID));
		memset(tmpChannel, 0x00, sizeof(tmpChannel));
		memset(tmpAuth, 0x00, sizeof(tmpAuth));
		memset(tmpEncry, 0x00, sizeof(tmpEncry));
		memset(tmp2Encry, 0x00, sizeof(tmp2Encry));
		memset(tmp3Encry, 0x00, sizeof(tmp3Encry));
		memset(tmpNetworkType, 0x00, sizeof(tmpNetworkType));
		memset(tmpBSSIDII, 0x00, sizeof(tmpBSSIDII));
		memset(tmpSSIDII, 0x00, sizeof(tmpSSIDII));
		memset(tmpNum, 0x00, sizeof(tmpNum));

		char strBssid[ 24 ] = { 0 };
		char strSsid[ 38 ] = { 0 };
		int curr_channel = 0;
		curr_channel = p_curr->i_channel;
		//char sChannel[16] = {0};
		strcpy(strSsid, p_curr->s_ssid);
		strcpy(strBssid, p_curr->s_bssid);
		sprintf((char *)tmpSSID, "<td>%s</td>", strSsid);
		sprintf((char *)tmpBSSID, "<td>%s</td>", strBssid);
		i++;
		Num = i;
		sprintf((char *)tmpNum, "<td>%d</td>", Num);

		nSigQua = p_curr->i_single;
       	sprintf((char *)tmpRSSI,"<td>%d%s</td>", nSigQua,"dBm");

		nChannel = p_curr->i_channel;
		sprintf((char *)tmpChannel, "<td>%d</td>", nChannel);
		//sprintf((char *)sChannel, "<td>%d</td>", nChannel);

		if (strncmp(p_curr->s_nt, "In", 2) == 0)
			sprintf((char *)tmpNetworkType, "<td>%s</td>", "Infrastructure");
		else
			sprintf((char *)tmpNetworkType, "<td>%s</td>", "Ad Hoc");

		char strAuth[ 7 ] = { 0 };
		char strEncry[ 7 ] = { 0 };
		strcpy(strAuth, p_curr->s_wps);
		strcpy(strEncry, p_curr->s_security);
		sprintf((char *)tmpAuth, "<td>%s</td>", strAuth);
		sprintf((char *)tmpEncry, "<td>%s</td>", strEncry);
		strcpy(radiocheck, "");
		char tmpMode[ 13 ]= { 0 };
		strcpy(tmpMode, p_curr->s_mode);
		sprintf((char *)tmpRadio, "<td><input type=radio name=selectedSSID %s value=\"%s\" onClick=\"selectedSSIDChange(this.value,'%s',%s,%d,'%s','%s')\"></td>", radiocheck, tmpSSIDII, tmpBSSIDII, tmpMode, nChannel, strEncry, strAuth);
		//strcpy(mac, strBssid);
		mac1[0] = strBssid[0];
		mac1[1] = strBssid[1];
		mac2[0] = strBssid[3];
		mac2[1] = strBssid[4];
		mac3[0] = strBssid[6];
		mac3[1] = strBssid[7];
		mac4[0] = strBssid[9];
		mac4[1] = strBssid[10];
		mac5[0] = strBssid[12];
		mac5[1] = strBssid[13];
		mac6[0] = strBssid[15];
		mac6[1] = strBssid[16];

		if(strstr(tmpEncry,"WEP")!=0)
			memcpy(tmp2Encry,"WEP",3);
		else if((strstr(tmpEncry,"WPAPSK")!=0)||(strstr(tmpEncry,"WPA2PSK")!=0)||(strstr(tmpEncry,"WPA1PSK")!=0))
		{
				if(strstr(tmpEncry,"WPA2PSK")!=0)
					memcpy(tmp2Encry,"WPA2PSK",7);
				else
					memcpy(tmp2Encry,"WPAPSK",6);
		}			
		else
			memcpy(tmp2Encry,"NONE",4);
		

		if(strstr(tmpEncry,"AES")!=0)
			memcpy(tmp3Encry,"AES",3);
		else if(strstr(tmpEncry,"TKIP")!=0)
			memcpy(tmp3Encry,"TKIP",4);
		else if(strstr(tmpEncry,"WEP")!=0)
			memcpy(tmp3Encry,"WEP",3);

//		websWrite(wp, T("<tr> %s %s %s %s %s %s %s \n"), tmpRadio, tmpSSID, tmpBSSID, tmpRSSI, tmpChannel, tmpEncry, tmpAuth);
		websWrite(wp, T("<tr> %s %s %s %s %s %s \n"), tmpNum, tmpSSID, tmpBSSID, tmpRSSI, tmpChannel, tmpEncry);
		websWrite(wp,T("<td class=\"connect_a\"><script>function SearchMacFromPopup_%d(){\n"),i);

/*wds1-4-1234*/
		websWrite(wp,T("if(1 == document.ap_site_survey.searchmac.value "));
		websWrite(wp,T("|| 2 == document.ap_site_survey.searchmac.value"));
		websWrite(wp,T("|| 3 == document.ap_site_survey.searchmac.value"));
		websWrite(wp,T("|| 4 == document.ap_site_survey.searchmac.value){"));
		/*add wds_1/wds_2/wds_3/wds_4*/
		websWrite(wp,T("if(((parent.opener.self.document.wireless_basic.wds_11.value == \"%s\")"),mac1);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_12.value == \"%s\")"),mac2);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_13.value == \"%s\")"),mac3);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_14.value == \"%s\")"),mac4);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_15.value == \"%s\")"),mac5);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_16.value == \"%s\"))||"),mac6);  
		websWrite(wp,T("((parent.opener.self.document.wireless_basic.wds_21.value == \"%s\")"),mac1);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_22.value == \"%s\")"),mac2);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_23.value == \"%s\")"),mac3);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_24.value == \"%s\")"),mac4);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_25.value == \"%s\")"),mac5);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_26.value == \"%s\")) || \n  "),mac6);
		websWrite(wp,T("((parent.opener.self.document.wireless_basic.wds_31.value == \"%s\")"),mac1);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_32.value == \"%s\")"),mac2);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_33.value == \"%s\")"),mac3);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_34.value == \"%s\")"),mac4);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_35.value == \"%s\")"),mac5);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_36.value == \"%s\")) || \n  "),mac6);
		websWrite(wp,T("((parent.opener.self.document.wireless_basic.wds_41.value == \"%s\")"),mac1);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_42.value == \"%s\")"),mac2);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_43.value == \"%s\")"),mac3);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_44.value == \"%s\")"),mac4);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_45.value == \"%s\")"),mac5);
		websWrite(wp,T("&&(parent.opener.self.document.wireless_basic.wds_46.value == \"%s\"))){alert('Already exist this one, please choose other!'); location.href=location.href; return;}"),mac6);

		/*channel compare*/
		//websWrite(wp,T("else if (\"%d\" != \"%d\"){alert('Local channel is %d,please choose the same channel or change the Local channel(Turn to AP Operation mode)!');return;}"),localchannel,curr_channel,localchannel);
		/*channel compare*/

		websWrite(wp,T("else if (1 == document.ap_site_survey.searchmac.value) {")); 
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_1.value=\"%s\";\n"),mac);  
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_11.value=\"%s\";\n"),mac1);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_12.value=\"%s\";\n"),mac2);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_13.value=\"%s\";\n"),mac3);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_14.value=\"%s\";\n"),mac4);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_15.value=\"%s\";\n"),mac5);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_16.value=\"%s\";\n}"),mac6);	
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.ETbutton0.checked=true;\n"));
		//websWrite(wp,T("parent.opener.self.showEncryption(0);\n"));
		//websWrite(wp,T("if(\"%s\"==\"WEP\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type0.options.selectedIndex = 2;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPAPSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type0.options.selectedIndex = 3;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPA2PSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type0.options.selectedIndex = 4;\n"));	
		//websWrite(wp,T("else\n"));
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type0.options.selectedIndex = 0;\n"));
		//websWrite(wp,T("parent.opener.self.WdsSecurityOnChange(0);\n}"));
		websWrite(wp,T("else if (2 == document.ap_site_survey.searchmac.value) {"));
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_2.value=\"%s\";\n"),mac);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_21.value=\"%s\";\n"),mac1);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_22.value=\"%s\";\n"),mac2);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_23.value=\"%s\";\n"),mac3);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_24.value=\"%s\";\n"),mac4);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_25.value=\"%s\";\n"),mac5);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_26.value=\"%s\";\n}"),mac6);	
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.ETbutton1.checked=true;\n"));
		//websWrite(wp,T("parent.opener.self.showEncryption(1);\n"));
		//websWrite(wp,T("if(\"%s\"==\"WEP\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type1.options.selectedIndex = 2;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPAPSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type1.options.selectedIndex = 3;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPA2PSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type1.options.selectedIndex = 4;\n"));	
		//websWrite(wp,T("else\n"));
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type1.options.selectedIndex = 0;\n"));
		//websWrite(wp,T("parent.opener.self.WdsSecurityOnChange(1);\n}"));
		websWrite(wp,T("else if (3 == document.ap_site_survey.searchmac.value) {"));
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_3.value=\"%s\";\n"),mac);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_31.value=\"%s\";\n"),mac1);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_32.value=\"%s\";\n"),mac2);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_33.value=\"%s\";\n"),mac3);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_34.value=\"%s\";\n"),mac4);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_35.value=\"%s\";\n"),mac5);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_36.value=\"%s\";\n}"),mac6);	
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.ETbutton2.checked=true;\n"));
		//websWrite(wp,T("parent.opener.self.showEncryption(2);\n"));
		//websWrite(wp,T("if(\"%s\"==\"WEP\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type2.options.selectedIndex = 2;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPAPSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type2.options.selectedIndex = 3;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPA2PSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type2.options.selectedIndex = 4;\n"));	
		//websWrite(wp,T("else\n"));
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type2.options.selectedIndex = 0;\n"));
		//websWrite(wp,T("parent.opener.self.WdsSecurityOnChange(2);\n}"));
		websWrite(wp,T("else if (4 == document.ap_site_survey.searchmac.value) {"));
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_4.value=\"%s\";\n"),mac);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_41.value=\"%s\";\n"),mac1);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_42.value=\"%s\";\n"),mac2);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_43.value=\"%s\";\n"),mac3);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_44.value=\"%s\";\n"),mac4);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_45.value=\"%s\";\n"),mac5);
		websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_46.value=\"%s\";\n}}"),mac6);	
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.ETbutton3.checked=true;\n"));
		//websWrite(wp,T("parent.opener.self.showEncryption(3);\n"));
		//websWrite(wp,T("if(\"%s\"==\"WEP\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type3.options.selectedIndex = 2;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPAPSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type3.options.selectedIndex = 3;\n"));
		//websWrite(wp,T("else if(\"%s\"==\"WPA2PSK\")\n"),tmp2Encry);
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type3.options.selectedIndex = 4;\n"));	
		//websWrite(wp,T("else\n"));
		//websWrite(wp,T("parent.opener.self.document.wireless_basic.wds_encryp_type3.options.selectedIndex = 0;\n"));
		//websWrite(wp,T("parent.opener.self.WdsSecurityOnChange(3);\n}}"));
/*wds1-4-1234*/


/*apcli*/
		websWrite(wp,T("if(5 == document.ap_site_survey.searchmac.value){"));		
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_ssid.value=\"%s\";\n"),strSsid);
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_bssid.value=\"%s\";\n"),strBssid);
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_channel.value=\"%d\";\n"),nChannel);

		websWrite(wp,T("if(\"%s\"==\"WPAPSK\")\n"),tmp2Encry);
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_mode.options.selectedIndex = 2;\n"));
		websWrite(wp,T("else if(\"%s\"==\"WPA2PSK\")\n"),tmp2Encry);
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_mode.options.selectedIndex = 3;\n"));
		websWrite(wp,T("else\n"));
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_mode.options.selectedIndex = 0;\n"));

		websWrite(wp,T("window.parent.SecurityModeSwitch();\n"));
		websWrite(wp,T("if(\"%s\"==\"TKIP\")\n"),tmp3Encry);
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_enc.options.selectedIndex = 0;\n"));
		websWrite(wp,T("else if(\"%s\"==\"AES\")\n"),tmp3Encry);
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_enc.options.selectedIndex = 1;\n"));
		websWrite(wp,T("else if(\"%s\"==\"WEP\")\n"),tmp3Encry);
		websWrite(wp,T("{window.parent.document.wireless_basic.apcli_enc.options.selectedIndex = 0;\n}"));
		websWrite(wp,T("else\n"));
		websWrite(wp,T("window.parent.document.wireless_basic.apcli_enc.options.selectedIndex = 1;\n"));

		websWrite(wp,T("window.parent.EncryptModeSwitch();\n"));		
		websWrite(wp,T("window.parent.document.getElementById(\"iframepage_apcli\").src = \"\";\n"));
		websWrite(wp,T("window.parent.document.getElementById(\"iframepage_apcli\").style.display = \"none\";\n"));		
		websWrite(wp,T("window.parent.top.document.getElementsByTagName('link')[0].href = \"css/styleweb.css\";\n"));
		websWrite(wp,T("window.parent.document.getElementById(\"wirelessinfo\").style.display = \"\";\n"));
		websWrite(wp,T("window.parent.document.getElementById(\"buttond1\").style.display = \"\";\n}")); 
	
/*apcli*/
		
/*stacli*/
		websWrite(wp,T("if(6 == document.ap_site_survey.searchmac.value){")); 
		websWrite(wp,T("parent.opener.self.document.wireless_basic.Ssid.value=\"%s\";\n}"),strSsid);
/*stacli*/
/*apcli_quicksetup liugang,20130322*/
		websWrite(wp,T("if(7 == document.ap_site_survey.searchmac.value){"));


		websWrite(wp,T("window.parent.document.quicksetup.apcli_ssid.value=\"%s\";\n"),strSsid);


		websWrite(wp,T("if(\"%s\"==\"WPAPSK\")\n"),tmp2Encry);
		websWrite(wp,T("window.parent.document.quicksetup.apcli_mode.options.selectedIndex = 2;\n"));
		websWrite(wp,T("else if(\"%s\"==\"WPA2PSK\")\n"),tmp2Encry);
		websWrite(wp,T("window.parent.document.quicksetup.apcli_mode.options.selectedIndex = 3;\n"));
		websWrite(wp,T("else\n"));
		websWrite(wp,T("window.parent.document.quicksetup.apcli_mode.options.selectedIndex = 0;\n"));

		websWrite(wp,T("window.parent.SecurityModeSwitch();\n"));
		websWrite(wp,T("if(\"%s\"==\"TKIP\")\n"),tmp3Encry);
		websWrite(wp,T("window.parent.document.quicksetup.apcli_enc.options.selectedIndex = 0;\n"));
		websWrite(wp,T("else if(\"%s\"==\"AES\")\n"),tmp3Encry);
		websWrite(wp,T("window.parent.document.quicksetup.apcli_enc.options.selectedIndex = 1;\n"));
		websWrite(wp,T("else if(\"%s\"==\"WEP\")\n"),tmp3Encry);
		websWrite(wp,T("window.parent.document.quicksetup.apcli_enc.options.selectedIndex = 0;\n"));
		websWrite(wp,T("else\n"));
		websWrite(wp,T("window.parent.document.quicksetup.apcli_enc.options.selectedIndex = 1;\n"));

		websWrite(wp,T("window.parent.EncryptModeSwitch();\n"));
		websWrite(wp,T("window.parent.document.getElementById(\"iframepage_apcli\").src = \"\";\n"));
		websWrite(wp,T("window.parent.document.getElementById(\"iframepage_apcli\").style.display = \"none\";\n"));		
		websWrite(wp,T("window.parent.document.getElementById(\"quick_setup9\").style.display = \"\";\n}")); 
	
/*apcli_quicksetup*/
		//for iphone safari
 		websWrite(wp,T("top.document.getElementById(\"mainbody\").style.height=\"800px\";")); 
		websWrite(wp,T("top.document.getElementById(\"iframepage\").style.height=\"800px\";"));
		websWrite(wp,T("window.parent.getElementById(\"iframepage_apcli\").style.height=\"800px\";")); 
		websWrite(wp,T("}</script>")); 
		/*start of change multi language minpengwei 20120525 */
		websWriteWithTranslation(wp, T("<a style=\"text-decoration:underline;\" href=\"#\" onclick=\"SearchMacFromPopup_%d();\"><#Connect#></a></td></tr>"), i);
		/*end of change multi language minpengwei 20120525 */
		p_curr = p_curr->p_next;
	}

	free_apcli_list( p_head );
	p_head = NULL;
	
	return 0;
}

static void set_SiteSurvey( webs_t wp, char_t *path, char_t *query )
{
    doSystem( "iwpriv ra0 set SiteSurvey=1" );
	return;
}

/* end of AP203N-W6P search_connect by wangjian at 20110624 */
static void revise_mbss_value(int old_num, int new_num)
{
	/* {{{ The parameters that support multiple BSSID is listed as followed,
	   1.) SSID,                 char SSID[33];
	   2.) AuthMode,             char AuthMode[14];
	   3.) EncrypType,           char EncrypType[8];
	   4.) WPAPSK,               char WPAPSK[65];
	   5.) DefaultKeyID,         int  DefaultKeyID;
	   6.) Key1Type,             int  Key1Type;
	   7.) Key1Str,              char Key1Str[27];
	   8.) Key2Type,             int  Key2Type;
	   9.) Key2Str,              char Key2Str[27];
	   10.) Key3Type,            int  Key3Type;
	   11.) Key3Str,             char Key3Str[27];
	   12.) Key4Type,            int  Key4Type;
	   13.) Key4Str,             char Key4Str[27];
	   14.) AccessPolicy,
	   15.) AccessControlList,
	   16.) NoForwarding,
	   17.) IEEE8021X,           int  IEEE8021X;
	   18.) TxRate,              int  TxRate;
	   19.) HideSSID,            int  HideSSID;
	   20.) PreAuth,             int  PreAuth;
	   21.) WmmCapable
	                             int  SecurityMode;
                             	 char VlanName[20];
	                             int  VlanId;
	                             int  VlanPriority;
	}}} */
	char new_value[264], *p;
	const char *old_value;
	int i;

#define MBSS_INIT(field, default_value) \
	do { \
		old_value = nvram_safe_get( #field); \
		snprintf(new_value, 264, "%s", old_value); \
		p = new_value + strlen(old_value); \
		for (i = old_num; i < new_num; i++) { \
			snprintf(p, 264 - (p - new_value), ";%s", default_value); \
			p += 1 + strlen(default_value); \
		} \
		nvram_set( #field, new_value); \
	} while (0)

#define MBSS_REMOVE(field) \
	do { \
		old_value = nvram_safe_get( #field); \
		snprintf(new_value, 264, "%s", old_value); \
		p = new_value; \
		for (i = 0; i < new_num; i++) { \
			if (0 == i) \
				p = strchr(p, ';'); \
			else \
				p = strchr(p+1, ';'); \
			if (NULL == p) \
				break; \
		} \
		if (p) \
			*p = '\0'; \
		nvram_set( #field, new_value); \
	} while (0)

	if (new_num > old_num) {
		//MBSS_INIT(SSID, "ssid");
		MBSS_INIT(AuthMode, "OPEN");
		MBSS_INIT(EncrypType, "NONE");
		//MBSS_INIT(WPAPSK, "12345678");
		MBSS_INIT(DefaultKeyID, "1");
		MBSS_INIT(Key1Type, "0");
		//MBSS_INIT(Key1Str, "");
		MBSS_INIT(Key2Type, "0");
		//MBSS_INIT(Key2Str, "");
		MBSS_INIT(Key3Type, "0");
		//MBSS_INIT(Key3Str, "");
		MBSS_INIT(Key4Type, "0");
		//MBSS_INIT(Key4Str, "");
/*		MBSS_INIT(AccessPolicy0, "0");
		MBSS_INIT(AccessControlList0, "");
		MBSS_INIT(AccessPolicy1, "0");
		MBSS_INIT(AccessControlList1, "");
		MBSS_INIT(AccessPolicy2, "0");
		MBSS_INIT(AccessControlList2, "");
		MBSS_INIT(AccessPolicy3, "0");
		MBSS_INIT(AccessControlList3, ""); */
		MBSS_INIT(NoForwarding, "0");
		MBSS_INIT(NoForwardingBTNBSSID, "0");
		MBSS_INIT(IEEE8021X, "0");
		MBSS_INIT(TxRate, "0");
		//MBSS_INIT(HideSSID, "0");
		MBSS_INIT(PreAuth, "0");
		MBSS_INIT(WmmCapable, "1");
		for (i = old_num + 1; i <= new_num; i++) {
			nvram_set( racat("WPAPSK", i), "12345678");
			nvram_set( racat("Key1Str", i), "");
			nvram_set( racat("Key2Str", i), "");
			nvram_set( racat("Key3Str", i), "");
			nvram_set( racat("Key4Str", i), "");
			// The index of AccessPolicy & AccessControlList starts at 0.
			nvram_set( racat("AccessPolicy", i-1), "0");
			nvram_set( racat("AccessControlList", i-1), "");
		}
	}
	else if (new_num < old_num) {
		//MBSS_REMOVE(SSID);
		MBSS_REMOVE(AuthMode);
		MBSS_REMOVE(EncrypType);
		//MBSS_REMOVE(WPAPSK);
		MBSS_REMOVE(DefaultKeyID);
		MBSS_REMOVE(Key1Type);
		//MBSS_REMOVE(Key1Str);
		MBSS_REMOVE(Key2Type);
		//MBSS_REMOVE(Key2Str);
		MBSS_REMOVE(Key3Type);
		//MBSS_REMOVE(Key3Str);
		MBSS_REMOVE(Key4Type);
		//MBSS_REMOVE(Key4Str);
/*		MBSS_REMOVE(AccessPolicy0);
		MBSS_REMOVE(AccessControlList0);
		MBSS_REMOVE(AccessPolicy1);
		MBSS_REMOVE(AccessControlList1);
		MBSS_REMOVE(AccessPolicy2);
		MBSS_REMOVE(AccessControlList2);
		MBSS_REMOVE(AccessPolicy3);
		MBSS_REMOVE(AccessControlList3); */
		MBSS_REMOVE(NoForwarding);
		MBSS_REMOVE(NoForwardingBTNBSSID);
		MBSS_REMOVE(IEEE8021X);
		MBSS_REMOVE(TxRate);
		MBSS_REMOVE(HideSSID);
		MBSS_REMOVE(PreAuth);
		MBSS_REMOVE(WmmCapable);
		for (i = new_num + 1; i <= old_num; i++) {
			nvram_set( racat("SSID", i), "");
			nvram_set( racat("WPAPSK", i), "");
			nvram_set( racat("Key1Str", i), "");
			nvram_set( racat("Key2Str", i), "");
			nvram_set( racat("Key3Str", i), "");
			nvram_set( racat("Key4Str", i), "");
			// The index of AccessPolicy & AccessControlList starts at 0.
			nvram_set( racat("AccessPolicy", i-1), "0");
			nvram_set( racat("AccessControlList", i-1), "");
		}
	}
}
static void wirelessMACFilter(webs_t wp, char_t *path, char_t *query)
{
    char_t *Macbutton;
    Macbutton = websGetVar(wp, T("Macbutton"), T("2"));
    if(!strncmp(Macbutton, "0", 2)){
        nvram_set( "Macbutton", "0");
    }
     if(!strncmp(Macbutton, "1", 2)){
        nvram_set( "Macbutton", "1");

    }
    //initInternet();
    //nvram_commit(RT2860_NVRAM);
    doSystem("wlan-basic.sh");
    //WPSRestart();
    nvram_set("wireless_perform_func", "2");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
    websRedirect(wp, "wireless_basic.asp");

}
static void wirelessBasicsetting(webs_t wp, char_t *path, char_t *query)
{
    char_t	*radio;
    char_t	*ssid1, *ssid2, *ssid3, *ssid4;
    char_t	*wirelessmode, *n_bandwidth;
    char_t  *sz11bChannel, *rate;
    int num = 1;
    radio = websGetVar(wp, T("radiobutton"), T("2"));
      printf("radio = %s\n", radio);
    if(!strncmp(radio, "0", 2)){
        nvram_set( "RadioOn", "0");
        //ledAlways(13, LED_OFF);
        //wpsStopTimerAll();
        //LedReset();
    }

    if(!strncmp(radio, "1", 2))
    {
        nvram_set( "RadioOn", "1");
        ssid1 = websGetVar(wp, T("SSID1"), T(""));
        ssid2 = websGetVar(wp, T("SSID2"), T(""));
        ssid3 = websGetVar(wp, T("SSID3"), T(""));
        ssid4 = websGetVar(wp, T("SSID4"), T(""));

        if (0 == strlen(ssid1))
            {
            //nvram_commit(RT2860_NVRAM);
            websError(wp, 403, T("'SSID' should not be empty!"));
            websRedirect(wp, "wireless_basic.asp");
            return;
            }
        else
            {
                nvram_set( "SSID1", ssid1);
                if (0 != strlen(ssid2))
                    {
                        num = 2;
                        nvram_set( "SSID2", ssid2);
                        if (0 != strlen(ssid3))
                            {
                                num = 3;
                                nvram_set( "SSID3", ssid3);
                                if (0 != strlen(ssid4))
                                    {
                                        num = 4;
                                        nvram_set( "SSID4", ssid4);
                                        }
                                else
                                    {
                                        nvram_set( "SSID4", "");
                                        }
                                }
                        else
                            {
                                nvram_set( "SSID3", "");
                                nvram_set( "SSID4", "");
                                }
                        }
                else
                    {
                        nvram_set( "SSID2", "");
                        nvram_set( "SSID3", "");
                        nvram_set( "SSID4", "");
                        }
                }
        sz11bChannel = websGetVar(wp, T("channel"), T(""));
        nvram_set( "sz11bChannel", sz11bChannel);

        wirelessmode = websGetVar(wp, T("Wirelessmode"), T(""));
        nvram_set( "WirelessMode", wirelessmode);

        n_bandwidth = websGetVar(wp, T("chanWidth"), T(""));
        nvram_set( "HT_BW", n_bandwidth );


        rate = websGetVar(wp, T("rate"), T(""));

        nvram_set( "HT_RATE", rate );

    }
    nvram_set( "BssidNum", (char*)num);
	//nvram_commit(RT2860_NVRAM);
    //initInternet();
    doSystem("wlan-basic.sh");
    //WPSRestart();
    nvram_set("wireless_perform_func", "3");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
    websRedirect(wp, "wireless_basic.asp");
}
/* goform/wirelessBasic */

static void wirelessBasic(webs_t wp, char_t *path, char_t *query)
{
	char_t	*wirelessmode;
	char_t	*hiddenssid;
	char_t	*mssid_0, *mssid_1, *mssid_2, *mssid_3, *mssid_4, *mssid_5, *mssid_6,
			*mssid_7, *bssid_num, *hssid, *isolated_ssid, *mbssidapisolated;
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
	char_t  *mssid_8, *mssid_9, *mssid_10, *mssid_11, *mssid_12, *mssid_13, *mssid_14,*mssid_15;
#endif
	char_t  *enabled_ssid1,*enabled_ssid2,*enabled_ssid3,*enabled_ssid4,
			*enabled_ssid5,*enabled_ssid6,*enabled_ssid7;
	char_t	*sz11aChannel, *sz11bChannel, *sz11gChannel, *abg_rate;
	char_t  *n_mode, *n_bandwidth, *n_gi, *n_mcs, *n_rdg, *n_extcha, *n_stbc;
	char_t  *n_amsdu, *n_autoba, *n_badecline, *n_disallow_tkip;
	char_t	*tx_stream, *rx_stream;
	char_t	*radio;
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
	char	hidden_ssid[32], noforwarding[32];
#else
	char	hidden_ssid[16], noforwarding[16];
#endif
	int i = 0, is_n = 0, new_bssid_num, old_bssid_num = 1;

	radio = websGetVar(wp, T("wirelessenable"), T("0"));
        if (!strncmp(radio, "0", 2))
        {
                nvram_set( "RadioOn", "1");
        }
        else if (!strncmp(radio, "1", 2))
        {
                nvram_set( "RadioOn", "0");
        }
        else
        {
                printf("unknow option about wireless enable or disable!");
                return;
        }

	hiddenssid = websGetVar(wp, T("hiddenssid"), T("0")); //9: bgn mode
	wirelessmode = websGetVar(wp, T("wirelessmode"), T("9")); //9: bgn mode
	mssid_0 = websGetVar(wp, T("ssid"), T(""));
	mssid_1 = websGetVar(wp, T("mssid_1"), T(""));
	mssid_2 = websGetVar(wp, T("mssid_2"), T(""));
	mssid_3 = websGetVar(wp, T("mssid_3"), T(""));
	mssid_4 = websGetVar(wp, T("mssid_4"), T(""));
	mssid_5 = websGetVar(wp, T("mssid_5"), T(""));
	mssid_6 = websGetVar(wp, T("mssid_6"), T(""));
	mssid_7 = websGetVar(wp, T("mssid_7"), T(""));
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
	mssid_8 = websGetVar(wp, T("mssid_8"), T(""));
	mssid_9 = websGetVar(wp, T("mssid_9"), T(""));
	mssid_10 = websGetVar(wp, T("mssid_10"), T(""));
	mssid_11 = websGetVar(wp, T("mssid_11"), T(""));
	mssid_12 = websGetVar(wp, T("mssid_12"), T(""));
	mssid_13 = websGetVar(wp, T("mssid_13"), T(""));
	mssid_14 = websGetVar(wp, T("mssid_14"), T(""));
	mssid_15 = websGetVar(wp, T("mssid_15"), T(""));
#endif
	enabled_ssid1=websGetVar(wp, T("enable_ssid1"), T(""));
	enabled_ssid2=websGetVar(wp, T("enable_ssid2"), T(""));
	enabled_ssid3=websGetVar(wp, T("enable_ssid3"), T(""));
	enabled_ssid4=websGetVar(wp, T("enable_ssid4"), T(""));
	enabled_ssid5=websGetVar(wp, T("enable_ssid5"), T(""));
	enabled_ssid6=websGetVar(wp, T("enable_ssid6"), T(""));
	enabled_ssid7=websGetVar(wp, T("enable_ssid7"), T(""));
	bssid_num = websGetVar(wp, T("bssid_num"), T("1"));
	hssid = websGetVar(wp, T("hssid"), T(""));
	isolated_ssid = websGetVar(wp, T("isolated_ssid"), T(""));
	mbssidapisolated = websGetVar(wp, T("mbssidapisolated"), T("0"));
	sz11aChannel = websGetVar(wp, T("sz11aChannel"), T(""));
	sz11bChannel = websGetVar(wp, T("sz11bChannel"), T(""));
	sz11gChannel = websGetVar(wp, T("sz11gChannel"), T(""));
	abg_rate = websGetVar(wp, T("abg_rate"), T(""));
	n_mode = websGetVar(wp, T("n_mode"), T("0"));
	n_bandwidth = websGetVar(wp, T("n_bandwidth"), T("0"));
	n_gi = websGetVar(wp, T("n_gi"), T("0"));
	n_mcs = websGetVar(wp, T("n_mcs"), T("33"));
	n_rdg = websGetVar(wp, T("n_rdg"), T("0"));
	n_extcha = websGetVar(wp, T("n_extcha"), T("0"));
	n_stbc = websGetVar(wp, T("n_stbc"), T("0"));
	n_amsdu = websGetVar(wp, T("n_amsdu"), T("0"));
	n_autoba = websGetVar(wp, T("n_autoba"), T("0"));
	n_badecline = websGetVar(wp, T("n_badecline"), T("0"));
	n_disallow_tkip = websGetVar(wp, T("n_disallow_tkip"), T("1"));
	tx_stream = websGetVar(wp, T("tx_stream"), T("0"));
	rx_stream = websGetVar(wp, T("rx_stream"), T("0"));

	old_bssid_num = atoi(nvram_safe_get( "BssidNum"));
	new_bssid_num = atoi(bssid_num);
	nvram_set( "Hiddenssid", hiddenssid);

	nvram_set( "WirelessMode", wirelessmode);
	//BasicRate: bg,bgn,n:15, b:3; g,gn:351
	if (!strncmp(wirelessmode, "4", 2) || !strncmp(wirelessmode, "7", 2)) //g, gn
		nvram_set( "BasicRate", "351");
	else if (!strncmp(wirelessmode, "1", 2)) //b
		nvram_set( "BasicRate", "3");
	else //bg,bgn,n
		nvram_set( "BasicRate", "15");

	if (!strncmp(wirelessmode, "8", 2) || !strncmp(wirelessmode, "9", 2) ||
		!strncmp(wirelessmode, "6", 2) || !strncmp(wirelessmode, "11", 3))
		is_n = 1;

	//SSID, Multiple SSID
	if (0 == strlen(mssid_0)) {
		//nvram_commit(RT2860_NVRAM);
		websError(wp, 403, T("'SSID' should not be empty!"));
		return;
	}
	nvram_set( "SSID1", mssid_0);
	if (strchr(hssid, '0') != NULL)
		sprintf(hidden_ssid, "%s", "1");
	else
		sprintf(hidden_ssid, "%s", "0");
	if (strchr(isolated_ssid, '0') != NULL)
		sprintf(noforwarding, "%s", "1");
	else
		sprintf(noforwarding, "%s", "0");


	default_shown_mbssid = 0;

	i = 2;
	if (0 != strlen(mssid_1)) {
		nvram_set( racat("SSID", i), mssid_1);
		if (strchr(hssid, '1') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '1') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_2)) {
		nvram_set( racat("SSID", i), mssid_2);
		if (strchr(hssid, '2') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '2') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_3)) {
		nvram_set( racat("SSID", i), mssid_3);
		if (strchr(hssid, '3') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '3') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_4)) {
		nvram_set( racat("SSID", i), mssid_4);
		if (strchr(hssid, '4') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '4') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_5)) {
		nvram_set( racat("SSID", i), mssid_5);
		if (strchr(hssid, '5') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '5') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_6)) {
		nvram_set( racat("SSID", i), mssid_6);
		if (strchr(hssid, '6') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '6') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_7)) {
		nvram_set( racat("SSID", i), mssid_7);
		if (strchr(hssid, '7') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '7') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}

#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
	if (0 != strlen(mssid_8)) {
		nvram_set( racat("SSID", i), mssid_8);
		if (strchr(hssid, '8') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '8') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_9)) {
		nvram_set( racat("SSID", i), mssid_9);
		if (strchr(hssid, '9') != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '9') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_10)) {
		nvram_set( racat("SSID", i), mssid_10);
		if (strstr(hssid, "10") != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '10') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_11)) {
		nvram_set( racat("SSID", i), mssid_11);
		if (strstr(hssid, "11") != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '11') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_12)) {
		nvram_set( racat("SSID", i), mssid_12);
		if (strstr(hssid, "12") != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '12') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_13)) {
		nvram_set( racat("SSID", i), mssid_13);
		if (strstr(hssid, "13") != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '13') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_14)) {
		nvram_set( racat("SSID", i), mssid_14);
		if (strstr(hssid, "14") != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '14') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
	if (0 != strlen(mssid_15)) {
		nvram_set( racat("SSID", i), mssid_15);
		if (strstr(hssid, "15") != NULL)
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
		else
			sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
		if (strchr(isolated_ssid, '15') != NULL)
			sprintf(noforwarding, "%s%s", noforwarding, ";1");
		else
			sprintf(noforwarding, "%s%s", noforwarding, ";0");
		i++;
	}
#endif

	nvram_set( "BssidNum", bssid_num);
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
	if (new_bssid_num < 1 || new_bssid_num > 16) {
#else
	if (new_bssid_num < 1 || new_bssid_num > 8) {
#endif
		//nvram_commit(RT2860_NVRAM);
		websError(wp, 403, T("'bssid_num' %s is out of range!"), bssid_num);
		return;
	}
	revise_mbss_value(old_bssid_num, new_bssid_num);

	//Broadcast SSID
	nvram_set( "HideSSID", hidden_ssid);

	// NoForwarding and NoForwardingBTNBSSID
	nvram_set( "NoForwarding", noforwarding);
	nvram_set( "NoForwardingBTNBSSID", mbssidapisolated);
	if (!strncmp(enabled_ssid1, "0", 2))
		{
			nvram_set( "ssidenable1", "0");
		}

	else
		{
			//system("ifconfig ra1 down");
			nvram_set( "ssidenable1", "1");
		}
	if (!strncmp(enabled_ssid2, "0", 2))
		{
			nvram_set( "ssidenable2", "0");
		}
	else
		{
			//system("ifconfig ra2 down");
			nvram_set( "ssidenable2", "1");
		}
	if (!strncmp(enabled_ssid3, "0", 2))
		{
			nvram_set( "ssidenable3", "0");
		}
	else
		{
			//system("ifconfig ra3 down");
			nvram_set( "ssidenable3", "1");
		}
	if (!strncmp(enabled_ssid4, "0", 2))
		{
			nvram_set( "ssidenable4", "0");
		}
	else
		{
			//system("ifconfig ra4 down");
			nvram_set( "ssidenable4", "1");
		}
	if (!strncmp(enabled_ssid5, "0", 2))
		{
			nvram_set( "ssidenable5", "0");
		}
	else
		{
			//system("ifconfig ra5 down");
			nvram_set( "ssidenable5", "1");
		}
	if (!strncmp(enabled_ssid6, "0", 2))
		{
			nvram_set( "ssidenable6", "0");
		}
	else
		{
			//system("ifconfig ra6 down");
			nvram_set( "ssidenable6", "1");
		}
	if (!strncmp(enabled_ssid7, "0", 2))
		{
			nvram_set( "ssidenable7", "0");
		}
	else
		{
			//system("ifconfig ra7 down");
			nvram_set( "ssidenable7", "1");
		}

	//11abg Channel or AutoSelect
	if ((0 == strlen(sz11aChannel)) && (0 == strlen(sz11bChannel)) &&
			(0 == strlen(sz11gChannel))) {
		//nvram_commit(RT2860_NVRAM);
		websError(wp, 403, T("'Channel' should not be empty!"));
		return;
	}
	if (!strncmp(sz11aChannel, "0", 2) || !strncmp(sz11bChannel, "0", 2) ||
			!strncmp(sz11gChannel, "0", 2))
		nvram_set( "AutoChannelSelect", "2");
	else
		nvram_set( "AutoChannelSelect", "0");
	if (0 != strlen(sz11aChannel))
	{
		nvram_set( "Channel", sz11aChannel);
		//doSystem("iwpriv ra0 set Channel=%s", sz11aChannel);
	}
	if (0 != strlen(sz11bChannel))
	{
		nvram_set( "Channel", sz11bChannel);
		//doSystem("iwpriv ra0 set Channel=%s", sz11bChannel);
	}
	if (0 != strlen(sz11gChannel))
	{
		nvram_set( "Channel", sz11gChannel);
		//doSystem("iwpriv ra0 set Channel=%s", sz11gChannel);
	}
	sleep(1);

	//Rate for a, b, g
	if (strncmp(abg_rate, "", 1)) {
		int rate = atoi(abg_rate);
		if (!strncmp(wirelessmode, "0", 2) || !strncmp(wirelessmode, "2", 2) || !strncmp(wirelessmode, "4", 2)) {
			if (rate == 1 || rate == 2 || rate == 5 || rate == 11)
				nvram_set( "FixedTxMode", "CCK");
			else
				nvram_set( "FixedTxMode", "OFDM");

			if (rate == 1)
				nvram_set( "HT_MCS", "0");
			else if (rate == 2)
				nvram_set( "HT_MCS", "1");
			else if (rate == 5)
				nvram_set( "HT_MCS", "2");
			else if (rate == 6)
				nvram_set( "HT_MCS", "0");
			else if (rate == 9)
				nvram_set( "HT_MCS", "1");
			else if (rate == 11)
				nvram_set( "HT_MCS", "3");
			else if (rate == 12)
				nvram_set( "HT_MCS", "2");
			else if (rate == 18)
				nvram_set( "HT_MCS", "3");
			else if (rate == 24)
				nvram_set( "HT_MCS", "4");
			else if (rate == 36)
				nvram_set( "HT_MCS", "5");
			else if (rate == 48)
				nvram_set( "HT_MCS", "6");
			else if (rate == 54)
				nvram_set( "HT_MCS", "7");
			else
				nvram_set( "HT_MCS", "33");
		}
		else if (!strncmp(wirelessmode, "1", 2)) {
			nvram_set( "FixedTxMode", "CCK");
			if (rate == 1)
				nvram_set( "HT_MCS", "0");
			else if (rate == 2)
				nvram_set( "HT_MCS", "1");
			else if (rate == 5)
				nvram_set( "HT_MCS", "2");
			else if (rate == 11)
				nvram_set( "HT_MCS", "3");
			//synchronize svn No.1369 by huangfeilan at 20110820 
			else if (rate == 0)  
	 			nvram_set( "HT_MCS", "33");  
			else
				nvram_set( "HT_MCS", "4");
		}
		else //shall not happen
			error(E_L, E_LOG, T("wrong configurations from web UI"));
	}
	else
		nvram_set( "FixedTxMode", "HT");

	//HT_OpMode, HT_BW, HT_GI, HT_MCS, HT_RDG, HT_EXTCHA, HT_AMSDU, HT_TxStream, HT_RxStream
	if (is_n) {
		nvram_set( "HT_OpMode", n_mode);
		nvram_set( "HT_BW", n_bandwidth);
		nvram_set( "HT_GI", n_gi);
		nvram_set( "HT_MCS", n_mcs);
		nvram_set( "HT_RDG", n_rdg);
		nvram_set( "HT_EXTCHA", n_extcha);
		nvram_set( "HT_STBC", n_stbc);
		nvram_set( "HT_AMSDU", n_amsdu);
		nvram_set( "HT_AutoBA", n_autoba);
		nvram_set( "HT_BADecline", n_badecline);
		nvram_set( "HT_DisallowTKIP", n_disallow_tkip);
	}
	nvram_set( "HT_TxStream", tx_stream);
	nvram_set( "HT_RxStream", rx_stream);

	if (!strncmp(wirelessmode, "6", 2) || !strncmp(wirelessmode, "11", 2))
	{
		int mbssid_num = atoi(nvram_safe_get( "BssidNum"));
		int i = 0;

		while (i < mbssid_num)
		{
			char tmp[128];
			char *EncrypType = (char *) nvram_safe_get( "EncrypType");
			getNthValueSafe(i, EncrypType, ';', tmp, 128);
			// fprintf(stderr, "SSID%d's EncrypType: %s\n", i, tmp);
			if (!strcmp(tmp, "NONE") || !strcmp(tmp, "AES") || !strcmp(tmp, "TKIPAES"))
			{
				memset(tmp, 0, 128);
				char *IEEE8021X = (char *) nvram_safe_get( "IEEE8021X");
				getNthValueSafe(i, IEEE8021X, ';', tmp, 128);
				// fprintf(stderr, "SSID%d's IEEE8021X: %s\n", i, tmp);
				if (!strcmp(tmp, "0"))
				{
					i++;
					continue;
				}
			}
			STFs( i, "AuthMode", "OPEN");
			STFs( i, "EncrypType", "NONE");
			STFs( i, "IEEE8021X", "0");
			i++;
		}
	}

end:
	//nvram_commit(RT2860_NVRAM);
	nvram_set("wan_set", "1");
	nvram_set("wireless_perform_func", "4");
	nvram_commit();
#if CONFIG_RT2860V2_AP == CONFIG_MIPS
	/* this is a workaround:
	 *  when AP is built as kernel
	 *  if more ssids are created, driver won't exe RT28xx_MBSS_Init again
	 *  therefore, we reboot to make it available
	 *  (PS. CONFIG_MIPS would be "y")
	 */
	if (new_bssid_num > old_bssid_num)
		doSystem("reboot");
#endif
    
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );

#ifdef	GOAHEAD_SHOWSUBMITINFO
	//debug print
	websHeader(wp);
	websWrite(wp, T("<h2>mode: %s</h2><br>\n"), wirelessmode);
	websWrite(wp, T("mssid_0: %s, bssid_num: %s<br>\n"), mssid_0, bssid_num);
	websWrite(wp, T("mssid_1: %s, mssid_2: %s, mssid_3: %s<br>\n"),
			mssid_1, mssid_2, mssid_3);
	websWrite(wp, T("mssid_4: %s, mssid_5: %s, mssid_6: %s, mssid_7: %s<br>\n"),
			mssid_4, mssid_5, mssid_6, mssid_7);
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
	websWrite(wp, T("mssid_8: %s, mssid_9: %s, mssid_10: %s, mssid_11: %s<br>\n"),
			mssid_8, mssid_9, mssid_10), mssid_11;
	websWrite(wp, T("mssid_12: %s, mssid_13: %s, mssid_14: %s, mssid_15: %s<br>\n"),
			mssid_12, mssid_13, mssid_14, mssid_15);
#endif
	websWrite(wp, T("hssid: %s<br>\n"), hssid);
	websWrite(wp, T("isolated_ssid: %s<br>\n"), isolated_ssid);
	websWrite(wp, T("mbssidapisolated: %s<br>\n"), mbssidapisolated);
	websWrite(wp, T("sz11aChannel: %s<br>\n"), sz11aChannel);
	websWrite(wp, T("sz11bChannel: %s<br>\n"), sz11bChannel);
	websWrite(wp, T("sz11gChannel: %s<br>\n"), sz11gChannel);
	if (strncmp(abg_rate, "", 1)) {
		websWrite(wp, T("abg_rate: %s<br>\n"), abg_rate);
	}
	if (is_n) {
		websWrite(wp, T("n_mode: %s<br>\n"), n_mode);
		websWrite(wp, T("n_bandwidth: %s<br>\n"), n_bandwidth);
		websWrite(wp, T("n_gi: %s<br>\n"), n_gi);
		websWrite(wp, T("n_mcs: %s<br>\n"), n_mcs);
		websWrite(wp, T("n_rdg: %s<br>\n"), n_rdg);
		websWrite(wp, T("n_extcha: %s<br>\n"), n_extcha);
		websWrite(wp, T("n_stbc: %s<br>\n"), n_stbc);
		websWrite(wp, T("n_amsdu: %s<br>\n"), n_amsdu);
		websWrite(wp, T("n_autoba: %s<br>\n"), n_autoba);
		websWrite(wp, T("n_badecline: %s<br>\n"), n_badecline);
		websWrite(wp, T("n_disallow_tkip: %s<br>\n"), n_disallow_tkip);
	}
	websWrite(wp, T("tx_stream: %s<br>\n"), tx_stream);
	websWrite(wp, T("rx_stream: %s<br>\n"), rx_stream);
	websFooter(wp);
	websDone(wp, 200);
#else
	if (!strncmp(radio, "0", 2) || !strncmp(radio, "1", 2) || !strncmp(radio, "4", 2))
        websRedirect(wp, "wl_basic.asp");
	else
		websRedirect(wp, "wl_basic_1.asp");
#endif
}

static void wirelessSetting(webs_t wp, char_t *path, char_t *query)
{
	char_t *opmode=nvram_get("sw_mode_ex");
	if(!strncmp(opmode,"1",2) || !strncmp(opmode,"2",2)||!strncmp(opmode,"5",2) || !strncmp(opmode,"6",2)||!strncmp(opmode,"8",2))
	{

		char_t	*wirelessmode;
		char_t	*hiddenssid;

		char_t	*mssid_0, *mssid_1, *mssid_2, *mssid_3, *mssid_4, *mssid_5, *mssid_6,
				*mssid_7, *bssid_num, *hssid, *isolated_ssid, *mbssidapisolated;
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
		char_t  *mssid_8, *mssid_9, *mssid_10, *mssid_11, *mssid_12, *mssid_13, *mssid_14,*mssid_15;
#endif
		char_t  *enabled_ssid1,*enabled_ssid2,*enabled_ssid3,*enabled_ssid4,
				*enabled_ssid5,*enabled_ssid6,*enabled_ssid7;
		char_t	*sz11aChannel, *sz11bChannel, *sz11gChannel, *abg_rate;
		char_t  *n_mode, *n_bandwidth, *n_gi, *n_mcs, *n_rdg, *n_extcha, *n_stbc;
		char_t  *n_amsdu, *n_autoba, *n_badecline, *n_disallow_tkip;
		char_t	*tx_stream, *rx_stream;
		char_t	*radio;		
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
		char	hidden_ssid[32], noforwarding[32];
#else
		char	hidden_ssid[16], noforwarding[16];
#endif
		int i = 0, is_n = 0, new_bssid_num, old_bssid_num = 1;

		/*radio = websGetVar(wp, T("wirelessenable"), T("0"));
	        if (!strncmp(radio, "0", 2))
	        {
	                nvram_set( "RadioOn", "1");
	        }
	        else if (!strncmp(radio, "1", 2))
	        {
	                nvram_set( "RadioOn", "0");
	        }
	        else
	        {
	                printf("unknow option about wireless enable or disable!");
	                return;
	        }*/

		hiddenssid = websGetVar(wp, T("hiddenssid"), T("0")); //9: bgn mode
		wirelessmode = websGetVar(wp, T("wirelessmode"), T("9")); //9: bgn mode
		mssid_0 = websGetVar(wp, T("ssid"), T(""));
		mssid_1 = websGetVar(wp, T("mssid_1"), T(""));
		mssid_2 = websGetVar(wp, T("mssid_2"), T(""));
		mssid_3 = websGetVar(wp, T("mssid_3"), T(""));
		mssid_4 = websGetVar(wp, T("mssid_4"), T(""));
		mssid_5 = websGetVar(wp, T("mssid_5"), T(""));
		mssid_6 = websGetVar(wp, T("mssid_6"), T(""));
		mssid_7 = websGetVar(wp, T("mssid_7"), T(""));
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
		mssid_8 = websGetVar(wp, T("mssid_8"), T(""));
		mssid_9 = websGetVar(wp, T("mssid_9"), T(""));
		mssid_10 = websGetVar(wp, T("mssid_10"), T(""));
		mssid_11 = websGetVar(wp, T("mssid_11"), T(""));
		mssid_12 = websGetVar(wp, T("mssid_12"), T(""));
		mssid_13 = websGetVar(wp, T("mssid_13"), T(""));
		mssid_14 = websGetVar(wp, T("mssid_14"), T(""));
		mssid_15 = websGetVar(wp, T("mssid_15"), T(""));
#endif
		enabled_ssid1=websGetVar(wp, T("enable_ssid1"), T(""));
		enabled_ssid2=websGetVar(wp, T("enable_ssid2"), T(""));
		enabled_ssid3=websGetVar(wp, T("enable_ssid3"), T(""));
		enabled_ssid4=websGetVar(wp, T("enable_ssid4"), T(""));
		enabled_ssid5=websGetVar(wp, T("enable_ssid5"), T(""));
		enabled_ssid6=websGetVar(wp, T("enable_ssid6"), T(""));
		enabled_ssid7=websGetVar(wp, T("enable_ssid7"), T(""));
		bssid_num = websGetVar(wp, T("bssid_num"), T("1"));
		hssid = websGetVar(wp, T("hssid"), T(""));
		isolated_ssid = websGetVar(wp, T("isolated_ssid"), T(""));
		mbssidapisolated = websGetVar(wp, T("mbssidapisolated"), T("0"));
		sz11aChannel = websGetVar(wp, T("sz11aChannel"), T(""));
		sz11bChannel = websGetVar(wp, T("sz11bChannel"), T(""));
		sz11gChannel = websGetVar(wp, T("sz11gChannel"), T(""));
		abg_rate = websGetVar(wp, T("abg_rate"), T(""));
		n_mode = websGetVar(wp, T("n_mode"), T("0"));
		n_bandwidth = websGetVar(wp, T("n_bandwidth"), T("0"));
		n_gi = websGetVar(wp, T("n_gi"), T("0"));
		n_mcs = websGetVar(wp, T("n_mcs"), T("33"));
		n_rdg = websGetVar(wp, T("n_rdg"), T("0"));
		n_extcha = websGetVar(wp, T("n_extcha"), T("0"));
		n_stbc = websGetVar(wp, T("n_stbc"), T("0"));
		n_amsdu = websGetVar(wp, T("n_amsdu"), T("0"));
		n_autoba = websGetVar(wp, T("n_autoba"), T("0"));
		n_badecline = websGetVar(wp, T("n_badecline"), T("0"));
		n_disallow_tkip = websGetVar(wp, T("n_disallow_tkip"), T("1"));
		tx_stream = websGetVar(wp, T("tx_stream"), T("0"));
		rx_stream = websGetVar(wp, T("rx_stream"), T("0"));	

		if(!strncmp(opmode,"5",2))
		{
			char_t	 *wds_phy_mode, *wds_encryp_type, *wds_encryp_key0,
			*wds_encryp_key1,*wds_encryp_key2, *wds_encryp_key3, *wds_list,
			*wds_hideencryp_0,*wds_hideencryp_1,*wds_hideencryp_2,*wds_hideencryp_3;

		
			wds_phy_mode = websGetVar(wp, T("wds_phy_mode"), T(""));
			//start of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
			wds_hideencryp_0 = websGetVar(wp, T("ETbutton0"), T("0"));
			wds_hideencryp_1 = websGetVar(wp, T("ETbutton1"), T("0"));
			wds_hideencryp_2 = websGetVar(wp, T("ETbutton2"), T("0"));
			wds_hideencryp_3 = websGetVar(wp, T("ETbutton3"), T("0"));
			//end of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
			wds_encryp_type = websGetVar(wp, T("wds_encryp_type"), T(""));
			wds_encryp_key0 = websGetVar(wp, T("wds_encryp_key0"), T(""));
			wds_encryp_key1 = websGetVar(wp, T("wds_encryp_key1"), T(""));
			wds_encryp_key2 = websGetVar(wp, T("wds_encryp_key2"), T(""));
			wds_encryp_key3 = websGetVar(wp, T("wds_encryp_key3"), T(""));
			wds_list = websGetVar(wp, T("wds_list"), T(""));

			//start of that set wireless in other mode except AP mode by huangfeilan at 20110701
          //  nvram_set("RadioOn", "1");
            nvram_set("WdsEnable", "3");
			nvram_set("WdsPhyMode", wds_phy_mode);
			//start of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
			nvram_set("HETbutton_0", wds_hideencryp_0);
		    nvram_set("HETbutton_1", wds_hideencryp_1);
		    nvram_set("HETbutton_2", wds_hideencryp_2);
		    nvram_set("HETbutton_3", wds_hideencryp_3);
			//end of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
			nvram_set("WdsEncrypType", wds_encryp_type);
			nvram_set("Wds0Key", wds_encryp_key0);
			nvram_set("Wds1Key", wds_encryp_key1);
			nvram_set("Wds2Key", wds_encryp_key2);
			nvram_set("Wds3Key", wds_encryp_key3);
			if (0 != strlen(wds_list))
				nvram_set("WdsList", wds_list);
		}
		old_bssid_num = atoi(nvram_safe_get( "BssidNum"));
		new_bssid_num = atoi(bssid_num);
		nvram_set( "Hiddenssid", hiddenssid);

		if(!strncmp(opmode,"5",2) || !strncmp(opmode,"6",2)||!strncmp(opmode,"8",2))
		{
			memset(wirelessmode, 0, sizeof(wirelessmode));
			strcpy(wirelessmode, "9");
		}
		nvram_set( "WirelessMode", wirelessmode);
		//BasicRate: bg,bgn,n:15, b:3; g,gn:351
		if (!strncmp(wirelessmode, "4", 2) || !strncmp(wirelessmode, "7", 2)) //g, gn
			nvram_set( "BasicRate", "351");
		else if (!strncmp(wirelessmode, "1", 2)) //b
			nvram_set( "BasicRate", "3");
		else //bg,bgn,n
			nvram_set( "BasicRate", "15");

		if (!strncmp(wirelessmode, "8", 2) || !strncmp(wirelessmode, "9", 2) ||
			!strncmp(wirelessmode, "6", 2) || !strncmp(wirelessmode, "11", 3))
			is_n = 1;

		//SSID, Multiple SSID
		if (0 == strlen(mssid_0)) {
			//nvram_commit(RT2860_NVRAM);
			websError(wp, 403, T("'SSID' should not be empty!"));
			return;
		}
		nvram_set( "SSID1", mssid_0);
		if (strchr(hssid, '0') != NULL)
			sprintf(hidden_ssid, "%s", "1");
		else
			sprintf(hidden_ssid, "%s", "0");
		if (strchr(isolated_ssid, '0') != NULL)
			sprintf(noforwarding, "%s", "1");
		else
			sprintf(noforwarding, "%s", "0");


		default_shown_mbssid = 0;

		i = 2;
		if (0 != strlen(mssid_1)) {
			nvram_set( racat("SSID", i), mssid_1);
			if (strchr(hssid, '1') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '1') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_2)) {
			nvram_set( racat("SSID", i), mssid_2);
			if (strchr(hssid, '2') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '2') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_3)) {
			nvram_set( racat("SSID", i), mssid_3);
			if (strchr(hssid, '3') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '3') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_4)) {
			nvram_set( racat("SSID", i), mssid_4);
			if (strchr(hssid, '4') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '4') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_5)) {
			nvram_set( racat("SSID", i), mssid_5);
			if (strchr(hssid, '5') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '5') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_6)) {
			nvram_set( racat("SSID", i), mssid_6);
			if (strchr(hssid, '6') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '6') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_7)) {
			nvram_set( racat("SSID", i), mssid_7);
			if (strchr(hssid, '7') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '7') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}

#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
		if (0 != strlen(mssid_8)) {
			nvram_set( racat("SSID", i), mssid_8);
			if (strchr(hssid, '8') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '8') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_9)) {
			nvram_set( racat("SSID", i), mssid_9);
			if (strchr(hssid, '9') != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '9') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_10)) {
			nvram_set( racat("SSID", i), mssid_10);
			if (strstr(hssid, "10") != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '10') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_11)) {
			nvram_set( racat("SSID", i), mssid_11);
			if (strstr(hssid, "11") != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '11') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_12)) {
			nvram_set( racat("SSID", i), mssid_12);
			if (strstr(hssid, "12") != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '12') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_13)) {
			nvram_set( racat("SSID", i), mssid_13);
			if (strstr(hssid, "13") != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '13') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_14)) {
			nvram_set( racat("SSID", i), mssid_14);
			if (strstr(hssid, "14") != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '14') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
		if (0 != strlen(mssid_15)) {
			nvram_set( racat("SSID", i), mssid_15);
			if (strstr(hssid, "15") != NULL)
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";1");
			else
				sprintf(hidden_ssid, "%s%s", hidden_ssid, ";0");
			if (strchr(isolated_ssid, '15') != NULL)
				sprintf(noforwarding, "%s%s", noforwarding, ";1");
			else
				sprintf(noforwarding, "%s%s", noforwarding, ";0");
			i++;
		}
#endif

		nvram_set( "BssidNum", bssid_num);
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
		if (new_bssid_num < 1 || new_bssid_num > 16) {
#else
		if (new_bssid_num < 1 || new_bssid_num > 8) {
#endif
			//nvram_commit(RT2860_NVRAM);
			websError(wp, 403, T("'bssid_num' %s is out of range!"), bssid_num);
			return;
		}
		revise_mbss_value(old_bssid_num, new_bssid_num);

		//Broadcast SSID
		nvram_set( "HideSSID", hidden_ssid);

		// NoForwarding and NoForwardingBTNBSSID
		nvram_set( "NoForwarding", noforwarding);
		nvram_set( "NoForwardingBTNBSSID", mbssidapisolated);
		if (!strncmp(enabled_ssid1, "0", 2))
			{
				nvram_set( "ssidenable1", "0");
			}

		else
			{
				//system("ifconfig ra1 down");
				nvram_set( "ssidenable1", "1");
			}
		if (!strncmp(enabled_ssid2, "0", 2))
			{
				nvram_set( "ssidenable2", "0");
			}
		else
			{
				//system("ifconfig ra2 down");
				nvram_set( "ssidenable2", "1");
			}
		if (!strncmp(enabled_ssid3, "0", 2))
			{
				nvram_set( "ssidenable3", "0");
			}
		else
			{
				//system("ifconfig ra3 down");
				nvram_set( "ssidenable3", "1");
			}
		if (!strncmp(enabled_ssid4, "0", 2))
			{
				nvram_set( "ssidenable4", "0");
			}
		else
			{
				//system("ifconfig ra4 down");
				nvram_set( "ssidenable4", "1");
			}
		if (!strncmp(enabled_ssid5, "0", 2))
			{
				nvram_set( "ssidenable5", "0");
			}
		else
			{
				//system("ifconfig ra5 down");
				nvram_set( "ssidenable5", "1");
			}
		if (!strncmp(enabled_ssid6, "0", 2))
			{
				nvram_set( "ssidenable6", "0");
			}
		else
			{
				//system("ifconfig ra6 down");
				nvram_set( "ssidenable6", "1");
			}
		if (!strncmp(enabled_ssid7, "0", 2))
			{
				nvram_set( "ssidenable7", "0");
			}
		else
			{
				//system("ifconfig ra7 down");
				nvram_set( "ssidenable7", "1");
			}

		//11abg Channel or AutoSelect
		if ((0 == strlen(sz11aChannel)) && (0 == strlen(sz11bChannel)) &&
				(0 == strlen(sz11gChannel))) {
			//nvram_commit(RT2860_NVRAM);
			websError(wp, 403, T("'Channel' should not be empty!"));
			return;
		}
		if (!strncmp(sz11aChannel, "0", 2) || !strncmp(sz11bChannel, "0", 2) ||
				!strncmp(sz11gChannel, "0", 2))
			nvram_set( "AutoChannelSelect", "2");
		else
			nvram_set( "AutoChannelSelect", "0");
		if (0 != strlen(sz11aChannel))
		{
			nvram_set( "Channel", sz11aChannel);
			//doSystem("iwpriv ra0 set Channel=%s", sz11aChannel);
		}
		if (0 != strlen(sz11bChannel))
		{
			nvram_set( "Channel", sz11bChannel);
			//doSystem("iwpriv ra0 set Channel=%s", sz11bChannel);
		}
		if (0 != strlen(sz11gChannel))
		{
			nvram_set( "Channel", sz11gChannel);
			//doSystem("iwpriv ra0 set Channel=%s", sz11gChannel);
		}
		sleep(1);

		//Rate for a, b, g
		if (strncmp(abg_rate, "", 1)) {
			int rate = atoi(abg_rate);
			if (!strncmp(wirelessmode, "0", 2) || !strncmp(wirelessmode, "2", 2) || !strncmp(wirelessmode, "4", 2)) {
				if (rate == 1 || rate == 2 || rate == 5 || rate == 11)
					nvram_set( "FixedTxMode", "CCK");
				else
					nvram_set( "FixedTxMode", "OFDM");

				if (rate == 1)
					nvram_set( "HT_MCS", "0");
				else if (rate == 2)
					nvram_set( "HT_MCS", "1");
				else if (rate == 5)
					nvram_set( "HT_MCS", "2");
				else if (rate == 6)
					nvram_set( "HT_MCS", "0");
				else if (rate == 9)
					nvram_set( "HT_MCS", "1");
				else if (rate == 11)
					nvram_set( "HT_MCS", "3");
				else if (rate == 12)
					nvram_set( "HT_MCS", "2");
				else if (rate == 18)
					nvram_set( "HT_MCS", "3");
				else if (rate == 24)
					nvram_set( "HT_MCS", "4");
				else if (rate == 36)
					nvram_set( "HT_MCS", "5");
				else if (rate == 48)
					nvram_set( "HT_MCS", "6");
				else if (rate == 54)
					nvram_set( "HT_MCS", "7");
				else
					nvram_set( "HT_MCS", "33");
			}
			else if (!strncmp(wirelessmode, "1", 2)) {
				nvram_set( "FixedTxMode", "CCK");
				if (rate == 1)
					nvram_set( "HT_MCS", "0");
				else if (rate == 2)
					nvram_set( "HT_MCS", "1");
				else if (rate == 5)
					nvram_set( "HT_MCS", "2");
				else if (rate == 11)
					nvram_set( "HT_MCS", "3");
				//synchronize svn No.1369 by huangfeilan at 20110820 
				else if (rate == 0)  
		 			nvram_set( "HT_MCS", "33");  
				else
					nvram_set( "HT_MCS", "4");
			}
			else //shall not happen
				error(E_L, E_LOG, T("wrong configurations from web UI"));
		}
		else
			nvram_set( "FixedTxMode", "HT");

		//HT_OpMode, HT_BW, HT_GI, HT_MCS, HT_RDG, HT_EXTCHA, HT_AMSDU, HT_TxStream, HT_RxStream
		if (is_n) {
			nvram_set( "HT_OpMode", n_mode);
			nvram_set( "HT_BW", n_bandwidth);
			nvram_set( "HT_GI", n_gi);
			nvram_set( "HT_MCS", n_mcs);
			nvram_set( "HT_RDG", n_rdg);
			nvram_set( "HT_EXTCHA", n_extcha);
			nvram_set( "HT_STBC", n_stbc);
			nvram_set( "HT_AMSDU", n_amsdu);
			nvram_set( "HT_AutoBA", n_autoba);
			nvram_set( "HT_BADecline", n_badecline);
			nvram_set( "HT_DisallowTKIP", n_disallow_tkip);
		}
		nvram_set( "HT_TxStream", tx_stream);
		nvram_set( "HT_RxStream", rx_stream);

		if (!strncmp(wirelessmode, "6", 2) || !strncmp(wirelessmode, "11", 2))
		{
			int mbssid_num = atoi(nvram_safe_get( "BssidNum"));
			int i = 0;

			while (i < mbssid_num)
			{
				char tmp[128];
				char *EncrypType = (char *) nvram_safe_get( "EncrypType");
				getNthValueSafe(i, EncrypType, ';', tmp, 128);
				// fprintf(stderr, "SSID%d's EncrypType: %s\n", i, tmp);
				if (!strcmp(tmp, "NONE") || !strcmp(tmp, "AES") || !strcmp(tmp, "TKIPAES"))
				{
					memset(tmp, 0, 128);
					char *IEEE8021X = (char *) nvram_safe_get( "IEEE8021X");
					getNthValueSafe(i, IEEE8021X, ';', tmp, 128);
					// fprintf(stderr, "SSID%d's IEEE8021X: %s\n", i, tmp);
					if (!strcmp(tmp, "0"))
					{
						i++;
						continue;
					}
				}
				STFs( i, "AuthMode", "OPEN");
				STFs( i, "EncrypType", "NONE");
				STFs( i, "IEEE8021X", "0");
				i++;
			}
		}
	if(!strncmp(opmode,"6",2)||!strncmp(opmode,"8",2))
		goto repeater;
end:
		//nvram_commit(RT2860_NVRAM);
		
#ifdef DEFINE_DHCP_AUTO_SWITCH	
		//if not in Repeater Mode,backup wireless info for restore anyway
		nvram_set( "res_SSID1", nvram_safe_get("SSID1"));
#endif		
		nvram_set("wan_set", "1");
		nvram_set("wireless_perform_func", "4");
		nvram_commit();
#if CONFIG_RT2860V2_AP == CONFIG_MIPS
		/* this is a workaround:
		 *  when AP is built as kernel
		 *  if more ssids are created, driver won't exe RT28xx_MBSS_Init again
		 *  therefore, we reboot to make it available
		 *  (PS. CONFIG_MIPS would be "y")
		 */
		if (new_bssid_num > old_bssid_num)
			doSystem("reboot");
#endif
	    
	    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );

#ifdef	GOAHEAD_SHOWSUBMITINFO
		//debug print
		websHeader(wp);
		websWrite(wp, T("<h2>mode: %s</h2><br>\n"), wirelessmode);
		websWrite(wp, T("mssid_0: %s, bssid_num: %s<br>\n"), mssid_0, bssid_num);
		websWrite(wp, T("mssid_1: %s, mssid_2: %s, mssid_3: %s<br>\n"),
				mssid_1, mssid_2, mssid_3);
		websWrite(wp, T("mssid_4: %s, mssid_5: %s, mssid_6: %s, mssid_7: %s<br>\n"),
				mssid_4, mssid_5, mssid_6, mssid_7);
#if (defined (CONFIG_RALINK_RT3352) || defined (CONFIG_RALINK_RT5350) || defined (CONFIG_RALINK_RT3883)) && defined (CONFIG_16MBSSID_MODE)
		websWrite(wp, T("mssid_8: %s, mssid_9: %s, mssid_10: %s, mssid_11: %s<br>\n"),
				mssid_8, mssid_9, mssid_10), mssid_11;
		websWrite(wp, T("mssid_12: %s, mssid_13: %s, mssid_14: %s, mssid_15: %s<br>\n"),
				mssid_12, mssid_13, mssid_14, mssid_15);
#endif
		websWrite(wp, T("hssid: %s<br>\n"), hssid);
		websWrite(wp, T("isolated_ssid: %s<br>\n"), isolated_ssid);
		websWrite(wp, T("mbssidapisolated: %s<br>\n"), mbssidapisolated);
		websWrite(wp, T("sz11aChannel: %s<br>\n"), sz11aChannel);
		websWrite(wp, T("sz11bChannel: %s<br>\n"), sz11bChannel);
		websWrite(wp, T("sz11gChannel: %s<br>\n"), sz11gChannel);
		if (strncmp(abg_rate, "", 1)) {
			websWrite(wp, T("abg_rate: %s<br>\n"), abg_rate);
		}
		if (is_n) {
			websWrite(wp, T("n_mode: %s<br>\n"), n_mode);
			websWrite(wp, T("n_bandwidth: %s<br>\n"), n_bandwidth);
			websWrite(wp, T("n_gi: %s<br>\n"), n_gi);
			websWrite(wp, T("n_mcs: %s<br>\n"), n_mcs);
			websWrite(wp, T("n_rdg: %s<br>\n"), n_rdg);
			websWrite(wp, T("n_extcha: %s<br>\n"), n_extcha);
			websWrite(wp, T("n_stbc: %s<br>\n"), n_stbc);
			websWrite(wp, T("n_amsdu: %s<br>\n"), n_amsdu);
			websWrite(wp, T("n_autoba: %s<br>\n"), n_autoba);
			websWrite(wp, T("n_badecline: %s<br>\n"), n_badecline);
			websWrite(wp, T("n_disallow_tkip: %s<br>\n"), n_disallow_tkip);
		}
		websWrite(wp, T("tx_stream: %s<br>\n"), tx_stream);
		websWrite(wp, T("rx_stream: %s<br>\n"), rx_stream);
		websFooter(wp);
		websDone(wp, 200);
#else

	    websRedirect(wp, "wl_basic.asp");

#endif
}

	// WDS
	
	if(!strncmp(opmode,"4",2))
	{
		char_t	 *wds_phy_mode, *wds_encryp_type, *wds_encryp_key0,
				*wds_encryp_key1,*wds_encryp_key2, *wds_encryp_key3, *wds_list,
				*wds_hideencryp_0,*wds_hideencryp_1,*wds_hideencryp_2,*wds_hideencryp_3;
		
		/*start of add channel by huangyikun at 20110803*/
		char_t	*bridge_sz11aChannel, *bridge_sz11bChannel, *bridge_sz11gChannel;	
		bridge_sz11aChannel = websGetVar(wp, T("bridge_sz11aChannel"), T("")); 
		bridge_sz11bChannel = websGetVar(wp, T("bridge_sz11bChannel"), T("")); 
		bridge_sz11gChannel = websGetVar(wp, T("bridge_sz11gChannel"), T("")); 

		if ((0 == strlen(bridge_sz11aChannel)) && (0 == strlen(bridge_sz11bChannel)) &&
				(0 == strlen(bridge_sz11gChannel))) {
			nvram_commit();
			websError(wp, 403, T("'Channel' should not be empty!"));
			return;
		}
		if (!strncmp(bridge_sz11aChannel, "0", 2) || !strncmp(bridge_sz11bChannel, "0", 2) ||
				!strncmp(bridge_sz11gChannel, "0", 2))
			nvram_set( "AutoChannelSelect", "2");
		else
			nvram_set( "AutoChannelSelect", "0");
		if (0 != strlen(bridge_sz11aChannel))
		{
			nvram_set( "Channel", bridge_sz11aChannel);
			doSystem("iwpriv ra0 set Channel=%s", bridge_sz11aChannel);
		}
		if (0 != strlen(bridge_sz11bChannel))
		{
			nvram_set( "Channel", bridge_sz11bChannel);
			doSystem("iwpriv ra0 set Channel=%s", bridge_sz11bChannel);
		}
		if (0 != strlen(bridge_sz11gChannel))
		{
			nvram_set( "Channel", bridge_sz11gChannel);
			doSystem("iwpriv ra0 set Channel=%s", bridge_sz11gChannel);
		}
		/*end of add channel by huangyikun at 20110803*/

		wds_phy_mode = websGetVar(wp, T("wds_phy_mode"), T(""));
		//start of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
		wds_hideencryp_0 = websGetVar(wp, T("ETbutton0"), T("0"));
		wds_hideencryp_1 = websGetVar(wp, T("ETbutton1"), T("0"));
		wds_hideencryp_2 = websGetVar(wp, T("ETbutton2"), T("0"));
		wds_hideencryp_3 = websGetVar(wp, T("ETbutton3"), T("0"));
		//end of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
		wds_encryp_type = websGetVar(wp, T("wds_encryp_type"), T(""));
		wds_encryp_key0 = websGetVar(wp, T("wds_encryp_key0"), T(""));
		wds_encryp_key1 = websGetVar(wp, T("wds_encryp_key1"), T(""));
		wds_encryp_key2 = websGetVar(wp, T("wds_encryp_key2"), T(""));
		wds_encryp_key3 = websGetVar(wp, T("wds_encryp_key3"), T(""));
		wds_list = websGetVar(wp, T("wds_list"), T(""));
		//start of that set wireless in other mode except AP mode by huangfeilan at 20110701
		//nvram_set( "RadioOn", "1");
        //nvram_set( "ApCliEnable", "0");
        nvram_set("WirelessMode", "9");
       // nvram_set( "WdsEnable", "2");
		nvram_set( "WdsPhyMode", wds_phy_mode);
		//start of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
		nvram_set( "HETbutton_0", wds_hideencryp_0);
		nvram_set( "HETbutton_1", wds_hideencryp_1);
		nvram_set( "HETbutton_2", wds_hideencryp_2);
		nvram_set( "HETbutton_3", wds_hideencryp_3);
		//end of that modify in bridge mode,that Encryption can not take effect by huangfeilan at 20110628
		nvram_set( "WdsEncrypType", wds_encryp_type);
		nvram_set( "Wds0Key", wds_encryp_key0);
		nvram_set( "Wds1Key", wds_encryp_key1);
		nvram_set( "Wds2Key", wds_encryp_key2);
		nvram_set( "Wds3Key", wds_encryp_key3);
		if (0 != strlen(wds_list))
			nvram_set( "WdsList", wds_list);
		//start of that only one SSID is valid except in AP mode by huangfeilan at 20110630
		//nvram_set( "BssidNum", "1");
	    nvram_set( "ssidenable1", "1");
	    nvram_set( "ssidenable2", "1");
	    nvram_set( "ssidenable3", "1");
	    nvram_set( "Hiddenssid", "0");
		//end of that only one SSID is valid except in AP mode by huangfeilan at 20110630
		nvram_set("wireless_perform_func", "4");
		nvram_set("wan_set", "1");
	  	nvram_commit();
	    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
		WPSRestart();
	    //WPSRestart();
		websRedirect(wp, "wl_basic.asp");//wl_wds.asp
	}

repeater:	
	    //Relate to client mode
	if(!strncmp(opmode,"3",2) || !strncmp(opmode,"7",2)||!strncmp(opmode,"6",2) || !strncmp(opmode,"8",2))
		{
			char_t	*ssid, *bssid, *mode, *enc, *wpapsk, *keyid,  *keytype1, *keytype2, *keytype3, *keytype4,
					*key1, *key2, *key3, *key4,*Cchannel;
			char* sync_apcli = NULL;
			char_t  *newSsid_flag; //value=1 means we have a new SSID
			//fetch from web input
			//start of that set wireless in other mode except AP mode by huangfeilan at 20110701
			 //nvram_set("RadioOn", "1");
			ssid = websGetVar(wp, T("apcli_ssid"), T(""));
			bssid = websGetVar(wp, T("apcli_bssid"), T(""));
			//start of that in client ,ap client mode,channel write to nvram by huangfeilan at 20110629
			Cchannel = websGetVar(wp, T("apcli_channel"), T(""));
			mode = websGetVar(wp, T("apcli_mode"), T("OPEN"));
			enc = websGetVar(wp, T("apcli_enc"), T("NONE"));
			wpapsk = websGetVar(wp, T("apcli_wpapsk"), T("12345678"));
			keyid = websGetVar(wp, T("apcli_default_key"), T("1"));
			keytype1 = websGetVar(wp, T("apcli_key1type"), T("1"));
			keytype2 = websGetVar(wp, T("apcli_key2type"), T("1"));
			keytype3 = websGetVar(wp, T("apcli_key3type"), T("1"));
			keytype4 = websGetVar(wp, T("apcli_key4type"), T("1"));
			key1 = websGetVar(wp, T("apcli_key1"), T(""));
			key2 = websGetVar(wp, T("apcli_key2"), T(""));
			key3 = websGetVar(wp, T("apcli_key3"), T(""));
			key4 = websGetVar(wp, T("apcli_key4"), T(""));
			/*
			if (gstrlen(ssid) == 0) {
				websError(wp, 200, "SSID is empty");
				return;
			}
			*/
			
#ifdef DEFINE_DHCP_AUTO_SWITCH	
			//backup wireless info for restore
			newSsid_flag = atoi(websGetVar(wp, T("newSsid_flag"), T("0")));
			if(newSsid_flag == 0)
			{
				printf("Repeater: res_SSID1, do nothing.\n");
				if( nvram_invmatch("SSID1", nvram_safe_get("res_SSID1")) ) //if user change mode from others to Repeater,in this case,backup wireless again
				{
					nvram_set( "SSID1", nvram_safe_get("res_SSID1"));
					nvram_set( "AuthMode", nvram_safe_get("res_AuthMode"));
					nvram_set( "EncrypType", nvram_safe_get("res_EncrypType"));
					nvram_set( "WPAPSK1", nvram_safe_get("res_WPAPSK1"));
				}
			}
			else //We have a new SSID1
			{
				nvram_set( "res_SSID1", nvram_safe_get("SSID1")); //we only change res_SSID1
			}
#endif			
			int k;
			for(k=0;k<3;k++)
			{
				apcli_t *p_head = NULL, *p_curr = NULL;
				printf("Enter getClientPar\n");
				doSystem( "iwpriv ra0 set SiteSurvey=1" );
			    sleep( 1 );
				get_site_survey_ap( &p_head );

				
				int curr_channel = 0;
				char ex_channel[10]={0};
				char strBssid[ 24 ] = { 0 };
				p_curr = p_head;
				while (p_curr)
				{
					char strSsid[ 38 ] = { 0 };
					strcpy(strSsid, p_curr->s_ssid);
					if(!strcmp(strSsid,ssid))
					{
						if(gstrlen(bssid) == 0)
							;
						else
						{
							strcpy(strBssid, p_curr->s_bssid);
							if(strcmp(strBssid,bssid)==0)
								;
							else
							{
								p_curr = p_curr->p_next;
								continue;
							}
						}
						printf("OK\n");
						curr_channel = p_curr->i_channel;
						strcpy(ex_channel,p_curr->s_extch);
						break;
					}

					p_curr = p_curr->p_next;							
				}
				
				free_apcli_list( p_head );
				p_head = NULL;
				printf("Client Exchannel=%s\n",ex_channel);
				printf("Client curr_channel=%d\n",curr_channel);
				

				if(curr_channel!=0)	
				{
					sprintf(Cchannel,"%d",curr_channel);
					if(strncmp(ex_channel, "BELOW", 5) == 0)
						nvram_set("HT_EXTCHA","0");
					if(strncmp(ex_channel, "ABOVE", 5) == 0)
						nvram_set("HT_EXTCHA","1");
					break;
					
				}
				
			}

			
			//nvram_set("WdsEnable", "0");
			if (gstrlen(ssid) == 0)
			{
				nvram_set("ApCliEnable", "0");
			}
			else
			{
				nvram_set("ApCliEnable", "1");
			}
			nvram_set("ApCliSsid", ssid);
			nvram_set("ApCliBssid", bssid);
			//start of that in client ,ap client mode,channel write to nvram by huangfeilan at 20110629
			nvram_set("ApCliChannel", Cchannel);
			nvram_set("Channel", Cchannel);
			if (!strncmp(Cchannel, "0", 2)) {
				nvram_set("AutoChannelSelect", "2");
			} else {
				nvram_set("AutoChannelSelect", "0");
			}

			nvram_set("WirelessMode", "9");
			nvram_set("ApCliAuthMode", mode);
			nvram_set("ApCliEncrypType", enc);
			nvram_set("ApCliWPAPSK", wpapsk);
			nvram_set("ApCliDefaultKeyID", keyid);
			nvram_set("ApCliKey1Type", keytype1);
			nvram_set("ApCliKey1Str", key1);
			nvram_set("ApCliKey2Type", keytype2);
			nvram_set("ApCliKey2Str", key2);
			nvram_set("ApCliKey3Type", keytype3);
			nvram_set("ApCliKey3Str", key3);
			nvram_set("ApCliKey4Type", keytype4);
			nvram_set("ApCliKey4Str", key4);
			//start of that only one SSID is valid except in AP mode by huangfeilan at 20110630
			//nvram_set("BssidNum", "1");
			nvram_set("ssidenable1", "1");
			nvram_set("ssidenable2", "1");
			nvram_set("ssidenable3", "1");
			nvram_set("Hiddenssid", "0");
			nvram_set("SynSsid", "0");
			
			sync_apcli = websGetVar(wp, T("synchronism"), T("off"));
			/*printf("sync_apcli:%s\n", sync_apcli);*/
			if (!strncmp(sync_apcli, "on", 2)) 
			{
				char* apclienable = nvram_safe_get( "ApCliEnable");
#ifndef DEFINE_DHCP_AUTO_SWITCH	
				if (!strcmp(apclienable, "1"))
				{
					/* for ap. liugang, 20130321 */
					nvram_set("SSID1", ssid);			
					nvram_set("AuthMode", mode);
					nvram_set("EncrypType", enc);			
					nvram_set("WPAPSK1", wpapsk);
					nvram_set("DefaultKeyID", keyid);			
					nvram_set("Key1Type", keytype1);
					nvram_set("Key1Str1", key1);
					nvram_set("Key2Type", keytype2);
					nvram_set("Key2Str1", key2);
					nvram_set("Key3Type", keytype3);
					nvram_set("Key3Str1", key3);
					nvram_set("Key4Type", keytype4);
					nvram_set("Key4Str1", key4);			
				}
#endif
				nvram_set("SynSsid", "1");
			}
#ifdef DEFINE_DHCP_AUTO_SWITCH	
			else // not sync_apcli,restore old wireless
			{
				printf("Repeater: not sync_apcli,restore old wireless.\n");
				nvram_set( "SSID1", nvram_safe_get("res_SSID1"));
				nvram_set( "AuthMode", nvram_safe_get("res_AuthMode"));
				nvram_set( "EncrypType", nvram_safe_get("res_EncrypType"));
				nvram_set( "WPAPSK1", nvram_safe_get("res_WPAPSK1"));
			}
#endif
			//end of that only one SSID is valid except in AP mode by huangfeilan at 20110630
#if 1//!defined(DEFINE_ITRAVEL2) && !defined(DEFINE_ISTORAGE2)
			if(!strncmp(opmode,"3",2) || !strncmp(opmode,"6",2))
			{
				nvram_set("wireless_perform_func", "4");
				nvram_set("wan_set", "1");
		   		nvram_commit();
		   		notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
			}
			else
#endif
			{
				nvram_set("wan_set", "1");
				nvram_commit();
				kill(1, SIGHUP);
				sleep(20);
			}
			
			//websRedirect(wp, "wl_basic.asp");//apcli.asp
		/*end of add sta apcli mode minpengwei 20110527*/
		}

}


/* goform/wirelessAdvanced */
static void wirelessAdvanced(webs_t wp, char_t *path, char_t *query)
{
	char_t	*bg_protection, /**basic_rate,*/ *beacon, *dtim, *fragment, *rts,
			*tx_power, *short_preamble, *short_slot, *tx_burst, *pkt_aggregate,
			*ieee_80211h, *wmm_capable, *apsd_capable, *dls_capable, *countrycode;
	char_t	*m2u_enable, *rd_region, *carrier_detect;
	int		i, ssid_num, wlan_mode;
	char	wmm_enable[16];
#ifdef CONFIG_RT2860V2_AUTO_PROVISION
	char_t  *auto_provision;
#endif
	char_t	*rvt;
	int		oldrvt;

	//fetch from web input
	bg_protection = websGetVar(wp, T("bg_protection"), T("0"));
	//basic_rate = websGetVar(wp, T("basic_rate"), T("15"));
	beacon = websGetVar(wp, T("beacon"), T("100"));
	dtim = websGetVar(wp, T("dtim"), T("1"));
	fragment = websGetVar(wp, T("fragment"), T("2346"));
	rts = websGetVar(wp, T("rts"), T("2347"));
	tx_power = websGetVar(wp, T("tx_power"), T("100"));
	short_preamble = websGetVar(wp, T("short_preamble"), T("0"));
	short_slot = websGetVar(wp, T("short_slot"), T("0"));
	tx_burst = websGetVar(wp, T("tx_burst"), T("0"));
	pkt_aggregate = websGetVar(wp, T("pkt_aggregate"), T("0"));
#ifdef CONFIG_RT2860V2_AUTO_PROVISION
	auto_provision = websGetVar(wp, T("auto_provision"), T("0"));
#endif
	ieee_80211h = websGetVar(wp, T("ieee_80211h"), T("0"));
	rd_region = websGetVar(wp, T("rd_region"), T("CE"));
	carrier_detect = websGetVar(wp, T("carrier_detect"), T("0"));
	rvt = websGetVar(wp, T("rvt"), T("0"));
	wmm_capable = websGetVar(wp, T("wmm_capable"), T("0"));
	apsd_capable = websGetVar(wp, T("apsd_capable"), T("0"));
	dls_capable = websGetVar(wp, T("dls_capable"), T("0"));
	m2u_enable = websGetVar(wp, T("m2u_enable"), T("0"));
	countrycode = websGetVar(wp, T("country_code"), T("HK"));
	const char *old_countrycode=nvram_safe_get("CountryCode");
	const char *old_rd_region = nvram_safe_get("RDRegion");
	if ( (!strncmp(countrycode,old_countrycode,2))
		|| (!strncmp(rd_region,old_rd_region,2)) )
	{
	           ;//Do nothing
	}
	else                  //countrycody changed  set Channel auto
	{
		nvram_set( "AutoChannelSelect", "2");
		nvram_set( "Channel", "0");
		//nvram_commit(RT2860_NVRAM);
	}
	if (NULL != nvram_get( "BssidNum"))
		ssid_num = atoi(nvram_safe_get( "BssidNum"));
	else
		ssid_num = 1;
	wlan_mode = atoi(nvram_safe_get( "WirelessMode"));

	if (NULL != nvram_get( "RVT"))
		oldrvt = atoi(nvram_safe_get( "RVT"));
	else
		oldrvt = 0;

	//set to nvram
	nvram_set( "BGProtection", bg_protection);
	//nvram_set( "BasicRate", basic_rate);
	nvram_set( "BeaconPeriod", beacon);
	nvram_set( "DtimPeriod", dtim);
	nvram_set( "FragThreshold", fragment);
	nvram_set( "RTSThreshold", rts);
	nvram_set( "TxPower", tx_power);
	nvram_set( "TxPreamble", short_preamble);
	nvram_set( "ShortSlot", short_slot);
	nvram_set( "TxBurst", tx_burst);
	nvram_set( "PktAggregate", pkt_aggregate);
#ifdef CONFIG_RT2860V2_AUTO_PROVISION
	nvram_set( "AutoProvisionEn", auto_provision);
#endif
	nvram_set( "IEEE80211H", ieee_80211h);
	nvram_set( "RDRegion", rd_region);
	nvram_set( "CarrierDetect", carrier_detect);
	if (!strncmp(rvt, "1", 2) && oldrvt != 1) {
		nvram_set( "RVT", "1");
		nvram_set( "HT_RxStream", "1");
		nvram_set( "HT_TxStream", "1");
		nvram_set( "HT_GI", "0");
		nvram_set( "VideoTurbine", "1");
		nvram_set( "ITxBfEn", "1");
	}
	else if (!strncmp(rvt, "0", 2) && oldrvt != 0) {
		nvram_set( "RVT", "0");
		nvram_set( "HT_RxStream", "3");
		nvram_set( "HT_TxStream", "3");
		nvram_set( "HT_GI", "1");
		nvram_set( "VideoTurbine", "0");
		nvram_set( "ITxBfEn", "0");
	}
	nvram_set( "APSDCapable", apsd_capable);
	nvram_set( "DLSCapable", dls_capable);
	nvram_set( "M2UEnabled", m2u_enable);

	bzero(wmm_enable, sizeof(char)*16);
	for (i = 0; i < ssid_num; i++)
	{
		sprintf(wmm_enable+strlen(wmm_enable), "%d", atoi(wmm_capable));
		sprintf(wmm_enable+strlen(wmm_enable), "%c", ';');
	}
	wmm_enable[strlen(wmm_enable) - 1] = '\0';
	nvram_set( "WmmCapable", wmm_enable);

	if (!strncmp(wmm_capable, "1", 2)) {
		if (wlan_mode < 5)
			nvram_set( "TxBurst", "0");
	}
#if 0 /* following code is not completely work why choices are only: FCC/ETSI/JP. hide by radar. 2010.6.13 */
	nvram_set( "CountryCode", countrycode);
	if (!strncmp(countrycode, "US", 3) || !strncmp(rd_region, "FCC", 4)) {
		nvram_set( "CountryRegion", "0");
		nvram_set( "CountryRegionABand", "0");
	}
	else if (!strncmp(countrycode, "JP", 3) || !strncmp(rd_region, "JAP", 4)) {
		nvram_set( "CountryRegion", "5");
		nvram_set( "CountryRegionABand", "6");
	}
	else if (!strncmp(countrycode, "FR", 3) || !strncmp(rd_region, "CE", 3)) {
		nvram_set( "CountryRegion", "1");
		nvram_set( "CountryRegionABand", "2");
	}
	else if (!strncmp(countrycode, "TW", 3) || !strncmp(rd_region, "CE", 3)) {
		nvram_set( "CountryRegion", "1");
		nvram_set( "CountryRegionABand", "3");
	}
	else if (!strncmp(countrycode, "IE", 3) || !strncmp(rd_region, "CE", 3)) {
		nvram_set( "CountryRegion", "1");
		nvram_set( "CountryRegionABand", "2");
	}
	else if (!strncmp(countrycode, "HK", 3) || !strncmp(rd_region, "CE", 3)) {
		nvram_set( "CountryRegion", "1");
		nvram_set( "CountryRegionABand", "0");
	}
	else {
		nvram_set( "CountryCode", "CN");
	}
#else	/* ref: see allCountry[] defined in ap_cfg.c */
	if (!strcmp(rd_region, "FCC"))  { /* FCC(1-11), country define to: US */
		countrycode = "US";
		nvram_set( "CountryRegion", "0");
		nvram_set( "CountryRegionABand", "0");
	}
	else if (!strcmp(rd_region, "CE")){ /* ETSI(1-13), country define to: CN */
		countrycode = "CN";
		nvram_set( "CountryRegion", "1");
		nvram_set( "CountryRegionABand", "4");
	}
	else if (!strcmp(rd_region, "JAP")){ /* JP(1-14), country define to: JP */
		countrycode = "JP";
		nvram_set( "CountryRegion", "5");
		nvram_set( "CountryRegionABand", "6");
	}
	nvram_set( "CountryCode", countrycode);
#endif

	//nvram_commit(RT2860_NVRAM);
	//initInternet();
	//doSystem("rc wlanapp");
	nvram_set("wireless_perform_func", "5");
	nvram_set("wan_set", "1");
    nvram_commit();
	notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	//WPSRestart();
#if 0
#ifdef CONFIG_RT2860V2_AP_IGMP_SNOOP
	if (!strncmp(m2u_enable, "1", 2))
		doSystem("iwpriv ra0 set IgmpSnEnable=1");
	else
		doSystem("iwpriv ra0 set IgmpSnEnable=0");
#endif
#endif

#ifdef	GOAHEAD_SHOWSUBMITINFO
	//debug print
	websHeader(wp);
	websWrite(wp, T("bg_protection: %s<br>\n"), bg_protection);
    //websWrite(wp, T("basic_rate: %s<br>\n"), basic_rate);
    websWrite(wp, T("beacon: %s<br>\n"), beacon);
    websWrite(wp, T("dtim: %s<br>\n"), dtim);
    websWrite(wp, T("fragment: %s<br>\n"), fragment);
    websWrite(wp, T("rts: %s<br>\n"), rts);
    websWrite(wp, T("tx_power: %s<br>\n"), tx_power);
    websWrite(wp, T("short_preamble: %s<br>\n"), short_preamble);
    websWrite(wp, T("short_slot: %s<br>\n"), short_slot);
    websWrite(wp, T("tx_burst: %s<br>\n"), tx_burst);
    websWrite(wp, T("pkt_aggregate: %s<br>\n"), pkt_aggregate);
#ifdef CONFIG_RT2860V2_AUTO_PROVISION
    websWrite(wp, T("auto_provision: %s<br>\n"), auto_provision);
#endif
    websWrite(wp, T("ieee_80211h: %s<br>\n"), ieee_80211h);
    websWrite(wp, T("rd_region: %s<br>\n"), rd_region);
    websWrite(wp, T("carrier_detect: %s<br>\n"), carrier_detect);
    websWrite(wp, T("RVT: %s<br>\n"), rvt);
    websWrite(wp, T("wmm_capable: %s<br>\n"), wmm_capable);
    websWrite(wp, T("apsd_capable: %s<br>\n"), apsd_capable);
    websWrite(wp, T("dls_capable: %s<br>\n"), dls_capable);
    websWrite(wp, T("countrycode: %s<br>\n"), countrycode);
#ifdef CONFIG_RT2860V2_AP_IGMP_SNOOP
    websWrite(wp, T("m2u_enable: %s<br>\n"), m2u_enable);
#endif
	websFooter(wp);
	websDone(wp, 200);
#else
	websRedirect(wp, "wl_adv.asp");
#endif
}

#ifdef CONFIG_RT2860V2_AP_WDS
/* goform/wirelessWds */
static void wirelessWds(webs_t wp, char_t *path, char_t *query)
{
	char_t	*wds_mode, *wds_phy_mode, *wds_encryp_type, *wds_encryp_key0,
			*wds_encryp_key1,*wds_encryp_key2, *wds_encryp_key3, *wds_list;

	wds_mode = websGetVar(wp, T("wds_mode"), T("0"));
	wds_phy_mode = websGetVar(wp, T("wds_phy_mode"), T(""));
	wds_encryp_type = websGetVar(wp, T("wds_encryp_type"), T(""));
	wds_encryp_key0 = websGetVar(wp, T("wds_encryp_key0"), T(""));
	wds_encryp_key1 = websGetVar(wp, T("wds_encryp_key1"), T(""));
	wds_encryp_key2 = websGetVar(wp, T("wds_encryp_key2"), T(""));
	wds_encryp_key3 = websGetVar(wp, T("wds_encryp_key3"), T(""));
	wds_list = websGetVar(wp, T("wds_list"), T(""));

	if (strncmp(wds_mode, "0", 2)) {
        *wds_mode += 1;
		nvram_set( "WdsEnable", wds_mode);
		nvram_set( "WdsPhyMode", wds_phy_mode);
		nvram_set( "WdsEncrypType", wds_encryp_type);
		nvram_set( "Wds0Key", wds_encryp_key0);
		nvram_set( "Wds1Key", wds_encryp_key1);
		nvram_set( "Wds2Key", wds_encryp_key2);
		nvram_set( "Wds3Key", wds_encryp_key3);
		if (!strncmp(wds_mode, "2", 2) || !strncmp(wds_mode, "3", 2)) {
			if (0 != strlen(wds_list))
				nvram_set( "WdsList", wds_list);
		}
	}
	else
		nvram_set( "WdsEnable", wds_mode);
	//nvram_commit(RT2860_NVRAM);
	nvram_set("wireless_perform_func", "6");
	nvram_set("wan_set", "1");
	nvram_commit();

	//initInternet();
	//doSystem("rc wlanapp");
	notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	//WPSRestart();
    //WPSRestart();
	#ifdef	GOAHEAD_SHOWSUBMITINFO
	//debug print
	websHeader(wp);
	websWrite(wp, T("wds_mode: %s<br>\n"), wds_mode);
	websWrite(wp, T("wds_phy_mode: %s<br>\n"), wds_phy_mode);
	websWrite(wp, T("wds_encryp_type: %s<br>\n"), wds_encryp_type);
	websWrite(wp, T("wds_encryp_key0: %s<br>\n"), wds_encryp_key0);
	websWrite(wp, T("wds_encryp_key1: %s<br>\n"), wds_encryp_key1);
	websWrite(wp, T("wds_encryp_key2: %s<br>\n"), wds_encryp_key2);
	websWrite(wp, T("wds_encryp_key3: %s<br>\n"), wds_encryp_key3);
	websWrite(wp, T("wds_list: %s<br>\n"), wds_list);
	websFooter(wp);
	websDone(wp, 200);
	#else
		websRedirect(wp, "wl_wds.asp");
	#endif
}
#endif

#ifdef CONFIG_RT2860V2_AP_APCLI
/* goform/wirelessApcli */
static void wirelessApcli(webs_t wp, char_t *path, char_t *query)
{
	char_t	*ssid, *bssid, *mode, *enc, *wpapsk, *keyid, *keytype,
			*key1, *key2, *key3, *key4;
	char_t* sync_apcli = NULL;
	//fetch from web input
	ssid = websGetVar(wp, T("apcli_ssid"), T(""));
	bssid = websGetVar(wp, T("apcli_bssid"), T(""));
	mode = websGetVar(wp, T("apcli_mode"), T("OPEN"));
	enc = websGetVar(wp, T("apcli_enc"), T("NONE"));
	wpapsk = websGetVar(wp, T("apcli_wpapsk"), T("12345678"));
	keyid = websGetVar(wp, T("apcli_default_key"), T("1"));
	keytype = websGetVar(wp, T("apcli_key1type"), T("1"));
	key1 = websGetVar(wp, T("apcli_key1"), T(""));
	key2 = websGetVar(wp, T("apcli_key2"), T(""));
	key3 = websGetVar(wp, T("apcli_key3"), T(""));
	key4 = websGetVar(wp, T("apcli_key4"), T(""));
	/*
	if (gstrlen(ssid) == 0) {
		websError(wp, 200, "SSID is empty");
		return;
	}
	*/
	if (gstrlen(ssid) == 0)
	{
		nvram_set("ApCliEnable", "0");
	}
	else
	{
		nvram_set("ApCliEnable", "1");
	}
	nvram_set( "ApCliSsid", ssid);
	/*nvram_set( "SSID1", ssid);*/
	nvram_set( "ApCliBssid", bssid);
	nvram_set( "ApCliAuthMode", mode);
	nvram_set( "ApCliEncrypType", enc);
	nvram_set( "ApCliWPAPSK", wpapsk);
	nvram_set( "ApCliDefaultKeyID", keyid);
	nvram_set( "ApCliKey1Type", keytype);
	nvram_set( "ApCliKey1Str", key1);
	nvram_set( "ApCliKey2Type", keytype);
	nvram_set( "ApCliKey2Str", key2);
	nvram_set( "ApCliKey3Type", keytype);
	nvram_set( "ApCliKey3Str", key3);
	nvram_set( "ApCliKey4Type", keytype);
	nvram_set( "ApCliKey4Str", key4);
	nvram_set("SynSsid", "0");

	sync_apcli = websGetVar(wp, T("synchronism"), T("off"));
	/*printf("sync_apcli:%s\n", sync_apcli);*/
	if (!strncmp(sync_apcli, "on", 2)) 
	{
		char* apclienable = nvram_safe_get( "ApCliEnable");

		if (!strcmp(apclienable, "1"))
		{
			/* for ap. liugang, 20130321 */
			nvram_set("SSID1", ssid);
			nvram_set("AuthMode", mode);
			nvram_set("EncrypType", enc);			
			nvram_set("WPAPSK1", wpapsk);
			nvram_set("DefaultKeyID", keyid);			
			nvram_set("Key1Type", keytype);
			nvram_set("Key1Str", key1);
			nvram_set("Key2Type", keytype);
			nvram_set("Key2Str", key2);
			nvram_set("Key3Type", keytype);
			nvram_set("Key3Str", key3);
			nvram_set("Key4Type", keytype);
			nvram_set("Key4Str", key4);
		}
		nvram_set("SynSsid", "1");
	}
	//nvram_commit(RT2860_NVRAM);
	nvram_commit();

	//debug print
	websHeader(wp);
	websWrite(wp, T("ssid: %s<br>\n"), ssid);
	websWrite(wp, T("bssid: %s<br>\n"), bssid);
	websWrite(wp, T("mode: %s<br>\n"), mode);
	websWrite(wp, T("enc: %s<br>\n"), enc);
	if (!strcmp(mode, "WPAPSK") || !strcmp(mode, "WPA2PSK")) {
		websWrite(wp, T("wpapsk: %s<br>\n"), wpapsk);
	}
	if (!strcmp(mode, "OPEN") || !strcmp(mode, "SHARED")) {
		websWrite(wp, T("keyid: %s<br>\n"), keyid);
		websWrite(wp, T("keytype: %s<br>\n"), keytype);
		websWrite(wp, T("key1: %s<br>\n"), key1);
		websWrite(wp, T("key2: %s<br>\n"), key2);
		websWrite(wp, T("key3: %s<br>\n"), key3);
		websWrite(wp, T("key4: %s<br>\n"), key4);
	}
	websFooter(wp);
	websDone(wp, 200);
}
#endif
//void WPSRestart(void);

/* goform/wirelessWmm */
static void wirelessWmm(webs_t wp, char_t *path, char_t *query)
{
	char_t	*ap_aifsn_all, *ap_cwmin_all, *ap_cwmax_all, *ap_txop_all,
			*ap_acm_all, *ap_ackpolicy_all,
			*sta_aifsn_all, *sta_cwmin_all, *sta_cwmax_all, *sta_txop_all,
			*sta_acm_all;

	ap_aifsn_all = websGetVar(wp, T("ap_aifsn_all"), T(""));
	ap_cwmin_all = websGetVar(wp, T("ap_cwmin_all"), T(""));
	ap_cwmax_all = websGetVar(wp, T("ap_cwmax_all"), T(""));
	ap_txop_all = websGetVar(wp, T("ap_txop_all"), T(""));
	ap_acm_all = websGetVar(wp, T("ap_acm_all"), T(""));
	ap_ackpolicy_all = websGetVar(wp, T("ap_ackpolicy_all"), T(""));
	sta_aifsn_all = websGetVar(wp, T("sta_aifsn_all"), T(""));
	sta_cwmin_all = websGetVar(wp, T("sta_cwmin_all"), T(""));
	sta_cwmax_all = websGetVar(wp, T("sta_cwmax_all"), T(""));
	sta_txop_all = websGetVar(wp, T("sta_txop_all"), T(""));
	sta_acm_all = websGetVar(wp, T("sta_acm_all"), T(""));

	if (0 != strlen(ap_aifsn_all))
		nvram_set( "APAifsn", ap_aifsn_all);
	if (0 != strlen(ap_cwmin_all))
		nvram_set( "APCwmin", ap_cwmin_all);
	if (0 != strlen(ap_cwmax_all))
		nvram_set( "APCwmax", ap_cwmax_all);
	if (0 != strlen(ap_txop_all))
		nvram_set( "APTxop", ap_txop_all);
	if (0 != strlen(ap_acm_all))
		nvram_set( "APACM", ap_acm_all);
	if (0 != strlen(ap_ackpolicy_all))
		nvram_set( "AckPolicy", ap_ackpolicy_all);
	if (0 != strlen(sta_aifsn_all))
		nvram_set( "BSSAifsn", sta_aifsn_all);
	if (0 != strlen(sta_cwmin_all))
		nvram_set( "BSSCwmin", sta_cwmin_all);
	if (0 != strlen(sta_cwmax_all))
		nvram_set( "BSSCwmax", sta_cwmax_all);
	if (0 != strlen(sta_txop_all))
		nvram_set( "BSSTxop", sta_txop_all);
	if (0 != strlen(sta_acm_all))
		nvram_set( "BSSACM", sta_acm_all);

	//nvram_commit(RT2860_NVRAM);

	// doSystem("ifconfig ra0 down");
	// doSystem("ralink_init make_wireless_config rt2860");
	// doSystem("ifconfig ra0 up");
	//after ra0 down&up we must restore WPS status
	nvram_set("wireless_perform_func", "7");
	nvram_set("wan_set", "1");
	nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	//WPSRestart();

	websHeader(wp);
	websWrite(wp, T("ap_aifsn_all: %s<br>\n"), ap_aifsn_all);
	websWrite(wp, T("ap_cwmin_all: %s<br>\n"), ap_cwmin_all);
	websWrite(wp, T("ap_cwmax_all: %s<br>\n"), ap_cwmax_all);
	websWrite(wp, T("ap_txop_all: %s<br>\n"), ap_txop_all);
	websWrite(wp, T("ap_acm_all: %s<br>\n"), ap_acm_all);
	websWrite(wp, T("ap_ackpolicy_all: %s<br>\n"), ap_ackpolicy_all);
	websWrite(wp, T("sta_aifsn_all: %s<br>\n"), sta_aifsn_all);
	websWrite(wp, T("sta_cwmin_all: %s<br>\n"), sta_cwmin_all);
	websWrite(wp, T("sta_cwmax_all: %s<br>\n"), sta_cwmax_all);
	websWrite(wp, T("sta_txop_all: %s<br>\n"), sta_txop_all);
	websWrite(wp, T("sta_acm_all: %s<br>\n"), sta_acm_all);
	websFooter(wp);
	websDone(wp, 200);
}

#ifdef AP_WAPI_SUPPORT
void restartWAPIDaemon(void)
{
	const char *auth_mode = nvram_safe_get( "AuthMode");

	doSystem("killall wapid 1>/dev/null 2>&1");
	if (NULL !=strstr(auth_mode, "WAIPSK") || NULL !=strstr(auth_mode, "WAICERT"))
	{
		doSystem("wapid");
	}
}
#endif

void restart8021XDaemon(void)
{
	int i, num, apd_flag = 0;
	char *auth_mode = (char *) nvram_safe_get( "AuthMode");
	char *ieee8021x = (char *)nvram_safe_get( "IEEE8021X");
	const char *num_s = nvram_get( "BssidNum");
	if(!num_s)
		return;
	num = atoi(num_s);

	doSystem("killall rt2860apd 1>/dev/null 2>&1");

	/*
	 * In fact we only support mbssid[0] to use 802.1x radius settings.
	 */
	for(i=0; i<num; i++){
		char tmp_auth[128];
		if( getNthValueSafe(i, auth_mode, ';', tmp_auth, 128) != -1){
			if(!strcmp(tmp_auth, "WPA") || !strcmp(tmp_auth, "WPA2") || !strcmp(tmp_auth, "WPA1WPA2")){
				apd_flag = 1;
				break;
			}
		}

		if( getNthValueSafe(i, ieee8021x, ';', tmp_auth, 128) != -1){
			if(!strcmp(tmp_auth, "1")){
				apd_flag = 1;
				break;
			}
		}
	}

	if(apd_flag){
		doSystem("rt2860apd");
	}
}

void getSecurity(webs_t wp, char_t *path, char_t *query)
{
	int num_ssid, i;
	const char *num_s = nvram_get("BssidNum");
	char_t result[4096];

	char_t *PreAuth, *AuthMode, *EncrypType, *DefaultKeyID, *Key1Type, *Key2Type,
		   *Key3Type, *Key4Type, *RekeyMethod, *RekeyInterval, *PMKCachePeriod, *IEEE8021X;
	char_t *RADIUS_Server, *RADIUS_Port, *session_timeout_interval, *idle_timeout_interval;
#ifdef AP_WAPI_SUPPORT
	// char_t *Wapiifname;
	char_t *WapiPskType, *WapiAsIpAddr, *WapiAsPort, *WapiAsCertPath, *WapiUserCertPath;
#endif

//	printf("***** nvram = %d\n", nvram);

	if(num_s)
		num_ssid = atoi(num_s);
	else
		num_ssid = 1;

	result[0] = '\0';

	// deal with shown MBSSID
	if(default_shown_mbssid > atoi(num_s))
		default_shown_mbssid = 0;
	sprintf(result, "%d\n",  default_shown_mbssid);

	{
		for(i=0; i<num_ssid; i++) {
			//LFF(result, nvram, SSID, i);
			gstrncat(result, (char*)nvram_safe_get(racat("SSID", i+1)), 4096);
			gstrncat(result, "\r", 4096);
			LFF(result, PreAuth, i);
			LFF(result, AuthMode, i);
			LFF(result, EncrypType, i);
			LFF(result, DefaultKeyID, i);
			LFF(result, Key1Type, i);
			//LFF(result, nvram, Key1Str, i);
			gstrncat(result, (char*)nvram_safe_get(racat("Key1Str", i+1)), 4096);
			gstrncat(result, "\r", 4096);
			LFF(result, Key2Type, i);
			//LFF(result, nvram, Key2Str, i);
			gstrncat(result, (char*)nvram_safe_get(racat("Key2Str", i+1)), 4096);
			gstrncat(result, "\r", 4096);
			LFF(result, Key3Type, i);
			//LFF(result, nvram, Key3Str, i);
			gstrncat(result, (char*)nvram_safe_get(racat("Key3Str", i+1)), 4096);
			gstrncat(result, "\r", 4096);
			LFF(result, Key4Type, i);
			//LFF(result, nvram, Key4Str, i);
			gstrncat(result, (char*)nvram_safe_get( racat("Key4Str", i+1)), 4096);
			gstrncat(result, "\r", 4096);
			//LFF(result, nvram, WPAPSK, i);
			gstrncat(result, (char*)nvram_safe_get(racat("WPAPSK", i+1)), 4096);
			gstrncat(result, "\r", 4096);

			LFF(result, RekeyMethod, i);
			LFF(result, RekeyInterval, i);
			LFF(result, PMKCachePeriod, i);
			LFF(result, IEEE8021X, i);
			LFF(result, RADIUS_Server, i);
			LFF(result, RADIUS_Port, i);
			//LFF(result, nvram, RADIUS_Key, i);
			gstrncat(result, nvram_safe_get(racat("RADIUS_Key", i+1)), 4096);
			gstrncat(result, "\r", 4096);
			LFF(result, session_timeout_interval, i);
			LFF(result, idle_timeout_interval, i);
			gstrncat(result, "\n", 4096);
#ifdef AP_WAPI_SUPPORT
			LFF(result, WapiPskType, i);
			gstrncat(result, nvram_safe_get(racat("WapiPsk", i+1)), 4096);
			gstrncat(result, "\r", 4096);
			LFF(result, WapiAsIpAddr, i);
			LFF(result, WapiAsPort, i);
			LFF(result, WapiAsCertPath, i);
			LFF(result, WapiUserCertPath, i);
#endif
		}
	}

	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));
	websWrite(wp, T("%s"), result);
	websDone(wp, 200);

}

static void wirelessGetSecurity(webs_t wp, char_t *path, char_t *query)
{
	return getSecurity(wp, path, query);
}

void updateFlash8021x(void)
{
	char lan_if_addr[16];
	const char *RADIUS_Server;
	const char *operation_mode;

	// if(! (operation_mode = nvram_safe_get( "OperationMode")))
	if(! (operation_mode = nvram_get( "OperationMode")))
		return;

	if(! (RADIUS_Server = nvram_get("RADIUS_Server")))
		return;

	if(!strlen(RADIUS_Server))
		return;

	if(*operation_mode == '0'){ // Bridge
		if (getIfIp(nvram_safe_get("lan_ifname"), lan_if_addr) == -1) {
			return;
		}
		nvram_set( "own_ip_addr", lan_if_addr);

#if defined (RTDEV_SUPPORT)
		nvram_set( "EAPifname", nvram_safe_get("lan_ifname"));
		nvram_set( "PreAuthifname", nvram_safe_get("lan_ifname"));
#endif

#if defined (CONFIG_RT2561_AP) || defined (CONFIG_RT2561_AP_MODULE)
		nvram_set( "Ethifname", nvram_safe_get("lan_ifname"));
#endif
	}else if(*operation_mode == '1'){	// Gateway
		if (getIfIp(nvram_safe_get("lan_ifname"), lan_if_addr) == -1)
			return;
		nvram_set( "own_ip_addr", lan_if_addr);

#if defined (RTDEV_SUPPORT)
		nvram_set( "EAPifname", nvram_safe_get("lan_ifname"));
		nvram_set( "PreAuthifname", nvram_safe_get("lan_ifname"));
#endif

#if defined (CONFIG_RT2561_AP) || defined (CONFIG_RT2561_AP_MODULE)
		nvram_set( "Ethifname", nvram_safe_get("lan_ifname"));
#endif
	}else if(*operation_mode == '2'){	// Wireless gateway
		if (getIfIp(nvram_safe_get("lan_ifname"), lan_if_addr) == -1)
			return;
		nvram_set( "own_ip_addr", lan_if_addr);

#if defined (RTDEV_SUPPORT)
		nvram_set( "EAPifname", nvram_safe_get("lan_ifname"));
		nvram_set( "PreAuthifname", nvram_safe_get("lan_ifname"));
#endif

#if defined (CONFIG_RT2561_AP) || defined (CONFIG_RT2561_AP_MODULE)
		nvram_set( "Ethifname", nvram_safe_get("lan_ifname"));
#endif
	}else{
		printf("not op mode\n");
		return;
	}

	nvram_commit();
}


int AccessPolicyHandle(webs_t wp, int mbssid)
{
	char_t *apselect, *newap_list;
	char str[32];
	char ap_list[2048];

	if(mbssid > 8 || mbssid < 0)
		return -1;

	sprintf(str, "apselect_%d", mbssid);	// UI on web page
	apselect = websGetVar(wp, str, T(""));
	if(!apselect){
		printf("cant find %s\n", apselect);
		return -1;
	}

	sprintf(str, "AccessPolicy%d", mbssid);
	nvram_set( str, apselect);

	sprintf(str, "newap_text_%d", mbssid);
	newap_list = websGetVar(wp, str, T(""));
	if(!newap_list)
		return -1;
	if(!gstrlen(newap_list))
		return 0;
	sprintf(str, "AccessControlList%d", mbssid);
	sprintf(ap_list, "%s", nvram_safe_get(str));
	if(strlen(ap_list))
		sprintf(ap_list, "%s;%s", ap_list, newap_list);
	else
		sprintf(ap_list, "%s", newap_list);

	nvram_set(str, ap_list);
	return 0;
}



void conf8021x(webs_t wp, int mbssid)
{
	char_t *RadiusServerIP, *RadiusServerPort, *RadiusServerSecret, *RadiusServerSessionTimeout, *RadiusServerIdleTimeout;

	LFW(RadiusServerIP, RadiusServerIP);
	LFW(RadiusServerPort, RadiusServerPort);
	LFW(RadiusServerSecret, RadiusServerSecret);
	LFW(RadiusServerSessionTimeout, RadiusServerSessionTimeout);
	LFW(RadiusServerIdleTimeout, RadiusServerIdleTimeout);
	if(!gstrlen(RadiusServerSessionTimeout))
		RadiusServerSessionTimeout = "0";

	STFs( mbssid, "RADIUS_Server", RadiusServerIP);
	STFs( mbssid, "RADIUS_Port", RadiusServerPort);
	nvram_set( racat("RADIUS_Key", mbssid+1), RadiusServerSecret);
	STFs( mbssid, "session_timeout_interval", RadiusServerSessionTimeout);
	STFs( mbssid, "idle_timeout_interval", RadiusServerIdleTimeout);

	updateFlash8021x();
	//restart8021XDaemon();
}

void confWEP(webs_t wp, int mbssid)
{
	char_t *DefaultKeyID, *Key1Type, *Key1Str, *Key2Type, *Key2Str, *Key3Type, *Key3Str, *Key4Type, *Key4Str;

	LFW(DefaultKeyID, wep_default_key);
	LFW(Key1Str, wep_key_1);
	LFW(Key2Str, wep_key_2);
	LFW(Key3Str, wep_key_3);
	LFW(Key4Str, wep_key_4);
	LFW(Key1Type, WEP1Select);
	LFW(Key2Type, WEP2Select);
	LFW(Key3Type, WEP3Select);
	LFW(Key4Type, WEP4Select);

	STF( mbssid, DefaultKeyID);
	STF( mbssid, Key1Type);
	STF( mbssid, Key2Type);
	STF( mbssid, Key3Type);
	STF( mbssid, Key4Type);
    
	nvram_set( racat("Key1Str", mbssid+1), Key1Str);
	nvram_set( racat("Key2Str", mbssid+1), Key2Str);
	nvram_set( racat("Key3Str", mbssid+1), Key3Str);
	nvram_set( racat("Key4Str", mbssid+1), Key4Str);
}

void confWPAGeneral(webs_t wp, int mbssid)
{
	char *cipher_str;
	char *key_renewal_interval;

	LFW(cipher_str, cipher);
	LFW(key_renewal_interval, keyRenewalInterval);

	switch(cipher_str[0]){
	case '0':
		STFs( mbssid, "EncrypType", "TKIP");
		break;
	case '1':
		STFs( mbssid, "EncrypType", "AES");
		break;
	case '2':
		STFs( mbssid, "EncrypType", "TKIPAES");
		break;
	default:
		return;							// there is no tkip-aes mixed mode in WPA-PSK.
	}
//	STFs( mbssid, "DefaultKeyID", "2");	// DefaultKeyID is 2

	STFs( mbssid, "RekeyInterval", key_renewal_interval);
	STFs( mbssid, "RekeyMethod", "TIME");
	STFs( mbssid, "IEEE8021X", "0");
}

inline void clearRadiusSetting(int mbssid)
{
	char *RADIUS_Server, *RADIUS_Port, *RADIUS_Key;
	//char *session_timeout_interval = NULL;

	RADIUS_Server = (char *)nvram_safe_get("RADIUS_Server");
	RADIUS_Port = (char *)nvram_safe_get("RADIUS_Port");
	RADIUS_Key = (char *)nvram_safe_get( racat("RADIUS_Key", mbssid+1));
	//session_timeout_interval = nvram_safe_get( "session_timeout_interval");

	STFs( mbssid, "IEEE8021X", "0");
	nvram_set( "RADIUS_Server", setNthValue(mbssid, RADIUS_Server, "0"));
	nvram_set( "RADIUS_Port", setNthValue(mbssid, RADIUS_Port, "1812"));
	nvram_set( racat("RADIUS_Key", mbssid+1), " ");
	//nvram_set( "session_timeout_interval", setNthValue(mbssid, session_timeout_interval, ""));

	return;
}

// lyl 20081119 this is for product only
int product_do_security_setting(char *buf)
{
	if (buf[1] == '1')        //only disable security
		return 1;
	//int mbssid_num;
	int i;
	int mbssid = default_shown_mbssid;
	char *security_mode = "Disable";


#ifndef CONFIG_RALINK_RT2880
	// RT2880: GPIO13 is belong to WPS PBC indicator.

	if (!strcmp(security_mode, "Disable") || !strcmp(security_mode, "OPEN"))
		ledAlways(13, LED_OFF); //turn off security LED (gpio 13)
	else
		ledAlways(13, LED_ON); //turn on security LED (gpio 13)

#endif

	clearRadiusSetting(mbssid);
	STFs( mbssid, "AuthMode", "OPEN");
	STFs( mbssid, "EncrypType", "NONE");
	STFs( mbssid, "IEEE8021X", "0");

//i don't know how to handle access policy
//# Access Policy
//	if(AccessPolicyHandle(nvram, wp, mbssid) == -1)
//		trace(0, "** error in AccessPolicyHandle()\n");
    char s_cmd[3] = { 0 };
    memset(s_cmd, 0, 3);
    sprintf(s_cmd, "%d", mbssid);
    nvram_set("mbssid", s_cmd);
#if 0
//# WPS
	{
		if(mbssid == 0){		// only ra0 supports WPS now.
			const char *wordlist= nvram_get( "WscModeOption");
			if(wordlist){
				if (strcmp(wordlist, "0"))
					doSystem("iwpriv ra0 set WscConfStatus=1");
                /* start modify wireless disable to wps by liuguangpeng at 20110802 */
				nvram_set("WscConfigured", "0");
				//g_wsc_configured = 0;
				nvram_set("g_wsc_configured", "0");
                //wps_config = 0;
                nvram_set("wps_config", "0");
                /* end modify wireless disable to wps by liuguangpeng at 20110802 */
			}
		}
	}
//# WPS

	//nvram_commit(nvram);
	nvram_commit();

	/*
	 *  TODO: move to inic.c
	 */
	mbssid_num = atoi(nvram_safe_get( "BssidNum"));

	notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	for(i=0; i<mbssid_num; i++){
		doSystem("ifconfig ra%d down", i);
		doSystem("ifconfig ra%d up", i);
	}
	WPSRestart();

	restart8021XDaemon();
#endif
    nvram_set("wireless_perform_func", "8");
	nvram_set("wan_set", "1");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
    
	return 1;

}

void Security(webs_t wp, char_t *path, char_t *query)
{
	char_t *SSID;
	int mbssid;
	char_t *security_mode;

    /************WPS En Dis***********/
	char *wsc_enable = NULL;
	LFW(wsc_enable, WPSEnable);
    nvram_set("g_wscresult", "0");

	if (strncmp(wsc_enable, "0", 1) == 0){
        nvram_set( "WscModeOption", "0");
	}else{
        nvram_set( "WscModeOption", "7");
	}
    /******************************/

	LFW(SSID, ssidIndex);
	if(!gstrlen(SSID))
		return;

	mbssid = atoi(SSID);

	default_shown_mbssid = mbssid;

	LFW(security_mode, security_mode);

/* itravel2 have no wps! liugang,20130913 */
#if 0	/* add by radar@20081212. */
	const char *radio_on = nvram_safe_get( "RadioOn");	/* radar@20081226 */
	if ('0' != radio_on[0]) {	/* radio on now. */
	// RT2880: GPIO13 is belong to WPS PBC indicator.

	if (!strcmp(security_mode, "Disable") || !strcmp(security_mode, "OPEN"))
		ledAlways(13, LED_OFF); //turn off security LED (gpio 13)
	else
		ledAlways(13, LED_ON); //turn on security LED (gpio 13)
	}
#endif

	//clear Radius settings
	clearRadiusSetting( mbssid);

	if(!strcmp(security_mode, "Disable")){			// !------------------       Disable Mode --------------
		STFs( mbssid, "AuthMode", "OPEN");
		STFs( mbssid, "EncrypType", "NONE");
		STFs( mbssid, "IEEE8021X", "0");
	}else if (!strcmp(security_mode, "OPEN")){				// Open-WEP Mode
		confWEP( wp, mbssid);
		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "EncrypType", "WEP");
		STFs( mbssid, "IEEE8021X", "0");
	}else if( !strcmp(security_mode, "SHARED")){	// !------------------       Shared Mode ----------------
		char *security_shared_mode;
		confWEP( wp, mbssid);

		LFW(security_shared_mode, security_shared_mode);

		STFs( mbssid, "AuthMode", security_mode);

		if(!strcmp(security_shared_mode, "None"))
			STFs( mbssid, "EncrypType", "NONE");
		else
			STFs( mbssid, "EncrypType", "WEP");

		STFs( mbssid, "IEEE8021X", "0");
		memset(security_mode, 0, sizeof(security_mode));
		strcpy(security_mode, "Shared");
	}else if( !strcmp(security_mode, "WEPAUTO")){ // !------------------       WEP Auto Mode ----------------
		confWEP( wp, mbssid);
		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "EncrypType", "WEP");
		STFs( mbssid, "IEEE8021X", "0");
	}else if(!strcmp(security_mode, "WPA") ||
			!strcmp(security_mode, "WPA1WPA2")){	// !------------------		WPA Enterprise Mode ----------------
		conf8021x(wp, mbssid);							// !------------------		WPA1WPA2 mixed mode
		confWPAGeneral(wp, mbssid);

		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "IEEE8021X", "0");
		memset(security_mode, 0, sizeof(security_mode));
		strcpy(security_mode, "WPA-Enterprise");
	}else if( !strcmp(security_mode, "WPAPSK")){ // !------------------       WPA Personal Mode ----------------
		char *pass_phrase_str;

		confWPAGeneral(wp, mbssid);

		LFW(pass_phrase_str, passphrase);

		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "IEEE8021X", "0");
		
		nvram_set( racat("WPAPSK", mbssid+1), pass_phrase_str);
		
		memset(security_mode, 0, sizeof(security_mode));
		strcpy(security_mode, "WPA-PSK");
	}else if( !strcmp(security_mode, "WPA2") ||
	          !strcmp(security_mode, "WPA1WPA2")){		// !------------------  WPA2 Enterprise Mode ----------------
		char *pass_phrase_str;
		char *PMKCachePeriod;
		char *PreAuth;

		conf8021x(wp, mbssid);
		confWPAGeneral(wp, mbssid);

		LFW(pass_phrase_str, passphrase);
		LFW(PMKCachePeriod, PMKCachePeriod);
		LFW(PreAuth, PreAuthentication);

		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "IEEE8021X", "0");
		nvram_set( racat("WPAPSK", mbssid+1), pass_phrase_str);
		STF( mbssid, PMKCachePeriod);
		STF( mbssid, PreAuth);
		memset(security_mode, 0, sizeof(security_mode));
		strcpy(security_mode, "WPA2-Enterprise");
	}else if(!strcmp(security_mode, "WPA2PSK") ||	// !------------------  WPA2 Personal Mode ----------------
			 !strcmp(security_mode, "WPAPSKWPA2PSK") ){ 	//! -------------   WPA PSK WPA2 PSK mixed
		char *pass_phrase_str;

		confWPAGeneral(wp, mbssid);
		LFW(pass_phrase_str, passphrase);

		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "IEEE8021X", "0");

		nvram_set( racat("WPAPSK", mbssid+1), pass_phrase_str);
	} else if (!strcmp(security_mode, "WPA2") ||			// WPA2 Enterprise Mode
			   !strcmp(security_mode, "WPA1WPA2")) {		// WPA Enterprise Mode
		char *PMKCachePeriod;
		char *PreAuth;

		conf8021x(wp, mbssid);
		confWPAGeneral(wp, mbssid);

		LFW(PMKCachePeriod, PMKCachePeriod);
		LFW(PreAuth, PreAuthentication);

		STFs( mbssid, "AuthMode", security_mode);
		STF( mbssid, PMKCachePeriod);
		STF( mbssid, PreAuth);
	} else if (!strcmp(security_mode, "WPA2PSK") ||			// WPA2 Personal Mode
			   !strcmp(security_mode, "WPAPSKWPA2PSK")) { 	// WPA PSK WPA2 PSK mixed
		char *pass_phrase_str;

		confWPAGeneral(wp, mbssid);
		LFW(pass_phrase_str, passphrase);

		STFs( mbssid, "AuthMode", security_mode);

		nvram_set( racat("WPAPSK", mbssid+1), pass_phrase_str);
        
	} else if (!strcmp(security_mode, "IEEE8021X")) {		// 802.1X WEP Mode
		char *ieee8021x_wep;

		conf8021x(wp, mbssid);
		STFs( mbssid, "IEEE8021X", "1");
		STFs( mbssid, "AuthMode", "OPEN");

		LFW(ieee8021x_wep, ieee8021x_wep);
		if(ieee8021x_wep[0] == '0')
			STFs( mbssid, "EncrypType", "NONE");
		else
			STFs( mbssid, "EncrypType", "WEP");
	}
#ifdef AP_WAPI_SUPPORT
	else if (!strcmp(security_mode, "WAICERT")) {			// WAPI-CERT Mode
		// char_t *Wapiifname, *WapiAsPort;
		char_t *WapiAsIpAddr, *WapiAsCertPath, *WapiUserCertPath;

		LFW(WapiAsIpAddr, wapicert_asipaddr);
		// LFW(WapiAsPort, wapicert_asport);
		LFW(WapiAsCertPath, wapicert_ascert);
		LFW(WapiUserCertPath, wapicert_usercert);

		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "EncrypType", "SMS4");
		nvram_set( "Wapiifname", "br0");
		nvram_set( "WapiAsIpAddr", WapiAsIpAddr);
		nvram_set( "WapiAsPort", "3810");
		nvram_set( "WapiAsCertPath", WapiAsCertPath);
		nvram_set( "WapiUserCertPath", WapiUserCertPath);
	} else if (!strcmp(security_mode, "WAIPSK")) {			// WAPI-PSK Mode
		char *preshared_key, *key_type;

		LFW(preshared_key, wapipsk_prekey);
		LFW(key_type, wapipsk_keytype);

		STFs( mbssid, "AuthMode", security_mode);
		STFs( mbssid, "EncrypType", "SMS4");
		STFs( mbssid, "WapiPskType", key_type);

		nvram_set( racat("WapiPsk", mbssid+1), preshared_key);
	}
#endif
	else {													// Open-None Mode
		STFs( mbssid, "AuthMode", "OPEN");
		STFs( mbssid, "EncrypType", "NONE");
	}

//# Access Policy
//	if(AccessPolicyHandle(nvram, wp, mbssid) == -1)
//		trace(0, "** error in AccessPolicyHandle()\n");
    char s_cmd[3] = { 0 };
    memset(s_cmd, 0, 3);
    sprintf(s_cmd, "%d", mbssid);
    nvram_set("mbssid", s_cmd);
    nvram_set("security_mode", security_mode);
#if 0
//# WPS
	{
		const char *wordlist= nvram_get( "WscModeOption");

		if (wordlist && mbssid == 0) {		// only ra0 supports WPS now.
			if (strcmp(wordlist, "0"))
				doSystem("iwpriv ra0 set WscConfStatus=1");
			//g_wsc_configured = 1;
           /* start modify wireless disable to wps by liuguangpeng at 20110803 */
           if(!strcmp(security_mode, "Disable")) {
                nvram_set("WscConfigured", "0");
                //g_wsc_configured = 0;
                nvram_set("g_wsc_configured", "0");
           } else {
			    nvram_set("WscConfigured", "1");
                //g_wsc_configured = 1;
                nvram_set("g_wsc_configured", "1");
           }
            //wps_config = 0;
            nvram_set("wps_config", "0");
            LedReset();
           /* start modify wireless disable to wps by liuguangpeng at 20110803 */
		}
	}
#endif

    nvram_set("wireless_perform_func", "1");
	nvram_set("wan_set", "1");

#ifdef DEFINE_DHCP_AUTO_SWITCH
	//restore wireless info
	nvram_set( "res_AuthMode", nvram_safe_get("AuthMode"));
	nvram_set( "res_EncrypType", nvram_safe_get("EncrypType"));
	nvram_set( "res_WPAPSK1", nvram_safe_get("WPAPSK1"));		
#endif

	
    nvram_commit();
    //doSystem("rc wlanapp");
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
    //WPSRestart();

#ifdef	GOAHEAD_SHOWSUBMITINFO
	//debug print
	websHeader(wp);
	websWrite(wp, T("<h2>MBSSID index: %d, Security Mode: %s Done</h2><br>\n"),
			mbssid, security_mode);
	websFooter(wp);
	websDone(wp, 200);
#else
	websRedirect(wp, "wl_secu.asp");
#endif

}

static void APSecurity(webs_t wp, char_t *path, char_t *query)
{
	Security(wp, path, query);
}

/* goform/wirelessWds */
#ifdef HAVE_GUEST
static void GuestSetting(webs_t wp, char_t *path, char_t *query)
{
	char_t *guest_enable, *guest_ssid, *guest_mode;
	
	guest_enable = websGetVar(wp, T("guestenable"), T(""));
	guest_ssid = websGetVar(wp, T("guestssid"), T(""));

	
	if (!strncmp(guest_enable, "1", 2))      //enable
	{
		nvram_set( "ssidenable1", "0");
		nvram_set( "BssidNum", "2");
		nvram_set( "SSID2", guest_ssid);
	}
	else
	{
		nvram_set( "ssidenable1", "1");
		nvram_set( "BssidNum", "1");
	}
	nvram_set( "guest_enable", guest_enable);
		
	int mbssid = 1;
	LFW(guest_mode, guestmode);
	//clear Radius settings
	clearRadiusSetting( mbssid);

	if(!strcmp(guest_mode, "0")){
		STFs( mbssid, "AuthMode", "OPEN");
		STFs( mbssid, "EncrypType", "NONE");
	}else if (!strcmp(guest_mode, "1")){
		char_t *Key1Type, *Key1Str;
		
		STFs( mbssid, "AuthMode", "WEPAUTO");
		STFs( mbssid, "EncrypType", "WEP");
		
		LFW(Key1Type, formatSelect);
		LFW(Key1Str, guestpass);

		STFs( mbssid, "DefaultKeyID", "1");
		STFs( mbssid, "Key1Type", Key1Type);
		nvram_set("Key1Str2", Key1Str);
	}else if( !strcmp(guest_mode, "2") ){
			char *pass_phrase_str;

			conf8021x(wp, mbssid);
			confWPAGeneral(wp, mbssid);

			LFW(pass_phrase_str, guestpass);

			STFs( mbssid, "AuthMode", "WPAPSKWPA2PSK");
			nvram_set( "WPAPSK2", pass_phrase_str);
	} 
	else {													// Open-None Mode
		STFs( mbssid, "AuthMode", "OPEN");
		STFs( mbssid, "EncrypType", "NONE");
	}

    char s_cmd[3] = { 0 };
    memset(s_cmd, 0, 3);
    sprintf(s_cmd, "%d", mbssid);
    nvram_set("mbssid", s_cmd);
   
	nvram_set("wireless_perform_func", "4");
	nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	
	websRedirect(wp, "wl_guest.asp");
}
#endif
/* add by zs for wlan mac filter end */
/* /goform/AddMacAndDelete */

/* As we know: the total number of ap's mac ACL is 32.
that define (MAX_MAC_ACL_NUM * MAC_BUF_LEN) for buffer. add by radar. 2010.4.12 */
#define MAC_BUF_LEN		19	// string line like: 00:11:22:33:44:55;
#define MAX_MAC_ACL_NUM	32
static void AddMacAndDelete(webs_t wp, char_t *path, char_t *query)
{
	char_t *mac_policy, *mac_address;
	char_t save_mac[MAC_BUF_LEN * MAX_MAC_ACL_NUM];
    char *tmp_mac, *edit_index, *src, *dest, list[10][19]={0}, buf[190]={0};
	int index=-1, i, num=0;

	mac_policy=mac_address=NULL;

	mac_policy = websGetVar(wp, T("ideal"), T(""));
	if (!strncmp(mac_policy, "0", 2))
	{
		nvram_set( "AccessPolicy0", mac_policy);
		nvram_set( "AccessPolicy1", mac_policy);
		nvram_set( "AccessPolicy2", mac_policy);
		nvram_set( "AccessPolicy3", mac_policy);

		//nvram_commit(RT2860_NVRAM);
		//doSystem("rc wlanapp");
		//nvram_commit();
		//notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
		//WPSRestart();
		//websRedirect(wp, "wl_mac.asp");
		//return;
	}
    else {
    	nvram_set( "AccessPolicy0", mac_policy);
    	nvram_set( "AccessPolicy1", mac_policy);
    	nvram_set( "AccessPolicy2", mac_policy);
    	nvram_set( "AccessPolicy3", mac_policy);

    	mac_address = websGetVar(wp, T("mac_address"), T(""));
    	if (strlen(mac_address)<2) {
    		//do nothing
    	}
    	else {
    		tmp_mac = (char *)nvram_safe_get( "AccessControlList0");
    		if (strlen(tmp_mac)<2)
    		{
    			nvram_set( "AccessControlList0", mac_address);
    			nvram_set( "AccessControlList1", mac_address);
    			nvram_set( "AccessControlList2", mac_address);
    			nvram_set( "AccessControlList3", mac_address);
    		}
    		else
    		{
#ifdef HAVE_WEB_CNS
    			snprintf(save_mac, sizeof(save_mac), "%s;%s", tmp_mac, mac_address);
    			nvram_set( "AccessControlList0", save_mac);
    			nvram_set( "AccessControlList1", save_mac);
    			nvram_set( "AccessControlList2", save_mac);
    			nvram_set( "AccessControlList3", save_mac);
#else
				edit_index = websGetVar(wp, T("edit_index"), T("")); 
				index = atoi(edit_index);
				if(index == -1) //add
				{
	    			snprintf(save_mac, sizeof(save_mac), "%s;%s", tmp_mac, mac_address);
	    			nvram_set( "AccessControlList0", save_mac);
	    			nvram_set( "AccessControlList1", save_mac);
	    			nvram_set( "AccessControlList2", save_mac);
	    			nvram_set( "AccessControlList3", save_mac);
				}
				else //modify
				{
					src = tmp_mac;
					for(i=0; *src!='\0'; i++)
					{
						dest = list[i];
						while(*src!=';' && *src!='\0'){
							*dest++ = *src++;
						}
						*dest = *src;
						if(*src == ';')
							src++;
					}
					num = i;
					
					memset(list[index],'0',sizeof(list[index]));
					strcpy(list[index],mac_address);
					if(index < num-1)
						strcat(list[index], ";");
					
					strcpy(buf,list[0]);
					for(i=1; i<num; i++)
					{
						strcat(buf,list[i]);
					}
	    			nvram_set( "AccessControlList0", buf);
	    			nvram_set( "AccessControlList1", buf);
	    			nvram_set( "AccessControlList2", buf);
	    			nvram_set( "AccessControlList3", buf);
				}
#endif
    		}
    	}
    }
	//nvram_commit(RT2860_NVRAM);
	//doSystem("rc wlanapp");
	nvram_set("wireless_perform_func", "9");
	nvram_commit();
	notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	//WPSRestart();
	websRedirect(wp, "wl_mac.asp");
}

static void APDelAccessList(webs_t wp, char_t *path, char_t *query)
{
	int i, j, rule_count;
	char_t name_buf[16];
	char_t *value;
	char *tmpbuf;
	int *deleArray;

	char_t save_mac[MAC_BUF_LEN * MAX_MAC_ACL_NUM];

       memset(save_mac,0,MAC_BUF_LEN * MAX_MAC_ACL_NUM);

    const char *rules = nvram_get( "AccessControlList0");
    if(!rules || !strlen(rules) )
        return;

	rule_count = getRuleNums(rules);

	if(!rule_count)
		return;

	tmpbuf = (char*)malloc(strlen(rules)+1);
	strncpy(tmpbuf, rules, strlen(rules));

	deleArray = (int *)malloc(rule_count * sizeof(int));

	for(i=0, j=0; i< rule_count; i++){
		snprintf(name_buf, 16, "DR%d", i);
		value = websGetVar(wp, name_buf, NULL);
		if(value){
			deleArray[j++] = i;
		}
	}
	if(!j){
	    websHeader(wp);
	    websWrite(wp, T("You didn't select any rules to delete.<br>\n"));
	    websFooter(wp);
	    websDone(wp, 200);
		return;
	}
	/*start of when delete all rules disable the status minpengwei 20120612*/
	if(j==rule_count)
	{
		nvram_set("AccessPolicy0","0");
	}
	/*end of when delete all rules disable the status minpengwei 20120612*/

	deleteNthValueMulti(deleArray, rule_count, tmpbuf, ';');
	free(deleArray);

	snprintf(save_mac, (MAC_BUF_LEN-1)*(rule_count-j), "%s",tmpbuf);

	nvram_set( "AccessControlList0", save_mac);
	nvram_set( "AccessControlList1", save_mac);
	nvram_set( "AccessControlList2", save_mac);
	nvram_set( "AccessControlList3", save_mac);

    //nvram_commit(RT2860_NVRAM);
    //doSystem("rc wlanapp");
    nvram_set("wireless_perform_func", "10");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
    //WPSRestart();
    //WPSRestart();
	websRedirect(wp, "wl_mac.asp");

    free(tmpbuf);
    tmpbuf = NULL;

	return;
}


/* add by zs for wlan mac filter end */

/*
 * ASP function
 */
static int showMACfilterMAC(int eid, webs_t wp, int argc, char_t **argv)
{
    int i=0;
    const char_t *mac_array = nvram_safe_get( "AccessControlList0");
    char rec[256]={0};
    char *tmpbuf;

    tmpbuf = (char*)malloc(strlen(mac_array)+1);
    strncpy(tmpbuf, mac_array, strlen(mac_array));

    while(getNthValueSafe(i, (char *)mac_array, ';', rec, sizeof(rec)) != -1 && strlen(rec)){
        websWrite(wp, T("<tr>\n"));
        websWrite(wp, T("<td> %d&nbsp; <input type=\"checkbox\" name=\"delRule%d\"> </td>"), i+1, i );
        // output Mac address
		websWrite(wp, T("<td> %s </td>"), rec);
		websWrite(wp, T("</tr>\n"));

		i++;
    }

    free(tmpbuf);
    tmpbuf = NULL;

    return 0;
}
void DeleteAccessPolicyList(webs_t wp, char_t *path, char_t *query)
{
	int mbssid, aplist_num;
	char str[32], apl[64*20];
	const char *tmp;
	sscanf(query, "%d,%d", &mbssid, &aplist_num);

	sprintf(str, "AccessControlList%d", mbssid);
	if(!(tmp = nvram_get( str)))
		return;
	strcpy(apl, tmp);

	deleteNthValueMulti(&aplist_num, 1, apl, ';');

	nvram_set( str, apl);

	default_shown_mbssid = mbssid;

	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));
	websWrite(wp, T("ok done"));
	websDone(wp, 200);

}

static void APDeleteAccessPolicyList(webs_t wp, char_t *path, char_t *query)
{
	DeleteAccessPolicyList(wp, path, query);
}

#ifdef CONFIG_RT2860V2_AP_MESH
/* goform/wirelessMesh */
static void wirelessMesh(webs_t wp, char_t *path, char_t *query)
{
	char_t	*meshenable, *mid, *hostname;
	char_t	*autolink;
	char_t	*mode, *encrypt_type, *wepkey, *wep_select, *wpakey;
	char defaultkey[2];

	//fetch from web input
	meshenable = websGetVar(wp, T("MeshEnable"), T(""));
	mid = websGetVar(wp, T("MeshID"), T(""));
	hostname = websGetVar(wp, T("HostName"), T(""));
	autolink = websGetVar(wp, T("AutoLinkEnable"), T(""));
	mode = websGetVar(wp, T("security_mode"), T(""));
	strcpy(defaultkey, "");
	if (0 == strcmp(mode, "OPEN"))
	{
		encrypt_type = websGetVar(wp, T("open_encrypt_type"), T(""));
		if (0 == strcmp(encrypt_type, "WEP"))
			strcpy(defaultkey, "1");
	}
	else if (0 == strcmp(mode, "WPANONE"))
	{
		encrypt_type = websGetVar(wp, T("wpa_cipher"), T(""));
	}
	wepkey = websGetVar(wp, T("wep_key"), T(""));
	wep_select = websGetVar(wp, T("wep_select"), T(""));
	wpakey = websGetVar(wp, T("passphrase"), T(""));

	// store to flash
	nvram_set( "MeshEnabled", meshenable);
	nvram_set( "MeshId", mid);
	nvram_set( "MeshHostName", hostname);
	nvram_set( "MeshAutoLink", autolink);
	nvram_set( "MeshAuthMode", mode);
	nvram_set( "MeshEncrypType", encrypt_type);
	nvram_set( "MeshDefaultkey", defaultkey);
	nvram_set( "MeshWEPKEY", wepkey);
	nvram_set( "MeshWEPKEYType", wep_select);
	nvram_set( "MeshWPAKEY", wpakey);

	//nvram_commit(RT2860_NVRAM);

	// restart network
	doSystem("internet.sh");

	// debug print
	websHeader(wp);
	websWrite(wp, T("MeshEnable: %s<br>\n"), meshenable);
	websWrite(wp, T("MeshID: %s<br>\n"), mid);
	websWrite(wp, T("HostName: %s<br>\n"), hostname);
	websWrite(wp, T("AutoLinkEnable: %s<br>\n"), autolink);
	websWrite(wp, T("security_mode: %s<br>\n"), mode);
	websWrite(wp, T("encrypt_type: %s<br>\n"), encrypt_type);
	websWrite(wp, T("defaultkey: %s<br>\n"), defaultkey);
	websWrite(wp, T("wep_key: %s<br>\n"), wepkey);
	websWrite(wp, T("wep_select: %s<br>\n"), wep_select);
	websWrite(wp, T("passphrase: %s<br>\n"), wpakey);
	websFooter(wp);
	websDone(wp, 200);
}

/* goform/meshManualLink */
static void meshManualLink(webs_t wp, char_t *path, char_t *query)
{
	char_t *action, *mpmac;

	// fetch from web input
	action = websGetVar(wp, T("link_action"), T(""));
	mpmac = websGetVar(wp, T("mpmac"), T(""));
    
    #if 0
	// link action
	if (0 == strcmp(action, "add"))
		doSystem("iwpriv mesh0 set MeshAddLink=%s", mpmac);
	if (0 == strcmp(action, "del"))
		doSystem("iwpriv mesh0 set MeshDelLink=%s", mpmac);
	sleep(1);
    #endif
    nvram_set("action", action);
    nvram_set("mpmac", mpmac);
    nvram_set("wireless_perform_func", "11");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	websRedirect(wp, "wireless/mesh.asp");
}

typedef struct _MESH_NEIGHBOR_ENTRY_INFO {
	char			Rssi;
	unsigned char	HostName[64 + 1];
	unsigned char	MacAddr[6];
	unsigned char	MeshId[32 + 1];
	unsigned char	Channel;
	unsigned char	Status;
	unsigned char	MeshEncrypType;
} MESH_NEIGHBOR_ENTRY_INFO;

typedef struct _MESH_NEIGHBOR_INFO {
	MESH_NEIGHBOR_ENTRY_INFO	Entry[64];
	unsigned char				num;
} MESH_NEIGHBOR_INFO;

/* goform/ShowMeshState */
static int ShowMeshState(int eid, webs_t wp, int argc, char_t **argv)
{
	int socket_id, ret, i;
	struct iwreq wrq;
	MESH_NEIGHBOR_INFO *neighbor;

	if (NULL == (neighbor = (MESH_NEIGHBOR_INFO *) malloc(sizeof(MESH_NEIGHBOR_INFO))))
	{
		fprintf(stderr, "can't allocat memory in MESH_NEIGHBOR_INFO !\n");
		return -1;
	}
	memset(neighbor, 0, sizeof(MESH_NEIGHBOR_INFO));

	if ((socket_id = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
	{
		fprintf(stderr, "ShowMeshState: open socket error !\n");
		websError(wp, 500, "ioctl sockey failed !");
		return -1;
	}

	strcpy(wrq.ifr_name, "mesh0");
	wrq.u.data.length = sizeof(MESH_NEIGHBOR_INFO);
	wrq.u.data.pointer = (caddr_t) neighbor;
	wrq.u.data.flags = OID_802_11_MESH_LIST;
	if ((ret = ioctl(socket_id, RT_PRIV_IOCTL, &wrq)) < 0)
	{
		fprintf(stderr, "ShowMeshState: ioctl -> OID_802_11_MESH_LIST error !\n");
		websError(wp, 500, "ioctl -> OID_802_11_MESH_LIST failed!");
		close(socket_id);
		return -1;
	}

	for(i=0;i<neighbor->num;i++)
	{
		websWrite(wp, T("<tr align=\"center\">"));
		if (1 == neighbor->Entry[i].Status)
			websWrite(wp, T("<td>%s</td>"), "<img src=\"/graphics/handshake.gif\">");
		else
			websWrite(wp, T("<td>%s</td>"), "<br />");
		websWrite(wp, T("<td>%02X:%02X:%02X:%02X:%02X:%02X</td>"),
					  neighbor->Entry[i].MacAddr[0],
					  neighbor->Entry[i].MacAddr[1],
					  neighbor->Entry[i].MacAddr[2],
					  neighbor->Entry[i].MacAddr[3],
					  neighbor->Entry[i].MacAddr[4],
					  neighbor->Entry[i].MacAddr[5]);
		websWrite(wp, T("<td>%d</td>"), neighbor->Entry[i].Rssi);
		websWrite(wp, T("<td>%s</td>"), neighbor->Entry[i].MeshId);
		websWrite(wp, T("<td>%s</td>"), neighbor->Entry[i].HostName);
		websWrite(wp, T("<td>%d</td>"), neighbor->Entry[i].Channel);
		if (neighbor->Entry[i].MeshEncrypType == 1)
			websWrite(wp, T("<td>%s</td>"), "OPEN-WEP");
		else if (neighbor->Entry[i].MeshEncrypType == 2)
			websWrite(wp, T("<td>%s</td>"), "WPANONE-TKIP");
		else if (neighbor->Entry[i].MeshEncrypType == 3)
			websWrite(wp, T("<td>%s</td>"), "WPANONE-AES");
		else
			websWrite(wp, T("<td>%s</td>"), "OPEN-NONE");
		websWrite(wp, T("</tr>"));
	}
	close(socket_id);

	return 0;
}
#endif

static int is3t3r(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined (CONFIG_RALINK_RT2883) || defined (CONFIG_RALINK_RT3883)
		websWrite(wp, T("1"));
#else
		websWrite(wp, T("0"));
#endif
	return 0;
}

static int isWPSConfiguredASP(int eid, webs_t wp, int argc, char_t **argv)
{
    //if(g_wsc_configured){
	if(atoi(nvram_safe_get("g_wsc_configured"))) {
		websWrite(wp, T("1"));
	}else
		websWrite(wp, T("0"));
	return 0;
}

#ifdef CONFIG_RT2860V2_RT3XXX_ANTENNA_DIVERSITY
void AntennaDiversityInit(void)
{
    #if 0
	const char *mode = nvram_safe_get( "AntennaDiversity");

	if(!gstrcmp(mode, "Disable")){						// Disable
		doSystem("echo 0 > /proc/AntDiv/AD_RUN");
	}else if(!gstrcmp(mode, "Enable_Algorithm1")){
		doSystem("echo 1 > /proc/AntDiv/AD_ALGORITHM"); // Algorithm1
		doSystem("echo 1 > /proc/AntDiv/AD_RUN");
	}else if(!gstrcmp(mode, "Enable_Algorithm2")){
		doSystem("echo 2 > /proc/AntDiv/AD_ALGORITHM"); // Algorithm2
		doSystem("echo 1 > /proc/AntDiv/AD_RUN");
	}else if(!gstrcmp(mode, "Antenna0")){				// fix Ant0
		doSystem("echo 0 > /proc/AntDiv/AD_RUN");
		doSystem("echo 0 > /proc/AntDiv/AD_FORCE_ANTENNA");
	}else if(!gstrcmp(mode, "Antenna2")){				// fix Ant2
		doSystem("echo 0 > /proc/AntDiv/AD_RUN");
		doSystem("echo 2 > /proc/AntDiv/AD_FORCE_ANTENNA");
	}else{
		doSystem("echo 0 > /proc/AntDiv/AD_RUN");
	return;
	}
    #endif
    nvram_set("wireless_perform_func", "12");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	return;
}

static void AntennaDiversity(webs_t wp, char_t *path, char_t *query)
{
	char_t	*mode;

	mode = websGetVar(wp, T("ADSelect"), T(""));
	if(!mode || !strlen(mode))
		return;

	nvram_set( "AntennaDiversity", mode);
	//nvram_commit(RT2860_NVRAM);

	// re-init
	AntennaDiversityInit();

	//debug print
	websHeader(wp);
	websWrite(wp, T("mode:%s"), mode);
	websFooter(wp);
	websDone(wp, 200);
}

static void getAntenna(webs_t wp, char_t *path, char_t *query)
{
	char buf[32];
	FILE *fp = fopen("/proc/AntDiv/AD_CHOSEN_ANTENNA", "r");
	if(!fp){
		strcpy(buf, "not support\n");
	}else{
		fgets(buf, 32, fp);
		fclose(fp);
	}
	websWrite(wp, T("HTTP/1.1 200 OK\nContent-type: text/plain\nPragma: no-cache\nCache-Control: no-cache\n\n"));
	websWrite(wp, "%s", buf);
	websDone(wp, 200);
}

static int isAntennaDiversityBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp, T("1"));
	return 0;
}
#else
static int isAntennaDiversityBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp, T("0"));
	return 0;
}
#endif

static int getWAPIASCertList(int eid, webs_t wp, int argc, char_t **argv)
{
	char *as_file = (char *) nvram_safe_get("ASCertFile");

	if (strlen(as_file) > 0)
		websWrite(wp, T("<option value=\"%s\">%s</option>"), as_file, as_file);
	else
		websWrite(wp, T("<option value=\"\"></option>"));

	return 0;
}

static int getWAPIUserCertList(int eid, webs_t wp, int argc, char_t **argv)
{
	char *user_file = (char *) nvram_safe_get("UserCertFile");

	if (strlen(user_file) > 0)
		websWrite(wp, T("<option value=\"%s\">%s</option>"), user_file, user_file);
	else
		websWrite(wp, T("<option value=\"\"></option>"));

	return 0;
}

int ApOidQueryInformation(unsigned long OidQueryCode, int socket_id, char *DeviceName, void *ptr, unsigned long PtrLength)
{
	struct iwreq wrq;

	strcpy(wrq.ifr_name, DeviceName);
	wrq.u.data.length = PtrLength;
	wrq.u.data.pointer = (caddr_t) ptr;
	wrq.u.data.flags = OidQueryCode;

#if WIRELESS_EXT > 17
	if (OidQueryCode == OID_802_11_BSSID_LIST )
		wrq.u.data.length = 8192;
#endif
	return (ioctl(socket_id, RT_PRIV_IOCTL, &wrq));
}

#if 0
static int getApStats(int eid, webs_t wp, int argc, char_t **argv)
{
	char_t *t;
	NDIS_802_11_STATISTICS stat;
	int s, ret;

	if (ejArgs(argc, argv, T("%s"), &t) < 1) {
		return websWrite(wp, T("Insufficient args"));
	}

	s = socket(AF_INET, SOCK_DGRAM, 0);
	ret = ApOidQueryInformation(OID_802_11_STATISTICS, s, "ra0", &stat, sizeof(stat));
	close(s);
	if (ret >= 0) {
		if (!strncmp(t, "TxSucc", 7))
			return websWrite(wp, T("%ld"), stat.TransmittedFragmentCount.QuadPart);
		else if (!strncmp(t, "TxRetry", 8))
			return websWrite(wp, T("%ld"), stat.RetryCount.QuadPart);
		else if (!strncmp(t, "TxFail", 7))
			return websWrite(wp, T("%ld"), stat.FailedCount.QuadPart);
		else if (!strncmp(t, "RTSSucc", 8))
			return websWrite(wp, T("%ld"), stat.RTSSuccessCount.QuadPart);
		else if (!strncmp(t, "RTSFail", 8))
			return websWrite(wp, T("%ld"), stat.RTSFailureCount.QuadPart);
		else if (!strncmp(t, "RxSucc", 7))
			return websWrite(wp, T("%ld"), stat.ReceivedFragmentCount.QuadPart);
		else if (!strncmp(t, "FCSError", 9))
			return websWrite(wp, T("%ld"), stat.FCSErrorCount.QuadPart);
		else
			return websWrite(wp, T("type not supported"));
	}
	else
		return websWrite(wp, T("ioctl %d"), ret);
}
#endif

/* goform/resetApCounters */
static void resetApCounters(webs_t wp, char_t *path, char_t *query)
{
	//system("iwpriv ra0 set ResetCounter=0");
	nvram_set("wireless_perform_func", "13");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
	websRedirect(wp, "wireless/apstatistics.asp");
	return;
}
#if WIRELESS_EXT <= 11
#ifndef SIOCDEVPRIVATE
#define SIOCDEVPRIVATE 0x8BE0
#endif
#define SIOCIWFIRSTPRIV SIOCDEVPRIVATE
#endif
#define RTPRIV_IOCTL_GSITESURVEY                (SIOCIWFIRSTPRIV + 0x0D)
/* start of modify best channel define by zengxianzhu at 20101216*/
#define SIOCGIWGET_BEST_CHANNEL                 (SIOCIWFIRSTPRIV + 0x1B)
/* end of modify best channel define by zengxianzhu at 20101216*/

#define SSID_NAME_SIZE                          36
#define CH_ONE_INFO_SIZE                        96
#define CH_ALL_INFO_SIZE                        (CH_ONE_INFO_SIZE * 2 *14)

typedef struct site_t_
{
    struct site_t_ *p_next;
    int i_channel;
    char s_ssid[ SSID_NAME_SIZE ];
}
site_t;

/* start of AP203N-W6P search_connect by wangjian at 20110624 */
int get_site_survey_ap( apcli_t **pp_site_list )
{
	char name[25];
	int socket_id;
	char data[ 4096 ] = { 0 };
	char s_line[ 128 ] = { 0 };
	char s_channel[ 6 ] = { 0 };
	char s_ssid[ 36 ] = { 0 };
	char s_bssid[ 22 ] = { 0 };
	char s_security[ 26 ] = { 0 };
	char s_single[ 12 ] = { 0 };
	char s_mode[ 12 ] = { 0 };
	char s_extch[ 10 ] = { 0 };
	char s_nt[ 6 ] = { 0 };
	char s_wps[ 6 ] = { 0 };
	
	char *sp = NULL, *sp_empty = NULL;
	apcli_t *p_head = NULL, *p_curr = NULL, *p_tmp = NULL;
	struct iwreq wrq;
	int ret = -1, len = 0, i_ch = 0, i_single = 0;
	
	socket_id = socket(AF_INET, SOCK_DGRAM, 0);
	if(socket_id < 0)
	{
		printf("\nrtuser::error::Open socket error!\n\n");
		return -1;
	}
	
	sprintf(name, "ra0");
	memset(data, 0x00, 255);
	
	memset(data, 0x00, 2048);
	strcpy(data, "");
	strcpy(wrq.ifr_name, name);
	wrq.u.data.length = 4096;
	wrq.u.data.pointer = data;
	wrq.u.data.flags = 0;
	ret = ioctl(socket_id, RTPRIV_IOCTL_GSITESURVEY, &wrq);
	if(ret != 0)
	{
		printf("\nrtuser::error::get site survey\n\n");
		goto rtuser_exit;
	}
	sp = wrq.u.data.pointer;
	sp = strchr( sp, '\n' );
	++sp;

	ret = -1;
	len = wrq.u.data.length;
	while( strlen( sp ) > 112 ) /*98changeto112*/
	{
		strncpy( s_line, sp, 116 ); 
		sp = sp + 116;
		if( strchr( s_line, ':' ) == NULL )
			continue;
	
		strncpy( s_channel, s_line, 4 );
		strncpy( s_ssid, s_line + 4, 33 );  /*34changeto33 add below*/
		strncpy( s_bssid, s_line + 37, 20 );
		strncpy( s_security, s_line + 57, 23 );
		strncpy( s_single, s_line + 80, 9 );
		strncpy( s_mode, s_line + 89, 8 );
		strncpy( s_extch, s_line + 97, 7 );
		strncpy( s_nt, s_line + 104, 3 );
		strncpy( s_wps, s_line + 107, 4 );
		
		sp_empty = strchr( s_ssid, ' ' );
		if( sp_empty != NULL )
			*sp_empty = '\0';
		
		i_ch = atoi( s_channel );
		if( i_ch < 1 || i_ch > 14 )
			continue;
			
		p_tmp = ( apcli_t * )malloc( sizeof( apcli_t ) ); /*site_t changeto apcli_t*/
		if( p_tmp == NULL )
		{
			printf( "ERROR: Can't get more memery(malloc fail).\n" );
			return -1;
		}
		memset( p_tmp, 0, sizeof( apcli_t ) );
		
		i_ch = atoi( s_channel );
		i_single = atoi( s_single );
		p_tmp->i_channel = i_ch;
		p_tmp->i_single = i_single;
		strncpy( p_tmp->s_ssid, s_ssid, 35 );
		strncpy( p_tmp->s_bssid, s_bssid, 21 );
		strncpy( p_tmp->s_security, s_security, 26 );
		strncpy( p_tmp->s_mode, s_mode, 11 );
		strncpy( p_tmp->s_extch, s_extch, 9 );
		strncpy( p_tmp->s_nt, s_nt, 5 );
		strncpy( p_tmp->s_wps, s_wps, 5 );
		
		if( p_head == NULL )
		{
			p_head = p_tmp;
			p_curr = p_tmp;
		}
		else
		{
			p_curr->p_next = p_tmp;
			p_curr = p_tmp;
		}
	}
	
rtuser_exit:
	if (socket_id >= 0)
		close(socket_id);
	*pp_site_list = p_head;

	return ret;
}
/* end of AP203N-W6P search_connect by wangjian at 20110624 */


int get_site_survey( site_t **pp_site_list )
{
    char name[25];
    int socket_id;
    char data[ 4096 ] = { 0 };
    char s_line[ 128 ] = { 0 };
    char s_channel[ 6 ] = { 0 };
    char s_ssid[ 36 ] = { 0 };
    char *sp = NULL, *sp_empty = NULL;
    site_t *p_head = NULL, *p_curr = NULL, *p_tmp = NULL;
    struct iwreq wrq;
    int ret = -1, len = 0, i_ch = 0;

    // open socket based on address family: AF_NET
    socket_id = socket(AF_INET, SOCK_DGRAM, 0);
    if(socket_id < 0)
    {
        printf("\nrtuser::error::Open socket error!\n\n");
        return -1;
    }

    // set interface name as "ra0"
    sprintf(name, "ra0");
    memset(data, 0x00, 255);

    //get AP's site survey, remove "get_site_survey" string
    memset(data, 0x00, 2048);
    strcpy(data, "");
    strcpy(wrq.ifr_name, name);
    wrq.u.data.length = 4096;
    wrq.u.data.pointer = data;
    wrq.u.data.flags = 0;
    ret = ioctl(socket_id, RTPRIV_IOCTL_GSITESURVEY, &wrq);
    if(ret != 0)
    {
        printf("\nrtuser::error::get site survey\n\n");
        goto rtuser_exit;
    }
    //printf( "----------------------------------------------" );
    //printf("\n%s\n", wrq.u.data.pointer);
    //printf("-----------------------------------------------\n");

    sp = wrq.u.data.pointer;
    sp = strchr( sp, '\n' );
    ++sp;

    ret = -1;
    len = wrq.u.data.length;
    while( strlen( sp ) > 98 )
    {
        /*start of Modify ssid Check duplication(site survey return value is change) by zengxianzhu at 20110104*/
        strncpy( s_line, sp, 116 );
        sp = sp + 116;
        /*end of Modify ssid Check duplication(site survey return value is change) by zengxianzhu at 20110104*/
        if( strchr( s_line, ':' ) == NULL )
            continue;

        strncpy( s_channel, s_line, 4 );
        strncpy( s_ssid, s_line + 4, 34 );
        sp_empty = strchr( s_ssid, ' ' );
        if( sp_empty != NULL )
            *sp_empty = '\0';

        i_ch = atoi( s_channel );
        if( i_ch < 1 || i_ch > 14 )
            continue;

        //printf( "line: %s", s_line );
        p_tmp = ( site_t * )malloc( sizeof( site_t ) );
        if( p_tmp == NULL )
        {
            printf( "ERROR: Can't get more memery(malloc fail).\n" );
			close(socket_id);
            return -1;
        }
        memset( p_tmp, 0, sizeof( site_t ) );
        p_tmp->i_channel = i_ch;
        strncpy( p_tmp->s_ssid, s_ssid, 35 );
        if( p_head == NULL )
        {
            p_head = p_tmp;
            p_curr = p_tmp;
        }
        else
        {
            p_curr->p_next = p_tmp;
            p_curr = p_tmp;
        }
    }

rtuser_exit:
    if (socket_id >= 0)
        close(socket_id);
    *pp_site_list = p_head;

    return ret;
}

#if 0
int get_site_survey_from_file( site_t **pp_site_list )
{
    FILE *fp = NULL;
    char s_line[ 128 ] = { 0 };
    char s_ssid[ SSID_NAME_SIZE ] = { 0 };
    char s_channel[ 6 ] = { 0 };
    char *sp_empty = NULL;
    site_t *p_head = NULL, *p_curr = NULL, *p_tmp = NULL;
    int i_ch = 0, i_ret = -1;

    if( pp_site_list == NULL )
        return -1;

    doSystem( "iwpriv ra0 get_site_survey > /tmp/site_list" );
    fp = fopen( "/tmp/site_list", "r" );
    if( fp != NULL )
    {
        fgets( s_line, 127, fp );
        while( fgets( s_line, 127, fp ) != NULL )
        {
            if( strchr( s_line, ':' ) == NULL )
                continue;

            strncpy( s_channel, s_line, 4 );
            strncpy( s_ssid, s_line + 4, SSID_NAME_SIZE - 1 );
            sp_empty = strchr( s_ssid, ' ' );
            if( sp_empty != NULL )
                *sp_empty = '\0';

            i_ch = atoi( s_channel );
            if( i_ch < 1 || i_ch > 14 )
                continue;

            //printf( "line: %s\n", s_line );
            p_tmp = ( site_t * )malloc( sizeof( site_t ) );
            if( p_tmp == NULL )
            {
                printf( "ERROR: Can't get more memery(malloc fail).\n" );
                return -1;
            }
            memset( p_tmp, 0, sizeof( site_t ) );
            p_tmp->i_channel = i_ch;
            strncpy( p_tmp->s_ssid, s_ssid, SSID_NAME_SIZE - 1 );
            if( p_head == NULL )
            {
                p_head = p_tmp;
                p_curr = p_tmp;
            }
            else
            {
                p_curr->p_next = p_tmp;
                p_curr = p_tmp;
            }
        }
    }
    fclose( fp );
    doSystem( "rm -f /tmp/site_list" );
    *pp_site_list = p_head;

    return i_ret;
}
#endif

int free_site_list( site_t *p_head )
{
    site_t *p_curr = NULL, *p_tmp = NULL;

    p_curr = p_head;
    while( p_curr )
    {
        p_tmp = p_curr;
        p_curr = p_curr->p_next;
        free( p_tmp );
    }

    return 0;
}



static void wirelessGetSsid( webs_t wp, char_t *path, char_t *query )
{
    char *p_ssid_name = NULL;
    site_t *p_head = NULL, *p_curr = NULL;
    int i_ret = 1;

    p_ssid_name = websGetVar(wp, T("ssid"), T(""));

    //doSystem( "iwpriv ra0 set SiteSurvey=1" );
    //sleep( 1 );
    nvram_set("wireless_perform_func", "14");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
    get_site_survey( &p_head );
    //get_site_survey_from_file( p_ssid_name );

    p_curr = p_head;
    while( p_curr )
    {
        if( !strncmp( p_curr->s_ssid, p_ssid_name, SSID_NAME_SIZE ) )
            i_ret = 0;
        p_curr = p_curr->p_next;
    }
    free_site_list( p_head );
    p_head = NULL;

    if( i_ret == 0 )
        websWrite( wp, T("1") );
    else
        websWrite( wp, T("0") );
    websDone(wp, 200);
}

static void wirelessSelBC( webs_t wp, char_t *path, char_t *query )
{
    int socket_id = 0, ret = 0;
    int i_best_ch = 0;
    char name[ 25 ] = { 0 };
    char data[ 4096 ] = { 0 };
    struct iwreq wrq;

    // open socket based on address family: AF_NET
    socket_id = socket(AF_INET, SOCK_DGRAM, 0);
    if(socket_id < 0)
    {
        printf("\nrtuser::error::Open socket error!\n\n");
        return;
    }

    // set interface name as "ra0"
    sprintf(name, "ra0");
    memset(data, 0x00, 255);

    memset(data, 0x00, 2048);
    strcpy(data, "");
    strcpy(wrq.ifr_name, name);
    wrq.u.data.length = 4096;
    wrq.u.data.pointer = data;
    wrq.u.data.flags = 0;
    ret = ioctl(socket_id, SIOCGIWGET_BEST_CHANNEL, &wrq);
    if(ret != 0)
    {
        i_best_ch = 6;
        printf("\nrtuser::error::get site survey\n\n");
        goto done;
    }
    memcpy( &i_best_ch, data, sizeof( i_best_ch ) );
    printf( "wirelessSelBC--------------->bc=%d\n", i_best_ch );

done:
    close(socket_id);

    websWrite( wp, "%d", i_best_ch );
    websDone(wp, 200);
}

static void wirelessChList( webs_t wp, char_t *path, char_t *query )
{
    char sa_data[ CH_ALL_INFO_SIZE ] = { 0 };
    char sa_line[ CH_ONE_INFO_SIZE ] = { 0 };
    char sa_chid[ 16 ] = { 0 };
    site_t *p_head = NULL, *p_curr = NULL, *p_node = NULL;
    char i_real_count = 0;
    char *pc_empty = NULL;
    int i_ch = 0, i_site_count = 0;
    int i_now_len = 0;

    //doSystem( "iwpriv ra0 set SiteSurvey=1" );
    //sleep( 1 );
    nvram_set("wireless_perform_func", "15");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );
    get_site_survey( &p_head );

    for( i_ch = 1; i_ch < 14; ++i_ch )
    {
        sa_line[ 0 ] = '\0';
        i_site_count = 0;
        i_real_count = 0;
        pc_empty = NULL;
        p_curr = p_head;
        while( p_curr )
        {
            if( p_curr->i_channel == i_ch )
            {
                ++i_site_count;
                i_now_len = strlen( sa_line ) + strlen( p_curr->s_ssid ) + 1;
                if( i_now_len < CH_ONE_INFO_SIZE )
                {
                    ++i_real_count;
                    pc_empty = sa_line + strlen( sa_line );
                    strcat( sa_line, " " );
                    strcat( sa_line, p_curr->s_ssid );
                }
            }
            p_curr = p_curr->p_next;
        }

        snprintf( sa_chid, sizeof( sa_chid )- 1, "%d(%d):",
            i_ch, i_site_count );
        strcat( sa_data, sa_chid );

        if( i_real_count < i_site_count && pc_empty != NULL )
        {
            *pc_empty = '\0';
            strcat( sa_line, "..." );
        }

        strcat( sa_data, sa_line );
        strcat( sa_data, ";" );
    }

    free_site_list( p_head );
    p_head = NULL;

    //printf( "#############---- %s\n", sa_data );
    websWrite( wp, "%s", sa_data );
    websDone(wp, 200);
}

/*
 * description: write AP SNR
 */
static int getApSNR(int eid, webs_t wp, int argc, char_t **argv)
{
	int s, n, ret;
	unsigned long SNR;

	if (ejArgs(argc, argv, T("%d"), &n) < 1) {
		return websWrite(wp, T("Insufficient args\n"));
	}

	s = socket(AF_INET, SOCK_DGRAM, 0);
	if (n == 0)
		ret = ApOidQueryInformation(RT_OID_802_11_SNR_0, s, "ra0", &SNR, sizeof(SNR));
	else if (n == 1)
		ret = ApOidQueryInformation(RT_OID_802_11_SNR_1, s, "ra0", &SNR, sizeof(SNR));
	else if (n == 2)
		ret = ApOidQueryInformation(RT_OID_802_11_SNR_2, s, "ra0", &SNR, sizeof(SNR));
	else
		ret = -1;
	close(s);

	//fprintf(stderr, "SNR%d = %ld\n", n, SNR);
	if (ret < 0)
		return websWrite(wp, "n/a");
	else
		return websWrite(wp, "%ld", SNR);
}

#ifdef CONFIG_RT2860V2_AP_TXBF
typedef struct {
	unsigned long   TxSuccessCount;
	unsigned long   TxRetryCount;
	unsigned long   TxFailCount;
	unsigned long   ETxSuccessCount;
	unsigned long   ETxRetryCount;
	unsigned long   ETxFailCount;
	unsigned long   ITxSuccessCount;
	unsigned long   ITxRetryCount;
	unsigned long   ITxFailCount;
} RT_COUNTER_TXBF;

typedef struct {
	unsigned long           Num;
	RT_COUNTER_TXBF         Entry[MAX_NUMBER_OF_MAC];
} RT_802_11_TXBF_TABLE;
#endif

static int getApTxBFStats(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_TXBF
	int s, ret, i;
	RT_802_11_TXBF_TABLE table = {0};
	RT_COUNTER_TXBF *pCnt;
	int hdr = 0;
	unsigned long totalNBF, totalEBF, totalIBF, totalTx, totalRetry, totalSuccess;

	s = socket(AF_INET, SOCK_DGRAM, 0);
	ret = ApOidQueryInformation(RT_OID_802_11_QUERY_TXBF_TABLE, s, "ra0", &table, sizeof(table));
	close(s);
	if (ret < 0)
		return websWrite(wp, "ioctl error %d", ret);

	for (i = 0; i < table.Num; i++) {
		pCnt = &(table.Entry[i]);
		totalNBF = pCnt->TxSuccessCount + pCnt->TxFailCount;
		totalEBF = pCnt->ETxSuccessCount + pCnt->ETxFailCount;
		totalIBF = pCnt->ITxSuccessCount + pCnt->ITxFailCount;
		totalTx = totalNBF + totalEBF + totalIBF;
		totalRetry = pCnt->TxRetryCount + pCnt->ETxRetryCount + pCnt->ITxRetryCount;
		totalSuccess = pCnt->TxSuccessCount + pCnt->ETxSuccessCount + pCnt->ITxSuccessCount;

		if (totalTx == 0)
			continue;
		if (hdr == 0) {
			websWrite(wp, T("<tr><td class=title>Detailed TX Statistics (Retry count is approximate)</td></tr> <tr>"));
			hdr = 1;
		}

		websWrite(wp, T("<td><kbd>"));
		websWrite(wp, T("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"));
		websWrite(wp, T("Success&nbsp;&nbsp;&nbsp;&nbsp;"));
		websWrite(wp, T("Retry/PER&nbsp;&nbsp;&nbsp;&nbsp;"));
		websWrite(wp, T("Fail/PLR<br>"));

		if (totalNBF!=0) {
			websWrite(wp, T("NonBF (%2lu%%):&nbsp;%7lu&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"),
					100*totalNBF/totalTx, pCnt->TxSuccessCount);
			websWrite(wp, T("%7lu (%2lu%%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"),
					pCnt->TxRetryCount, 100*pCnt->TxRetryCount/(pCnt->TxSuccessCount+pCnt->TxRetryCount));
			websWrite(wp, T("%5lu (%1lu%%)<br>"),
					pCnt->TxFailCount, 100*pCnt->TxFailCount/totalNBF);
		}
		if (totalEBF!=0) {
			websWrite(wp, T("ETxBF (%2lu%%):&nbsp;%7lu&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"),
					100*totalEBF/totalTx, pCnt->ETxSuccessCount);
			websWrite(wp, T("%7lu (%2lu%%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"),
					pCnt->ETxRetryCount, 100*pCnt->ETxRetryCount/(pCnt->ETxSuccessCount+pCnt->ETxRetryCount));
			websWrite(wp, T("%5lu (%1lu%%)<br>"),
					pCnt->ETxFailCount, 100*pCnt->ETxFailCount/totalEBF);
		}
		if (totalIBF!=0) {
			websWrite(wp, T("ITxBF (%2lu%%):&nbsp;%7lu&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"),
					100*totalIBF/totalTx, pCnt->ITxSuccessCount);
			websWrite(wp, T("%7lu (%2lu%%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"),
					pCnt->ITxRetryCount, 100*pCnt->ITxRetryCount/(pCnt->ITxSuccessCount+pCnt->ITxRetryCount));
			websWrite(wp, T("%5lu (%1lu%%)<br>"),
					pCnt->ITxFailCount, 100*pCnt->ITxFailCount/totalIBF);
		}
		websWrite(wp, T("Total&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"));
		websWrite(wp, T("%7lu&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"), totalSuccess);
		websWrite(wp, T("%7lu (%2lu%%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"),
				totalRetry, 100*totalRetry/(totalSuccess + totalRetry));
		websWrite(wp, T("%5lu (%1lu%%)"),
				pCnt->TxFailCount+pCnt->ETxFailCount+pCnt->ITxFailCount,
				100*(pCnt->TxFailCount+pCnt->ETxFailCount+pCnt->ITxFailCount)/totalTx);
		websWrite(wp, T("</kbd></td>"));
	}
	if (hdr)
		websWrite(wp, T("</tr>"));
#endif
	return 0;
}

/* goform/wirelessRvt */
static void wirelessRvt(webs_t wp, char_t *path, char_t *query)
{
	char_t	*etxbf, *itxbf;
	//char_t	*itxbfto, *etxbfto;
	char_t	*macenhance, *classifier;

	itxbf = websGetVar(wp, T("itxbf"), T("0"));
	//itxbfto = websGetVar(wp, T("itxbfto"), T("0"));
	etxbf = websGetVar(wp, T("etxbf"), T("0"));
	//etxbfto = websGetVar(wp, T("etxbfto"), T("0"));
	macenhance = websGetVar(wp, T("macenhance"), T("0"));
	classifier = websGetVar(wp, T("classifier"), T("0"));

	nvram_set( "ITxBfEn", itxbf);
	/*
	if (strncmp(itxbfto, "0", 2))
		nvram_set( "ITxBfTimeout", itxbfto);
	*/
	nvram_set( "ETxBfEnCond", etxbf);
	/*
	if (strncmp(etxbfto, "0", 2))
		nvram_set( "ETxBfTimeout", etxbfto);
	*/
	nvram_set( "VideoTurbine", macenhance);
	//nvram_commit(RT2860_NVRAM);
	
    #if 0
	if (!strncmp(classifier, "0", 2))
		doSystem("rmmod cls");
	else
		doSystem("insmod cls");
    #endif
    nvram_set("classifier", classifier);
    nvram_set("wireless_perform_func", "16");
    nvram_commit();
    notification_send_rc( OID_NETWORK_WIRELESS, NOTIFY_WAIT );

	//debug print
	websHeader(wp);
	websWrite(wp, T("itxbf: %s<br>\n"), itxbf);
	//websWrite(wp, T("itxbfto: %s<br>\n"), itxbfto);
	websWrite(wp, T("etxbf: %s<br>\n"), etxbf);
	//websWrite(wp, T("etxbfto: %s<br>\n"), etxbfto);
	websWrite(wp, T("macenhance: %s<br>\n"), macenhance);
	websWrite(wp, T("classifier: %s<br>\n"), classifier);
	websFooter(wp);
	websDone(wp, 200);
	return;
}

static int getMeshBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined CONFIG_RT2860V2_AP_MESH || defined CONFIG_RT2860V2_STA_MESH
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getRVTBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined CONFIG_RA_CLASSIFIER_MODULE && defined CONFIG_RT2860V2_AP_VIDEO_TURBINE && CONFIG_RT2860V2_AP_TXBF
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getWDSBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_WDS
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getWSCBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined CONFIG_RT2860V2_AP_WSC || defined CONFIG_RT2860V2_STA_WSC
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getUniWPSBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#if defined CONFIG_UNIQUE_WPS
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getMBSSIDBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AP_MBSS
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int get16MBSSIDBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_16MBSSID_MODE
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}

static int getAutoProvisionBuilt(int eid, webs_t wp, int argc, char_t **argv)
{
#ifdef CONFIG_RT2860V2_AUTO_PROVISION
	return websWrite(wp, T("1"));
#else
	return websWrite(wp, T("0"));
#endif
}
